SystemOrganization addCategory: #'SqueakSource-Model'!
SystemOrganization addCategory: #'SqueakSource-View'!
SystemOrganization addCategory: #'SqueakSource-Server'!
SystemOrganization addCategory: #'SqueakSource-Tests'!

!ByteArray methodsFor: '*squeaksource' stamp: 'bf 5/26/2005 18:43'!
asMIMEDocument 
	^ SeasidePlatformSupport mimeDocumentClass content: self! !

!WAHtmlResponse methodsFor: '*SqueakSource' stamp: 'lr 3/19/2004 19:14'!
printHtmlOn: aStream
	aStream nextPutAll: '<?xml version="1.0" encoding="iso-8859-1"?>'.
	aStream nextPutAll: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	aStream nextPutAll: '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">'.
	head printHtmlOn: aStream.
	body printHtmlOn: aStream.
	aStream nextPutAll: '</html>'.! !

!WARequest methodsFor: '*SqueakSource' stamp: 'lr 1/27/2004 11:45'!
accessPath
	^self path findTokens: '/'! !

Object subclass: #SSBareComponent
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSBareComponent class methodsFor: 'instance creation' stamp: 'lr 2/14/2004 13:14'!
session: aSession
	^self new
		setSession: aSession;
		yourself! !

!SSBareComponent methodsFor: 'rendering' stamp: 'lr 1/29/2004 11:36'!
render
	| document html |
	document _ WAHtmlResponse new.
	html _ WAHtmlBuilder on: document.
	self renderContentOn: html.
	^document! !

!SSBareComponent methodsFor: 'rendering' stamp: 'lr 1/29/2004 11:26'!
renderContentOn: html! !

!SSBareComponent methodsFor: 'accessing' stamp: 'bf 12/15/2005 19:24'!
repository
	^self session repository! !

!SSBareComponent methodsFor: 'accessing' stamp: 'lr 1/31/2004 22:43'!
session
	^session! !

!SSBareComponent methodsFor: 'initialization' stamp: 'lr 2/14/2004 13:14'!
setSession: aSession
	session _ aSession! !

SSBareComponent subclass: #SSVersionListing
	instanceVariableNames: 'projects associations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

SSVersionListing subclass: #SSBlessedVersionListing
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSBlessedVersionListing methodsFor: 'as yet unclassified' stamp: 'avi 9/23/2004 22:46'!
renderProject: aProject version: aVersion on: html
	html anchorWithUrl: aVersion fileName do: aVersion package! !

!SSBlessedVersionListing methodsFor: 'as yet unclassified' stamp: 'avi 9/23/2004 22:45'!
shouldRenderProject: aProject version: aVersion
	^ (super shouldRenderProject: aProject version: aVersion)
		and: [aProject isVersionBlessed: aVersion]
	! !

SSVersionListing subclass: #SSDirectoryListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSDirectoryListing methodsFor: 'rendering' stamp: 'lr 2/19/2004 12:13'!
render
	(self session request url endsWith: '/')
		ifFalse: [ self session redirectTo: self session request url , '/' ].
	^super render.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'bf 5/25/2005 19:24'!
renderConfigsOn: html

	projects do: [:aProject |
		(aProject isMember: self session user allowedTo: SSAccessPolicy read)
			ifTrue: [aProject configs do: [:each |
				self renderProject: aProject config: each on: html]]]! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'bf 4/18/2005 19:11'!
renderContentOn: html
	html title: self title.
	html heading: self title level: 1.
	html paragraph: [
		html textWithCr: self description ].
	super renderContentOn: html.
	self renderConfigsOn: html.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'bf 5/25/2005 19:24'!
renderProject: aProject config: aConfig on: html
	html anchorWithUrl: aConfig fileName do: aConfig fileName.
	html break.
! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'lr 2/14/2004 13:20'!
renderProject: aProject version: aVersion on: html
	html anchorWithUrl: aVersion fileName do: aVersion fileName.
	html break.! !

SSVersionListing subclass: #SSRssListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSRssListing methodsFor: 'initialization' stamp: 'lr 3/19/2004 10:34'!
appendProject: aProject to: aStream
	super appendProject: aProject to: aStream.
	aProject feeds do: [ :feed |
		aStream nextPut: aProject -> feed ].! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 3/19/2004 10:34'!
associations
	^super associations
		first: (self defaultSize min: super associations size)! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 13:02'!
defaultSize
	^20! !

!SSRssListing methodsFor: 'private' stamp: 'bf 12/14/2005 19:27'!
escape: aString
	| str |
	str := aString.
	#(
		'&' '&amp;'
		'<' '&lt;'
		'>' '&gt;'
	) pairsDo: [:org :substitute |
		(str includes: org first)
			ifTrue: [str := str copyReplaceAll: org with: substitute]].
	^str! !

!SSRssListing methodsFor: 'private' stamp: 'bf 12/15/2005 12:24'!
escapeHtml: aString
	"First create HTML source for a string, then escape it as CDATA"
	| str |
	str := aString.
	#(
		'&' '&amp;'
		'<' '&lt;'
		'>' '&gt;'
	'
'	'<br/>')	pairsDo: [:org :substitute |
		(str includes: org first)
			ifTrue: [str := str copyReplaceAll: org with: substitute]].
	^self escape: str! !

!SSRssListing methodsFor: 'rendering' stamp: 'pmm 1/17/2006 21:56'!
render
	^WAGenericResponse
		document: (String streamContents: [ :stream |
			self renderContentOn: stream ])
		mimeType: 'application/rss+xml'! !

!SSRssListing methodsFor: 'rendering' stamp: 'bf 12/15/2005 12:28'!
renderContentOn: aStream
	aStream nextPutAll: '<?xml version="1.0" encoding="iso-8859-1"?>'; cr.
	aStream nextPutAll: '<rss version="2.0">'; cr.
		aStream nextPutAll: '<channel>';cr.
			aStream nextPutAll: '<title>'; nextPutAll: (self escape: self title); nextPutAll: '</title>'; cr.
			aStream nextPutAll: '<description>'; nextPutAll: (self escapeHtml: self description); nextPutAll: '</description>'; cr.
			aStream nextPutAll: '<link>'; nextPutAll: (self url); nextPutAll: '</link>'; cr.
			aStream nextPutAll: '<generator>'; nextPutAll: (self escape: self repository title); nextPutAll: '</generator>'; cr.
			super renderContentOn: aStream.
		aStream nextPutAll: '</channel>'; cr.
	aStream nextPutAll: '</rss>'; cr.! !

!SSRssListing methodsFor: 'rendering' stamp: 'pmm 1/18/2006 07:21'!
renderProject: aProject version: aVersion on: aStream
	aStream nextPutAll: '<item>'; cr.
		aStream nextPutAll: '<title>'; nextPutAll: (self escape: aVersion title); nextPutAll: '</title>'; cr.
		aStream nextPutAll: '<link>'; nextPutAll: (aVersion url: aProject); nextPutAll: '</link>'; cr.
		aStream nextPutAll: '<description>'; nextPutAll: (self escapeHtml: aVersion message); nextPutAll: '</description>'; cr.
		aStream nextPutAll: '<pubDate>'; nextPutAll: (aVersion timestamp printHttpFormat); nextPutAll: '</pubDate>'; cr.
		(aVersion author notNil and: [ aVersion author hasRssAuthorString ]) ifTrue: [
			aStream nextPutAll: '<author>'; nextPutAll: (self escape: aVersion author rssAuthorString); nextPutAll: '</author>'; cr ].
		aStream nextPutAll: '<category>'; nextPutAll: (self escape: aProject title); nextPutAll: '</category>'; cr.
	aStream nextPutAll: '</item>'; cr.! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'lr 2/14/2004 13:14'!
session: aSession project: aProject
	^self 
		session: aSession 
		projects: { aProject }! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'lr 2/14/2004 13:14'!
session: aSession projects: aCollection
	^(self session: aSession)
		setProjects: aCollection;
		yourself! !

!SSVersionListing methodsFor: 'initialization' stamp: 'lr 3/19/2004 09:50'!
appendProject: aProject to: aStream
	aProject versions do: [ :version |
		(self shouldRenderProject: aProject version: version)
			ifTrue: [ aStream nextPut: aProject -> version ] ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
associations
	^associations! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 3/19/2004 21:22'!
description
	^self isOneProject
		ifTrue: [ self project description ]
		ifFalse: [ String new ]! !

!SSVersionListing methodsFor: 'testing' stamp: 'lr 2/14/2004 13:06'!
isOneProject
	^self projects size = 1! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
project
	^self projects anyOne! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
projects
	^projects! !

!SSVersionListing methodsFor: 'rendering' stamp: 'lr 2/19/2004 12:06'!
renderContentOn: html
	self associations do: [ :assoc |
		self renderProject: assoc key version: assoc value on: html ]! !

!SSVersionListing methodsFor: 'rendering' stamp: 'lr 2/14/2004 13:01'!
renderProject: aProject version: aVersion on: html
	self subclassResponsiblity! !

!SSVersionListing methodsFor: 'initialization' stamp: 'lr 3/19/2004 09:50'!
setProjects: aCollection
	projects _ aCollection.
	associations _ Array streamContents: [ :stream |
		projects do: [ :project |
			self appendProject: project to: stream ] ].
	associations sort: [ :x :y | x value timestamp > y value timestamp ].! !

!SSVersionListing methodsFor: 'testing' stamp: 'lr 2/14/2004 12:59'!
shouldRenderProject: aProject version: aVersion
	^aProject
		isMember: self session user
		allowedTo: SSAccessPolicy read 
		for: aVersion! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/14/2004 13:08'!
title
	^self isOneProject
		ifTrue: [ self project title ]
		ifFalse: [ self repository title ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/14/2004 13:32'!
url
	^SSRepository rootUrl! !

Object subclass: #SSModel
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

SSModel subclass: #SSAccessPolicy
	instanceVariableNames: 'admins developers guests globalRight blessing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
admin
	^#admin! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllRead
	^#read! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllWrite
	^#readAndWrite! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:29'!
allowNothing
	^#noAccess! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'avi 9/23/2004 15:36'!
bless
	^ #bless! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 7/29/2004 10:12'!
globalRights
	^Array
		with: self allowAllRead
		with: self allowAllWrite
		with: self allowNothing! !

!SSAccessPolicy class methodsFor: 'migration' stamp: 'lr 2/27/2004 18:41'!
migrateGuests
	self allInstances do: [ :each |
		each guests isNil
			ifTrue: [ each guests: Set new ] ]! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
read
	^#read! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
write
	^#write! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addAdmin: aMember
	admins add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addDeveloper: aMember
	developers add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/27/2004 18:36'!
addGuest: aMember
	guests add: aMember! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
admins
	^admins! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
admins: aCollection
	admins _ aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:55'!
allowAllRead
	^self allowAllWrite 
		or: [ globalRight = self class allowAllRead ]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/7/2004 19:24'!
allowAllWrite
	^globalRight = self class allowAllWrite! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'avi 9/24/2004 10:26'!
canBless
	^ blessing ifNil: [false]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'avi 9/24/2004 10:26'!
canBless: aBoolean
	blessing _ aBoolean! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
developers
	^developers! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
developers: aCollection
	developers _ aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight
	^globalRight! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight: aSymbol
	globalRight _ aSymbol! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:35'!
guests
	^guests! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:34'!
guests: aCollection
	guests _ aCollection! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/25/2005 10:59'!
hasMember: aMember
	^(self isMember: aMember in: self admins)
		or: [self isMember: aMember in: self developers]
		or: [self isMember: aMember in: self guests]
	
! !

!SSAccessPolicy methodsFor: 'initialization' stamp: 'al 7/29/2004 10:16'!
initialize
	super initialize.
	self developers: Set new.
	self admins: Set new.
	self guests: Set new.	
	self globalRight: self class allowAllRead.
! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/24/2005 15:04'!
isMember: aMember allowedTo: aSymbol
	(aMember notNil and: [ aMember isSuperUser ])
		ifTrue: [ ^true ].
	aSymbol = self class read ifTrue: [
		^self allowAllRead
			or: [ self allowAllWrite ]
			or: [ self isMember: aMember in: self developers ]
			or: [ self isMember: aMember in: self admins ]
			or: [ self isMember: aMember in: self guests ] ].
	aSymbol = self class write ifTrue: [
		^self allowAllWrite
			or: [ self isMember: aMember in: self developers ]
			or: [ self isMember: aMember in: self admins ] ].
	aSymbol = self class admin ifTrue: [
		^self isMember: aMember in: self admins ].
	aSymbol = self class bless ifTrue: [
		^ self canBless and:
			[(self isMember: aMember in: self developers)	
				or: [self isMember: aMember in: self admins] ]].
	^self error: 'Action ', aSymbol, ' unknown'
				! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isMember: aMember in: aList
	^(aList includes: aMember)
		or: [(aList select: [:ea | ea isGroup])
				anySatisfy: [:group | group hasMember: aMember]]! !

SSModel subclass: #SSFeedEntry
	instanceVariableNames: 'title message author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author
	^author! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author: aMember
	author _ aMember! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message
	^message! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message: aMessage
	message _ aMessage! !

!SSFeedEntry methodsFor: 'metamodel' stamp: 'lr 3/19/2004 10:25'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.
	metaobject textAttribute: #title do: [ :attribute | 
		attribute
			label: 'Title';
			maxLength: 50;
			addRequiredRule ].
	metaobject textAttribute: #message do: [ :attribute | 
		attribute
			label: 'Message';
			multiLine: true ].
	^metaobject! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title
	^title! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title: aString
	title _ aString! !

!SSFeedEntry methodsFor: 'conveniance' stamp: 'bf 12/13/2004 17:53'!
url: aProject
	^SSRepository rootUrl! !

SSModel subclass: #SSGroup
	instanceVariableNames: 'id fullname members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname
	^fullname! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname: aString
	fullname := aString! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:11'!
hasMember: aMember
	^self members includes: aMember! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
id
	^id! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:33'!
id: aString
	id := aString! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 12/20/2005 00:40'!
initials
	^ self id
! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^true! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members
	^members ifNil: [members := Set new]! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members: someMembers
	members := someMembers! !

!SSGroup methodsFor: 'metamodel' stamp: 'bf 5/24/2005 15:16'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.

	metaobject textAttribute: #fullname do: [ :attribute | 
		attribute
			label: 'Name';
			maxLength: 50;
			addRequiredRule ].

	metaobject textAttribute: #id do: [ :attribute | 
		attribute
			label: 'Id';
			maxLength: 10;
			addRequiredRule;
			addValidationRule: [ :value | SSRepository current isUniqueGroupId: value ]
				errorString: 'group already exists' ].

	metaobject multipleRelationshipAttribute: #members do: [ :attribute | 
		attribute
			label: 'Members';
			relationshipTo: [ SSRepository current members ]].
		
	^metaobject! !

!SSGroup methodsFor: 'metamodel' stamp: 'bf 5/24/2005 14:30'!
metaobjectEdit
	^self metaobject
		removeAttributeOf: #id;
		yourself! !

!SSGroup methodsFor: 'metamodel' stamp: 'bf 5/24/2005 14:11'!
metaobjectRegister
	^self metaobject! !

!SSGroup methodsFor: 'printing' stamp: 'bf 5/24/2005 16:17'!
printInitialsOn: aStream
	self members do: [:each | aStream nextPutAll: each initials]
		separatedBy: [aStream nextPutAll: ', '].
! !

!SSGroup methodsFor: 'printing' stamp: 'bf 5/24/2005 16:17'!
printOn: aStream
	aStream 
		nextPutAll: '* ';
		nextPutAll: self fullname;
		nextPutAll: ' ('.
	self printInitialsOn: aStream.
	aStream nextPut: $)! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 18:22'!
title
	^self fullname! !

!SSGroup methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSGroupView model: self! !

SSModel subclass: #SSMember
	instanceVariableNames: 'initials fullname passwordHash superuser email description'
	classVariableNames: 'AnonymousMember'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSMember class methodsFor: 'instance creation' stamp: 'al 2/16/2004 19:23'!
anonymousMember
	^AnonymousMember
		ifNil: [ AnonymousMember _ self new
			initials: String new;
			fullname: String new;
			yourself ]! !

!SSMember class methodsFor: 'instance creation' stamp: 'lr 2/2/2004 13:29'!
initials: aString
	^self new
		setInitials: aString;
		yourself! !

!SSMember methodsFor: 'comparing' stamp: 'bf 3/18/2005 19:22'!
<= aMember
	^self fullname <= aMember fullname! !

!SSMember methodsFor: 'conveniance' stamp: 'bf 5/25/2005 11:28'!
adminInProjects
	^SSRepository current visibleProjects select: [ :each |
		each admins includes: self ].! !

!SSMember methodsFor: 'private' stamp: 'lr 1/31/2004 19:49'!
buildHash: aString
	^SecureHashAlgorithm new
		hashMessage: aString! !

!SSMember methodsFor: 'conveniance' stamp: 'lr 2/26/2004 22:44'!
commitCount
	^SSRepository current projects 
		inject: 0
		into: [ :result :project | result + (project numberOfCommitsBy: self) ]! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:57'!
description
	^description! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:57'!
description: aString
	description _ aString! !

!SSMember methodsFor: 'conveniance' stamp: 'bf 5/25/2005 11:29'!
developerInProjects
	^SSRepository current visibleProjects select: [ :each |
		each developers includes: self ].! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:55'!
email
	^email! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:55'!
email: aString
	email _ aString! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/29/2004 10:50'!
fullname
	^fullname! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/29/2004 10:50'!
fullname: aString
	fullname _ aString! !

!SSMember methodsFor: 'conveniance' stamp: 'bf 5/24/2005 18:04'!
groups
	^SSRepository current groups select: [ :each | 
		each hasMember: self]! !

!SSMember methodsFor: 'conveniance' stamp: 'bf 5/25/2005 11:29'!
guestInProjects
	^SSRepository current visibleProjects select: [ :each |
		each guests includes: self ].! !

!SSMember methodsFor: 'testing' stamp: 'pmm 1/17/2006 21:46'!
hasRssAuthorString
	^self email isEmptyOrNil not! !

!SSMember methodsFor: 'initialization' stamp: 'lr 2/6/2004 17:41'!
initialize
	super initialize.
	superuser _ false.! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/26/2004 21:55'!
initials
	^initials! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/3/2004 21:46'!
initials: aString
	self initials isEmptyOrNil ifFalse: [ ^self error: 'Member initials are immutable' ].
	initials _ aString! !

!SSMember methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^false! !

!SSMember methodsFor: 'testing' stamp: 'lr 1/31/2004 19:51'!
isPasswordValid: aString
	^(self buildHash: aString) = passwordHash! !

!SSMember methodsFor: 'testing' stamp: 'lr 2/6/2004 18:43'!
isSuperUser
	^superuser! !

!SSMember methodsFor: 'metamodel' stamp: 'al 3/29/2004 21:47'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.
	metaobject textAttribute: #fullname do: [ :attribute | 
		attribute
			label: 'Name';
			maxLength: 50;
			addRequiredRule ].
	metaobject textAttribute: #initials do: [ :attribute | 
		attribute
			label: 'Initials';
			maxLength: 5;
			addRequiredRule;
			addValidationRule: [ :value |
				SSRepository current isUniqueMemberInitials: value ]
				errorString: 'initials already existing' ].
	metaobject passwordAttribute: #password do: [ :attribute | 
		attribute
			label: 'Password';
			addValidationRule: [ :value | value size >= 4 ]
				errorString: 'password is too short (at least 4 digits)' ].
	metaobject textAttribute: #email do: [ :attribute |
		attribute 
			label: 'E-Mail' ].
	metaobject textAttribute: #description do: [ :attribute |
		attribute
			label: 'Description';
			multiLine: true ].
	^metaobject! !

!SSMember methodsFor: 'metamodel' stamp: 'al 2/3/2004 22:02'!
metaobjectEdit
	^self metaobject
		removeAttributeOf: #initials;
		yourself! !

!SSMember methodsFor: 'metamodel' stamp: 'al 2/3/2004 21:51'!
metaobjectRegister
	^self metaobject! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/6/2004 21:23'!
password
	^passwordHash ifNotNil: ['****************']! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/3/2004 21:45'!
password: aString
	aString = self password ifFalse: [
		passwordHash _ self buildHash: aString ]! !

!SSMember methodsFor: 'printing' stamp: 'lr 2/7/2004 13:57'!
printOn: aStream
	aStream nextPutAll: self fullname.! !

!SSMember methodsFor: 'conveniance' stamp: 'lr 2/27/2004 20:03'!
projectCount
	^self projects size! !

!SSMember methodsFor: 'conveniance' stamp: 'bf 5/25/2005 11:00'!
projects
	^SSRepository current projects select: [ :each |
		each hasMember: self]! !

!SSMember methodsFor: 'accessing' stamp: 'pmm 1/17/2006 22:00'!
rssAuthorString
	^String streamContents: [ :stream |
		self fullname isEmptyOrNil ifFalse: [
			stream
				nextPutAll: self fullname;
				nextPut: Character space ].
		stream
			nextPut: $<;
			nextPutAll: self email;
			nextPut: $> ]! !

!SSMember methodsFor: 'initialization' stamp: 'lr 2/2/2004 13:27'!
setInitials: aString
	initials _ aString! !

!SSMember methodsFor: 'testing' stamp: 'bf 12/19/2005 09:52'!
stringsSatisfy: aBlock
	^aBlock value: fullname! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser
	^superuser! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser: aBoolean
	superuser _ aBoolean! !

!SSMember methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSMemberView model: self! !

!SSModel methodsFor: 'initialization' stamp: 'lr 2/6/2004 17:26'!
initialize
	timestamp _ TimeStamp current.! !

!SSModel methodsFor: 'accessing' stamp: 'lr 2/6/2004 17:26'!
timestamp
	^timestamp! !

SSModel subclass: #SSProject
	instanceVariableNames: 'id title description creator accessPolicy versions dateCreated feeds wiki blessings configs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSProject class methodsFor: 'instance creation' stamp: 'al 2/2/2004 22:36'!
creator: aMember
	^self new
		setCreator: aMember;
		yourself! !

!SSProject methodsFor: 'comparing' stamp: 'lr 3/15/2004 16:44'!
<= anObject
	^self title <= anObject title! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy
	^accessPolicy! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy: anAccessPolicy
	accessPolicy _ anAccessPolicy! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/6/2004 18:32'!
activity
	^self versions
		inject: 0.0
		into: [ :result :version | result + version activity ]! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 4/18/2005 19:01'!
addConfig: aString author: aUser url: anUrl
	| config |
	config _ (MCMcmReader on: aString readStream fileName: anUrl) version.
	^self configs at: config fileName put: config
! !

!SSProject methodsFor: 'accessing-versions' stamp: 'lr 2/6/2004 17:09'!
addVersion: aString author: aUser
	| array version |
	array _ aString asByteArray.
	version _ SSVersion 
		stream: array readStream 
		author: aUser.
	SSRepository storage saveMonticello: array of: version to: self.
	^versions at: version fileName put: version.
		! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:45'!
adminNames
	^String streamContents: [ :stream |
		self admins 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:44'!
admins
	^self accessPolicy admins! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:06'!
admins: aCollection
	self accessPolicy admins: aCollection! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 21:50'!
allBlessedVersions
	^ self blessings keys asSortedCollection collect: [:ea | self blessedVersionForPackage: ea]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:34'!
blessVersion: aVersion ifForbidden: errorBlock
	(self canBlessVersion: aVersion) ifFalse: [^ errorBlock value].
	(self blessedVersionListForPackage: aVersion package) addLast: aVersion! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:34'!
blessedVersionForPackage: aPackage
	| list |
	list _ self blessedVersionListForPackage: aPackage.
	^ list isEmpty ifFalse: [list last]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:49'!
blessedVersionListForPackage: aPackage
	^ self blessings at: aPackage ifAbsentPut: [OrderedCollection new]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:28'!
blessings
	^ blessings ifNil: [blessings _ Dictionary new]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless
	^ self accessPolicy canBless! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless: aBoolean
	self accessPolicy canBless: aBoolean! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 16:05'!
canBlessVersion: aVersion
	| previous |
	previous _ self blessedVersionForPackage: aVersion package.
	^ previous isNil or: [aVersion hasAncestor: previous project: self]! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 4/18/2005 18:45'!
configs
	^configs ifNil: [configs := Dictionary new].
! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/2/2004 13:13'!
creator
	^creator! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/2/2004 13:33'!
creatorName
	^self creator initials! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/3/2004 16:27'!
creators
	^Array with: creator! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 3/18/2005 18:31'!
deleteVersion: aVersion
	aVersion propertyAt: #deleted put: true! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:18'!
description
	^description! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:18'!
description: aString
	description _ aString! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:43'!
developerNames
	^String streamContents: [ :stream |
		self developers 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:43'!
developers
	^self accessPolicy developers! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:07'!
developers: aCollection
	self accessPolicy developers: aCollection! !

!SSProject methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:57'!
feeds
	feeds isNil
		ifTrue: [ feeds _ OrderedCollection new ].
	^feeds! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/7/2004 13:36'!
fullUrl
	^SSRepository rootUrl , self id! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:30'!
globalRight
	^self accessPolicy globalRight! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:31'!
globalRight: aSymbol
	self accessPolicy globalRight: aSymbol! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:54'!
guestNames
	^String streamContents: [ :stream |
		self guests 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests
	^self accessPolicy guests! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests: aCollection
	self accessPolicy guests: aCollection! !

!SSProject methodsFor: 'testing' stamp: 'bf 5/25/2005 10:57'!
hasMember: aMember
	^self accessPolicy hasMember: aMember
! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/28/2004 23:03'!
id
	^id! !

!SSProject methodsFor: 'accessing' stamp: 'al 2/2/2004 22:52'!
id: aString
	id isEmptyOrNil ifFalse: [ self error: 'Cannot redefine id of a project' ].
	id _ aString! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 12/14/2004 12:39'!
importVersionsFromStorage
	SSRepository storage importVersionsFor: self! !

!SSProject methodsFor: 'initialization' stamp: 'lr 2/4/2004 23:07'!
initialize
	super initialize.
	id _ title _ description _ String new.
	accessPolicy _ SSAccessPolicy new.
	versions _ Dictionary new.
	dateCreated _ Date today.
! !

!SSProject methodsFor: 'testing' stamp: 'al 2/7/2004 20:02'!
isMember: aMember allowedTo: aSymbol
	^self accessPolicy isMember: aMember allowedTo: aSymbol! !

!SSProject methodsFor: 'testing' stamp: 'lr 2/7/2004 21:22'!
isMember: aMember allowedTo: aSymbol for: aVersion
	^(self isMember: aMember allowedTo: aSymbol)
		or: [ aVersion isRelease
		and: [ SSAccessPolicy read = aSymbol ] ]		! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 15:31'!
isVersionBlessed: aVersion
	^ (self blessedVersionForPackage: aVersion package) = aVersion! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 3/18/2005 17:10'!
latestVersions
	| latest |
	latest := Dictionary new.
	self versions do: [:each |
		| last |
		last := -1.
		latest at: each packageName ifPresent: [:v | last := v packageVersion].
		each packageVersion > last
			ifTrue: [latest at: each packageName put: each]].
	^latest asSortedCollection
! !

!SSProject methodsFor: 'metamodel' stamp: 'avi 9/24/2004 10:30'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.
	metaobject textAttribute: #id do: [ :attribute | 
		attribute
			label: 'Name';
			maxLength: 20;
			addRequiredRule;
			addValidationRule: [ :value |
				value allSatisfy: [ :char | char isLetter or: [ char isDigit ] ] ]
				errorString: 'name should only contain letters and digits';
			addValidationRule: [ :value |
				SSRepository current isUniqueProjectId: value ]
				errorString: 'name is not unique' ].
	metaobject textAttribute: #title do: [ :attribute | 
		attribute
			label: 'Title';
			maxLength: 50;
			addRequiredRule ].
	metaobject textAttribute: #description do: [ :attribute | 
		attribute
			label: 'Description';
			multiLine: true ].
		
	metaobject booleanAttribute: #canBless do: [:attribute |
		attribute
			label: 'Enable Blessings'.
	].

	metaobject singleRelationshipAttribute: #globalRight do: [ :attribute | 
		attribute
			label: 'Global';
			relationshipTo: SSAccessPolicy globalRights
				formatWith: [ :symbol | symbol asCapitalizedPhrase ] ].
	metaobject multipleRelationshipAttribute: #admins do: [ :attribute |
		attribute
			label: 'Administrators';
			addValidationRule: [:admins | SSSession currentSession isSuperUser
				or: [ admins includes: SSSession currentSession user ] ]
				errorString: 'You can''t remove yourself from the list of administrators';
			hide ].
	metaobject multipleRelationshipAttribute: #developers do: [ :attribute |
		attribute label: 'Developers'; hide ].
	metaobject multipleRelationshipAttribute: #guests do: [ :attribute |
		attribute label: 'Guests'; hide ].
	^metaobject! !

!SSProject methodsFor: 'metamodel' stamp: 'al 2/3/2004 20:28'!
metaobjectEdit
	" same as register, but attribute id should not be changed anymore "
	^self metaobject
		removeAttributeOf: #id;
		yourself
		! !

!SSProject methodsFor: 'metamodel' stamp: 'al 2/3/2004 20:24'!
metaobjectRegister
	^self metaobject! !

!SSProject methodsFor: 'statistics' stamp: 'lr 2/26/2004 22:41'!
numberOfCommitsBy: aMember
	^self versions count: [ :version |
		version author = aMember ]
		! !

!SSProject methodsFor: 'statistics' stamp: 'al 2/4/2004 21:21'!
numberOfNormalVersions
	^self versions count: [ :each | each isRelease not ]! !

!SSProject methodsFor: 'statistics' stamp: 'al 2/4/2004 21:21'!
numberOfReleases
	^self versions count: [ :each | each isRelease ]! !

!SSProject methodsFor: 'statistics' stamp: 'al 2/26/2004 22:00'!
numberOfTotalDownloads
	^self versions detectSum: [ :each | each totalDownloads ]! !

!SSProject methodsFor: 'printing' stamp: 'lr 2/7/2004 13:57'!
printOn: aStream
	aStream nextPutAll: self title.! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/13/2004 12:34'!
releases
	^self versions 
		select: [ :each | each isRelease ]! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/13/2004 12:35'!
releasesSorted
	^self releases
		asSortedCollection! !

!SSProject methodsFor: 'initialization' stamp: 'lr 2/4/2004 23:07'!
setCreator: aMember
	accessPolicy addAdmin: (creator _ aMember).! !

!SSProject methodsFor: 'testing' stamp: 'bf 12/19/2005 10:24'!
stringsSatisfy: aBlock
	(aBlock value: title) ifTrue: [^true].
	(aBlock value: description) ifTrue: [^true].
	^self versions anySatisfy: [:any | aBlock value: any versionInfo name].
! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:17'!
title
	^title! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:18'!
title: aString
	title _ aString! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:35'!
unblessVersion: aVersion
	(self blessedVersionListForPackage: aVersion package) remove: aVersion ifAbsent: []! !

!SSProject methodsFor: 'conveniance' stamp: 'al 2/15/2004 12:21'!
url
	^String streamContents: [ :stream |
		stream nextPutAll: SSRepository rootUrl.
		stream nextPutAll: self id.
		stream nextPut: $/ ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'lr 2/4/2004 17:52'!
versionAt: aFilename
	^self versionAt: aFilename ifAbsent: [ nil ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 4/18/2005 19:28'!
versionAt: aFileName ifAbsent: aBlock
	^self versions at: aFileName ifAbsent: aBlock! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 3/18/2005 18:33'!
versions
	^versions reject: [:each | each propertyAt: #deleted ifAbsent: [false]]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'al 1/17/2006 16:26'!
versionsSorted
	^self versions 
		asSortedCollection! !

!SSProject methodsFor: 'actions' stamp: 'bf 5/24/2005 18:07'!
view
	^ SSProjectView model: self! !

!SSProject methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
wiki
	wiki isNil 
		ifTrue: [ wiki _ TWFolder new ].
	^wiki! !

SSModel subclass: #SSRepository
	instanceVariableNames: 'title members projects groups properties'
	classVariableNames: 'Storage StatisticsThread Statistics Current'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSRepository class methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:09'!
current
	^Current! !

!SSRepository class methodsFor: 'private' stamp: 'lr 3/19/2004 21:20'!
defaultRepository
	| lukas adrian stef ss fpm traits |
	
	" member "
	lukas _ (SSMember initials: 'lr')
		fullname: 'Lukas Renggli';
		superuser: true;
		password: 'p';
		yourself.
	adrian _ (SSMember initials: 'al')
		fullname: 'Adrian Lienhard';
		password: 'p';
		yourself.
	stef _ (SSMember initials: 'sd')
		fullname: 'Stephane Ducasse';
		password: 'p';
		yourself.

	" projects "
	ss _ (SSProject creator: adrian)
		id: 'ss';
		title: 'SqueakSource';
		yourself.
	fpm _ (SSProject creator: lukas)
		id: 'fpm';
		title: 'Functional Pattern Matching';
		yourself.
	traits _ (SSProject creator: adrian)
		id: 'traits';
		title: 'Traits';
		description: 'Composable Units of Behavior';
		yourself.
		
	" policies "
	ss accessPolicy
		addAdmin: lukas;
		addDeveloper: stef.
	traits accessPolicy
		addDeveloper: stef.
		
	" repository "
	^SSRepository new
		title: 'SqueakSource (Alpha)';
		addMember: lukas;
		addMember: adrian;
		addMember: stef;
		addProject: ss;
		addProject: fpm;
		addProject: traits.! !

!SSRepository class methodsFor: 'private' stamp: 'lr 2/7/2004 13:33'!
defaultRootUrl
	^'http://localhost:8080/'! !

!SSRepository class methodsFor: 'private' stamp: 'lr 1/31/2004 20:08'!
defaultStorage
	^SSFilesystem new! !

!SSRepository class methodsFor: 'initialization' stamp: 'lr 2/15/2004 17:02'!
initialize

	" -- initialize default repository -- "
	" Current _ self defaultRepository.
	  RootUrl _ self defaultRootUrl.
	  Storage _ self defaultStorage. "

	" -- save the current repository -- "
	" self storage saveRepository: self current. "
	
	" -- load the last repository -- "
	" Current _ self storage loadRepository. "
	
	" -- clear seaside caches -- "
	" WARegistry clearAllHandlers.
	  Smalltalk garbageCollect. "! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 14:48'!
isStatisticsThreadRunning
	^StatisticsThread isNil not! !

!SSRepository class methodsFor: 'accessing' stamp: 'bf 12/15/2005 21:20'!
rootUrl
	^self current rootUrl! !

!SSRepository class methodsFor: 'startup' stamp: 'al 1/12/2006 18:33'!
shutDown
	"Smalltalk addToShutDownList: self"
	SSKom stop.
	
	"Current _ nil."
! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 15:08'!
startStatisticsThread
	StatisticsThread isNil ifTrue: [
		StatisticsThread _ [ [
			self current statistics calculate.
			Transcript show: '.'.
			(Delay forSeconds: 60 * 60) wait ] repeat ] fork.
		StatisticsThread priority: 60 ]! !

!SSRepository class methodsFor: 'startup' stamp: 'al 1/12/2006 18:32'!
startUp
	"Smalltalk addToStartUpList: self"
	
	"Current _ self storage loadRepository."
	
	self current projects do: [ :each |
		self storage importVersionsFor: (self current
			projectAt: each id) ].
	SSKom startOn: Current port.! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 14:48'!
stopStatisticsThread
	StatisticsThread ifNotNil: [
		StatisticsThread terminate.
		StatisticsThread _ nil ]! !

!SSRepository class methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:09'!
storage
	^Storage! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'bf 5/24/2005 14:36'!
addGroup: aGroup
	self groups. "init"
	groups at: aGroup id put: aGroup! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
addMember: aMember
	members at: aMember initials put: aMember! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:41'!
addProject: aProject
	projects at: aProject id put: aProject! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:37'!
allProjectsVisible
	^self properties
		at: #allProjectsVisible
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:38'!
allProjectsVisible: aBoolean
	^self properties
		at: #allProjectsVisible
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:22'!
allowRegisterProject
	^self properties
		at: #allowRegisterProject
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:23'!
allowRegisterProject: aBoolean
	^self properties
		at: #allowRegisterProject
		put: aBoolean! !

!SSRepository methodsFor: 'authentication' stamp: 'lr 2/13/2004 12:50'!
authenticateUser: aUsername password: aPassword
	| user |
	user _ self 
		memberAt: aUsername 
		ifAbsent: [ ^nil ].
	aPassword isEmpty
		ifTrue: [ ^nil ].
	^(user isPasswordValid: aPassword)
		ifTrue: [ user ]
		ifFalse: [ nil ].! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/19/2005 09:15'!
batchSize
	^self properties
		at: #batchSize
		ifAbsent: [20]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/19/2005 09:15'!
batchSize: anInteger
	^self properties
		at: #batchSize
		put: anInteger! !

!SSRepository methodsFor: 'accessing' stamp: 'bf 7/28/2005 18:34'!
dirty
	^self properties at: #dirty ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing' stamp: 'bf 7/28/2005 18:34'!
dirty: aBoolean
	^self properties at: #dirty put: aBoolean! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'bf 5/24/2005 13:52'!
groups
	groups ifNil: [groups := Dictionary new].
	^groups values! !

!SSRepository methodsFor: 'initialization' stamp: 'bf 5/24/2005 13:50'!
initialize
	super initialize.
	title _ String new.
	members _ Dictionary new.
	groups _ Dictionary new.
	projects _ Dictionary new.
	Statistics _ SSStatistics model: self! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:17'!
introText
	^self properties
		at: #introText
		ifAbsent: [String new]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:15'!
introText: aString
	^self properties
		at: #introText
		put: aString! !

!SSRepository methodsFor: 'testing' stamp: 'bf 5/24/2005 14:26'!
isUniqueGroupId: aString
	^self groups 
		allSatisfy: [ :each | each id ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'lr 2/6/2004 17:28'!
isUniqueMemberInitials: aString
	^self members 
		allSatisfy: [ :each | each initials ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'lr 2/6/2004 17:28'!
isUniqueProjectId: aString
	^self projects 
		allSatisfy: [ :each | each id ~= aString ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'bf 5/25/2005 11:35'!
maxActivity
	^self visibleProjects
		inject: 1.0
		into: [ :result :each | result max: each activity ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
memberAt: aString
	^self memberAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
memberAt: aString ifAbsent: aBlock
	^members at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
members
	^members values! !

!SSRepository methodsFor: 'accessing-members' stamp: 'al 3/1/2004 21:52'!
membersCount
	^members size! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/19/2005 09:14'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.

	metaobject textAttribute: #rootUrl do: [ :attribute | 
		attribute label: 'Root URL';
			addRequiredRule].
	metaobject integerAttribute: #port do: [ :attribute | 
		attribute label: 'Port';
			addValidationRule: [ :value | value notNil ]
				errorString: 'invalid number';
			addValidationRule: [ :value | value between: 1 and: 65535 ]
				errorString: 'invalid port';
			addRequiredRule].
	metaobject textAttribute: #smtpServer do: [ :attribute | 
		attribute label: 'SMTP server';
			addRequiredRule].
	metaobject textAttribute: #superUserEmail do: [ :attribute | 
		attribute label: 'Admin email';
			addRequiredRule].
	metaobject booleanAttribute: #allowRegisterProject do: [ :attribute | 
		attribute label: 'Everyone can register projects'].
	metaobject booleanAttribute: #allProjectsVisible do: [ :attribute | 
		attribute label: 'Everyone can see all projects'].
	metaobject integerAttribute: #batchSize do: [ :attribute | 
		attribute label: 'Batch size for table reports';
			addValidationRule: [ :value | value notNil ]
				errorString: 'invalid number';
			addValidationRule: [ :value | value > 1 ]
				errorString: 'too small';
			addRequiredRule].
	metaobject colorAttribute: #styleColor do: [ :attribute | 
		attribute label: 'Style color';
			addValidationRule: [ :value | value ~= Color white ]
			errorString: 'invalid color'].
	metaobject textAttribute: #introText do: [ :attribute | 
		attribute label: 'Override home text'; 
			multiLine: true].
	^metaobject! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 22:05'!
port
	^self properties
		at: #port
		ifAbsent: [8888]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 22:05'!
port: anInteger
	^self properties
		at: #port
		put: anInteger! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString
	^self projectAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString ifAbsent: aBlock
	^projects at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projects
	^projects values! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'al 3/1/2004 21:52'!
projectsCount
	^projects size! !

!SSRepository methodsFor: 'accessing-properties' stamp: 'bf 7/28/2005 18:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'al 2/27/2004 18:58'!
removeProject: aProject
	projects removeKey: aProject id! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:18'!
rootUrl
	^self properties
		at: #rootUrl
		ifAbsent: ['http://localhost:8888/']! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:23'!
rootUrl: aString
	^self properties
		at: #rootUrl
		put: aString! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:50'!
smtpServer
	^self properties
		at: #smtpServer
		ifAbsent: ['haegar.unibe.ch']! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:15'!
smtpServer: aString
	^self properties
		at: #smtpServer
		put: aString! !

!SSRepository methodsFor: 'accessing' stamp: 'al 7/26/2004 15:46'!
statistics
	^Statistics ifNil: [Statistics _ SSStatistics model: self]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:35'!
styleColor
	^self properties
		at: #styleColor
		ifAbsent: [Color r: 0.21484375 g: 0.1171875 b: 0.51953125]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 17:11'!
styleColor: aColor
	^self properties
		at: #styleColor
		put: aColor! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:42'!
superUserEmail
	^self properties
		at: #superUserEmail
		ifAbsent: [String streamContents: [:strm |
			self members do: [:ea |
				ea isSuperUser ifTrue: [
					strm nextPutAll: ea email; nextPut: $,]].
			strm skip: -1]]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:43'!
superUserEmail: aStringWithCommas
	^self properties
		at: #superUserEmail
		put: aStringWithCommas! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:09'!
title
	^title! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:13'!
title: aString
	title _ aString! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'bf 12/15/2005 19:37'!
visibleProjects
	self allProjectsVisible ifTrue: [^self projects].
	^self projects select: [:each |
		each isMember: SSSession currentSession user allowedTo: SSAccessPolicy read]! !

SSModel subclass: #SSVersion
	instanceVariableNames: 'author versionInfo dependencies properties downloadStatistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSVersion class methodsFor: 'migration' stamp: 'lr 2/20/2004 14:21'!
migrate
	self allInstances do: [ :version |
		version dependencies do: [ :dependency |
			(dependency isKindOf: MCVersionDependency)
				ifTrue: [ dependency become: dependency versionInfo ].
			dependency clearAncestors ].
		version versionInfo ancestors do: [ :each |
			each clearAncestors ] ].! !

!SSVersion class methodsFor: 'properties' stamp: 'avi 9/23/2004 15:46'!
packageProperty
	^ #package! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/8/2004 11:44'!
releaseProperty
	^ #release! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPackageProperty
	^ #smPackage! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPasswordProperty
	^ #smPassword! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smUsernameProperty
	^ #smUsername! !

!SSVersion class methodsFor: 'properties' stamp: 'al 3/3/2004 18:14'!
smVersionCommentProperty
	^ #smVersionComment! !

!SSVersion class methodsFor: 'instance creation' stamp: 'lr 2/4/2004 18:26'!
stream: aStream author: aMember
	^self new
		initializeFromStream: aStream author: aMember;
		yourself! !

!SSVersion methodsFor: 'comparing' stamp: 'bf 12/16/2004 19:30'!
<= aVersion
	^self packageName = aVersion packageName
		ifFalse: [ self packageName < aVersion packageName ]
		ifTrue: [ self packageVersion > aVersion packageVersion ]
! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 3/22/2004 19:23'!
activity
	"This is non-trivial code with physical background: it calculates an artifical float representing the activity of the receiver. The bigger the number, the more siginification is this publication in the past days. This codes uses the halflife-time known from radioactive elements, in this example the constant lambda has been set to 3 days."
	
	| lambda time |
	lambda _ 2 ln / (3 * 24 * 60 * 60).
	time _ self timestamp asSeconds - TimeStamp current asSeconds.
	^(time * lambda) exp.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 2/4/2004 17:37'!
ancestors
	^self versionInfo ancestors! !

!SSVersion methodsFor: 'accessing' stamp: 'al 1/31/2004 17:22'!
author
	^author! !

!SSVersion methodsFor: 'accessing' stamp: 'al 2/16/2004 19:21'!
author: aMember
	author _ aMember! !

!SSVersion methodsFor: 'conveniance' stamp: 'al 2/16/2004 19:19'!
authorString
	^self author fullname! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 18:33'!
buildDiff: aFileName in: aProject
	| baseName base |
	baseName := MCDiffyVersion baseNameFrom: aFileName.
	base := aProject versionAt: baseName, '.', self readerClass extension ifAbsent: [^nil].
	^self buildDiffFrom: (base reader: aProject)
		to: (self reader: aProject).! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 18:40'!
buildDiffFrom: baseReader to: versionReader

	| diff diffData |
	versionReader info = baseReader info ifTrue: [^nil].
	(versionReader info hasAncestor: baseReader info) ifFalse: [^nil].
	[
		diff := MCDiffyVersion
			package: versionReader package
			info: versionReader info
			dependencies: versionReader dependencies
			baseInfo: baseReader info
			patch: (versionReader snapshot patchRelativeToBase: baseReader snapshot).
		diffData := ByteArray streamContents: [:strm | diff fileOutOn: strm]
	]
		on: ProgressInitiationException
		do: [ :ex |  ex sendNotificationsTo: [ :min :max :curr | "no progress bar please" ] ].

	^diffData! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/20/2004 14:12'!
dependencies
	^dependencies! !

!SSVersion methodsFor: 'conveniance' stamp: 'bf 5/26/2005 13:28'!
diffName
	^String streamContents: [ :stream |
		stream nextPutAll: self versionInfo name.
		stream nextPut: $..
		stream nextPutAll: MCMcdReader extension ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 19:18'!
diffNamesDo: aBlock
	^(self propertyAt: #diffs ifAbsent: [^nil])
		keysAndValuesDo: [:diffName :valid |
			valid ifTrue: [aBlock value: diffName]]
! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 17:16'!
diffs
	^self propertyAt: #diffs ifAbsentPut: [Dictionary new]
! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:52'!
downloadCountForType: aSymbol
	^self downloadStatistics at: aSymbol ifAbsent: [ 0 ]! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:50'!
downloadStatistics
	^downloadStatistics ifNil: [ downloadStatistics _ Dictionary new ]! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 2/4/2004 18:33'!
fileName
	^String streamContents: [ :stream |
		stream nextPutAll: self versionInfo name.
		stream nextPut: $..
		stream nextPutAll: self readerClass extension ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 7/15/2005 16:23'!
getDiff: aFileName in: aProject
	| diffName data |
	diffName := MCDiffyVersion canonicalNameFor: aFileName.
	self diffs at: diffName ifPresent: [:hasDiff | 
		^hasDiff ifTrue: [SSRepository storage loadDiffNamed: diffName from: aProject]].

	data := [self buildDiff: diffName in: aProject]
		on: Error do: [:ex | ex return: nil].
	data ifNotNil: [SSRepository storage saveDiff: data named: diffName to: aProject].
	self diffs at: diffName put: data notNil.
	^data! !

!SSVersion methodsFor: 'testing' stamp: 'avi 9/23/2004 16:04'!
hasAncestor: aVersion project: aProject
	^ (self readVersionInfoFromProject: aProject) hasAncestor: aVersion versionInfo! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:35'!
id
	^self versionInfo id! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:53'!
increaseDownloadCounterForType: aSymbol
	self downloadStatistics
		at: aSymbol
		put: (self downloadCountForType: aSymbol) + 1! !

!SSVersion methodsFor: 'initialization' stamp: 'lr 2/8/2004 11:41'!
initialize
	super initialize.
	properties _ Dictionary new.! !

!SSVersion methodsFor: 'initialization' stamp: 'avi 9/23/2004 15:47'!
initializeFromStream: aStream author: aMember
	| reader |
	reader _ self readerClass on: aStream.
	dependencies _ reader dependencies
		collect: [ :each | each versionInfo clearAncestors ].
	(versionInfo _ reader info) ancestors
		do: [ :each | each clearAncestors ].
	author _ aMember.
	self package: (reader package name)! !

!SSVersion methodsFor: 'testing' stamp: 'lr 2/8/2004 11:55'!
isRelease
	^self release! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:32'!
message
	^self versionInfo message! !

!SSVersion methodsFor: 'accessing' stamp: 'avi 9/23/2004 16:30'!
package
	^ self propertyAt: self class packageProperty ifAbsent: [self packageName]! !

!SSVersion methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:47'!
package: aString
	self propertyAt: self class packageProperty put: aString! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'bf 12/14/2004 13:39'!
packageName
	^self versionInfo name copyUpToLast: $-.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'bf 12/16/2004 19:28'!
packageVersion
	^(self versionInfo name copyAfterLast: $.) asNumber
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:42'!
propertyAt: aSymbol
	^properties at: aSymbol! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:43'!
propertyAt: aSymbol ifAbsent: aBlock
	^properties at: aSymbol ifAbsent: aBlock
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'bf 5/30/2005 17:21'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^properties at: aSymbol ifAbsentPut: aBlock
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:43'!
propertyAt: aSymbol put: aValue
	^properties at: aSymbol put: aValue! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/11/2004 11:47'!
propertyIncludes: aSymbol
	^properties includesKey: aSymbol! !

!SSVersion methodsFor: 'accessing-project' stamp: 'avi 9/23/2004 16:06'!
readVersionInfoFromProject: aProject
	^ (self reader: aProject) info! !

!SSVersion methodsFor: 'accessing-project' stamp: 'lr 2/4/2004 18:56'!
reader: aProject
	| data |
	data _ SSRepository storage loadMonticello: self from: aProject.
	^self readerClass on: data asByteArray readStream.! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 3/15/2004 16:06'!
readerClass
	^MCMczReader! !

!SSVersion methodsFor: 'conveniance' stamp: 'al 3/3/2004 18:25'!
registerSqueakMap: aProject
	"Copyied from MCSMReleaseRepository>>releaseVersion:url: and slightly modified. This message returns an error string in case of any problem, else nil is returned."

	| result |
	result _ HTTPSocket
		httpPost: self squeakMapUrl, '/packagebyname/' , (self propertyAt: self class smPackageProperty) , '/newrelease'
		args: {
			'version' -> { (self versionInfo name copyAfter: $.) extractNumber asString }.
			'note' -> { self propertyAt: self class smVersionCommentProperty }.
			'downloadURL' -> { self url: aProject } }
		user: (self propertyAt: self class smUsernameProperty)
		passwd: (self propertyAt: self class smPasswordProperty).
	^result contents size > 4 
		ifTrue: [ result contents ]
		ifFalse: [ nil ]! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:43'!
release
	^self 
		propertyAt: self class releaseProperty
		ifAbsent: [ false ]! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:44'!
release: aBoolean
	self 
		propertyAt: self class releaseProperty
		put: aBoolean! !

!SSVersion methodsFor: 'initialization' stamp: 'al 2/11/2005 14:30'!
setTimestampFromVersionInfo
        timestamp _ TimeStamp date: versionInfo date time: versionInfo time.! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 2/11/2004 12:15'!
squeakMapUrl
	^'http://map1.squeakfoundation.org/sm'! !

!SSVersion methodsFor: 'testing' stamp: 'bf 12/19/2005 09:55'!
stringsSatisfy: aBlock
	(aBlock value: versionInfo name) ifTrue: [^true].
	(aBlock value: versionInfo message) ifTrue: [^true].
	^author stringsSatisfy: aBlock! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 3/19/2004 09:54'!
title
	^self fileName! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 22:01'!
totalDownloads
	^self downloadStatistics detectSum: [ :each | each value ]! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 2/7/2004 13:43'!
truncatedMessage
	^self message truncateWithElipsisTo: 35! !

!SSVersion methodsFor: 'accessing-project' stamp: 'al 2/15/2004 12:21'!
url: aProject
	^aProject url, self fileName! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 1/31/2004 21:31'!
versionInfo
	^versionInfo! !

Object subclass: #SSStatistics
	instanceVariableNames: 'model cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSStatistics class methodsFor: 'instance creation' stamp: 'al 7/26/2004 14:38'!
model: aRepository
	^self basicNew
		model: aRepository;
		initialize;
		yourself! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:27'!
calculate
	self calculateMembersActive.
	self calculateMembersNew.
	self calculateProjectsActive.
	self calculateProjectsDownloads.
	self calculateProjectsNew.
	self calculateProjectsRecent! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:21'!
calculateMembersActive
	| histogram value |
	histogram _ Dictionary new.
	self model projects do: [ :project |
		project versions do: [ :version |
			value _ histogram at: version author ifAbsent: [ 0.0 ].
			histogram at: version author put: value + version activity ] ].
	cache at: #membersActive put: (self model members asSortedCollection: [ :x :y |
		(histogram at: x ifAbsent: [ 0.0 ]) >= (histogram at: y ifAbsent: [ 0.0 ]) ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:21'!
calculateMembersNew
	cache at: #membersNew put: (self model members asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:23'!
calculateProjectsActive
	cache at: #projectsActive put: (self model projects asSortedCollection: [ :x :y |
		x activity >= y activity ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:23'!
calculateProjectsDownloads
	cache at: #projectsDownloads put: (self model projects asSortedCollection: [ :x :y |
		x numberOfTotalDownloads >= y numberOfTotalDownloads ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:23'!
calculateProjectsNew
	cache at: #projectsNew put: (self model projects asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:24'!
calculateProjectsRecent
	| associations |
	associations _ SortedCollection sortBlock: [ :x :y |
		x value timestamp >= y value timestamp ].
	self model projects do: [ :project |
		project versions do: [ :version |
			associations add: project -> version ] ].
	cache at: #projectsRecent put: (associations collect: [ :each | 
		each key ])! !

!SSStatistics methodsFor: 'accessing' stamp: 'al 7/26/2004 14:26'!
doesNotUnderstand: aMessage
	^cache
		at: aMessage selector
		ifAbsent: [ super doesNotUnderstand: aMessage ]! !

!SSStatistics methodsFor: 'initialize-release' stamp: 'al 7/26/2004 14:26'!
initialize
	super initialize.
	cache _ Dictionary new.
	self calculate! !

!SSStatistics methodsFor: 'accessing' stamp: 'al 7/26/2004 14:16'!
model
	^model! !

!SSStatistics methodsFor: 'accessing' stamp: 'al 7/26/2004 14:16'!
model: aRepository
	model _ aRepository! !

Object subclass: #SSStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSStorage commentStamp: 'al 1/17/2006 16:31' prior: 0!
AUTOMATIC IMAGE SAVING (as alternative to ref streams)
storage := [ 
	[ Smalltalk garbageCollect.
	  Smalltalk saveSession.
	  (Delay forSeconds: 60 * 60) wait ] repeat ] forkAt: 51.
storage terminate.

====================================

MIGRATION SCRIPTS (old squeaksource instance on kilana to macamis)

"Chronology library changes"
(TimeStamp allInstances
	select: [:each | (each instVarNamed: 'seconds')
			isKindOf: Date])
	do: [:each | each become: (
		TimeStamp
			date: (Date julianDayNumber: (each instVarNamed: 'seconds') start)
			time: ((each instVarNamed: 'offset') instVarNamed: 'nanos' put: 0;
					 yourself))] displayingProgress: 'Converting TimeStamp'

"New instvars in MCVersionInfo. Note, this would normally be doable with SmartRefStream, but it seams to be broken for larger data sets."			
(MCVersionInfo allInstances
	select: [:each | (each stepChildren isKindOf: UUID) and: [ each author isNil ]])
	do: [:each | 
		8 to: 3 by: -1 do: [ :i |
			each instVarAt: i put: (each instVarAt: i - 1) ] ] displayingProgress: 'Converting MCVersionInfo'!

SSStorage subclass: #SSFilesystem
	instanceVariableNames: ''
	classVariableNames: 'CriticalSection'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSFilesystem class methodsFor: 'accessing' stamp: 'lr 2/26/2004 23:24'!
criticalSection
	CriticalSection isNil
		ifTrue: [ CriticalSection _ Semaphore forMutualExclusion ].
	^CriticalSection! !

!SSFilesystem class methodsFor: 'utilities' stamp: 'al 2/11/2005 16:03'!
recoverAllLostVersions
	SSRepository current projects do: [ :each |
	Transcript cr; show: 'Importing project: ' , each id; cr.
	self new importVersionsFor: (
		SSRepository current projectAt: each id) ]! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 7/28/2005 14:45'!
backupBaseFor: aString
	^aString copyUpToLast: $.! !

!SSFilesystem methodsFor: 'utilities' stamp: 'lr 2/1/2004 18:56'!
backupExtensionFor: aString
	| timestamp |
	timestamp _ TimeStamp current.
	^String streamContents: [ :stream |
		timestamp date printOn: stream format: #(3 2 1 $- 1 1 2).
		stream nextPut: $..
		stream nextPutAll: (timestamp time print24 collect: [ :each |
			each isDigit ifTrue: [ each ] ifFalse: [ $- ] ]) ].! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 7/28/2005 14:51'!
backupFileNames
	| base ext |
	base := self backupBaseFor: self streamFile.
	ext := (self backupExtensionFor: self streamFile)
		collect: [:c | c isDigit ifTrue: [$#] ifFalse: [c]].
	^self rootDirectory fileNamesMatching: base, FileDirectory dot, ext! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 7/28/2005 14:45'!
createBackupIn: aFileDirectory of: aString
	(aFileDirectory fileExists: aString) ifTrue: [
		aFileDirectory
			copyFileWithoutOverwriteConfirmationNamed: aString
			toFileNamed: (FileDirectory 
				fileName: (self backupBaseFor: aString) 
				extension: (self backupExtensionFor: aString)) ]! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 9/29/2005 19:47'!
fileKaput: aFileName
	| d i kaputName |
	d := self rootDirectory.
	(d fileExists: aFileName) ifFalse: [^self].
	i := 0.
	kaputName := aFileName, '.kaputt'.
	[d fileExists: kaputName]	
		whileTrue: [kaputName := aFileName, '.kaputt', (i:=i+1) asString].
	[d
		rename: aFileName
		toBe: kaputName.
		self log: 'BROKEN ', kaputName.
	] on: Error do: [:ex | "ignore"]
! !

!SSFilesystem methodsFor: 'logging' stamp: 'bf 9/29/2005 19:25'!
getLogOfSize: anInteger 
	| log buf |
	log := self rootDirectory readOnlyFileNamed: self logFileName.
	[
		log position: (log size - anInteger max: 0).
		buf := log upToEnd.
	] ensure: [log close].
	^buf! !

!SSFilesystem methodsFor: 'utilities' stamp: 'lr 1/10/2006 10:13'!
importVersionsFor: aProject
	| dir contents initials user version |
	dir := self projectDirectoryFor: aProject.
	(dir fileNamesMatching: '*.mcz') do: [ :each |
		aProject versionAt: each ifAbsent: [
			contents _ (dir readOnlyFileNamed: each) contentsOfEntireFile.
			initials _ (each copyAfterLast: $-) copyUpTo: $. .
			user _ SSRepository current memberAt: initials.
			user ifNil: [ user _ SSMember anonymousMember ].
			version _ aProject addVersion: contents author: user.
			version setTimestampFromVersionInfo ] ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 5/30/2005 17:53'!
loadDiffNamed: aFileName from: aProject
	| stream |
	stream _ (self projectDirectoryFor: aProject)
		readOnlyFileNamed: aFileName.
	^[ stream binary; contents ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 5/26/2005 17:15'!
loadMonticello: aVersion from: aProject
	| stream |
	stream _ (self projectDirectoryFor: aProject)
		readOnlyFileNamed: aVersion fileName.
	^[ stream binary; contents ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 12/20/2005 21:07'!
loadRepository
	[
		Display border: Display boundingBox width: 10 fillColor: Color green.
		[^self loadRepositoryFrom: self streamFile]
			on: Error do: [:ex |
				self fileKaput: self streamFile.
				ex return: nil].
		Display border: Display boundingBox width: 10 fillColor: Color yellow.
		self backupFileNames sort reverseDo: [:f |
			[^self loadRepositoryFrom: f]
				on: Error do: [:ex |
					self fileKaput: f.
					ex return: nil]].
		self error: 'Could not load repository nor any backup'
	] ensure: [World changed]! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 9/29/2005 19:48'!
loadRepositoryFrom: aFileName
	| stream reference |
	self log: 'LOADING repository from ', aFileName.
	stream _ self rootDirectory readOnlyFileNamed: aFileName.
	^[ reference _ self streamClass on: stream.
		[ reference next ]
			ensure: [ reference close ] ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'logging' stamp: 'bf 9/29/2005 19:19'!
log: aString
	| log |
	log := self rootDirectory fileNamed: self logFileName.
	[
		log
			setToEnd;
			nextPutAll: DateAndTime now asString; 
			space;
			nextPutAll: aString;
			cr
	] ensure: [log close]! !

!SSFilesystem methodsFor: 'logging' stamp: 'bf 9/29/2005 19:11'!
logFileName
	^'ss.log'! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/31/2004 21:23'!
projectDirectoryFor: aProject
	^(self rootDirectory directoryNamed: aProject id)
		assureExistence;
		yourself! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/31/2004 21:23'!
rootDirectory
	^(FileDirectory default directoryNamed: 'ss')
		assureExistence;
		yourself! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 5/30/2005 18:07'!
saveDiff: aByteArray named: aFileName to: aProject
	| directory stream |
	directory _ self projectDirectoryFor: aProject.
	self createBackupIn: directory of: aFileName.
	stream _ directory forceNewFileNamed: aFileName.
	[ stream nextPutAll: aByteArray ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 9/29/2005 18:17'!
saveMonticello: aByteArray of: aVersion to: aProject
	| directory stream |
	directory _ self projectDirectoryFor: aProject.
	self createBackupIn: directory of: aVersion fileName.
	stream _ directory forceNewFileNamed: aVersion fileName.
	[	stream nextPutAll: aByteArray.
		self log: 'STORED ', aProject id, '/', aVersion fileName.
	]
		ensure: [ stream close ].

! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 12/20/2005 21:12'!
saveRepository: aRepository
	| where stream reference |
	Display border: Display boundingBox width: 10 fillColor: Color orange.
	where := thisContext sender sender.
	self log: 'MODIFIED by ', where receiver class name, '>>', where method selector.
	aRepository dirty: true.
	[	self class criticalSection critical: [
			aRepository dirty ifTrue: [
				Display border: Display boundingBox width: 10 fillColor: Color red.
				self log: 'BEGIN SAVING'.
				aRepository dirty: false.
				self createBackupIn: self rootDirectory of: self streamFile.
				stream _ self rootDirectory forceNewFileNamed: self streamFile.
				[	reference _ self streamClass on: stream.
					[	reference nextPut: aRepository.
						self log: 'DONE SAVING'.
					]
						ensure: [ reference close ]
				] ensure: [ stream close ]. 
				aRepository dirty ifFalse: [World changed].
			]
		]
	] forkAt: Processor activePriority-1 named: 'store'! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/29/2004 11:20'!
streamClass
	^ReferenceStream! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 2/1/2004 13:23'!
streamFile
	^'data.obj'! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadMonticello: aVersion from: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadRepository
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'bf 5/26/2005 12:00'!
saveDiff: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
saveMonticello: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 1/31/2004 21:16'!
saveRepository: aRepository
	self subclassResponsibility! !

!WAEmailErrorPage methodsFor: '*SqueakSource' stamp: 'bf 12/15/2005 19:06'!
emailAddresses
	^ SSRepository current superUserEmail findTokens: ','! !

!WAEmailErrorPage methodsFor: '*SqueakSource' stamp: 'bf 12/15/2005 19:09'!
show
	SeasidePlatformSupport deliverMailFrom: 'SqueakSource' to: self emailAddresses text: self emailText.
	super show! !

TestCase subclass: #SSTestAccessRights
	instanceVariableNames: 'creator admin developer guest other project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSTestAccessRights methodsFor: 'setUp' stamp: 'lr 2/27/2004 19:14'!
setUp
	creator _ SSMember initials: 'cr'.
	admin _ SSMember initials: 'ad'.
	developer _ SSMember initials: 'de'.
	guest _ SSMember initials: 'gu'.
	other _ SSMember initials: 'ot'.
	
	project _ SSProject creator: creator.
	project accessPolicy addAdmin: admin.
	project accessPolicy addDeveloper: developer.
	project accessPolicy addGuest: guest.! !

!SSTestAccessRights methodsFor: 'running' stamp: 'al 7/29/2004 10:21'!
testAccess
	"Test default global read all access right"
	"self run: #testAccess"
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
! !

!SSTestAccessRights methodsFor: 'running' stamp: 'al 7/29/2004 10:19'!
testAccessNoAccess
	"self run: #testAccessNoAccess"
	
	project globalRight: SSAccessPolicy allowNothing.
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self deny: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy read).
! !

!SSTestAccessRights methodsFor: 'running' stamp: 'lr 2/27/2004 19:17'!
testGlobalAccess
	"self run: #testGlobalAccess"
	
	project globalRight: SSAccessPolicy allowAllRead.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	project globalRight: SSAccessPolicy allowAllWrite.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	! !

!SSTestAccessRights methodsFor: 'running' stamp: 'al 7/29/2004 10:16'!
testInitialization
	"self run: #testInitialization"
	
	self deny: project accessPolicy isNil.
	
	self assert: project creator = creator.
	
	self assert: (project admins includesAllOf: {creator. admin}).
	self assert: project admins size = 2.
	
	self assert: (project developers includes: developer).
	self assert: project developers size = 1.
	
	self assert: (project guests includes: guest).
	self assert: project guests size = 1.
	
	self assert: project globalRight = SSAccessPolicy allowAllRead
	
	
	! !

!SSTestAccessRights methodsFor: 'running' stamp: 'lr 2/27/2004 19:19'!
testSuperuser
	"self run: #testSuperuser"
	
	| superuser |
	superuser _ (SSMember initials: 'su') superuser: true.
	self assert: superuser isSuperUser.
	
	project globalRight: SSAccessPolicy allowAllRead.
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy read).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy write).
	
	! !

!Color class methodsFor: '*SqueakSource' stamp: 'lr 2/27/2004 19:46'!
activity: aFloat
	| index hue |
	index _ aFloat min: 1.0 max: 0.0.
	hue _ 240 - (240 * index).
	^self h: hue s: 1 v: 1! !

!Color methodsFor: '*SqueakSource' stamp: 'pmm 1/17/2006 20:16'!
asHTMLColor
	^ '#', self hex! !

!Color methodsFor: '*SqueakSource' stamp: 'pmm 1/17/2006 20:15'!
hex
	^ ((self red * 255) asInteger printPaddedWith: $0 to: 2 base: 16) ,
	  ((self green * 255) asInteger printPaddedWith: $0 to: 2 base: 16) ,
	  ((self blue * 255) asInteger printPaddedWith: $0 to: 2 base: 16).! !

WABatchedList subclass: #SSBatchedList
	instanceVariableNames: 'displayedPages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeEnd
	^ self maxPages
		min: self currentPage + (self displayedPages / 2)! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeStart
	^ 1 max: self currentPage - (self displayedPages)! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages
	^displayedPages! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages: anInteger
	displayedPages := anInteger! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:55'!
firstPage
	self currentPage: 1! !

!SSBatchedList methodsFor: 'initialize-release' stamp: 'pmm 7/10/2005 14:57'!
initialize
	super initialize.
	self displayedPages: 10! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 15:04'!
items: aCollection
	super items: aCollection.
	self currentPage: (self maxPages min: self currentPage)! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:56'!
lastPage
	self currentPage: self maxPages! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 15:06'!
maxPages
	^ 1 max: (items size / batchSize) ceiling! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 16:37'!
nextPage
	self isOnLastPage ifFalse: [
		self currentPage:
			(self maxPages min: self currentPage + (self displayedPages / 2)) ]! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:04'!
pageRangeEnd
	| basicStart increment |
	basicStart := self basicPageRangeStart.
	increment := (self displayedPages / 2) + (self currentPage - basicStart).
	^ self maxPages
		min: self currentPage + increment! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:03'!
pageRangeStart
	| increment basicEnd |
	basicEnd := self basicPageRangeEnd.
	increment := (self displayedPages / 2) + (basicEnd - self currentPage).
	^ 1 max: self currentPage - increment! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 16:37'!
previousPage
	self isOnFirstPage ifFalse: [
		self currentPage: (1 max: currentPage - (self displayedPages / 2)) ]! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:34'!
renderFirstOn: html
	self pageRangeStart = 1 ifFalse: [
		html anchorWithAction: [self currentPage: 1 ] text: '1'.
		html space.
		self pageRangeStart = 2 ifFalse: [
			html text: '...'.
			html space ] ].! !

!SSBatchedList methodsFor: 'rendering' stamp: 'bf 12/20/2005 00:24'!
renderLastOn: html
	self pageRangeEnd = self maxPages ifFalse: [
		html space.
		self pageRangeEnd = (self maxPages - 1) ifFalse: [
			html text: '...'.
			html space ].
		html anchorWithAction: [self currentPage: self maxPages ] text: self maxPages.
		html space ].
	! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:33'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [
			html attributes title: 'next'.
			html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:34'!
renderPagesOn: html
	self renderFirstOn: html.
	super renderPagesOn: html.
	self renderLastOn: html.! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:33'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ 
			html attributes title: 'previous'.
			html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

WAControllerSession subclass: #SSSession
	instanceVariableNames: 'request user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSSession methodsFor: 'actions' stamp: 'avi 9/24/2004 02:24'!
blessingDeniedFor: aProject
	^ WAGenericResponse new
		status: '500';
		nextPutAll: 'You cannot bless that version.';
		yourself
		
	! !

!SSSession methodsFor: 'request handling' stamp: 'bf 5/25/2005 13:37'!
createRootFromRequest: aRequest
	"Make a project home page for projectname.html"
	| accessPath frame |
	frame _ super createRootFromRequest: aRequest.
	accessPath _ aRequest accessPath.
	accessPath size > 0 ifTrue: [
		(self projectNamed: (accessPath first copyUpToLast: $.))
			ifNotNilDo: [:project | frame setComponent: project view]].
	^ frame! !

!SSSession methodsFor: 'private' stamp: 'al 3/9/2004 18:17'!
downloadTypeOfCurrentRequest
	| agent |
	agent _ self request headers
		at: 'user-agent'
		ifAbsent: [ 'unknown' ].
	^(agent beginsWith: 'Squeak')
		ifTrue: [ #Squeak ]
		ifFalse: [ #Web ]! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 1/17/2006 22:54'!
enterSession: aBlock
	^ monitor critical: [
		self withEscapeContinuation: [
			self withErrorHandler: [
				self alwaysRedirect ifTrue: [ self redirect ].
				aBlock value ] ] ]! !

!SSSession methodsFor: 'request handling' stamp: 'bf 12/15/2004 15:41'!
enterSessionWithRequest: aRequest
	" This method is overridden to hock-in requests coming from monticello, it isn't used while being in a seaside session. "

	^self withRequest: aRequest do: [ 
		aRequest method = 'PUT'
			ifTrue: [ self handleProject: #putRequest: ]
			ifFalse: [
				(self wantsSessionForRequest: aRequest)
					ifTrue: [ super enterSessionWithRequest: aRequest ]
					ifFalse: [ self handleProject: #getRequest: ] ] ]! !

!SSSession methodsFor: 'errors' stamp: 'lr 2/15/2004 23:09'!
errorNotFound: aString
	self returnResponse: (WANotFoundResponse location: aString).! !

!SSSession methodsFor: 'errors' stamp: 'bf 12/15/2004 12:31'!
errorPageClass
	(user notNil and: [user isSuperUser])
		ifTrue: [^WAWalkbackPage].
	
	^ super errorPageClass! !

!SSSession methodsFor: 'actions' stamp: 'avi 9/23/2004 22:43'!
getBlessed: aProject
	| component |
	component _ SSBlessedVersionListing session: self project: aProject.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'bf 5/20/2005 12:18'!
getConfig: aConfig
	^ self returnResponse: (WAGenericResponse
		document: (String streamContents: [:strm | aConfig fileOutOn: strm])
		mimeType: 'text/plain')
! !

!SSSession methodsFor: 'actions' stamp: 'bf 5/30/2005 18:22'!
getDiff: fileName from: aProject
	| verName version diffData |
	verName _ MCDiffyVersion verNameFrom: fileName.
	version _ aProject versionAt: verName, '.mcz'.
	version ifNil: [ self errorNotFound: fileName ].
	self returnResponse: ((self isAllowed: SSAccessPolicy read for: version in: aProject)
		ifFalse: [ WABasicAuthResponse realm: aProject title ]
		ifTrue: [
			diffData _ version getDiff: fileName in: aProject.
			diffData ifNil: [ self errorNotFound: fileName ].
			version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
			WAGenericResponse
				document: diffData
				mimeType: 'application/monticello' ])! !

!SSSession methodsFor: 'actions' stamp: 'bf 5/26/2005 18:15'!
getFile: aProject
	| fileName |
	fileName _ self request accessPath second.
	fileName = 'feed.rss'
		ifTrue: [ ^self getRss: aProject ].
	aProject configs at: fileName
		ifPresent: [:aConfig | ^ self getConfig: aConfig].		
	fileName = 'blessed'
		ifTrue:	[self request accessPath size > 2
					ifTrue: [fileName _ self request accessPath third]
					ifFalse: [^ self getBlessed: aProject]].
	(fileName endsWith: MCMcdReader extension)
		ifTrue: [^self getDiff: fileName from: aProject].
	self getVersion: fileName from: aProject! !

!SSSession methodsFor: 'actions' stamp: 'lr 2/15/2004 17:05'!
getListing: aProject
	| component |
	component _ SSDirectoryListing session: self project: aProject.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'lr 2/15/2004 17:05'!
getRequest: aProject
	self expire.
	self request accessPath size > 1
		ifTrue: [ self getFile: aProject ]
		ifFalse: [ self getListing: aProject ] ! !

!SSSession methodsFor: 'actions' stamp: 'bf 5/25/2005 11:20'!
getRss
	| component |
	component _ SSRssListing session: self projects: self repository visibleProjects.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'lr 2/14/2004 13:15'!
getRss: aProject
	| component |
	component _ SSRssListing session: self project: aProject.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'bf 5/26/2005 18:13'!
getVersion: fileName from: aProject
	| version |
	version _ aProject 
		versionAt: fileName
		ifAbsent: [ self errorNotFound: fileName ].
	self returnResponse: ((self isAllowed: SSAccessPolicy read for: version in: aProject)
		ifFalse: [ WABasicAuthResponse realm: aProject title ]
		ifTrue: [ 
			version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
			WAGenericResponse
				document: (self storage loadMonticello: version from: aProject)
				mimeType: 'application/monticello' ])! !

!SSSession methodsFor: 'request handling' stamp: 'bf 5/26/2005 18:32'!
handleProject: aSymbol 
	" This method looks-up the project if outside a seaside-session and if successfull initializes a stateless environment with error-handler and escape continuation that can be used similarly while while inside a session. "

	^self withErrorHandler: [
		self withEscapeContinuation: [
			| accessPath project |
			accessPath _ self request accessPath.
			project _ self projectNamed: accessPath first.
			project isNil 
				ifTrue: [ 
					accessPath first = 'feed.rss'
						ifTrue: [ self getRss ]
						ifFalse: [ self errorNotFound: accessPath first ] ]
				ifFalse: [ self perform: aSymbol with: project ] ] ]! !

!SSSession methodsFor: 'testing' stamp: 'lr 2/2/2004 12:55'!
isAllowed: aSymbol for: aVersion in: aProject
	^aProject isMember: self user allowedTo: aSymbol for: aVersion! !

!SSSession methodsFor: 'testing' stamp: 'lr 2/1/2004 19:09'!
isAllowed: aSymbol in: aProject
	^aProject isMember: self user allowedTo: aSymbol! !

!SSSession methodsFor: 'testing' stamp: 'lr 2/6/2004 18:42'!
isSuperUser
	^self isValidUser
		and: [ self user isSuperUser ]! !

!SSSession methodsFor: 'testing' stamp: 'lr 1/31/2004 18:27'!
isValidUser
	^self user notNil! !

!SSSession methodsFor: 'actions' stamp: 'lr 3/15/2004 17:49'!
login: aMember
	user _ aMember! !

!SSSession methodsFor: 'actions' stamp: 'lr 3/15/2004 17:02'!
logout
	isActive _ false.
	user _ nil.! !

!SSSession methodsFor: 'private' stamp: 'bf 5/25/2005 13:36'!
projectNamed: aString

	^(self repository projectAt: aString) ifNotNilDo: [:project |
		(self isAllowed: SSAccessPolicy read in: project)
			ifTrue: [project]]! !

!SSSession methodsFor: 'actions' stamp: 'bf 9/30/2005 11:24'!
putRequest: aProject
	| author data version response blessed |
	self expire.
	(self isAllowed: SSAccessPolicy write in: aProject)
		ifFalse: [ self returnResponse: (WABasicAuthResponse realm: aProject title) ].
	author _ self user ifNil: [ SSMember anonymousMember ].
	self storage log: 'PUT ', self request url, ' (', author initials, ')'.
	data _ self request at: 'PUTData'.
	(self request url endsWith: '.mcm')
		ifTrue: [aProject addConfig: data author: author url: self request url]
		ifFalse: [version := aProject addVersion: data author: author].
	(version notNil and: [self request accessPath second = 'blessed'])
		ifTrue: [blessed _ true.
				aProject blessVersion: version ifForbidden: 
					[blessed _ false]].
	self save.
	response _ SSCreatedResponse new.
	blessed ifNotNil:
		[blessed
			ifTrue: [response nextPutAll: 'Version blessed']
			ifFalse: [response nextPutAll: 'Version NOT blessed']].
	self returnResponse: response! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 17:24'!
repository
	^SSRepository current
	! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 22:00'!
request
	^request! !

!SSSession methodsFor: 'request handling' stamp: 'lr 2/15/2004 16:58'!
responseForRequest: aRequest
	" This method is overridden to hock-in requests coming from seaside. "

	^self withRequest: aRequest do: [ 
		super responseForRequest: aRequest ]! !

!SSSession methodsFor: 'actions' stamp: 'al 1/17/2006 16:27'!
save
	"self storage saveRepository: self repository."! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:18'!
storage
	^SSRepository storage
	! !

!SSSession methodsFor: 'accessing' stamp: 'lr 2/1/2004 18:35'!
user
	user isNil ifTrue: [ 
		user _ self repository 
			authenticateUser: request user
			password: request password ].
	^user! !

!SSSession methodsFor: 'actions' stamp: 'avi 9/23/2004 23:44'!
verifyBlessingOf: dataString project: aProject
	^ false! !

!SSSession methodsFor: 'request handling' stamp: 'bf 5/25/2005 13:39'!
wantsSessionForRequest: aRequest
	"We want to start a regular session if the path is empty or a project home page (projectname.html)"
	| accessPath fileName baseName |
	accessPath _ aRequest accessPath.
	accessPath size = 0 ifTrue: [^true].
	accessPath size > 1 ifTrue: [^false].
	fileName _ accessPath first.
	(fileName endsWith: '.html') ifFalse: [^false].
	baseName _ fileName copyUpToLast: $. .
	^ (self projectNamed: baseName) notNil! !

!SSSession methodsFor: 'request handling' stamp: 'lr 2/15/2004 16:58'!
withRequest: aRequest do: aBlock
	" We have to make sure that all those dirty huge requests are thrown away after the request has been processed. "

	request _ aRequest.
	^aBlock
		ensure: [ request _ nil ]! !

MWEditorVisitor subclass: #SSEditorVisitor
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSEditorVisitor class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 11:23'!
metaobject: aMetaobject heading: aString
	^(self metaobject: aMetaobject)
		heading: aString;
		yourself! !

!SSEditorVisitor methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:21'!
heading
	^heading! !

!SSEditorVisitor methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:21'!
heading: aString
	heading _ aString! !

!SSEditorVisitor methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:57'!
renderButtonsOn: html
	html break.
	html submitButtonWithAction: [ self save ] text: 'Save'.
	html submitButtonWithAction: [ self cancel ] text: 'Cancel' ! !

!SSEditorVisitor methodsFor: 'rendering' stamp: 'lr 2/8/2004 11:21'!
renderContentOn: html
	html heading: self heading.
	super renderContentOn: html.! !

!SSEditorVisitor methodsFor: 'rendering' stamp: 'lr 2/8/2004 11:22'!
renderLabel: aString control: aBlock
	renderer attributes valign: #top.
	renderer
		tableRowWithLabel: aString , ':'
		column: aBlock! !

!SSEditorVisitor methodsFor: 'accessing' stamp: 'bf 12/19/2005 15:27'!
repository
	^SSRepository current! !

!SSEditorVisitor methodsFor: 'accessing' stamp: 'bf 5/25/2005 14:42'!
resetModel
	self cancel! !

!SSEditorVisitor methodsFor: 'accessing' stamp: 'lr 2/6/2004 16:29'!
style
	^nil! !

SSEditorVisitor subclass: #SSProjectEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSProjectEditor methodsFor: 'actions' stamp: 'lr 3/22/2004 19:07'!
chooseMemberFrom: aCollection heading: aString
	^self call: (SSSimpleObjectChooser 
		model: (aCollection asSortedCollection: [ :x :y | x name <= y name ])
		heading: aString)! !

!SSProjectEditor methodsFor: 'testing' stamp: 'al 2/3/2004 20:38'!
isCreatingNewProject
	self metaobject attributeOf: #id ifAbsent: [ ^false ].
	^true! !

!SSProjectEditor methodsFor: 'rendering' stamp: 'lr 3/19/2004 19:20'!
renderIntroductionTextOn: html
	self isCreatingNewProject ifTrue: [
		html paragraph: 'To register a new project please fill-in the following form. Note that the project name has to be unique within SqueakSource, it cannot be changed after registration and should not contain blanks or other special characters.' ].
	html paragraph: [
		html render: 'SqueakSource allows a fine-grained control about the people being allowed to read, write and admin your project. The following settings are available:' ].
	html unorderedList: [
		html listItem: 'Global specifies the default right for users not being marked as guest, developer or administrator of this project.'.
		html listItem: 'Administrators are allowed to edit the project settings, to update the rss-feed, to make releases and to open and save versions.'.
		html listItem: 'Developers are allowed to open and save versions.'.
		html listItem: 'Guests are allowed to open versions.' ].! !

!SSProjectEditor methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:54'!
renderMainOn: html	
	self renderIntroductionTextOn: html.
	html layoutTable: [
		self renderValidationErrorsOn: html.
		self renderFieldsOn: html.
		self renderMemberListForAttribute: (self metaobject attributeOf: #admins) on: html.
		self renderMemberListForAttribute: (self metaobject attributeOf: #developers) on: html.
		self renderMemberListForAttribute: (self metaobject attributeOf: #guests) on: html.
		html tableRowWith: [ html space ] span: 2.
		html tableRowWith: [ self renderButtonsOn: html ] span: 2 ]! !

!SSProjectEditor methodsFor: 'rendering' stamp: 'bf 12/15/2005 19:24'!
renderMemberListForAttribute: anAttribute on: html
	html attributes valign: #top.
	html
		tableRowWith: [
			html spanClass: 'label' with: anAttribute label , ':'.
			html text: ' ('.
			html
				anchorWithAction: [
					(self 
						chooseMemberFrom: ((self repository members, self repository groups)
							copyWithoutAll: anAttribute cache) 
						heading: 'Add ' , (anAttribute label allButLast))
						ifNotNilDo: [ :member | anAttribute cache add: member ] ]
				text: 'add'.
			html render: ')' ]
		with:  [
			anAttribute cache
				do: [ :member |
					html render: member fullname.
					html space.
					html 
						text: '(';
						anchorWithAction: [ anAttribute cache remove: member ] text: 'remove';
						text: ')' ]
				separatedBy: [ html break ] ]
				! !

!Stream methodsFor: '*squeaksource-override' stamp: 'bf 7/28/2005 13:01'!
printOn: stream

	super printOn: stream.
"	stream space.
	self contents printOn: stream.
"! !

WAGenericResponse subclass: #SSCreatedResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSCreatedResponse methodsFor: 'accessing' stamp: 'lr 1/29/2004 12:08'!
status
	^'201'! !

!WAHtmlBuilder methodsFor: '*SqueakSource' stamp: 'pmm 7/10/2005 11:02'!
lefDoubleArrow
	self text: '&lArr;'! !

!WAHtmlBuilder methodsFor: '*SqueakSource' stamp: 'lr 3/19/2004 13:17'!
orderedList: aBlock
	self tag: 'ol' do: aBlock! !

!WAHtmlBuilder methodsFor: '*SqueakSource' stamp: 'pmm 7/10/2005 11:02'!
rightDoubleArrow
	self text: '&rArr;'! !

!WAHtmlBuilder methodsFor: '*SqueakSource' stamp: 'lr 2/11/2004 10:34'!
textWithCr: aString
	| stream |
	stream _ aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: (stream upTo: Character cr).
		stream atEnd ifFalse: [ self break ] ].! !

!WAHtmlBuilder methodsFor: '*SqueakSource' stamp: 'lr 3/19/2004 13:17'!
unorderedList: aBlock
	self tag: 'ul' do: aBlock! !

WATabPanel subclass: #SSTabPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:26'!
renderComponentOn: html
	html render: self selectedTab! !

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:25'!
renderContentOn: html
	self renderTabsOn: html.
	self renderLineOn: html.
	self renderComponentOn: html.! !

!SSTabPanel methodsFor: 'rendering' stamp: 'al 4/30/2004 12:35'!
renderLineOn: html
	html layoutTableOfWidth: '100%' do: [
		html cssClass: 'TabLine'.
		html tableRowWith: [
			html text: '<img width="1" height="1" src="" alt="" />' ] ]! !

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:30'!
renderTabSpacerOn: html
	html 
		cssClass: 'TabSpacer'; 
		tableData: nil! !

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:27'!
renderTabsOn: html
	html layoutTable: [
		html tableRow: [
			self renderTabSpacerOn: html.
			tabs 
				do: [ :each | self renderTab: each value named: each key on: html ]
				separatedBy: [ self renderTabSpacerOn: html ] ] ]! !

!SSTabPanel methodsFor: 'style' stamp: 'lr 3/19/2004 09:12'!
style
	^nil! !

WAKom subclass: #SSKom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSKom class methodsFor: 'accessing' stamp: 'pmm 7/9/2005 09:33'!
default
	| application |
	application _ (WAApplication path: String new)
		sessionClass: SSSession;
		preferenceAt: #entryPoint put: SSFrame;
		preferenceAt: #showToolbar put: false;
		preferenceAt: #errorPage put: WAEmailErrorPage;
		yourself.
	^self handler: application! !

!ZipArchive methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:31'!
writeEndOfCentralDirectoryTo: aStream

	aStream nextPutAll: EndOfCentralDirectorySignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: 0. "diskNumber"
	aStream nextLittleEndianNumber: 2 put: 0. "diskNumberWithStartOfCentralDirectory"
	aStream nextLittleEndianNumber: 2 put: members size. "numberOfCentralDirectoriesOnThisDisk"
	aStream nextLittleEndianNumber: 2 put: members size. "numberOfCentralDirectories"
	aStream nextLittleEndianNumber: 4 put: writeEOCDOffset - writeCentralDirectoryOffset. "size of central dir"
	aStream nextLittleEndianNumber: 4 put: writeCentralDirectoryOffset. "offset of central dir"
	aStream nextLittleEndianNumber: 2 put: zipFileComment size. "zip file comment"
	zipFileComment isEmpty ifFalse: [ aStream nextPutAll: zipFileComment ].

! !

WAComponent subclass: #SSComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

SSComponent subclass: #SSBrowser
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSBrowser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:17'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSBrowser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:16'!
heading
	^heading! !

!SSBrowser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:16'!
heading: aString
	heading _ aString! !

!SSBrowser methodsFor: 'rendering' stamp: 'al 2/7/2004 18:45'!
renderButtonsOn: html
	html form: [
		html submitButtonWithAction: [ self model switchBeInstance ] text: 'Instance'.
		html space.
		html submitButtonWithAction: [ self model switchBeComment ] text: 'Comment'.
		html space.
		html submitButtonWithAction: [ self model switchBeClass ] text: 'Class' ].
! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:53'!
renderColumnsOn: html
	| columns |
	columns _ #(category class protocol method) collect: [ :each |
		WAPluggableSelectBox
			on: self model
			list: (each , 'List') asSymbol
			selected: (each , 'Selection') asSymbol
			changeSelected: (each , 'Selection:') asSymbol ].
	html layoutTable: [
		html tableRow: [
			columns do: [ :each | 
				html tableData: each ] ] ].! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 2/4/2004 19:11'!
renderContentOn: html
	self renderTitleOn: html.
	self renderColumnsOn: html.
	self renderButtonsOn: html.
	self renderTextOn: html.! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 2/4/2004 19:05'!
renderTextOn: html
	html pre: self model text! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 2/8/2004 12:17'!
renderTitleOn: html
	html heading: self heading.! !

!SSComponent class methodsFor: 'instance creation' stamp: 'lr 1/26/2004 16:21'!
model: aModel
	^self new
		setModel: aModel;
		yourself! !

!SSComponent methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:26'!
actions
	^Array new! !

!SSComponent methodsFor: 'actions' stamp: 'bf 12/15/2005 19:47'!
editSettings
	| metaobject |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: SSRepository current) ].
	self session isSuperUser ifFalse: [
			self inform: 'Only the administrator is allowed to change repository settings!!'.
			^self answer].
	metaobject _ self session repository metaobject.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Repository Settings'))
		ifNotNil: [ self session save ].! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:31'!
loginMember
	self call: (SSLogin model: self model)! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:30'!
logoutMember
	self session logout! !

!SSComponent methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:20'!
model
	^model! !

!SSComponent methodsFor: 'actions' stamp: 'bf 12/15/2005 19:22'!
registerGroup
	| metaobject |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: SSRepository current) ].
	self session isValidUser ifFalse: [^self].
	
	self session isSuperUser ifFalse: [
		self inform: 'Only the <a href="mailto:',
			self repository superUserEmail
			,'">administrator</a> can create groups!!'.
		^self].

	metaobject _ SSGroup new metaobjectRegister.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Register Group'))
		ifNotNilDo: [ :group | 
			self model addGroup: group.
			self session save ].
! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/23/2004 14:00'!
registerMember
	| metaobject |
	metaobject _ SSMember new metaobjectRegister.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Register Member')) ifNotNilDo: [ :member | 
		self model addMember: member.
		self session isValidUser ifFalse: [
			self session login: member ].
		self session save ].! !

!SSComponent methodsFor: 'actions' stamp: 'bf 12/15/2005 19:23'!
registerProject
	| metaobject |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: SSRepository current) ].
	self session isValidUser ifTrue: [
		(self repository allowRegisterProject
			or: [self session user superuser]) ifFalse: [
				self inform: 'On this server, only the  <a href="mailto:',
					self repository superUserEmail
					,'">administrator</a> can create new projects!!'.
				^self answer].
		metaobject _ (SSProject creator: self session user) metaobjectRegister.
		(self call: (SSProjectEditor metaobject: metaobject heading: 'Register Project')) ifNotNilDo: [ :project | 
			self model addProject: project.
			self session save.
			self call: project view ] ].! !

!SSComponent methodsFor: 'accessing' stamp: 'bf 12/15/2005 19:22'!
repository
	^self session repository! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 2/4/2004 09:55'!
resetModel
	self setModel: self model.! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 1/26/2004 16:21'!
setModel: aModel
	model _ aModel! !

SSComponent subclass: #SSGroupView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSGroupView methodsFor: 'accessing' stamp: 'bf 5/24/2005 18:16'!
actions
	^#( 'Edit' edit ) ,
		super actions! !

!SSGroupView methodsFor: 'actions' stamp: 'bf 12/15/2005 19:23'!
edit
	| metaobject |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: SSRepository current) ].
	self session isValidUser ifFalse: [^self].
	
	self session isSuperUser ifFalse: [
		self inform: 'Only the <a href="mailto:',
			self repository superUserEmail,
			'">administrator</a> can edit groups!!'.
		^self].

	metaobject _ self model metaobjectEdit.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Edit Group'))
		ifNotNil: [ self session save ]
! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:27'!
renderContentOn: html
	self renderTitleOn: html.
	self renderTableOn: html.! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 18:09'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html attributeAt: #width put: '100px'.
			html tableData: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html 
							anchorWithAction: [ self call: each view ] 
							text: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:28'!
renderTableOn: html
	html layoutTable: [
		self renderList: self model members label: 'Members:' on: html.
	]! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:26'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model id , ')'! !

SSComponent subclass: #SSGroups
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSGroups methodsFor: 'actions' stamp: 'bf 5/24/2005 15:21'!
registerGroup
	super registerGroup.
	self resetModel.

! !

!SSGroups methodsFor: 'rendering' stamp: 'pmm 7/10/2005 10:49'!
renderContentOn: html
	html heading: 'Groups'.
	self renderGroupsOn: html.! !

!SSGroups methodsFor: 'rendering' stamp: 'pmm 7/10/2005 10:48'!
renderGroupsOn: html
	html break.
	self report rows isEmpty
		ifFalse: [ html render: self report ]
		ifTrue: [
			html italic: 'No groups available' ]! !

!SSGroups methodsFor: 'accessing' stamp: 'bf 12/15/2005 23:53'!
report
	^report! !

!SSGroups methodsFor: 'initialization' stamp: 'bf 5/24/2005 18:12'!
setModel: aModel
	| sort renderMember |
	super setModel: aModel.
	renderMember _ [ :item :html |
		item
			do: [ :each | html anchorWithAction: [ self call: each view ] text: each initials ]
			separatedBy: [ html text: ', ' ] ].
	report _ SSTableReport new
		rowPeriod: 1;
		rows: aModel groups;
		columns: {
			sort _ WAReportColumn 
				selector: #fullname 
				title: 'Name' 
				onClick: [ :item | self call: item view ].
			WAReportColumn
				selector: #id
				title: 'id'.
			(WAReportColumn
				selector: #members
				title: 'Members')
				formatBlock: renderMember;
				sortBlock: nil;
				yourself.
			};
		sortColumn: sort;
		yourself.! !

SSComponent subclass: #SSHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSHelp methodsFor: 'rendering' stamp: 'lr 3/19/2004 13:28'!
renderContentOn: html
	html heading: 'Help'.
	self renderWhatIsOn: html.
	self renderHowToSqueakOn: html.
	self renderHowToProjectOn: html.! !

!SSHelp methodsFor: 'rendering' stamp: 'bf 12/15/2005 19:23'!
renderHowToProjectOn: html
	html heading: 'How to create a project?' level: 2.
	self repository allowRegisterProject
		ifTrue: [
			html paragraph: [
				html render: 'To create a new project you need to have a SqueakSource account ('.
				html anchorWithAction: [ self registerMember ] text: 'Register member'.
				html render: ') and you need to be logged-in ('.
				html anchorWithAction: [ self loginMember ] text: 'Login'.
				html render: '). Then you are able to create any number of new projects ('.
				html anchorWithAction: [ self registerProject ] text: 'Register Project'.
				html render: '), by filling-in the project form. '.
				html render: 'You will find some additional information concerning this step at the top of the project-registration dialog.' ]]
		ifFalse: [
			html paragraph: [
				html render: 'On this server, only the  <a href="mailto:',
					self repository superUserEmail,
					'">administrator</a> can create new projects ('.
				html anchorWithAction: [ self registerProject ] text: 'Register Project'.
				html render: ').' ]].
	html paragraph: [
		html render: 'The newly created project is now shown in the list with all the projects you are involved in below your name on the left. The following tabs are available in the project-view:' ].
	html unorderedList: [
		html listItem: 'Overview: Project''s description, members, registration template and some statistics. Use the registration template to create a new repository in your monticello client.'.
		html listItem: [ 
			html text: 'Wiki: Each project has its own wiki that can be modified by developers and admins. The syntax is similar to the one of SmallWiki:'.
			html unorderedList: [
				html listItem: 'Paragraph: A carriage return becomes a new paragraph.'.
				html listItem: 'Headers: A line starting with one or more <code>!!</code> becomes a header.'.
				html listItem: 'Horizontal Rule: A line starting with <code>_</code> becomes a horizotal rule.'.
				html listItem: 'Lists: A block of lines starting with <code>#</code> or <code>-</code> becomes a ordered-/unordered list.'.
				html listItem: 'Preformatted: A block of lines starting with <code>=</code> becomes preformatted.'.
				html listItem: 'Links: Text beteween stars becomes an internal (e.g. <code>*My Page*</code>) or an external reference (e.g <code>*http://www.google.com*</code>).'.
				html listItem: 'XHTML: Use any valid XHTML tags withing your code.' ] ].
		html listItem: 'RSS-Feed: Administrators are able to add custom messages to the project-feed by clicking on ''Add Message''. They will show up on this tab-panel and in the rss-feed of the project.'.
		html listItem: 'Releases: Releases are committed versions that have been released. They are public and readable by everybody. To remove a release select ''details->Remove Release''. Releases do show up automatically in the rss-feed of the project.'.
		html listItem: 'Versions: This list shows all commits that have not been tagged as releases. To create a release or create a SqueakMap release, click on ''details/release''. This view shows details about the versions and let you make a release or browse the code in your web-browser.'. ].! !

!SSHelp methodsFor: 'rendering' stamp: 'lr 3/19/2004 19:18'!
renderHowToSqueakOn: html.
	html heading: 'How to use SqueakSource?' level: 2.
	html paragraph: [
		html render: 'To use SqueakSource you have to create a project, what is described below, and to install the '.
		html anchorWithUrl: 'http://minnow.cc.gatech.edu/squeak/1287' do: 'Monticello'.
		html render: ' client into your Squeak image:' ].
	html orderedList: [
		html listItem: 'Open the ''Package Loader'' from the world-menu.'.
		html listItem: 'Load the most recent versions of ''MCInstaller'' and ''Monticello''.'.
		html listItem: 'Open the ''Monticello Browser'' from the world-menu.'.
		html listItem: 'Click ''+Repository'' and choose ''HTTP'' to add the SqueakSource repository to the ''Monticello Browser''.'.
		html listItem: 'Copy and paste the registration-string from the overview-tab of your project into the dialog and add your password manually.'.
		html listItem: 'Now you should be able to open and save versions of your project into that repository.' ].! !

!SSHelp methodsFor: 'rendering' stamp: 'lr 3/19/2004 13:18'!
renderWhatIsOn: html.
	html heading: 'What is SqueakSource?' level: 2. 
	html paragraph: 'SqueakSource is a monticello code repository server which hosts your projects. You  connect to it with the monticello client to commit and load code. SqueakSource also implements a web-frontend (which you are looking at) which makes it easy to create and admin your projects or browse other public projects.'.
	html paragraph: 'The creator of a project assigns the global access-policy and which people are administrators, developers and guests. Further-on the committed versions of your code can be marked as releases to be public accessible. Other feature are to automatically register a release on SqueakMap or browse the code with your web-browser using a similar interface like the code-browser of squeak. RSS-Feeds of all SqueakSource projects and of single projects are available: They show all public versions and releases plus additional items created by the project admin.'.! !

SSComponent subclass: #SSHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSHome methodsFor: 'configuration' stamp: 'lr 2/19/2004 12:59'!
defaultLongSize
	^20! !

!SSHome methodsFor: 'configuration' stamp: 'lr 2/7/2004 13:45'!
defaultShortSize
	^3! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
membersActive
	^self statistics membersActive! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
membersNew
	^self statistics membersNew! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsActive
	^self statistics projectsActive! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsDownloads
	^self statistics projectsDownloads! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsNew
	^self statistics projectsNew! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:40'!
projectsRecent
	^self statistics projectsRecent! !

!SSHome methodsFor: 'rendering' stamp: 'bf 12/15/2005 17:40'!
renderContentOn: html
	self renderTitleOn: html.
	self renderIntroductionOn: html.
	"
	self renderStatisticsOn: html
	"
	self session user ifNotNil: [ self session isSuperUser
		ifTrue: [self renderLogOn: html]].
! !

!SSHome methodsFor: 'rendering' stamp: 'bf 12/15/2005 19:29'!
renderIntroductionOn: html
	self repository introText withBlanksTrimmed isEmpty ifFalse: [
		^(self repository introText findTokens: String cr) do: [:para | 
			html paragraph: [
				html render: para]]].

	html paragraph: [
		html render: 'Welcome to SqueakSource, the smart Monticello code-repository for Squeak. To get started register your personal account and create any number of projects to host on our server. You''ll immediately get all the necessary permissions to create and manage your account, projects and versions. Detailed instructions can be found on the '.
		html anchorWithAction: [ self call: (SSHelp model: self model) ] text: 'Help'.
		html render: ' page.' ].
	
	html paragraph: 'This service is brought to you for free: it is hosted on a Solaris server that is backed up daily. Still, please make sure that you have proper backups and note that we cannot give any accessibility guarantees. However, if you wish you can set up your own SqueakSource server. It is self-hosted and can be downloaded from SqueakMap.'.

	html paragraph: 'Please report any problems or suggestions to the <a href="mailto:squeak-dev@lists.squeakfoundation.org">Squeak Mailing-List</a>. Enjoy!!'! !

!SSHome methodsFor: 'rendering' stamp: 'lr 3/15/2004 16:25'!
renderLabel: aString list: aListSelector click: aClickSelector more: aMoreSelector on: html
	| fullCollection shortCollection |
	fullCollection _ self perform: aListSelector.
	fullCollection _ fullCollection first: (self defaultLongSize min: fullCollection size).
	fullCollection isEmpty ifFalse: [
		shortCollection _ fullCollection first: (self defaultShortSize min: fullCollection size).
		html tableRow: [
			html attributeAt: #width put: '120px'.
			html tableData: aString , ':'.
			html tableData: [
				shortCollection
					do: [ :each | 
						html 
							anchorWithAction: [ self perform: aClickSelector with: each ] 
							text: each asString ]
					separatedBy: [ html text: ', ' ].
				shortCollection size < fullCollection size ifTrue: [ 
					html text: ', '.
					html 
						anchorWithAction: [ self perform: aMoreSelector with: fullCollection with: aString ] 
						text: '...' ] ] ] ]! !

!SSHome methodsFor: 'rendering' stamp: 'bf 9/30/2005 12:32'!
renderLogOn: html
	html heading: 'Log' level: 2.
	html text: '(showing last 2 KB, up to 100 KB '.
	html anchorWithAction: [
		self session returnResponse: (WAGenericResponse
			document: (self session storage getLogOfSize: 100000)
			mimeType: 'text/plain')
		] text: 'here'.
	html text: ')'.
	html preformatted: [
		| log |
		log := (self session storage getLogOfSize: 2000) readStream.
		log upTo: Character cr.
		html text: log upToEnd ]! !

!SSHome methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:54'!
renderStatisticsOn: html
	html heading: 'Statistics' level: 2.
	html heading: 'Members (' , self model membersCount asString , ')' level: 3.
	html layoutTable: [
		self renderLabel: 'Recently Joined' list: #membersNew click: #showMember: more: #showMoreMembers:titled: on: html.
		self renderLabel: 'Most Active' list: #membersActive click: #showMember: more: #showMoreMembers:titled: on: html ].
	html heading: 'Projects (' , self model projectsCount asString , ')' level: 3.
	html layoutTable: [
		self renderLabel: 'Recently Created' list: #projectsNew click: #showProject: more: #showMoreProjects:titled: on: html.
		self renderLabel: 'Recently Used' list: #projectsRecent click: #showProject: more: #showMoreProjects:titled: on: html.
		self renderLabel: 'Most Active' list: #projectsActive click: #showProject: more: #showMoreProjects:titled: on: html.
		self renderLabel: 'Most Downloads' list: #projectsDownloads click: #showProject: more: #showMoreProjects:titled: on: html ].! !

!SSHome methodsFor: 'rendering' stamp: 'lr 3/15/2004 19:28'!
renderTitleOn: html
	html heading: 'Home'.! !

!SSHome methodsFor: 'actions' stamp: 'bf 5/24/2005 18:09'!
showMember: aMember
	self call: aMember view! !

!SSHome methodsFor: 'actions' stamp: 'lr 2/19/2004 13:06'!
showMoreMembers: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchorWithAction: [ self showMember: value ] text: value ];
		yourself)! !

!SSHome methodsFor: 'actions' stamp: 'lr 2/19/2004 12:57'!
showMoreProjects: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchorWithAction: [ self showProject: value ] text: value ];
		yourself)! !

!SSHome methodsFor: 'actions' stamp: 'bf 5/24/2005 18:13'!
showProject: aProject
	self call: aProject view! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
statistics
	^self model statistics! !

SSComponent subclass: #SSListPrinter
	instanceVariableNames: 'renderBlock title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:23'!
renderBlock
	^renderBlock! !

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:23'!
renderBlock: aBlock
	renderBlock _ aBlock! !

!SSListPrinter methodsFor: 'rendering' stamp: 'lr 2/19/2004 13:00'!
renderContentOn: html
	html heading: self title.
	html tag: 'ol' do: [
		self model do: [ :each |
			html tag: 'li' do: [
				self renderBlock value: html value: each ] ] ].
	html form: [ 
		html submitButtonWithAction: [ self answer ] text: 'Close' ].! !

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:55'!
title
	^title! !

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:55'!
title: aString
	title _ aString! !

SSComponent subclass: #SSLogin
	instanceVariableNames: 'username password loginFailed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSLogin methodsFor: 'actions' stamp: 'lr 3/15/2004 18:04'!
cancel
	self answer! !

!SSLogin methodsFor: 'actions' stamp: 'al 3/29/2004 22:13'!
login
	self session login: (self model
		authenticateUser: self username
		password: self password).
	self session isValidUser
		ifTrue: [ self answer ]
		ifFalse: [ loginFailed _ true ]! !

!SSLogin methodsFor: 'accessing' stamp: 'al 3/29/2004 22:13'!
loginFailed
	loginFailed ifNil: [^false].
	^loginFailed! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
password
	^password! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
password: aString
	password _ aString! !

!SSLogin methodsFor: 'rendering' stamp: 'al 3/29/2004 22:10'!
renderContentOn: html
	self renderTitleOn: html.
	self renderFormOn: html.
	self renderForgottonpasswordOn: html! !

!SSLogin methodsFor: 'rendering' stamp: 'lr 3/30/2004 18:50'!
renderForgottonpasswordOn: html
	| linkBlock |
	linkBlock _ [html
		anchorWithAction: [ self sendPassword ]
		text: 'I forgot my password' ].
	html break.
	self loginFailed
		ifTrue: [ html bold: linkBlock ]
		ifFalse: [ html render: linkBlock ]! !

!SSLogin methodsFor: 'rendering' stamp: 'al 3/29/2004 22:11'!
renderFormOn: html
	html form: [
		html layoutTable: [
			html tableRow: [
				html attributeAt: #width put: '80px'.
				html tableData: 'Initials:'.
				html tableData: [ html textInputOn: #username of: self ] ].
			html tableRow: [
				html tableData: 'Password:'.
				html tableData: [ html passwordInputOn: #password of: self ] ] ].
		html break.
		html submitButtonWithAction: [ self login ] text: 'Login'.
		html space.
		html submitButtonWithAction: [ self cancel ] text: 'Cancel' ].! !

!SSLogin methodsFor: 'rendering' stamp: 'lr 3/15/2004 17:59'!
renderTitleOn: html
	html heading: 'Login'.! !

!SSLogin methodsFor: 'actions' stamp: 'al 3/29/2004 22:07'!
sendPassword
	self call: (SSSendPassword model: self model)! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
username
	^username! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
username: aString
	username _ aString! !

SSComponent subclass: #SSMemberView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSMemberView methodsFor: 'accessing' stamp: 'lr 2/6/2004 18:44'!
actions
	^(self session user = self model or: [ self session isSuperUser ])
		ifTrue: [ #( 'Edit' edit ) ]
		ifFalse: [ super actions ]! !

!SSMemberView methodsFor: 'actions' stamp: 'bf 1/7/2006 13:29'!
edit
	| metaobject |
	metaobject _ self model metaobjectEdit.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Edit Member'))
		ifNotNil: [self session save].! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:03'!
renderContentOn: html
	self renderTitleOn: html.
	self renderDescriptionOn: html.
	self renderTableOn: html.! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:03'!
renderDescriptionOn: html
	self model description isNil ifFalse: [
		html textWithCr: self model description ].! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:31'!
renderEmailOn: html
	self model email isEmptyOrNil ifFalse: [
		html tableRow: [
			html attributeAt: #width put: '100px'.
			html tableData: 'E-Mail:'.
		 	html tableData: [ 
				html anchorWithUrl: 'mailto:' , self model email do: self model email ] ] ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'bf 5/24/2005 18:07'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html attributeAt: #width put: '100px'.
			html tableData: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html 
							anchorWithAction: [ self call: each view ] 
							text: each title ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSMemberView methodsFor: 'rendering' stamp: 'bf 5/24/2005 18:21'!
renderTableOn: html
	html layoutTable: [
		self renderEmailOn: html.
		self renderList: self model adminInProjects label: 'Admin:' on: html.
		self renderList: self model developerInProjects label: 'Developer:' on: html.
		self renderList: self model guestInProjects label: 'Guest:' on: html.
		self renderList: self model groups label: 'Groups:' on: html ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:04'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model initials , ')'! !

SSComponent subclass: #SSMembers
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSMembers methodsFor: 'actions' stamp: 'lr 3/15/2004 18:27'!
registerMember
	super registerMember.
	self resetModel.

! !

!SSMembers methodsFor: 'rendering' stamp: 'lr 2/4/2004 23:30'!
renderContentOn: html
	html heading: 'Members'.
	html render: report.! !

!SSMembers methodsFor: 'initialization' stamp: 'pmm 1/18/2006 23:37'!
setModel: aModel
	| sort |
	super setModel: aModel.
	report _ SSTableReport new
		rowPeriod: 1;
		rows: aModel members;
		columns: {
			sort _ WAReportColumn 
				selector: #fullname 
				title: 'Name' 
				onClick: [ :item | self call: item view ].
			WAReportColumn
				selector: #initials
				title: 'Initials'.
			(WAReportColumn
				selector: #projectCount
				title: 'Projects')
				sortBlock: [ :a : b | a > b];
				yourself.
			(WAReportColumn
				selector: #commitCount
				title: 'Commits')
				sortBlock: [ :a : b | a > b];
				yourself. };
		sortColumn: sort;
		yourself.! !

SSComponent subclass: #SSProjectRSS
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSProjectRSS methodsFor: 'rendering' stamp: 'bf 12/19/2005 17:24'!
renderContentOn: html
	batchedList batch isEmpty
		ifTrue: [ html italic: 'No feed available' ]
		ifFalse: [ self renderFeedListingOn: html ]! !

!SSProjectRSS methodsFor: 'rendering' stamp: 'lr 3/19/2004 13:46'!
renderFeedListingOn: html
	html layoutTableOfWidth: '100%' do: [ 
		batchedList batch do: [ :each |
			html cssClass: 'TabUnselected'.
			html tableRow: [
				html attributeAt: 'align' put: 'left'.
				html tableData: [
					html strong: each title ].
				html attributeAt: 'align' put: 'right'.
				html tableData: [
					html render: each author.
					html text: ', '.
					html render: each timestamp ] ].
			html 
				tableRowWith: [ html textWithCr: each message ]
				span: 3.
			html
				tableRowWith: [ html space ]
				span: 3 ] ].
	batchedList maxPages > 1 ifTrue: [ 
		html render: batchedList ]! !

!SSProjectRSS methodsFor: 'initialization' stamp: 'bf 12/20/2005 00:15'!
setModel: aModel
	super setModel: aModel.
	batchedList _ SSBatchedList new
		batchSize: 10;
		items: self sortedItems;
		yourself! !

!SSProjectRSS methodsFor: 'accessing' stamp: 'bf 12/19/2005 12:37'!
sortedItems
	^(SortedCollection sortBlock: [:a :b | a timestamp > b timestamp])
		addAll: model feeds;
		addAll: model versions;
		yourself! !

SSComponent subclass: #SSProjectView
	instanceVariableNames: 'releaseReport versionReport latestReport tabPanel feed wiki blessingReport searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 7/9/2005 12:26'!
actions
	^Array streamContents: [ :stream |
		stream nextPut: 'RSS feed'; nextPut: self model fullUrl , '/feed.rss'.
		(self model isMember: self session user allowedTo: SSAccessPolicy admin) ifTrue: [
			stream nextPutAll: #( 'Add Message' rss ).
			stream nextPutAll: #( 'Edit Project' edit ).
			stream nextPutAll: #( 'Delete Project' delete ) ].
		(self model isMember: self session user allowedTo: SSAccessPolicy write)
			ifTrue: [ stream nextPutAll: #( 'Import Versions' import ) ] ].! !

!SSProjectView methodsFor: 'accessing' stamp: 'avi 9/23/2004 21:49'!
blessedVersions
	^ self model allBlessedVersions
		select: [:ea | ea notNil and:
						[self model 
							isMember: self session user 
							allowedTo: SSAccessPolicy read
							for: ea] ]! !

!SSProjectView methodsFor: 'initialization' stamp: 'avi 9/23/2004 16:21'!
blessingReportColumns
	^(Array
		with: (WAReportColumn 
			selector: #package 
			title: 'Package')),
	self reportColumns
! !

!SSProjectView methodsFor: 'actions' stamp: 'bf 12/15/2005 19:24'!
delete
	(self confirm: 'You are about to delete the project ''', self model title, '''. All data and version information will be lost!! Are you sure you really want to delete this project?') ifTrue: [
		self repository removeProject: self model.
		self session save.
		self session expire ]! !

!SSProjectView methodsFor: 'actions' stamp: 'lr 2/9/2004 12:23'!
edit
	self call: (SSProjectEditor metaobject: self model metaobjectEdit heading: 'Edit Project').
	self session save.! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 1/18/2006 07:16'!
feedUrl
	^SSRepository rootUrl , self model id , '/feed.rss'! !

!SSProjectView methodsFor: 'private' stamp: 'bf 12/19/2005 10:11'!
filter: someVersions
	searchText isEmptyOrNil ifTrue: [
		^someVersions].
	^(searchText includes: $*)
		ifTrue: [
			someVersions select: [ :each |
				each stringsSatisfy: [:str |
					searchText match: str]]]
		ifFalse: [
			someVersions select: [ :each |
				each stringsSatisfy: [ :str |
					str includesSubstring: searchText
						caseSensitive: false]]].
! !

!SSProjectView methodsFor: 'actions' stamp: 'lr 2/9/2004 12:23'!
import
	self call: (SSVersionImporter model: self model).
	self session save.! !

!SSProjectView methodsFor: 'initialization' stamp: 'lr 3/19/2004 10:12'!
initializeFeed
	feed _ SSProjectRSS model: self model! !

!SSProjectView methodsFor: 'initialization' stamp: 'bf 5/20/2005 12:06'!
initializeReports
	releaseReport _ SSTableReport new
		columns: self reportColumns;
		rowPeriod: 1;
		yourself.
	versionReport _ SSTableReport new
		columns: self reportColumns;
		rowPeriod: 1;
		yourself.
	latestReport _ SSTableReport new
		columns: self reportColumns;
		rowPeriod: 1;
		yourself.
	blessingReport _ SSTableReport new
		columns: self blessingReportColumns;
		rowPeriod: 1;
		yourself! !

!SSProjectView methodsFor: 'initialization' stamp: 'bf 5/20/2005 12:19'!
initializeTabPanel
	tabPanel _ SSTabPanel new
		addTab: [ :html | self renderOverviewOn: html ] named: 'Overview';
		addTab: [ :html | self renderWikiOn: html ] named: 'Wiki';
		addTab: [ :html | self renderRssFeedOn: html ] named: 'RSS Feed';
		addTab: [ :html | self renderReleasesOn: html ] named: 'Releases';
		yourself.
		
	self model canBless ifTrue:
		[tabPanel addTab: [ :html | self renderBlessedVersionsOn: html] named: 'Blessings'].
	
	tabPanel
		addTab: [ :html | self renderVersionsOn: html ] named: 'Versions';
		addTab: [ :html | self renderLatestOn: html ] named: 'Latest'
! !

!SSProjectView methodsFor: 'accessing' stamp: 'bf 3/18/2005 17:12'!
latest
	^self model latestVersions select: [ :each |
		self model 
			isMember: self session user 
			allowedTo: SSAccessPolicy read
			for: each ]! !

!SSProjectView methodsFor: 'accessing' stamp: 'lr 2/13/2004 12:29'!
releases
	^self model releasesSorted! !

!SSProjectView methodsFor: 'rendering' stamp: 'bf 12/20/2005 18:51'!
renderBlessedVersionsOn: html
	html break.
	self renderSearchOn: html.
	html break.
	blessingReport rows isEmpty
		ifFalse: [ html render: blessingReport ]
		ifTrue: [ html italic: (String streamContents: [:stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'blessed versions available'])]! !

!SSProjectView methodsFor: 'rendering' stamp: 'al 3/18/2004 22:57'!
renderContentOn: html
	self resetReports.
	self renderTitleOn: html.
	html render: tabPanel! !

!SSProjectView methodsFor: 'rendering' stamp: 'al 3/18/2004 23:30'!
renderDescriptionOn: html
	html heading: 'Project Description' level: 2.
	html paragraph: self model description! !

!SSProjectView methodsFor: 'rendering-head' stamp: 'pmm 1/18/2006 07:21'!
renderHeadElementsOn: html
	super renderHeadElementsOn: html.
	html rssLinkWithUrl: self feedUrl title: self model title.! !

!SSProjectView methodsFor: 'rendering' stamp: 'bf 12/19/2005 10:34'!
renderLatestOn: html
	html break.
	self renderSearchOn: html.
	html break.
	latestReport rows isEmpty
		ifFalse: [ html render: latestReport ]
		ifTrue: [
			html italic: (String streamContents: [:stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available'])]
! !

!SSProjectView methodsFor: 'rendering' stamp: 'bf 5/24/2005 18:10'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html attributeAt: #width put: '120px'.
			html tableData: aString.
			html tableData: [
				aCollection
					do: [ :each |
						html
							anchorWithAction: [ self call: each view ]
							text: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSProjectView methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:32'!
renderMembersOn: html
	html heading: 'Members' level: 2.
	html layoutTable: [
		self renderList: self model creators label: 'Creator:' on: html.
		self renderList: self model admins label: 'Admin:' on: html.
		self renderList: self model developers label: 'Developer:' on: html.
		self renderList: self model guests label: 'Guests:' on: html ].! !

!SSProjectView methodsFor: 'rendering' stamp: 'al 3/18/2004 23:26'!
renderOverviewOn: html
	self renderDescriptionOn: html.
	self renderMembersOn: html.
	self renderRegistrationOn: html.
	self renderStatisticsOn: html.
	! !

!SSProjectView methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:33'!
renderRegistrationOn: html
	html heading: 'Registration' level: 2.
	html pre: [
		html text: 'MCHttpRepository'; break.
		html text: '    location: '; text: self model fullUrl printString; break.
		html text: '    user: '; text: (self session isValidUser
			ifTrue: [ self session user initials ]
			ifFalse: [ String new ]) printString; break.
		html text: '    password: '; text: String new printString; break ].! !

!SSProjectView methodsFor: 'rendering' stamp: 'bf 12/19/2005 10:33'!
renderReleasesOn: html
	html break.
	self renderSearchOn: html.
	html break.
	releaseReport rows isEmpty
		ifFalse: [ html render: releaseReport ]
		ifTrue: [ html italic: 'No ',
			(searchText isEmptyOrNil
				ifTrue: ['']
				ifFalse: ['matching ' ]),
			'releases available' ]! !

!SSProjectView methodsFor: 'rendering' stamp: 'lr 3/28/2004 20:19'!
renderRssFeedOn: html
	html break; render: feed.! !

!SSProjectView methodsFor: 'rendering' stamp: 'pmm 1/18/2006 22:16'!
renderSearchOn: html
	html form: [
		html textInputOn: #searchText of: self.
		html space.
		html submitButtonWithAction: [ self search ] text: 'Search'  ].
! !

!SSProjectView methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:55'!
renderStatisticsOn: html
	html heading: 'Statistics' level: 2.
	html layoutTable: [
		html tableRow: [
			html attributeAt: #width put: '120px'.
			html tableData: 'Registered:'.
			html tableData: self model timestamp ].
		html tableRowWithLabel: 'Total Releases:' column: self model numberOfReleases.
		html tableRowWithLabel: 'Total Versions:' column: self model numberOfNormalVersions.
		html tableRowWithLabel: 'Total Downloads:' column: self model numberOfTotalDownloads ].! !

!SSProjectView methodsFor: 'rendering' stamp: 'al 3/18/2004 23:26'!
renderTitleOn: html
	html heading: self model title level: 1! !

!SSProjectView methodsFor: 'rendering' stamp: 'bf 12/19/2005 10:32'!
renderVersionsOn: html
	html break.
	self renderSearchOn: html.
	html break.
	versionReport rows isEmpty
		ifFalse: [ html render: versionReport ]
		ifTrue: [
			html italic: (String streamContents: [:stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available'])]
! !

!SSProjectView methodsFor: 'rendering' stamp: 'lr 3/27/2004 10:15'!
renderWikiOn: html
	html render: self wiki! !

!SSProjectView methodsFor: 'initialization' stamp: 'pmm 1/18/2006 23:47'!
reportColumns
	^Array
		with: (WAReportColumn 
			selector: #fileName 
			title: 'Filename' 
			onClick: [ :each | self call: (SSVersionView project: self model version: each) ])
		with: (WAReportColumn 
			selector: #author 
			title: 'Author'
			onFormat: [ :each :html |
				each isNil
					ifTrue: [ html text: 'unknown' ]
					ifFalse: [ 
						html 
							anchorWithAction: [ self call: each view ]
							text: each name ] ])
		with: ((WAReportColumn
			selector: #timestamp
			title: 'Timestamp'
			onFormat: [ :each | each date yyyymmdd , ' ' , each time print24 ])
			sortBlock: [ :a :b | a > b];
			yourself)
		with: ((WAReportColumn 
			selector: #yourself 
			title: 'Actions' 
			onFormat: [ :each :html | 
				html anchorWithAction: [ self call: (SSVersionView project: self model version: each) ] text: 'details'.
				html space.
				html anchorWithUrl: (each url: self model) do: 'download' ])
			sortBlock: nil;
			yourself)! !

!SSProjectView methodsFor: 'private' stamp: 'bf 12/19/2005 10:12'!
resetReports
	releaseReport rows: (self filter: self releases).
	versionReport rows: (self filter: self versions).
	latestReport rows: (self filter: self latest).
	blessingReport rows: (self filter: self blessedVersions).
! !

!SSProjectView methodsFor: 'actions' stamp: 'lr 3/19/2004 10:28'!
rss
	| entry |
	entry _ SSFeedEntry new
		author: self session user;
		title: self model title;
		message: String new;
		yourself.
	entry _ self call: (SSEditorVisitor metaobject: entry metaobject heading: 'Add Message').
	entry isNil ifFalse: [
		self model feeds add: entry.
		self resetModel.
		self session save ]! !

!SSProjectView methodsFor: 'actions' stamp: 'bf 12/19/2005 10:13'!
search
	self resetReports.! !

!SSProjectView methodsFor: 'accessing' stamp: 'bf 12/19/2005 10:16'!
searchText
	^searchText! !

!SSProjectView methodsFor: 'accessing' stamp: 'bf 12/19/2005 17:16'!
searchText: aString
	searchText := aString ifNotNil: [aString withBlanksTrimmed]! !

!SSProjectView methodsFor: 'initialization' stamp: 'lr 3/19/2004 10:12'!
setModel: aModel
	super setModel: aModel.
	self initializeFeed.
	self initializeReports.
	self initializeTabPanel.! !

!SSProjectView methodsFor: 'accessing' stamp: 'lr 2/13/2004 12:29'!
versions
	^self model versionsSorted select: [ :each |
		each isRelease not and: [
			self model 
				isMember: self session user 
				allowedTo: SSAccessPolicy read
				for: each ] ]! !

!SSProjectView methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:10'!
wiki
	wiki isNil 
		ifTrue: [ wiki _ SSWiki on: self model ].
	^wiki! !

SSComponent subclass: #SSProjects
	instanceVariableNames: 'report searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSProjects methodsFor: 'actions' stamp: 'lr 3/15/2004 19:50'!
registerProject
	super registerProject.
	self resetModel.! !

!SSProjects methodsFor: 'rendering' stamp: 'pmm 7/9/2005 09:52'!
renderContentOn: html
	html heading: 'Projects'.
	self renderSearchOn: html.
	html render: report! !

!SSProjects methodsFor: 'rendering' stamp: 'pmm 1/18/2006 22:16'!
renderSearchOn: html
	html form: [
		html textInputOn: #searchText of: self.
		html space.
		html submitButtonWithAction: [ self search ] text: 'Search'  ].
	html break.! !

!SSProjects methodsFor: 'actions' stamp: 'bf 12/19/2005 10:00'!
search
	| all found |
	all := self model visibleProjects.
	searchText isEmptyOrNil ifTrue: [
		^report rows: all].
	found := (searchText includes: $*)
		ifTrue: [
			all select: [ :each |
				each stringsSatisfy: [:str |
					searchText match: str]]]
		ifFalse: [
			all select: [ :each |
				each stringsSatisfy: [ :str |
					str includesSubstring: searchText
						caseSensitive: false]]].
	report rows: found.! !

!SSProjects methodsFor: 'accessing' stamp: 'pmm 7/9/2005 09:57'!
searchText
	^searchText! !

!SSProjects methodsFor: 'accessing' stamp: 'bf 12/19/2005 17:16'!
searchText: aString
	searchText := aString ifNotNil: [aString withBlanksTrimmed]! !

!SSProjects methodsFor: 'initialization' stamp: 'pmm 1/18/2006 22:32'!
setModel: aModel
	| maxActivity renderMember sort |
	super setModel: aModel.
	maxActivity _ aModel maxActivity.
	renderMember _ [ :item :html |
		item
			do: [ :each | html anchorWithAction: [ self call: each view ] text: each initials ]
			separatedBy: [ html text: ', ' ] ].
	report _ SSTableReport new
		rowPeriod: 1;
		rows: aModel visibleProjects;
		columns: {
			sort _ WAReportColumn 
				selector: #title 
				title: 'Project' 
				onClick: [ :item | self call: (item view searchText: searchText) ].
			(WAReportColumn			
				selector: #admins
				title: 'Admins')
				formatBlock: renderMember;
				sortBlock: nil;
				yourself.
			(WAReportColumn
				selector: #developers
				title: 'Developers')
				formatBlock: renderMember;
				sortBlock: nil;
				yourself.
			(WAReportColumn
				selector: #guests
				title: 'Guests')
				formatBlock: renderMember;
				sortBlock: nil;
				yourself.
			(WAReportColumn
				selector: #activity
				title: 'Activity')
				formatBlock: [ :each :html |
					html attributes cellspacing: 0; cellpadding: 0; align: #center.
					html table: [
						html tableRow: [
							html attributes bgcolor: (Color activity: each / maxActivity) asHTMLColor.
							html tableData: [ html space; space; space ]] ] ];
				sortBlock: [ :a : b | a > b];
				yourself.
			(WAReportColumn
				selector: #numberOfTotalDownloads
				title: 'Downloads')
				sortBlock: [ :a : b | a > b];
				yourself };
		sortColumn: sort;
		yourself.
	self searchText isEmptyOrNil
		ifFalse: [self search].! !

SSComponent subclass: #SSRegisterSqueakMap
	instanceVariableNames: 'default form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSRegisterSqueakMap methodsFor: 'private' stamp: 'al 3/3/2004 18:38'!
metaobject
	| metaobject |
	metaobject _ MWMetaobject for: self.
	metaobject textAttribute: #package do: [ :attribute | 
		attribute
			label: 'Package';
			addRequiredRule ].
	metaobject textAttribute: #username do: [ :attribute | 
		attribute
			label: 'User';
			addRequiredRule ].
	metaobject passwordAttribute: #password do: [ :attribute | 
		attribute
			label: 'Password';
			addRequiredRule ].
	metaobject textAttribute: #versionComment do: [ :attribute | 
		attribute
			label: 'Version Comment';
			multiLine: true ].
	^metaobject! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
package
	^default 
		propertyAt: SSVersion smPackageProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
package: aString
	self version 
		propertyAt: SSVersion smPackageProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
password
	^default 
		propertyAt: SSVersion smPasswordProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
password: aString
	self version 
		propertyAt: SSVersion smPasswordProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
project
	^self model first! !

!SSRegisterSqueakMap methodsFor: 'rendering' stamp: 'lr 2/11/2004 11:21'!
renderContentOn: html
	html render: form! !

!SSRegisterSqueakMap methodsFor: 'initialization' stamp: 'al 3/3/2004 18:38'!
setModel: aModel
	super setModel: aModel.
	default _ (self version propertyIncludes: SSVersion smPackageProperty)
		ifTrue: [ self version ]
		ifFalse: [
			self project versionsSorted
				detect: [ :each | 
					each packageName = self version packageName 
						and: [ each propertyIncludes: SSVersion smPackageProperty ] ]
				ifNone: [ SSVersion new ] ].
	form _ SSEditorVisitor
		metaobject: self metaobject 
		heading: 'SqueakMap Release for ' , self version fileName.
	form onAnswer: [ :value | self answer: value ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
username
	^default 
		propertyAt: SSVersion smUsernameProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
username: aString
	self version 
		propertyAt: SSVersion smUsernameProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
version
	^self model second! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment
	^default 
		propertyAt: SSVersion smVersionCommentProperty 
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment: aString
	self version 
		propertyAt: SSVersion smVersionCommentProperty
		put: aString! !

SSComponent subclass: #SSSendPassword
	instanceVariableNames: 'initials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSSendPassword methodsFor: 'actions' stamp: 'lr 3/30/2004 18:38'!
cancel
	self answer: nil.! !

!SSSendPassword methodsFor: 'accessing' stamp: 'lr 3/30/2004 18:33'!
initials
	^initials! !

!SSSendPassword methodsFor: 'accessing' stamp: 'lr 3/30/2004 18:33'!
initials: aString
	initials _ aString! !

!SSSendPassword methodsFor: 'rendering' stamp: 'lr 3/30/2004 18:39'!
renderContentOn: html
	html heading: 'I forgot my password'.
	html render: 'You will get an e-mail with a secure url that takes you to your personal member-settings where you are able to set a new password. The url will be available for a few minutes only, so check your e-mail soon.'.
	html break; break.
	html form: [
		html layoutTable: [
		html tableRow: [
			html attributeAt: #width put: '80px'.
			html tableData: 'Initials: '.
			html tableData: [
				html attributeAt: #size put: '5'.
				html textInputOn: #initials of: self ] ] ].
		html break.
		html submitButtonWithAction: [ self send ] text: 'Send'; space.
		html submitButtonWithAction: [ self cancel ] text: 'Cancel' ].! !

!SSSendPassword methodsFor: 'actions' stamp: 'lr 3/30/2004 18:40'!
send
	self sendPasswordToUserWithLogin: self initials.! !

!SSSendPassword methodsFor: 'actions' stamp: 'bf 1/7/2006 13:23'!
sendMailWithUrl: aUrl toMember: aMember
	| messageText |
	messageText _ 'Hi ' , aMember fullname , '

You have requested to change your password of your SqueakSource account. Please navigate to: ' , aUrl , ' within the next minutes and fill in your new password.
	
Please report any problems to the squeak-dev mailing list.
	
' , SSRepository rootUrl.

	SeasidePlatformSupport
		deliverMailFrom: (SSRepository current superUserEmail findTokens: ',') first
		to: (Array with: aMember email)
		text: messageText! !

!SSSendPassword methodsFor: 'actions' stamp: 'bf 1/7/2006 13:35'!
sendPasswordToUserWithLogin: login
	| member url |
	member _ self model memberAt: login.
	member isNil ifTrue: [
		self inform: 'You specified an unknown account. Please contact the site-administrator.'.
		self answer ].
	member email isNil ifTrue: [
		self inform: 'No e-mail address specified for this account. Please contact the site-administrator.'.
		self answer ].
	member isSuperUser ifTrue: [
		self inform: 'Superusers shoud never forget their password.'.
		self answer ].
	Continuation currentDo: [ :cc | 
		url _ self session actionUrlForContinuation: cc.
		url _ SSRepository rootUrl , url copyWithoutFirst.
		[ self sendMailWithUrl: url toMember: member ]
			on: Exception
			do: [ :error | self inform: error messageText , '. Please contact the site-administrator.'; answer ].
		self inform: 'An e-mail has been successfully sent to you.'.
		self answer ].
	(self call: (SSEditorVisitor 
		metaobject: member metaobjectEdit 
		heading: 'Change your password'))
			ifNotNil: [self session save].
	self answer! !

SSComponent subclass: #SSSimpleObjectChooser
	instanceVariableNames: 'heading selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSSimpleObjectChooser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:03'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:02'!
heading
	^heading! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:02'!
heading: aString
	heading _ aString! !

!SSSimpleObjectChooser methodsFor: 'rendering' stamp: 'lr 3/22/2004 19:09'!
renderContentOn: html
	html heading: self heading.
	html form: [
		html attributeAt: 'size' put: 15.
		html attributeAt: 'style' put: 'width: 100%'.
		html 
			selectFromList: self model 
			selected: self selection
			callback: [ :value | self selection: value ].
		html break; break.
		html submitButtonWithAction: [ self answer: self selection ] text: 'Ok'.
		html submitButtonWithAction: [ self answer: nil ] text: 'Cancel' ].! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 3/22/2004 19:05'!
selection
	^selection! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 3/22/2004 19:05'!
selection: anObject
	selection _ anObject! !

SSComponent subclass: #SSVersionImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSVersionImporter methodsFor: 'rendering' stamp: 'lr 2/6/2004 16:51'!
renderContentOn: html
	self renderTitleOn: html.
	self renderUploadsOn: html.! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'lr 2/6/2004 16:51'!
renderTitleOn: html
	html heading: 'Import into ' , self model title.! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:57'!
renderUploadsOn: html
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html layoutTable: [
			1 to: 10 do: [ :each |
				html 
					tableRowWithLabel: each asString , ':'
					column: [
						html fileUploadWithCallback: [ :file | 
							file contents isEmpty
								ifFalse: [ self uploadFile: file ] ] ] ] ].
		html break.
		html submitButtonWithAction: [ self answer ] text: 'Upload' ].! !

!SSVersionImporter methodsFor: 'actions' stamp: 'bf 12/16/2004 20:00'!
uploadFile: aFile
	[
		| version |
	 	version := self model
			addVersion: aFile contents
			author: self session user.
		version setTimestampFromVersionInfo.
	]
		on: Error
		do: [ self inform: 'There was an error importing the file ', aFile fileName , '. The file has to be in mcz format!!' ] ! !

SSComponent subclass: #SSVersionView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSVersionView class methodsFor: 'instance creation' stamp: 'lr 2/4/2004 17:35'!
project: aProject version: aVersion
	^self model: (Array 
		with: aProject 
		with: aVersion)! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 1/10/2006 09:43'!
actions
	^Array streamContents: [ :stream |
		(self project isMember: self session user allowedTo: SSAccessPolicy read for: self version) ifTrue: [ 
			stream nextPutAll: #( 'Download Package' download ).
			stream nextPutAll: #( 'Browse Code' browse ).
			stream nextPutAll: #( 'Copy Version' copy ) ].
		(self project isMember: self session user allowedTo: SSAccessPolicy write for: self version) ifTrue: [ 
			stream nextPutAll: #( 'Move Version' move ).
			stream nextPutAll: #( 'Delete Version' delete ).
			stream nextPutAll: #( 'Delete Package' deleteAll ) ]. ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:52'!
bless
	self project blessVersion: self version ifForbidden: [self blessingForbidden]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 16:01'!
blessingForbidden
	self inform: 'You cannot bless ', self version fileName, ', because ', (self project blessedVersionForPackage: self version package) fileName , ' is not among its ancestors.  Please merge these two versions together first.'! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/8/2004 12:18'!
browse
	| reader browser |
	reader _ self version reader: self project.
	browser _ MCSnapshotBrowser forSnapshot: reader snapshot.
	self call: (SSBrowser model: browser heading: 'Browse ' , self version fileName).! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 1/10/2006 09:52'!
copy
	| user result |
	user := self session user.
	result := self call: (SSSimpleObjectChooser 
		model: ((SSRepository current visibleProjects
			select: [ :each |
				self project ~= each
					and: [ each isMember: user allowedTo: SSAccessPolicy write ] ])
			asSortedCollection: [ :x :y | x name <= y name ])
		heading: 'Select the project to copy "' , self version fileName , '" to:').
	result isNil ifTrue: [ ^ self ].
	result 
		addVersion: (SSRepository storage
			loadMonticello: self version
			from: self project)
		author: self version author.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'bf 3/18/2005 18:59'!
delete
	(self project isMember: self session user allowedTo: SSAccessPolicy admin for: self version)
		ifFalse: [^self inform: 'Only admins can delete versions!!'].

	(self confirm: 'Really delete version "', self version fileName,'"?')
		ifTrue: [
			self project deleteVersion: self version.
			self session save.
			self answer.
		].! !

!SSVersionView methodsFor: 'actions' stamp: 'bf 4/4/2005 12:23'!
deleteAll
	| all |
	(self project isMember: self session user allowedTo: SSAccessPolicy admin for: self version)
		ifFalse: [^self inform: 'Only admins can delete versions!!'].

	all := self project versions select: [:each |
		each packageName = self version packageName].
	(self confirm: (String streamContents: [:strm |
		strm nextPutAll: 'Really delete all versions of package "'.
		strm nextPutAll: self version packageName.
		strm nextPutAll: '"? <ul>'.
		all asSortedCollection
			do: [:each | strm nextPutAll: '<li>'.
					strm nextPutAll: each fileName.
					strm nextPutAll: '</li>'].
		strm nextPutAll: '</ul>']))
			ifTrue: [
				all do: [:each | self project deleteVersion: each].
				self session save.
				self answer.
			].! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/4/2004 18:35'!
download
	self session redirectTo: (self version url: self project).! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 1/10/2006 09:53'!
move
	| user result |
	user := self session user.
	result := self call: (SSSimpleObjectChooser 
		model: ((SSRepository current visibleProjects
			select: [ :each |
				self project ~= each
					and: [ each isMember: user allowedTo: SSAccessPolicy write ] ])
			asSortedCollection: [ :x :y | x name <= y name ])
		heading: 'Select the project to move "' , self version fileName , '" to:').
	result isNil ifTrue: [ ^ self ].
	result 
		addVersion: (SSRepository storage
			loadMonticello: self version
			from: self project)
		author: self version author.
	self project deleteVersion: self version.
	self session save.
	self answer.! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
project
	^self model first! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/11/2004 11:07'!
releaseCreate
	self version release: true.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/11/2004 12:22'!
releaseCreateSM
	| result |
	result _ self call: (SSRegisterSqueakMap model: self model).
	result isNil ifFalse: [
		result _ self version registerSqueakMap: self project.
		result isNil
			ifTrue: [ self version release: true. self session save ]
			ifFalse: [
				self session returnResponse: (WAGenericResponse
					document: result contents 
					mimeType: 'text/html') ] ]! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/11/2004 11:07'!
releaseRemove
	self version release: false.
	self session save.! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 4/7/2004 18:56'!
renderAncestorsOn: html
	| filename version |
	self version ancestors isEmpty ifFalse: [
		html tableRowWithLabel: 'Ancestors:' column: [
			self version ancestors 
				do: [ :each | 
					filename _ each name , '.mcz'.
					version _ self project versionAt: filename.
					self renderFilename: filename of: version on: html ]
				separatedBy: [ html text: ', ' ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'bf 5/24/2005 18:10'!
renderAuthorOn: html
	html tableRowWithLabel: 'Author:' column: [
		html
			anchorWithAction: [ self call: self version author view ]
			text: self version authorString ].! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:58'!
renderBlessingInfoOn: html
	| blessed |
	blessed _ self project blessedVersionForPackage: self version package.
	blessed ifNotNil:
		[blessed = self version
			ifTrue: [html strong: 'This is the currently blessed version for package ', blessed package printString]
			ifFalse: [html string: 'The currently blessed version of package ', blessed package printString, ' is ', blessed fileName]]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:31'!
renderButtonsOn: html
	html break.
	html form: [
		(self project isMember: self session user allowedTo: SSAccessPolicy admin)
			ifTrue:
				[self version isRelease 
					ifFalse: [ html submitButtonWithAction: [ self releaseCreate ] text: 'Create Release' ]
					ifTrue: [ html submitButtonWithAction: [ self releaseRemove ] text: 'Remove Release' ].
				html space; submitButtonWithAction: [ self releaseCreateSM ] text: 'SqueakMap Release'].
		(self project isMember: self session user allowedTo: SSAccessPolicy bless)
			ifTrue:
				[html space.
				(self project isVersionBlessed: self version)
					ifFalse: [ html submitButtonWithAction: [self bless] text: 'Bless']
					ifTrue: [ html submitButtonWithAction: [self unbless] text: 'Remove Blessing']].
	]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:57'!
renderContentOn: html
	html heading: self version fileName , (self version isRelease
		ifTrue: [ ' (Release)' ]
		ifFalse: [ String new ]).
	html layoutTable: [
		self renderFilenameOn: html.
		self renderAuthorOn: html.
		self renderTimestampOn: html.
		self renderUUIDOn: html.	
		self
			renderPackageList: self version ancestors 
			label: 'Ancestors:' on: html.
		self
			renderPackageList: self version dependencies 
			label: 'Dependencies:' on: html.
		self renderReleaseOn: html.
		self renderMessageOn: html.
		self renderStatisticsOn: html ].
	self renderButtonsOn: html.
	self renderBlessingInfoOn: html.! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 4/7/2004 19:04'!
renderFilename: aString of: aVersion on: html
	aVersion isNil
		ifTrue: [ html text: aString ]
		ifFalse: [ 
			(self session isAllowed: SSAccessPolicy allowAllRead for: aVersion in: self project)
				ifFalse: [ html text: aString ]
				ifTrue: [
					html
						anchorWithAction: [ self call: (SSVersionView project: self project version: aVersion) ]
						text: aString ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 3/19/2004 21:47'!
renderFilenameOn: html
	html tableRow: [
		html attributeAt: 'width' put: '100px'.
		html tableData: 'Filename:'.
		html tableData: [
			html
				anchorWithUrl: (self version url: self project) 
				do: self version fileName ] ]
! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 2/11/2004 10:35'!
renderMessageOn: html
	html tableRowWithLabel: 'Message:' column: [
		html textWithCr: self version message ].! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 4/7/2004 18:58'!
renderPackageList: aCollection label: aString on: html
	| filename version |
	aCollection isEmpty 
		ifTrue: [ ^self ].
	html tableRowWithLabel: aString column: [
		aCollection 
			do: [ :each |
				filename _ each name , '.mcz'.
				version _ self project versionAt: filename.
				self renderFilename: filename of: version on: html ]
			separatedBy: [ html text: ', ' ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 2/11/2004 11:15'!
renderReleaseOn: html
	self version isRelease ifTrue: [
		html tableRowWithLabel: 'Release:' column: 'This is a release that can be read by anybody.' ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'al 2/26/2004 22:10'!
renderStatisticsOn: html
	html tableRowWithLabel: 'Downloads:' column: [
		self version downloadStatistics isEmpty
			ifTrue: [ html render: 0 ]
			ifFalse: [
				self version downloadStatistics associationsDo: [ :assoc |
					html render: assoc key asString , ': '.
					html render: assoc value.
					html break ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 2/4/2004 17:51'!
renderTimestampOn: html
	html tableRowWithLabel: 'Timestamp:' column: self version timestamp.! !

!SSVersionView methodsFor: 'rendering' stamp: 'lr 2/4/2004 17:51'!
renderUUIDOn: html
	html tableRowWithLabel: 'UUID:' column: self version id.! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:49'!
unbless
	self project unblessVersion: self version! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
version
	^self model second! !

WAComponent subclass: #SSGenericFrame
	instanceVariableNames: 'style'
	classVariableNames: 'Back'
	poolDictionaries: ''
	category: 'SqueakSource-View'!

SSGenericFrame class
	instanceVariableNames: 'Logo'!

SSGenericFrame subclass: #SSFrame
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSFrame class methodsFor: 'private' stamp: 'lr 3/15/2004 15:28'!
formLogo
	"Transcript show: (JPEGReadWriter2 formFromFileNamed: 'ss.jpeg') storeString"

	^Form
		extent: 780 @ 50
		depth: 32
		fromArray: #(4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281934727 4281605763 4282132104 4285027750 4286936499 4287068590 4286937010 4287002556 4285883812 4284172693 4282921870 4281868934 4281737348 4282131590 4281802371 4282131339 4282065543 4281999751 4282197132 4281933960 4282131336 4282197381 4282921355 4285882292 4287003320 4287266229 4286871471 4285817767 4283514260 4282197129 4282394508 4282131586 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282460301 4282526346 4282460553 4282329483 4282461072 4282395279 4282395278 4282527116 4282657932 4282657932 4282592141 4282657934 4282592141 4282592139 4282789770 4282592390 4282592909 4282658702 4282723725 4282657932 4282789520 4282789520 4282723473 4282789266 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921874 4282921872 4282921872 4282856079 4282987663 4282987918 4283645848 4285290673 4287265467 4286673079 4285422506 4283909016 4283119504 4283053456 4283185042 4283119504 4283251090 4283185044 4283184792 4283382171 4283250837 4282988175 4283383187 4283251599 4284698793 4286936508 4288055742 4287990203 4286870709 4283975063 4283645079 4283447446 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369569 4284369567 4284369818 4285291426 4286936502 4287857855 4288186816 4288713415 4288516296 4288582086 4288648131 4288648131 4288516293 4286410668 4284896925 4284830882 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830371 4284764576 4284896162 4284896162 4284830369 4284961955 4284896162 4284896416 4284896165 4285093543 4285093543 4284896162 4284962209 4285028000 4285028000 4285291426 4285093541 4285159334 4285159334 4285159334 4285225127 4285159588 4285159586 4285422758 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285488805 4285291172 4285488551 4285554346 4285554344 4285620137 4285488805 4285554597 4285685930 4286344622 4288845512 4289109703 4289306827 4288582087 4286278833 4285751473 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286146734 4286278320 4287398078 4289240784 4289569482 4289635277 4288187331 4286146734 4286278067 4286278321 4286212777 4286344111 4286212527 4286409906 4286410158 4286278570 4286475951 4286344113 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286673587 4286739380 4286739634 4286739634 4286805427 4286871220 4286805427 4286937012 4287924410 4289569231 4289108680 4289503692 4290293457 4290161871 4290161622 4289240017 4287726780 4287200182 4287134391 4287134391 4287200184 4287002805 4287200184 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287463354 4287594940 4287792573 4287858366 4287924159 4288055745 4288253124 4288450503 4288647879 4289042637 4288976844 4288253122 4287660985 4287660985 4287726780 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4287989950 4288055743 4288187329 4288121535 4288450752 4289635275 4290688984 4290820820 4289963991 4288648131 4288253375 4288384961 4288253375 4288450500 4288450500 4288450500 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288648133 4288582338 4288713924 4288582338 4288845510 4290293208 4291215328 4291150039 4291017950 4289701836 4288714945 4288846276 4288845508 4288911303 4288648131 4288977096 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108934 4289108680 4289108682 4289108684 4289174477 4289371852 4289437898 4289437896 4289767882 4290096848 4289504457 4289307080 4289307082 4289109448 4289307082 4289241289 4289437899 4289569485 4289437899 4289503691 4289569484 4289503689 4289569482 4289569482 4289635278 4289701071 4289635277 4289701070 4289766863 4289766863 4289701070 4289898449 4289899469 4291478498 4291873762 4292005348 4291346912 4290360020 4289833422 4289833422 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290096845 4290096847 4289965008 4290030803 4290096598 4290030803 4290228180 4290228180 4290293722 4290293977 4290293975 4290294227 4291017947 4291873510 4291741922 4291610590 4291479004 4291347164 4291149785 4290952408 4290886615 4290820568 4290623191 4290425812 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291018201 4291479004 4292597484 4292729322 4292531943 4292202726 4291281371 4291017947 4291017947 4291083740 4291017947 4291017947 4291149787 4291149787 4291083994 4291149787 4291215329 4291149535 4291149787 4291610336 4292136933 4292400103 4292268517 4292005345 4292531941 4292663527 4292795115 4292795115 4292926701 4292992494 4292860654 4292663275 4292136680 4291873508 4291610336 4291544543 4291544543 4291610336 4291610336 4291676129 4291742176 4291676129 4291610336 4291741922 4291676383 4291742175 4292531689 4292992494 4293058285 4293058287 4292531689 4292005347 4291939555 4292005348 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268519 4292400103 4293058285 4293321456 4293387249 4293255664 4292663529 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292861419 4293321969 4293585141 4293585141 4293387762 4292993004 4292729833 4292729579 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293190383 4293519346 4293782772 4293848565 4293782770 4293848563 4293914358 4293848565 4293387762 4293256176 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4293782772 4293782772 4293782772 4293914358 4293914358 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294111735 4294111735 4294177528 4294177527 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294572285 4294638078 4294703871 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294572539 4294572539 4294638332 4294638332 4294704125 4294704125 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281539716 4281934476 4281934728 4283711639 4286738869 4287134130 4287200182 4286936761 4287002292 4286738618 4285290418 4282987415 4281671556 4281933957 4281999751 4281868167 4282065543 4281868165 4282065546 4281999753 4282131337 4282065797 4282329219 4283842457 4286213040 4287265978 4287331771 4286343860 4284106144 4282328716 4282131336 4282263174 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282328969 4282526346 4282526346 4282263690 4282329486 4282461071 4282724493 4282987916 4282987918 4282856077 4282658702 4282724241 4282526864 4282395276 4282592655 4282526862 4282526864 4282658450 4282789520 4282723725 4282789518 4282855311 4282789518 4282855311 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282856081 4282921872 4282987665 4282921872 4283053456 4282987663 4283053711 4283777434 4285159586 4284501404 4283514258 4282987918 4282987665 4283185044 4283119251 4282921870 4283118732 4283381906 4283119249 4282921870 4283119504 4283711641 4283514007 4283514007 4285489062 4287726528 4288121535 4287792573 4286212528 4283580053 4283579032 4283579286 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369567 4284435614 4284369820 4284699037 4285422758 4285686183 4285817767 4286278318 4286541742 4286936499 4287463097 4287726269 4287791809 4286212527 4284962209 4284698785 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830371 4284764576 4284896162 4284896162 4284896162 4284896162 4284830369 4285093795 4285159588 4284961955 4284961955 4285159336 4285225129 4285290920 4285093541 4284961955 4285159588 4285225127 4285159334 4285225127 4285356713 4285291174 4285159586 4285225379 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285554598 4285422758 4285554344 4285488553 4285488551 4285488551 4285554598 4285949355 4286015148 4287134391 4288977098 4289109703 4289504206 4288253121 4285884071 4285883311 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286146734 4286278320 4287266745 4289371852 4289767115 4289569482 4288055742 4286344365 4286344111 4286212777 4286212777 4286278318 4286146735 4286278320 4286409904 4286278570 4286344365 4286475699 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286739380 4286739380 4286739634 4286739634 4286805427 4286871220 4286871220 4287068598 4288845512 4290227414 4289964242 4290030033 4290293456 4290293457 4289700817 4288055743 4287200436 4287134389 4287134391 4287068598 4287200184 4287134391 4287331770 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287331768 4287397561 4287463608 4287463608 4287463608 4287529401 4287595194 4287726780 4287529399 4287660985 4287660985 4287529399 4287529401 4287660987 4287792573 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288121536 4288187329 4288055743 4288187329 4288253375 4289306313 4290688985 4290557398 4289174475 4288319166 4288253375 4288384961 4288319168 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288582338 4288648131 4288582338 4288779717 4289964243 4291017949 4291149785 4291017949 4290228180 4288912324 4288714694 4288779719 4288911305 4288977096 4288911301 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289240520 4289108934 4289240520 4289503692 4289569484 4289701068 4290293459 4291017180 4291215328 4291083743 4289965008 4289372873 4289307082 4289241289 4289504461 4289438668 4289503692 4289569485 4289503692 4289569485 4289635278 4289635278 4289766864 4289701071 4289635278 4289701071 4289635277 4289701070 4289766863 4289701070 4289701070 4289832656 4290162640 4291544545 4291807969 4291873762 4291149533 4290162387 4289833424 4289899217 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289899215 4289965008 4289965010 4290162391 4290162391 4290096596 4290162387 4290162387 4290096594 4290293973 4290425813 4290491603 4291149787 4291939301 4292136934 4292334312 4292268520 4292071141 4292070887 4292136680 4291939303 4291281119 4290820570 4290688984 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291018201 4291873762 4292400103 4292597736 4292597736 4292334312 4291741922 4291083994 4290886361 4291083740 4291083740 4291083740 4291083994 4291083994 4291083994 4291215580 4291083742 4291149533 4291544543 4292136934 4292597482 4292729068 4292729322 4292663529 4292729320 4292860908 4292992494 4292926447 4292729068 4292465898 4292136933 4291873761 4291807715 4291610336 4291478750 4291478750 4291544543 4291610336 4291610336 4291676129 4291741922 4291676129 4291610336 4291807715 4291742176 4291939554 4292794861 4293124080 4293058285 4292926701 4292400103 4291939554 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292531943 4293124078 4293387249 4293387249 4293189871 4292597736 4292334310 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292664039 4293124590 4293453553 4293585139 4293585139 4293387762 4293124591 4293058798 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293453553 4293782518 4293848565 4293848563 4293848565 4293782772 4293651186 4293256176 4293256176 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848565 4293848565 4293848565 4293782772 4293848565 4293848565 4293848565 4293782772 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294111735 4294111735 4294177528 4294177528 4294177527 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294572285 4294572285 4294638078 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281802374 4282131087 4281802890 4283053458 4286475446 4286870706 4287199925 4287199671 4287134130 4286673078 4284303776 4282263692 4281934474 4282131339 4282197132 4281933960 4282197129 4281933957 4281999751 4281999753 4281999753 4282065543 4282197383 4282460553 4284370333 4286278580 4286212787 4284632992 4283119251 4282262923 4282131336 4282197381 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282526348 4282394760 4282526348 4282526864 4282329485 4282395530 4283843223 4285751725 4285751471 4284567199 4283316879 4282921870 4282856081 4282724241 4282658450 4282395278 4282592657 4282658450 4282527116 4282657930 4282723723 4282723977 4282723723 4282723723 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921874 4282921872 4282921872 4282856079 4282987663 4283053456 4282921870 4283053711 4283514258 4283119502 4282856077 4282921874 4283118999 4283185046 4283185046 4283185044 4283250318 4283184527 4283513239 4283513241 4283381655 4283185297 4284830372 4285159588 4286542506 4287924410 4288055996 4287397563 4285356967 4283645848 4283513493 4283447699 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369821 4284369821 4284369821 4284435614 4284501407 4284435614 4284435614 4284698786 4284764828 4284896414 4285093793 4285093793 4285291174 4284896162 4284567199 4284567200 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830371 4284830369 4284896162 4284830369 4284896162 4284896162 4284961955 4285488553 4285620388 4285291425 4285225379 4285159334 4284830372 4284830372 4285159337 4285225129 4285093795 4285093795 4285027748 4285093541 4285225127 4285291174 4285291172 4285291172 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285423012 4285422758 4285488551 4285488553 4285488551 4285488551 4285751977 4286541492 4287331511 4288253122 4289240266 4289109703 4289175241 4287924156 4285950117 4285817769 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286212527 4287002805 4288911051 4289898196 4289635026 4288121538 4286475951 4286278572 4286278570 4286212779 4286278320 4286343860 4286212528 4286344111 4286344365 4286278572 4286475697 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286739380 4286739380 4286739634 4286805427 4286805427 4286871220 4286937013 4287265975 4289306059 4290096080 4290161873 4290359250 4290293456 4289898701 4288253373 4287332022 4286937264 4287200182 4287134391 4287002806 4287200184 4287134391 4287200184 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287463354 4287463354 4287463608 4287463608 4287463608 4287529401 4287529401 4287660987 4287529401 4287463608 4287595194 4287726780 4287726526 4287660733 4287660733 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288187328 4288187329 4287924157 4288253122 4288055742 4288779717 4290228184 4289767631 4288516547 4288121789 4288253375 4288384961 4288319168 4288318914 4288318914 4288450500 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288648131 4288582338 4288648131 4288713926 4289503692 4290754778 4291149785 4291149533 4290688985 4289043655 4288714440 4288911051 4288911305 4289108682 4288845762 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289174727 4289569484 4290030033 4290425043 4290885593 4291280605 4291477984 4291477984 4291478498 4291346914 4290491606 4290096594 4290030803 4289701838 4289570252 4289307080 4289503689 4289569484 4289437898 4289503692 4289503692 4289437645 4289635024 4289569233 4289635278 4289635278 4289635277 4289701070 4289766863 4289701070 4289701070 4289832656 4290557396 4291676129 4291873761 4291807715 4290952156 4290030803 4289701840 4289899219 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290096598 4290096598 4289965012 4290096598 4290096596 4290096594 4290294227 4290425812 4290557650 4290886615 4291281373 4291478750 4291873762 4292136934 4292136933 4292202726 4292202724 4292136933 4292202727 4292202473 4291676131 4290952154 4290491605 4290425813 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291018199 4292334313 4292334310 4292531941 4292663527 4292465896 4292465899 4291544543 4290952154 4291083740 4291083740 4291017947 4291083994 4291018201 4291018201 4291215580 4291083994 4291412957 4292005348 4292597482 4292795115 4292795115 4292795115 4292926701 4292926701 4292795115 4292663275 4292465898 4292136933 4291807969 4291544543 4291478750 4291544543 4291478750 4291478750 4291544543 4291610336 4291610336 4291610336 4291610336 4291676129 4291610336 4291676129 4291807715 4291742176 4292202726 4292992494 4293124080 4293058285 4292663529 4292136931 4291807968 4291873762 4291939555 4291873762 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292334310 4292663529 4293255664 4293453042 4293387249 4293058285 4292531943 4292334310 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292598246 4293058797 4293387760 4293519600 4293651186 4293716725 4293519348 4293321969 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293453553 4293782518 4293914358 4293848565 4293782772 4293585139 4293387760 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293848565 4293914358 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294177528 4294177528 4294177528 4294177528 4294177527 4294243320 4294243320 4294177527 4294177527 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294572285 4294572285 4294572539 4294638332 4294704125 4294769918 4294704125 4294704125 4294704125 4294769918 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281868167 4281802120 4281802374 4282658702 4285685678 4287002295 4287068339 4287199923 4286936751 4286278318 4283843477 4282000772 4281934728 4281933960 4281802374 4282197132 4282131336 4282065543 4282065544 4282065546 4281999753 4282065544 4282328715 4282262922 4282658698 4284172190 4283645844 4282198402 4281868932 4282131337 4282197130 4282131590 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282592139 4282394760 4282526348 4282592657 4282263692 4282395526 4284501658 4287199674 4287331258 4287133881 4286673078 4285817518 4284435614 4283316881 4282987663 4282856077 4282921870 4283711386 4283777434 4282987918 4282658183 4282789770 4282921104 4282789520 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921872 4282921872 4282987665 4282921872 4282921872 4283053456 4283119249 4283053456 4282921870 4282921870 4283053458 4283185046 4283119253 4282987667 4283053458 4283250835 4283381907 4283316114 4282987149 4283447700 4283184527 4283579788 4285883814 4287726267 4287660985 4287924410 4288253375 4287529147 4285356965 4284369567 4283645078 4283579285 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284435614 4284304028 4284369821 4284501153 4284501153 4284501153 4284501153 4284566948 4284632990 4284567199 4284567200 4284501407 4284567200 4284632993 4284764578 4284764578 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830371 4284896162 4284830369 4284764576 4284896162 4284896162 4285093541 4285949104 4287858364 4287200182 4286213036 4285554855 4285225894 4285159847 4285159847 4284830882 4285093793 4285225381 4285291174 4285290920 4285225127 4285159588 4285225379 4285291172 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285423012 4285422758 4285488551 4285422760 4285554344 4285488551 4285817770 4286738871 4288976587 4289240268 4289503692 4289372620 4289043657 4288516293 4287397561 4286278570 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286212527 4286278578 4286081450 4285818531 4286015911 4286147245 4286015406 4286081454 4286213036 4286475949 4286344111 4286475700 4286212528 4286212527 4286475951 4286344365 4286409904 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286937013 4287529399 4289635277 4290227663 4290227664 4290227664 4290096077 4289898449 4288516294 4287397815 4287068596 4287200184 4287068598 4287002806 4287200184 4287134391 4287068598 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463608 4287529401 4287529401 4287529401 4287726526 4287660733 4287660733 4287726526 4287726526 4287660733 4287660733 4287726526 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288187328 4288055743 4288253122 4288055743 4288384961 4289175245 4288780485 4288319168 4288253375 4288319168 4288319168 4288318914 4288318914 4288318914 4288516293 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288713924 4288648131 4288779719 4288648133 4289108680 4290491606 4291215580 4291215580 4290820571 4289241034 4288714440 4288976845 4288845258 4288911303 4288911555 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289503438 4290424793 4291280352 4291412189 4291412187 4291544027 4291609566 4291477980 4291544543 4291676131 4291346912 4291215328 4291215328 4291017949 4291017949 4290952156 4290754007 4290754007 4290622422 4290425045 4289964242 4289569485 4289635024 4289569231 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289766863 4289964242 4290820822 4291742176 4291873761 4291741922 4290754778 4289899219 4289636047 4289833426 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290030805 4290030803 4289965010 4290228180 4290491606 4290688982 4291083994 4291347164 4291742175 4291807968 4292005347 4292136933 4292202726 4292202726 4292136933 4292136933 4292268517 4292268519 4292071141 4291544543 4290952408 4290623191 4290557399 4290557399 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291215578 4292531692 4292465896 4292531941 4292597734 4292466150 4292663277 4291873508 4291215326 4291149533 4290952154 4290952154 4291149787 4291149787 4291083994 4291149787 4291347418 4291873761 4292465896 4292729322 4292729320 4292729320 4292729320 4292729320 4292663275 4292268517 4291939554 4291742176 4291544543 4291412959 4291412959 4291544291 4291478750 4291478750 4291544543 4291610336 4291610336 4291610336 4291610336 4291610336 4291676129 4291610336 4291676129 4291807715 4291807969 4292400103 4293058287 4292992492 4292992494 4292465896 4291939554 4291807969 4291873762 4291873762 4291873762 4291939554 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292334310 4292795115 4293321457 4293453042 4293321456 4292926699 4292466150 4292334310 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292729832 4293190381 4293453553 4293453807 4293519600 4293651186 4293650932 4293453553 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293519348 4293848311 4293848565 4293716979 4293585139 4293387760 4293190383 4293124590 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4293914358 4293848565 4293782772 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294177528 4294177528 4294177528 4294177528 4294177527 4294243320 4294309113 4294177527 4294177527 4294177527 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506746 4294638332 4294704125 4294769918 4294704125 4294704125 4294704125 4294769918 4294704125 4294704125 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281868164 4281868165 4281802372 4282328965 4284764579 4287396801 4286804913 4287134132 4287199925 4287002293 4285620137 4283185295 4281934725 4281933960 4281868167 4281999753 4281933957 4282131336 4282065544 4282131337 4282065546 4281999753 4282131337 4282131337 4281934725 4282263944 4282000772 4281803139 4282197129 4282197130 4282131337 4282197129 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282526346 4282592139 4282526348 4282263692 4282395276 4283316883 4285356967 4287397053 4287463093 4287463093 4287463095 4287528636 4287265467 4286541492 4285554344 4284501658 4284041107 4285751725 4286212276 4284698783 4283119754 4282789770 4282855313 4282855060 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282856079 4282856079 4282921872 4283053458 4282987665 4282921872 4282987665 4282921870 4282921870 4282987663 4283053458 4283053458 4283053456 4283053456 4283053711 4283053709 4283249566 4283184025 4283644827 4283315862 4283184276 4283316883 4285751471 4287659973 4287923907 4287858366 4287924156 4288187329 4287068088 4285751725 4284039834 4283381907 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284435360 4284303774 4284369567 4284501407 4284435614 4284435613 4284501406 4284435613 4284501406 4284435613 4284567200 4284698532 4284632993 4284632992 4284567197 4284501658 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830371 4284830369 4284830369 4284764576 4284896162 4284896162 4285027748 4285883311 4287924408 4288845512 4288647880 4287726526 4286871220 4286081452 4285555110 4285226145 4285093793 4285093793 4285225381 4285290920 4285290920 4285225381 4285225381 4285225379 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285554598 4285488551 4285488551 4285488553 4285554344 4285488551 4285620391 4286409906 4289042376 4289371852 4289437899 4289372620 4289241036 4289305809 4288318663 4286475949 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286146734 4285818029 4286015406 4286213040 4286147247 4286015661 4286344624 4287331771 4288252870 4287594681 4286541742 4286344113 4286278321 4286212527 4286410158 4286410158 4286409904 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286739634 4286739634 4287002806 4288384707 4289898447 4290293456 4290227666 4290161873 4290227666 4289898196 4289174226 4287463354 4287134389 4287068598 4287068599 4287134392 4287200184 4287200184 4287200182 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287463608 4287463608 4287463608 4287463354 4287529147 4287594940 4287594940 4287594940 4287660733 4287726526 4287792319 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4287989949 4288121535 4288253122 4288055743 4288055743 4288318915 4288188098 4288188098 4288318914 4288384707 4288318914 4288253121 4288318914 4288384707 4288384707 4288450500 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288713924 4288648131 4288779719 4288648133 4288911301 4290096594 4291149533 4291215580 4290886363 4289701840 4288648901 4288845258 4288911305 4288779717 4288977348 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289306059 4289766863 4290556629 4291280603 4291544027 4291544027 4291609820 4291741152 4291479003 4291610590 4291544543 4291544543 4291544545 4291412959 4291478750 4291544543 4291675359 4291741152 4291609568 4291280351 4290359250 4289635275 4289701070 4289635277 4289635278 4289701071 4289635277 4289635277 4289701070 4289766863 4289832656 4290095828 4291083992 4291742176 4291807969 4291544545 4290491606 4289833426 4289701840 4289899219 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290030801 4290162387 4290360019 4291083740 4291544543 4291742176 4292071140 4292136933 4292202726 4292136933 4292202726 4292268519 4292136933 4292071141 4292268520 4292334313 4292202726 4291939555 4291347164 4290755029 4290360017 4290360019 4290425813 4290491352 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291544545 4292334313 4292465896 4292531941 4292597734 4292400357 4292136933 4291610336 4291281119 4291149533 4290952154 4290952154 4291149787 4291149787 4291149787 4291347166 4291807968 4292400105 4292794861 4292795115 4292729320 4292860906 4292926701 4292729322 4292202726 4291807968 4291479004 4291412957 4291478752 4291412959 4291412705 4291544291 4291478750 4291544543 4291610336 4291610336 4291610336 4291610336 4291610336 4291610336 4291676129 4291610336 4291741922 4291807969 4291939554 4292597482 4293124078 4292992491 4292860654 4292268517 4291807968 4291807969 4291939555 4291939555 4291939555 4292005347 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268771 4292860908 4293321456 4293453042 4293255663 4292795113 4292400103 4292400105 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292861418 4293256176 4293585139 4293585393 4293519600 4293651186 4293585139 4293387760 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293519348 4293848311 4293782518 4293453553 4293321967 4293190383 4293124590 4293190383 4293190383 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293914358 4293980151 4293848565 4293782772 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294177528 4294177528 4294177528 4294177528 4294177527 4294243320 4294374906 4294243320 4294243320 4294177527 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506746 4294572539 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294704125 4294704125 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281802371 4282065543 4281934211 4282131588 4283842457 4285883059 4285093793 4286541492 4287199672 4287068086 4286804662 4284764830 4282461574 4282065543 4282131337 4281933958 4281999751 4282131337 4281999751 4281999751 4282131337 4281999751 4281999751 4282065544 4282065544 4282065544 4282065543 4282197129 4282262922 4282197129 4282197129 4282131336 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282526348 4282592141 4282460555 4282329483 4282526862 4283316628 4284896164 4286475700 4287397050 4287463097 4287463097 4287463097 4287528890 4287594683 4287594429 4287199672 4286673328 4287397051 4287791809 4286936248 4285159588 4283316881 4282723725 4282855060 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921872 4282921872 4282856079 4283053458 4283053458 4282987665 4282987665 4282856079 4283053456 4283185042 4283119249 4282987663 4283053711 4283185297 4283251088 4283119502 4283184779 4283251340 4282987914 4282987665 4283316378 4283250835 4285291172 4287463097 4287989700 4288318663 4287726778 4287989952 4287068086 4284896414 4283776916 4283513239 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369567 4284369567 4284435614 4284435613 4284304027 4284304025 4284370072 4284435865 4284567199 4284435613 4284435614 4284632993 4284435613 4284567197 4284633244 4284699037 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284764578 4284764576 4284896162 4284896162 4284896162 4284830369 4284830369 4285356967 4287003054 4288713926 4289108684 4288845512 4288779719 4288318915 4287463354 4286542254 4285686184 4285225379 4284962209 4285093795 4285225127 4285225381 4285291174 4285291172 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285554598 4285422758 4285488551 4285488553 4285620137 4285554344 4285554598 4286146734 4288121276 4289306059 4289306313 4289241289 4289372622 4289042637 4287463356 4285817767 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286015148 4286080941 4286081193 4286146732 4286278318 4286081452 4286476462 4287792573 4289042889 4289437899 4289042378 4287199925 4286212525 4286344113 4286344113 4286344365 4286410158 4286541490 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286805173 4286739380 4286739634 4286805427 4286739634 4286805427 4287200185 4289042889 4290030287 4290293457 4290227414 4290029782 4289635278 4288516547 4287858114 4287200182 4287068598 4287068598 4287134392 4287134392 4287134391 4287134391 4287265975 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287463354 4287463354 4287463354 4287529147 4287529147 4287529147 4287529401 4287529401 4287594940 4287660733 4287660733 4287594940 4287594940 4287726526 4287792573 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288253121 4287989949 4288121536 4288318915 4287859134 4288188099 4288187328 4288318914 4288253121 4288318914 4288384707 4288384707 4288450754 4288384961 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288582340 4288648131 4288648133 4288582086 4288779717 4289701838 4290952154 4291149787 4291083740 4290359766 4288978117 4288977094 4289108682 4288845508 4288911301 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289174473 4289174727 4289437896 4290096078 4290885593 4291412191 4291477982 4291412189 4291544797 4291413211 4291347164 4291544545 4291741924 4291676131 4291544543 4291478750 4291675613 4291807199 4291806945 4291412191 4290359249 4289503943 4289569482 4289569482 4289635278 4289701071 4289635277 4289635277 4289701070 4289766863 4289898449 4290161621 4291544545 4291939301 4291873508 4291346912 4290228180 4289833426 4289767633 4289899217 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289965008 4290031055 4290425810 4291281371 4291939555 4292071140 4292136931 4292005345 4292071141 4292071141 4292005348 4292005094 4291741922 4291610336 4291939301 4292136680 4291873508 4291215580 4290623443 4290557396 4290557398 4290491606 4290425813 4290557399 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291412705 4291610336 4292071140 4292400357 4292663529 4292531689 4291742176 4291149785 4291083740 4291083740 4291017947 4291017947 4291083994 4291083994 4291281373 4291610338 4292268520 4292663277 4292860654 4292663275 4292597482 4292794861 4292794861 4292597484 4292005348 4291610336 4291347164 4291347164 4291478752 4291412959 4291412959 4291412959 4291412957 4291478750 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291610336 4291610336 4291741922 4291807969 4292202726 4292926701 4293124078 4293058284 4292663275 4292136933 4291807968 4291873762 4291939555 4291939555 4291939554 4291939554 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292334564 4292992492 4293321456 4293453042 4293189870 4292597734 4292334310 4292400105 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292729833 4293124591 4293519348 4293650932 4293651186 4293651186 4293585139 4293321967 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293519348 4293716725 4293519346 4293256174 4293124590 4293124591 4293124591 4293190383 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293914356 4294045942 4294111735 4294045942 4293914356 4293848563 4293848563 4293848563 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177527 4294309113 4294440699 4294309113 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294440699 4294506746 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281802374 4281802372 4281802371 4281934211 4282592141 4283250067 4282790539 4284501155 4286475699 4287068086 4287331257 4286409904 4284106648 4282328965 4281933957 4282065544 4282131337 4281999751 4281999751 4281933957 4281999750 4282131336 4282131336 4282197129 4282131337 4282197130 4282262925 4282065544 4281999750 4282197383 4282262922 4282131336 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282394508 4282394762 4282526346 4282592655 4282461069 4282198151 4282724746 4283711891 4284764578 4285554346 4286541493 4287331260 4287594429 4287594683 4287594683 4287265718 4287726526 4287463608 4287463095 4287594429 4286738869 4284830369 4283185295 4282592907 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282987665 4283053458 4282856079 4282921872 4283053458 4282987665 4283119251 4283053458 4282987665 4283119251 4283185044 4283053456 4282921870 4283053456 4283119249 4283185042 4283119002 4283053458 4283316881 4283185808 4282922382 4283646355 4284041869 4287134640 4287792822 4287660984 4288055745 4287529150 4285686184 4283646095 4283447697 4283710618 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284304028 4284435614 4284435614 4284435614 4284435613 4284435613 4284501406 4284567199 4284501407 4284501407 4284501406 4284698785 4284501404 4284698783 4284698785 4284698785 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284764578 4284764576 4284896162 4284896162 4284896162 4284896162 4284830369 4285028002 4286081704 4288252870 4289174477 4289043141 4288911555 4288911303 4288976844 4288516296 4286607286 4285751977 4285159586 4285225381 4285225381 4285225381 4285225381 4285291172 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285423012 4285356965 4285488551 4285488553 4285554344 4285554344 4285620391 4285949355 4287594934 4289437647 4289503692 4289307082 4289109450 4287989950 4286147243 4285620137 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285883563 4285949356 4286015148 4286015148 4286015148 4286015148 4286080941 4286146984 4286146732 4286080941 4286081454 4286739633 4288384961 4289635277 4289570250 4289766351 4288384450 4286804913 4286344111 4286409904 4286344111 4286409904 4286475697 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286805173 4286739380 4286673841 4286805427 4286739634 4286937013 4287463357 4289240520 4290161873 4290030033 4289569235 4288779466 4287990203 4287200434 4286937013 4287068598 4287068598 4287134392 4287134392 4287134392 4287068598 4287134391 4287200182 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287265977 4287331770 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287529147 4287529147 4287529147 4287660987 4287726780 4287726780 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055743 4288121536 4288187328 4288055742 4288121535 4288253121 4288056512 4288188098 4288187329 4288253122 4288187329 4288384707 4288384707 4288318914 4288450754 4288319168 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288648133 4288450754 4288648133 4288582086 4288647879 4288911303 4289438666 4290820570 4291149787 4291215326 4290820570 4289965262 4289832654 4289108934 4288977094 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4288911303 4289174475 4289240266 4289108934 4289437898 4290293459 4291082973 4291543523 4291412705 4290886361 4290491605 4290557399 4290820571 4291083742 4291215328 4291346912 4291412189 4291543775 4291609570 4291346144 4290293459 4289503689 4289569484 4289569484 4289635278 4289701071 4289701070 4289701070 4289766863 4289701070 4289832656 4290095828 4291346912 4291676131 4291676131 4291083740 4289965008 4289833426 4289833424 4289833676 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290096596 4290096594 4290294226 4291215580 4291939301 4292071141 4292071141 4291939301 4291675877 4291544291 4291215326 4291017947 4290688982 4290754775 4291412705 4291610084 4290952156 4290491605 4290294226 4290425812 4290557399 4290491606 4290425813 4290491606 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4291017949 4290952408 4291544797 4292334310 4292729068 4292597484 4291873762 4291018199 4291017947 4291083740 4291083740 4291083740 4291083994 4291083994 4291281373 4291676131 4292005094 4292136934 4292202726 4292071140 4292005347 4292071141 4292071141 4292005094 4291807717 4291544545 4291347166 4291347164 4291412957 4291412957 4291412957 4291478750 4291412957 4291478750 4291478750 4291478750 4291544543 4291610336 4291610336 4291544543 4291610336 4291610336 4291741922 4291807969 4292400105 4292992494 4292992491 4293058538 4292465898 4292005347 4291807969 4291873762 4291939555 4291939555 4291939554 4291939554 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292466150 4293189871 4293387249 4293387249 4293189870 4292531943 4292334310 4292400105 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292663786 4292795626 4293190383 4293519346 4293585139 4293716725 4293585139 4293321967 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293387762 4293453553 4293256174 4293058795 4293058797 4293124591 4293190130 4293190383 4293190383 4293190383 4293256176 4293321969 4293321969 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848563 4294045942 4294243321 4294177528 4294045942 4293980149 4293914356 4293848563 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294111735 4294111735 4294177528 4294243320 4294374906 4294506492 4294440699 4294309113 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294374906 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506746 4294506746 4294572539 4294572539 4294572539 4294638332 4294638332 4294638332 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802372 4281802372 4281802372 4281868165 4281868165 4281868165 4281868165 4281999502 4281736327 4281933958 4281736579 4281933960 4281999753 4282000521 4282329485 4285291426 4286936500 4287068337 4287002292 4286212276 4283710872 4282197129 4282065544 4282065546 4281868165 4282131336 4282065543 4281934211 4282197383 4282131590 4282000004 4282197129 4281999751 4282065546 4282197130 4282262922 4282197383 4282131590 4282132106 4282197129 4282197129 4282197129 4282262922 4282197129 4282263176 4282263176 4282263176 4282263176 4282263176 4282328969 4282328969 4282328969 4282328969 4282394762 4282394762 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282460301 4282592141 4282526346 4282329737 4282461069 4282526862 4282527114 4282593160 4282527375 4282988178 4283777943 4284896929 4285752489 4286476462 4287331770 4287529147 4287397561 4287726780 4287660472 4287463095 4287594429 4287067836 4285225129 4283316879 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282724493 4283119251 4282987665 4282921872 4282987665 4282856081 4282987667 4282921874 4283053206 4283053460 4283053460 4283053458 4283119251 4283185044 4283119253 4283053460 4282987924 4283186558 4294964991 4294967039 4294966521 4294967039 4294967039 4294967039 4291082972 4287595695 4287529147 4285752234 4283711890 4283448467 4283513493 4283315860 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283580055 4283514262 4283514262 4283580055 4283645848 4283580055 4283580055 4283645848 4283645846 4283645846 4283645846 4283711639 4283711639 4283777432 4283777432 4283777432 4283777432 4283777432 4283843225 4283843225 4283843225 4283909018 4283909018 4283909018 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369818 4284501406 4284435613 4284369821 4284501153 4284501155 4284369569 4284435364 4284566178 4284763811 4284632223 4284698015 4284566683 4284829601 4284763809 4284698018 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284896164 4284764576 4284896162 4284830369 4284830369 4284961955 4284961955 4285093795 4285160099 4287397310 4288713673 4289108934 4289043138 4289108934 4288977098 4287989952 4286146735 4285357219 4285028000 4285225381 4285291174 4285093795 4285159588 4285291172 4285291174 4285291174 4285291174 4285356967 4285356965 4285422758 4285422758 4285422758 4285488805 4285356965 4285554344 4285554346 4285422758 4285488551 4285554598 4285817769 4287199923 4289042891 4289437899 4289241289 4288385727 4286937264 4285620903 4285948850 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285883563 4285949356 4286015148 4286015148 4286015148 4286015148 4286080941 4286015148 4286146481 4286146229 4286146996 4286344624 4287595192 4289109448 4289636045 4289766604 4289371341 4287594683 4286410158 4286344111 4286409904 4286475697 4286344113 4286410158 4286475951 4286475951 4286475951 4286541744 4286541744 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286805173 4286739380 4286673841 4286739634 4286739634 4287068599 4287726529 4289701070 4290030287 4288648383 4287858364 4287200182 4286937264 4287003057 4287134138 4287002805 4287134391 4287068599 4287068599 4287134392 4287200184 4287200184 4287134389 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397563 4287463356 4287463354 4287529147 4287529147 4287529147 4287529147 4287529147 4287529147 4287529147 4287594940 4287660987 4287660987 4287660985 4287660985 4287726778 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055743 4288121536 4288055742 4288253121 4288121789 4288055996 4288253891 4288056512 4288318915 4288318915 4288253122 4288450500 4288318914 4288253121 4288450754 4288384961 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288713926 4288450754 4288713926 4288647879 4288713672 4289042891 4289372875 4290754777 4291215326 4291215326 4290952408 4291083740 4290754008 4289043140 4288911301 4288977098 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289306061 4289174475 4289174477 4289240270 4289174475 4289174727 4289766861 4290425043 4291017696 4290228180 4289636045 4289372873 4289438666 4289570252 4289701836 4289833422 4290293456 4290359249 4290622422 4290622424 4289898447 4289437898 4289635278 4289635278 4289569485 4289701071 4289701070 4289701070 4289766863 4289701070 4289766863 4289964242 4290491605 4290952408 4291083994 4290688984 4289767629 4289833424 4289833422 4289767882 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289965012 4289899217 4290031055 4290886363 4291478498 4291478752 4291281119 4290952154 4290623192 4290491606 4290294226 4290360019 4290294226 4290360019 4290820570 4290688984 4290359766 4290491606 4290491606 4290425813 4290360020 4290425813 4290491606 4290491606 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886364 4290886361 4291347164 4292268519 4292597482 4292465898 4292070887 4291149787 4291083740 4291083740 4291017947 4291083740 4291149787 4291083994 4291149787 4291412959 4291347164 4291281371 4291281625 4291347418 4291347418 4291281371 4291281371 4291412959 4291347166 4291347166 4291347166 4291412957 4291412957 4291413211 4291479004 4291544797 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291544543 4291676129 4291676129 4291741922 4291742176 4292465898 4292992494 4292795112 4292926952 4292268519 4291873761 4291807969 4291939555 4291873762 4291939555 4291939554 4291873761 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292597736 4293255664 4293453042 4293453042 4293124077 4292466150 4292334310 4292400106 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663529 4292663529 4292663529 4292597995 4292597993 4292861419 4293190383 4293453553 4293650932 4293585141 4293321969 4292860908 4292860908 4292860908 4292926701 4292926701 4292926701 4292926701 4292926701 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293256176 4293256174 4293124588 4293058797 4293124590 4293190384 4293190130 4293124590 4293124590 4293190383 4293256176 4293387762 4293387762 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293716977 4294045942 4294309114 4294309114 4294243321 4294111735 4294045942 4293980149 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294045942 4294111735 4294111735 4294111735 4294177528 4294243320 4294374906 4294506492 4294506492 4294374906 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294374906 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506746 4294506746 4294506746 4294572539 4294572539 4294572539 4294638332 4294638332 4294572539 4294572539 4294638332 4294638332 4294704125 4294704125 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4282132107 4281605763 4281802372 4281868165 4281736579 4281868164 4281868418 4281868418 4281999753 4281802372 4282065793 4281802371 4281933455 4281802120 4282131588 4281933957 4282593669 4286081201 4286937013 4286739883 4286937264 4285291938 4282725257 4281869445 4281737346 4282066064 4281933957 4282066047 4282328718 4281802122 4282131336 4282065797 4282131588 4282065543 4282197132 4282065544 4282131590 4282197381 4282000004 4282328715 4282197129 4282197129 4282262922 4282328715 4282328715 4282197383 4282197383 4282263176 4282394251 4282197129 4282328715 4281869186 4282329735 4282394758 4282460553 4282394251 4282394760 4282394760 4282460553 4282460553 4282394762 4282394762 4282526094 4282394509 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282527116 4282527116 4282724241 4282592655 4283053458 4283974811 4284896164 4286409655 4287332022 4287660733 4287529147 4287660735 4287660735 4287463357 4287068599 4285818532 4284039836 4282921355 4282723977 4282921102 4282789518 4282855311 4282921104 4282986897 4282921104 4282986897 4282986895 4282855309 4282790286 4282921874 4282921874 4282790288 4283052941 4283052941 4282987148 4283052941 4283184528 4283184528 4283184528 4283184528 4282987918 4283053711 4283053456 4283119249 4283053456 4283184274 4283315860 4283316114 4283119502 4282922382 4294967039 4294967291 4294967039 4294967293 4294967293 4294967295 4290623692 4287332020 4286344114 4284106130 4283447697 4283381906 4283579537 4283382676 4283448214 4283448214 4283448214 4283448469 4283448469 4283514262 4283514262 4283514262 4283644819 4283710871 4283579537 4283776914 4283580053 4283580305 4283580053 4283514019 4283514771 4283514769 4283843987 4283580815 4283449229 4283909529 4283580313 4283711647 4283646357 4283711899 4283975071 4283909267 4283975314 4284106395 4283842974 4283974560 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284106395 4284106395 4284172188 4284172188 4284172188 4284172442 4284238235 4284238235 4284303774 4284172190 4284237983 4284369569 4284303776 4284369567 4284501153 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830369 4284830369 4284830369 4284896162 4284896162 4284896162 4284961955 4284961955 4285159336 4286409904 4288713672 4288977347 4289043140 4289043141 4288977096 4288319168 4286870457 4285357219 4285093793 4285225381 4285159334 4285291174 4285291174 4285225379 4285356967 4285356967 4285291174 4285291174 4285356967 4285488551 4285554344 4285422758 4285554598 4285488805 4285422758 4285620137 4285554344 4285422758 4285620137 4285620137 4286410155 4288976585 4289437386 4288910790 4287462844 4285883563 4285949356 4285620388 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286146734 4286212525 4286146734 4286212525 4286673328 4288186816 4289832146 4289636045 4289766863 4288845510 4286739631 4286409904 4286409907 4286212525 4286541741 4286475951 4286410158 4286475951 4286475951 4286410158 4286541744 4286607537 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286805173 4286673587 4286739634 4286871220 4286673841 4287068599 4288121287 4288581835 4287923905 4287265975 4287002805 4287068598 4287068599 4287002806 4287068599 4287002292 4287199671 4287068339 4287134132 4287200184 4287002806 4287068345 4287134140 4287200184 4287200185 4287331771 4287331770 4287265464 4287331511 4287463095 4287331509 4287332022 4287397561 4287463354 4287397561 4287331768 4287594940 4287792573 4287529399 4287726526 4287397561 4287595194 4287660987 4287529147 4287660733 4287726526 4287594942 4287858364 4287726778 4287726778 4287792571 4287792571 4287792571 4287858366 4287924159 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288516547 4288582340 4288713672 4288648133 4288779715 4289635275 4290754007 4291214810 4291411938 4291346398 4291412189 4291346398 4290490838 4289174727 4288845510 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289701071 4289635278 4289503692 4289437899 4289372106 4289437899 4289503692 4289569485 4289635278 4289635278 4289635278 4289635278 4289635278 4289635278 4289569485 4289569485 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290227666 4290161873 4290227666 4290425045 4290556631 4290556631 4290425045 4290359252 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886361 4290952156 4291083740 4292268520 4292465896 4292465896 4292136680 4291215328 4291083740 4291017947 4291017947 4291083740 4291149533 4291149533 4291149533 4291215326 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291281373 4291412959 4291347166 4291347166 4291478752 4291478752 4291347166 4291544545 4291610336 4291478750 4291478752 4291610338 4291676131 4291610336 4291610590 4291676383 4291610336 4291610336 4291676129 4291741922 4291873508 4292071141 4292268520 4292400106 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292005347 4292202726 4292202727 4292136934 4292202726 4292202724 4292400103 4292663529 4292926698 4293255663 4293518836 4293321457 4292795115 4292400103 4292400103 4292465896 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292729322 4292729322 4292795113 4293255664 4293716214 4293650421 4293321710 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293124588 4293256428 4293716979 4293914358 4293848565 4293782518 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387762 4293453555 4293519348 4293519346 4293453553 4293651186 4293848565 4293651186 4293585139 4293585139 4293585139 4293650932 4293650932 4293585139 4293585139 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848565 4293914356 4294177528 4294374907 4294309113 4294243320 4294309113 4294177781 4293980149 4293914356 4293914356 4293914356 4293914356 4293980149 4294045942 4294045942 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294177528 4294111735 4294111735 4294177528 4294243320 4294440699 4294506492 4294572539 4294506746 4294374906 4294309113 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4283843223 4282658953 4282000004 4281736581 4281802122 4281933706 4281868167 4281868164 4281604744 4281933957 4281474177 4282131853 4281803393 4283514512 4287857851 4291806937 4293387250 4294900735 4294900991 4294967039 4293255663 4292794612 4289438413 4286411688 4282198652 4281408383 4282328969 4281868668 4281802372 4282065546 4282328969 4282065797 4282262922 4281933958 4282262923 4282262922 4282131588 4282328967 4282197130 4281933706 4282197129 4282197129 4282197129 4282262922 4282262922 4282197383 4282263176 4282394762 4282526085 4282394760 4282526864 4282395279 4282329486 4282066313 4282197383 4282525835 4282460555 4282394762 4282328969 4282263176 4282394762 4282526348 4282591887 4282526094 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282527116 4282263944 4282526862 4282592655 4282527116 4282527367 4283053707 4284632992 4287199925 4287463097 4287331511 4287397050 4287397051 4287397051 4287397051 4286541744 4284960938 4283513493 4282855309 4282789518 4282789518 4282986897 4282921104 4282723725 4282855563 4282855309 4282921102 4283052690 4282921874 4282921874 4282856081 4282856081 4282921104 4283118483 4283184276 4283052690 4283052690 4283184276 4283250069 4283118483 4282987665 4283053458 4283119251 4283119251 4283119251 4283184274 4283184528 4283184528 4283119502 4282922382 4294967039 4294967291 4294967039 4294967293 4294967293 4294967295 4290228936 4285752990 4284567703 4283316614 4283316113 4283381907 4283513744 4283316628 4283382421 4283448214 4283448214 4283448469 4283448469 4283448469 4283514262 4283514262 4283776413 4283710869 4283645846 4283514260 4283646095 4285094559 4289108682 4292070620 4293650157 4294966527 4294966783 4294966527 4292991722 4292004578 4288846011 4287858864 4284765592 4284567964 4285686445 4286146732 4285949353 4284896162 4283974811 4284040606 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284172188 4284172188 4284172188 4284172442 4284238235 4284238235 4284172442 4284172442 4284303774 4284303774 4284106649 4284172442 4284369821 4284304027 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284632992 4284764578 4284764578 4284764578 4284764578 4284830371 4284830369 4284830369 4284830369 4284830369 4284896162 4284896162 4284896162 4284961955 4284896164 4285686183 4287792573 4288911303 4288911301 4289108682 4289437647 4288911303 4288318152 4286804916 4285488804 4285159586 4285422506 4285225127 4285028002 4285422760 4285225381 4285356967 4285422760 4285356967 4285291172 4285291172 4285356965 4285356965 4285422760 4285554346 4285422760 4285422758 4285488551 4285488805 4285620391 4285488804 4286015400 4288515783 4289173962 4287792313 4286344365 4285685930 4285686184 4285620388 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286212527 4286080939 4286080941 4286212527 4286344365 4287331509 4288976585 4289636047 4289701070 4289437645 4287858364 4286542255 4286344113 4286607283 4286344363 4286475951 4286410158 4286475951 4286541744 4286475951 4286541744 4286607537 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286739380 4286739380 4286739634 4286805427 4286739634 4286871220 4287331771 4287331768 4287002803 4286805426 4286805426 4286937012 4286937013 4286937013 4287002806 4287199671 4287265464 4287068085 4287068598 4287200184 4287200184 4287200184 4287134391 4287265977 4287134391 4287265977 4287397563 4287331770 4287331257 4287463097 4287528890 4287463354 4287331768 4287397561 4287463354 4287594940 4287858366 4288253122 4288516293 4288253121 4288187328 4287792570 4287660984 4287924157 4287858364 4287660987 4287726780 4287595194 4287726780 4287924159 4287924157 4287792571 4287792571 4287858366 4287858366 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288648131 4288648133 4288648133 4288648133 4288713924 4289306312 4290425045 4291214558 4291280351 4291346396 4291412187 4291346396 4290359252 4289043141 4288779717 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289437899 4289372106 4289372106 4289372106 4289372106 4289437899 4289503692 4289503692 4289569485 4289569485 4289569485 4289569485 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290096080 4290096080 4290293459 4290359252 4290359252 4290293459 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886363 4291083740 4292202727 4292597482 4292729322 4292465899 4291610338 4291083740 4291017947 4291017947 4291083740 4291149533 4291149533 4291149533 4291215326 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291281373 4291347166 4291412959 4291347166 4291347164 4291544543 4291610336 4291478750 4291478750 4291544543 4291610338 4291544545 4291544545 4291610336 4291610590 4291610590 4291676129 4291676129 4291610336 4291676129 4291676129 4291742176 4291807969 4291873762 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292202726 4292136934 4292136934 4292136933 4292268517 4292597482 4293058287 4293189870 4293321456 4293453043 4293387250 4293058287 4292663529 4292400103 4292334310 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292729322 4292729322 4292729322 4292729320 4292992492 4293387249 4293518835 4293387249 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293190381 4293322221 4293716979 4293980151 4293914358 4293848311 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387762 4293387762 4293519348 4293519346 4293519346 4293782772 4293914358 4293782772 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293585139 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293914356 4294177528 4294309114 4294243320 4294243320 4294309113 4294243320 4294045942 4293980149 4293980149 4293914356 4293980149 4293980149 4294045942 4294045942 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294177528 4294111735 4294111735 4294177528 4294309113 4294440699 4294506492 4294572539 4294506746 4294440699 4294374906 4294309113 4294309113 4294309113 4294243320 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286410158 4284764828 4283185297 4282328716 4281933708 4281802123 4281736327 4281933960 4282065543 4281868685 4281802639 4284304540 4291412191 4294966783 4294966783 4294967295 4294967039 4294967039 4294967293 4294901754 4294967291 4294769916 4294967039 4294967039 4287791808 4282001023 4281803139 4281868668 4282065797 4282131336 4282000002 4282197129 4282197132 4282131337 4282065543 4282526344 4283184527 4282855563 4282065543 4282262673 4282197129 4282197129 4282197129 4282262922 4282197129 4282197383 4282328969 4282526348 4284434843 4283776662 4282658700 4282395278 4282263439 4282329232 4282262922 4282394762 4282262922 4282460301 4282591887 4282460301 4282394508 4282394508 4282394762 4282394762 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282724493 4282329737 4282395276 4282461069 4282526862 4282527114 4283251090 4284830120 4285949356 4286015149 4285620391 4285356965 4285028000 4284830623 4284830623 4284370072 4284105629 4283184528 4282921102 4282855311 4282789518 4282986897 4283052690 4282986895 4282921356 4282921356 4282921104 4282724495 4282724495 4282790286 4282921870 4282987918 4283118485 4283052692 4283118485 4283184278 4283052690 4283184276 4283315860 4283250067 4283053456 4283316628 4283250837 4282987665 4283053458 4283250067 4283250321 4283250320 4283119502 4282922382 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4289571007 4283844739 4282922624 4282856063 4283250320 4283316114 4283513490 4283382421 4283382421 4283382421 4283448214 4283448469 4283448469 4283448469 4283514262 4283514262 4283580053 4283579802 4283119512 4285752487 4291939555 4294966527 4294966783 4294967291 4294966783 4294967039 4294967039 4294835450 4294901241 4294967291 4294967293 4294835196 4290359000 4287200433 4287397561 4288055230 4288055232 4285620390 4283777683 4283777684 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284172188 4284172188 4284172442 4284238235 4284238235 4284106649 4284238235 4284435614 4284369820 4284238234 4284304027 4284304027 4284238234 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284435614 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284632992 4284698785 4284764578 4284698785 4284764578 4284830371 4284764576 4284830369 4284830369 4284830369 4284896162 4284896162 4284896162 4284961955 4284896164 4285159586 4286936500 4288581835 4288253124 4288384708 4289108684 4289042889 4288976585 4288384195 4286673328 4285423011 4285159588 4285159334 4285225127 4285356967 4285291174 4285356967 4285422760 4285356967 4285291172 4285356965 4285422758 4285488551 4285488553 4285685932 4285554344 4285620137 4285686184 4285554598 4285554597 4285686183 4286015149 4287726016 4288515783 4286805167 4285620388 4285751723 4285685930 4285883562 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286278320 4286015146 4286015148 4286278321 4286080941 4286541742 4287923646 4289569231 4289701071 4289964243 4288977096 4287266229 4286278829 4286673076 4286409904 4286475951 4286410158 4286475951 4286541744 4286475951 4286541744 4286607537 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286739380 4286739380 4286739634 4286739634 4286805427 4286805427 4286739634 4286871219 4286805426 4286871219 4287002805 4287068598 4287002806 4287068599 4287134392 4286936499 4287133879 4287134138 4287199931 4287002806 4287002803 4287332020 4287332019 4287397815 4287332022 4287332022 4287397815 4287397561 4287463354 4287528890 4287397304 4287397561 4287331768 4287397561 4287463354 4287463608 4287726778 4288713926 4289963993 4289898196 4290095575 4289503692 4289174727 4289042887 4288648131 4288319168 4288121535 4287858112 4287726526 4287792573 4287792573 4287726780 4287858366 4287858366 4287726778 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288648131 4288648133 4288648133 4288647879 4288648133 4288911301 4289701070 4290687963 4291280351 4291346396 4291346394 4291149017 4290030287 4288977094 4288845510 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289240520 4289240520 4289306313 4289306313 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290096080 4290096080 4290161873 4290227666 4290227666 4290227666 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886363 4291017947 4292005348 4292466150 4292663527 4292334310 4291610590 4291083740 4291017947 4291017947 4291083740 4291149533 4291149533 4291149533 4291215326 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347164 4291347164 4291412957 4291412957 4291479004 4291939555 4292136934 4291676383 4291413211 4291610336 4291676129 4291544545 4291478752 4291610336 4291676129 4291610590 4291610336 4291610336 4291676129 4291676129 4291676129 4291742176 4291742176 4291742176 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292136933 4292136933 4292136934 4292136934 4292202726 4292268517 4292729068 4293321459 4293387503 4293321456 4293321456 4293453043 4293321457 4292926701 4292531943 4292268771 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292729322 4292729322 4292729320 4292795113 4292992492 4293189870 4293255663 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293256174 4293388014 4293782772 4293980151 4293914358 4293848311 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387762 4293387762 4293453553 4293453553 4293585139 4293914358 4294045944 4293980151 4293650932 4293585139 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4294111735 4294309114 4294243321 4294243320 4294309113 4294243320 4294111735 4294045942 4293980149 4293914356 4293980149 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294243321 4294309113 4294440699 4294572285 4294506746 4294506746 4294506492 4294440699 4294440699 4294374906 4294309113 4294243320 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286870960 4287068088 4286212274 4284106395 4282723723 4282262922 4281999751 4281933960 4281671304 4281606014 4287003057 4294966527 4294967293 4294836212 4294836215 4294901503 4294967288 4294967290 4294901753 4294901754 4294967293 4294967295 4294835709 4294967295 4288252860 4281409136 4281671553 4281671807 4281933957 4282065797 4282000002 4282131339 4282066062 4282000521 4282395528 4284106649 4285751725 4284896164 4282856077 4282132106 4282197129 4282197129 4282197129 4282262922 4282197129 4282197383 4282328969 4282526348 4284632476 4286474680 4285554094 4284040602 4282658698 4282592655 4282657934 4282263176 4282460301 4282328715 4282328715 4282328715 4282460301 4282657680 4282526348 4282592141 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282263942 4282329737 4282592655 4282658448 4282658448 4282592655 4282395530 4282790286 4283119249 4283185042 4282987663 4282921872 4282856079 4282724493 4282856079 4282724493 4282987149 4282789770 4282986895 4282921104 4282723725 4282855311 4282855311 4282921102 4283052688 4282855311 4282790288 4282987667 4282987663 4283251086 4284501404 4285817516 4284106144 4283185297 4282922125 4283185295 4283185293 4283251086 4283711891 4284040856 4284633244 4284961955 4284435360 4283316883 4282987663 4283315860 4283250067 4283316114 4283053709 4282856589 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4288715446 4282528881 4282264696 4282856063 4283184527 4283316114 4283513490 4283382423 4283382421 4283448214 4283448214 4283448469 4283448469 4283514262 4283514262 4283514262 4283251347 4283317390 4288451268 4294966271 4294704121 4294967286 4294901751 4294967039 4294967295 4294967295 4294835709 4294967293 4294835709 4294967295 4294967295 4294967295 4290688718 4287266727 4287595443 4287726516 4287726520 4285883560 4284238232 4283975062 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284172188 4284172188 4284172442 4284172442 4284238235 4284237981 4284237981 4284304028 4284106649 4284172441 4284369820 4284369821 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284632992 4284764578 4284764578 4284764578 4284764578 4284830371 4284830369 4284830369 4284830369 4284830369 4284896162 4284896162 4284961955 4284961955 4285093543 4284962209 4285686184 4287067834 4286344624 4286739634 4288318915 4289306061 4289043140 4289174473 4288121536 4286739634 4285489062 4285028515 4285357226 4285225640 4285356967 4285291174 4285291174 4285291172 4285422758 4285488551 4285356965 4285488551 4285752489 4286213040 4285884075 4285555110 4285620903 4285554855 4285554857 4285489064 4285883311 4286541492 4287068086 4286081193 4285554598 4285817516 4285554344 4285817769 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286212525 4286080939 4286146734 4286343860 4286080942 4286212525 4287068086 4288779465 4289569231 4289898449 4289503691 4288319168 4286739631 4286739380 4286805173 4286475951 4286410158 4286475951 4286541744 4286541744 4286541744 4286607537 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286673587 4286739380 4286739634 4286739634 4286871220 4286937013 4286739634 4286871219 4286871219 4286937012 4287002805 4286937012 4286871220 4286937013 4287068599 4287134391 4287068599 4287002552 4287134138 4287331771 4287858366 4288582338 4288583104 4288648901 4288911303 4288845510 4288648131 4288779719 4289042637 4288582087 4287726780 4287397561 4287397561 4287397561 4287397561 4287332022 4287463605 4288450754 4289898198 4290293205 4290622170 4290490838 4290556631 4290358998 4290227414 4290161368 4289042889 4288055745 4287792319 4287726526 4287792319 4287792319 4287792573 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582338 4288648131 4288648133 4288713672 4288713926 4288582340 4288977094 4289766610 4291017179 4291346396 4291412187 4291017433 4289767115 4289042887 4288977098 4288911305 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289306313 4289306313 4289372106 4289372106 4289372106 4289372106 4289372106 4289372106 4289437899 4289437899 4289437899 4289503692 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290227666 4290161873 4290161873 4290227666 4290227666 4290227666 4290227666 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886363 4290952154 4291741922 4292400357 4292663527 4292466150 4291873761 4291083740 4291017947 4291017947 4291083740 4291149533 4291149533 4291149533 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347164 4291281371 4291412957 4291610590 4292071140 4292597484 4292663275 4292268517 4291610590 4291610590 4291544543 4291478750 4291544545 4291610336 4291610336 4291610590 4291610336 4291610336 4291676129 4291741922 4291807715 4291807969 4291873762 4291873762 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136934 4292202727 4292202726 4292136931 4292531689 4293124080 4293387503 4293321710 4293321456 4293453042 4293387250 4292992492 4292531943 4292334564 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292597736 4292663529 4292729322 4292795115 4292795113 4292795113 4292860906 4292992492 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293256174 4293519600 4293848565 4294045944 4293914358 4293782518 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387762 4293387760 4293387760 4293519346 4293716979 4293980151 4294111737 4294111737 4293782518 4293650932 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4294111735 4294309114 4294243321 4294309113 4294309113 4294309113 4294111735 4294045942 4293914356 4293914356 4293980149 4294045942 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294243321 4294309113 4294440699 4294572285 4294506746 4294506746 4294506492 4294506492 4294440699 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4287199674 4287002293 4286870706 4286607537 4285554598 4283579535 4281934207 4281868165 4281605511 4287200434 4294967037 4294835699 4294967039 4294835967 4294770680 4294705148 4294967291 4294967293 4294967295 4294835455 4294967295 4294967295 4294967291 4294835958 4287529389 4281277549 4281474174 4281671807 4281868935 4281933958 4282065797 4282262671 4282000521 4282592909 4284369567 4286344114 4287133879 4286607283 4284764576 4282527367 4282197129 4282197129 4282262922 4282262922 4282197129 4282197383 4282328969 4282460555 4283974295 4286869434 4286870707 4286871220 4285489062 4283777684 4283052942 4282592137 4282460553 4282197383 4282394508 4282460301 4282394508 4282394508 4282328969 4282460553 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282527114 4282527116 4282527116 4282329483 4282461069 4282658448 4282461069 4282461069 4282526864 4282592657 4282526864 4282592657 4282658450 4282658450 4282724243 4282658450 4282855563 4282723723 4282855311 4282789518 4282855311 4282986897 4282855311 4282855309 4282592655 4283053206 4283053458 4282922125 4283975062 4285949356 4287200185 4287463354 4285225379 4284633242 4284765082 4285488805 4285817769 4286080939 4286607283 4287002295 4287134132 4287331258 4286212528 4284040855 4282987918 4283315860 4283184274 4283184276 4283053709 4282856589 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4287860137 4281870951 4282198903 4282856063 4282987146 4283250321 4283447697 4283250837 4283448214 4283448214 4283448214 4283448469 4283514262 4283514262 4283514262 4283514262 4283449750 4288122555 4294637817 4294967290 4294901247 4294901759 4294836215 4294901759 4294967293 4294967293 4294967295 4294901500 4294967293 4294967291 4294901754 4294967290 4290491338 4286543004 4286937515 4287397555 4287594683 4285751723 4284106649 4283843477 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284106395 4284172442 4284172442 4284238235 4284172192 4284237983 4284435360 4284304028 4284369821 4284501153 4284303774 4284303776 4284435614 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284501407 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830369 4284830369 4284830369 4284896162 4284896162 4284961955 4284961955 4284961955 4284961957 4284896162 4284896416 4285620137 4285093793 4285357731 4286871219 4288253122 4289043140 4289306059 4288911305 4288318917 4286871220 4285357731 4285094306 4285160101 4285291174 4285225379 4285356965 4285291172 4285422758 4285422758 4285225379 4285422758 4286805678 4288252870 4288187077 4286871219 4285818278 4285555110 4285620652 4285554605 4285685932 4285751977 4285883562 4285686183 4285686184 4285817516 4285751977 4285751977 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286146732 4286146732 4286212527 4286212274 4286212274 4286344113 4286475951 4287660987 4289174477 4289832656 4289832654 4289437899 4288253121 4288055491 4287660735 4286541744 4286410158 4286475951 4286607537 4286541744 4286541744 4286607537 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286805173 4286607794 4286739380 4286871220 4286739634 4286805427 4287002806 4286871220 4286871220 4286871220 4286871220 4286937013 4286937013 4286871219 4286937012 4287068598 4287002803 4287068598 4287002806 4287068599 4287331768 4288188096 4289701585 4290359766 4289965010 4290096594 4290162389 4290227412 4290227414 4290095575 4289174477 4287924156 4287463354 4287463354 4287331768 4287463354 4287595194 4287529399 4287727031 4288384961 4290030803 4290491352 4290425813 4290557398 4290557398 4290622938 4290228184 4288517311 4287989950 4287726778 4287792573 4288055491 4287923905 4287726780 4287792571 4287989950 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288516545 4288648131 4288648133 4288648133 4288713926 4288648133 4288648133 4288977096 4290227664 4291083226 4291477982 4291017179 4289503689 4289042887 4289042891 4288911305 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289372106 4289372106 4289372106 4289372106 4289372106 4289372106 4289372106 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290227666 4290161873 4290227666 4290293459 4290293459 4290227666 4290227666 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886361 4290886363 4290886363 4291478750 4292268517 4292597734 4292466150 4292005345 4291149533 4291017947 4291017947 4291083740 4291149533 4291083740 4291149533 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347164 4291347164 4291742176 4292597484 4292992240 4292860908 4292729322 4291939554 4291610590 4291413211 4291478750 4291610336 4291610336 4291544543 4291610590 4291676129 4291676129 4291676129 4291676129 4291676129 4291742176 4291742176 4291742176 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292202727 4292268520 4292202726 4292071138 4292334310 4292926701 4293255917 4293321710 4293387249 4293387249 4293124078 4292729322 4292466150 4292400357 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292795115 4292795115 4292729320 4292729320 4292795113 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293321967 4293519600 4293848565 4293980151 4293914358 4293650932 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387760 4293387760 4293453553 4293519346 4293782772 4294045944 4294111737 4294111735 4293914104 4293716725 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293716979 4293848565 4294111737 4294243321 4294243321 4294243321 4294374906 4294309113 4294111735 4294045942 4293914356 4293914356 4293914356 4293980149 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294243321 4294309113 4294440699 4294506492 4294506746 4294506746 4294506492 4294440699 4294374906 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286870457 4287068086 4287002544 4287002542 4287199925 4286014895 4283645078 4282197383 4282461831 4294373119 4294901492 4294967039 4294967295 4294836217 4294901755 4294901759 4294967291 4294835709 4294835455 4294966783 4294769407 4294901247 4294901503 4294967293 4284765831 4281145963 4281737596 4281540217 4281539970 4281803142 4282394762 4282262923 4282922125 4284830118 4286541239 4287199672 4287331509 4287133879 4285554346 4283053709 4282197129 4282197129 4282262922 4282262922 4282262922 4282197383 4282263176 4282394762 4283052942 4286212274 4287068337 4287200687 4287200436 4286804664 4285685680 4284105879 4283316114 4282394758 4282460553 4282526094 4282460301 4282526094 4282460555 4282592139 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282461323 4282395530 4282461323 4282527116 4282592655 4282592655 4282526862 4282592655 4282592907 4282592907 4282527114 4282527114 4282658700 4282658700 4282592907 4282658700 4282789516 4282789516 4282855311 4282789520 4282921106 4283052690 4282855309 4282986895 4283053460 4282856077 4283448465 4285093541 4286673078 4287397563 4287595192 4287660984 4287068598 4287134391 4287463354 4287660733 4287660733 4287726780 4287792573 4287660987 4287792311 4287857853 4286607283 4284106646 4282922123 4283250067 4283250069 4283250069 4283053709 4282856589 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4287596711 4281673572 4282198901 4282724475 4282921607 4283381906 4283513490 4283250837 4283448214 4283448214 4283448214 4283448469 4283448469 4283514262 4283514262 4283514262 4284108179 4294044927 4294967291 4294835455 4294967295 4294770674 4294901755 4294835711 4294967291 4294769914 4294901503 4294967039 4294703871 4294967039 4294967039 4294769663 4287530404 4285029516 4285489564 4285094295 4284830872 4284501406 4284040604 4283909016 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172442 4284172442 4284238235 4284172192 4284172190 4284369567 4284238235 4284304027 4284369821 4284172188 4284369569 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284698785 4284632992 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830369 4284830369 4284830369 4284896162 4284896162 4284896162 4284961955 4284961955 4284961957 4285093541 4284962209 4285225127 4285027748 4284962209 4285489315 4286344875 4288253121 4289108684 4289174477 4288977098 4288450501 4286871220 4285555110 4285225892 4285291172 4285225379 4285422758 4285225379 4285291172 4285422758 4285488805 4286212528 4287858617 4289042891 4289306063 4288516293 4287331768 4286278829 4285818027 4285620652 4285554598 4285620391 4285554598 4285620391 4285620391 4285751977 4285883563 4285751977 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080942 4286146734 4286212779 4286212525 4286080942 4286212274 4286344113 4286212525 4286608047 4288384707 4289701070 4289898701 4289636047 4289504210 4289503958 4288122305 4286673330 4286475951 4286475951 4286541744 4286541744 4286541744 4286541744 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286607794 4286739380 4286937013 4286805427 4286739634 4286871220 4286871220 4286937013 4286871220 4286937013 4286937013 4287002806 4287068598 4287068598 4287068598 4287002803 4287200182 4287200182 4287332022 4287530168 4288385727 4289636045 4290228434 4290294226 4290162640 4290294226 4290425813 4290227412 4289371852 4288253375 4287397813 4287397815 4287397561 4287397561 4287463354 4287529147 4287463608 4287463606 4287595191 4289043655 4290293975 4290557399 4290425812 4290557396 4290557399 4290162387 4289307082 4288516545 4287924410 4287660985 4287792573 4287858112 4287792573 4287858366 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288582340 4288648133 4288648133 4288582340 4288713926 4288779719 4288779719 4288845512 4289306312 4290490838 4291214558 4291017180 4289372105 4288911303 4288977098 4288911305 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289306313 4289306313 4289306313 4289306313 4289306313 4289372106 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290227666 4290227666 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820568 4290886363 4290952156 4291281373 4292268519 4292597482 4292465896 4292136933 4291149533 4291083740 4291017947 4291083740 4291149533 4291083740 4291083740 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291412959 4291281371 4291676383 4292531691 4292860654 4292795115 4292860906 4292400103 4291873761 4291479004 4291544543 4291676129 4291610336 4291544543 4291610336 4291676129 4291676129 4291676129 4291676129 4291676129 4291742176 4291742176 4291807969 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292136933 4292202726 4292202727 4292202727 4292202726 4292136931 4292334310 4292860908 4293255663 4293387249 4293453043 4293189871 4292729322 4292400357 4292334310 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292795115 4292729322 4292663529 4292729322 4292729322 4292729322 4292729322 4292795115 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124591 4293190383 4293321967 4293585393 4293848565 4293980151 4293848565 4293519346 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387760 4293453553 4293453553 4293651186 4293914358 4294111737 4294045942 4294111735 4294045690 4293782518 4293650932 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293782772 4294045944 4294177528 4294111735 4294177528 4294309113 4294309113 4294177528 4294111735 4293980149 4293914356 4293914356 4293980149 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294309113 4294374906 4294440699 4294506746 4294506746 4294506492 4294374906 4294309113 4294243320 4294243320 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286739380 4287068598 4287134132 4287002544 4286804914 4285225381 4282856332 4282000518 4288056263 4294571775 4294967284 4294967039 4294901503 4294835707 4294967295 4294901247 4291939301 4288320688 4287333793 4287004826 4289966016 4292269020 4294967293 4294901494 4284634507 4280817509 4280816999 4281606514 4282000772 4281737348 4282198147 4282987663 4285225633 4286738871 4287199674 4287199671 4287331257 4286344113 4284237981 4282461323 4282197129 4282131336 4282197129 4282262922 4282197129 4282197383 4282197383 4282328969 4282592141 4285027748 4287265718 4287398066 4287332022 4287397053 4287331008 4287132857 4285553327 4283316113 4282394758 4282328969 4282394508 4282723473 4282526348 4282263174 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282461323 4282395530 4282395530 4282527116 4282527116 4282461323 4282527116 4282592909 4282658700 4282724493 4282658700 4282592905 4282724491 4282724491 4282592905 4282658698 4282723723 4282855311 4282986897 4282855313 4282789520 4282789518 4282723723 4283118481 4283448465 4284501406 4286080942 4287331260 4287792319 4287792573 4287726778 4287726778 4287726780 4287858366 4287858366 4287660987 4287595194 4287792573 4287924159 4287858366 4288055230 4287726015 4286673079 4284435614 4283119504 4283381653 4283250067 4283250067 4282987916 4282790796 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4287662504 4281673572 4282199155 4282658936 4282987398 4283447697 4283447951 4283382421 4283382421 4283382421 4283382421 4283382676 4283448469 4283448469 4283448469 4283448469 4288846029 4294769151 4294967286 4294967295 4294901502 4294967290 4294901759 4294835711 4292795115 4289900223 4289439418 4288913074 4291084495 4292532192 4294900991 4294967293 4285819283 4282857844 4282989183 4283449222 4283777933 4283974809 4283711639 4283843223 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284106649 4284172442 4284238235 4284435360 4284172442 4284435611 4284501658 4284896416 4284961955 4284369820 4284435614 4284369821 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284632992 4284632992 4284632992 4284698785 4284698785 4284698785 4284698785 4284764578 4284764576 4284764576 4284830369 4284830369 4284830369 4284896162 4284896162 4284896162 4285224359 4285158820 4285028002 4284896416 4285093543 4285027748 4285159586 4285620390 4286673841 4288187077 4289042891 4289042887 4289174473 4288450501 4286673587 4285423269 4285291172 4285225379 4285356965 4285159586 4285225379 4285423012 4285686184 4286673079 4288977098 4289108682 4289174473 4289437647 4289240270 4288187329 4286937012 4285884325 4285686181 4285686183 4285817770 4285817770 4285620390 4285554597 4285686183 4285686184 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080688 4286146734 4286212779 4286146732 4286146734 4286212528 4286212527 4286212779 4286344876 4287858364 4289372106 4289701068 4289504459 4289701585 4289767378 4288319932 4286739123 4286475951 4286475951 4286541744 4286541744 4286475951 4286541744 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286673587 4286739380 4286805427 4286805427 4286805427 4286805427 4286805427 4286805173 4286870966 4286871220 4286871220 4286937013 4287002805 4287068598 4287068598 4287068850 4287397813 4287595191 4288384959 4289241034 4289965010 4290293973 4290162641 4290294227 4290228434 4290294227 4290096594 4289306312 4288187582 4287529401 4287331770 4287332022 4287397815 4287463354 4287463356 4287331770 4287397563 4287529147 4287660733 4287924924 4289504208 4290491354 4290557398 4290557398 4290623191 4290557145 4290622940 4289766863 4288977348 4288253375 4287858364 4287792319 4287923905 4287924159 4287792571 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288648133 4288582340 4288582338 4288648131 4288648131 4288779717 4288845510 4288845510 4288779717 4289701071 4290359252 4290622170 4289240520 4288911303 4288911305 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289240520 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290293459 4290227666 4290227666 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290755029 4290886363 4291017950 4291149533 4292202473 4292465898 4292334313 4292070887 4291149533 4291083740 4291017947 4291083740 4291149533 4291083740 4291083740 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291346912 4291346912 4291347166 4291479004 4291939554 4292465896 4292795115 4292860906 4292794861 4292202726 4291742176 4291610336 4291610336 4291544543 4291544543 4291676129 4291676129 4291676129 4291676129 4291741922 4291741922 4291807969 4291807969 4291873762 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292136933 4292202726 4292136934 4292136934 4292202726 4292202724 4292334310 4292663529 4293255664 4293387250 4293255664 4292860908 4292465896 4292334310 4292334312 4292334312 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292729322 4292729322 4292729322 4292663529 4292729322 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293190384 4293190383 4293387760 4293651186 4293848565 4293980151 4293782772 4293453553 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293387760 4293519346 4293585139 4293782772 4294111737 4294177528 4294045942 4294111735 4294111483 4293914104 4293716725 4293650932 4293585139 4293585139 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293782772 4293914358 4293980151 4293914356 4294045942 4294243321 4294309113 4294309114 4294177528 4294111735 4293980149 4293980149 4293980149 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294243320 4294309113 4294374906 4294506746 4294506746 4294506492 4294374906 4294309113 4294243320 4294243320 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286608045 4287002803 4287133878 4287199674 4286935997 4284895911 4282329735 4281605762 4291216593 4294967039 4294835448 4294967039 4294966271 4294967039 4294967039 4288058017 4280357964 4280291919 4280291920 4280489045 4280620885 4280160331 4282594923 4287332271 4283581821 4280949347 4281343592 4282001776 4281869182 4282132104 4283580053 4285422509 4287002292 4287133878 4287133878 4287133878 4285818021 4283646095 4282461323 4282066064 4282197129 4282131336 4282131336 4282197129 4282197129 4282197383 4282263176 4282328969 4282460301 4283580305 4286673330 4287200182 4287331771 4287396799 4287002293 4287001774 4284632222 4282658435 4282395012 4282526346 4282131336 4282262922 4282394762 4282460553 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282395276 4282527116 4282461323 4282461321 4282461321 4282527114 4282592909 4282395530 4282592141 4282723727 4282789520 4282657934 4282789518 4282789518 4282657932 4282723725 4282723725 4282723725 4282789520 4282657934 4282789520 4282921104 4282986895 4283513239 4285093793 4286475699 4287594429 4287726265 4287595191 4287792571 4287858112 4287660735 4287660987 4287595194 4287463354 4287331768 4287265975 4287068598 4286805426 4286673840 4286212779 4285817769 4285225127 4283645846 4282856079 4283250067 4283250321 4283316113 4282987916 4282790796 4294967039 4294967291 4294967039 4294967293 4294901500 4294967295 4287596711 4281607779 4282133362 4282658935 4282987397 4283316365 4283250570 4283316628 4283316628 4283316628 4283382421 4283382676 4283382676 4283382676 4283448469 4283448469 4291676632 4294967039 4294769908 4294967039 4294966783 4294967039 4294638843 4289506488 4283452258 4283780971 4283780720 4282727782 4281938011 4281477715 4283583089 4287991472 4284634758 4282331249 4282594174 4283317384 4283448716 4283843223 4283711639 4283975063 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284106649 4284172442 4284172442 4284304027 4284369818 4285356965 4286344114 4287067836 4286607286 4284896416 4284172439 4284304028 4284304028 4284304028 4284369821 4284369821 4284369821 4284369821 4284369821 4284501406 4284501406 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284632992 4284567199 4284567199 4284632992 4284698785 4284632992 4284698785 4284764578 4284698783 4284764576 4284764576 4284764576 4284830369 4284830369 4284830369 4284896162 4285026980 4284829853 4285159586 4284764830 4285159336 4284961957 4284961955 4285093793 4285225892 4286476462 4288384707 4288977347 4288911554 4288582340 4286937012 4285357731 4285225379 4285159586 4285291172 4285225379 4285357219 4285423012 4285357219 4286146735 4287397813 4288582340 4289240266 4289240520 4289174727 4289306059 4288845512 4287792570 4286278570 4285883560 4286278320 4286409907 4286015148 4285686181 4285554597 4285883563 4285751977 4285751977 4285817770 4285817770 4285817770 4285883563 4285883563 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286014895 4286212527 4286146986 4286081193 4286278318 4286212527 4286080939 4286410158 4287199931 4288253124 4289569231 4289898449 4289767631 4289636047 4289570252 4288781247 4286804916 4286541744 4286475951 4286541744 4286475951 4286475951 4286541744 4286541744 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739380 4286739380 4286673587 4286673841 4286805427 4286871220 4286937013 4286871220 4286870966 4286936759 4286936759 4286937013 4286937013 4287068598 4287265977 4287397563 4287858366 4288845259 4289569233 4289898964 4290228182 4290228180 4290293973 4290293973 4290162389 4290228180 4290162387 4289438668 4288122555 4287332020 4287200184 4287397312 4287529399 4287332022 4287397561 4287529149 4287463357 4287529150 4287594942 4287463356 4287595962 4288517061 4289965012 4290425813 4290294226 4290425812 4290557145 4290425561 4290622424 4290293207 4289635026 4288647880 4287924159 4287858112 4287989952 4287924157 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384961 4288516547 4288450754 4288450754 4288516547 4288516547 4288516547 4288582340 4288713926 4288516547 4288582338 4288713924 4288648129 4288648129 4288779715 4288779717 4288713672 4289108680 4289503691 4290095828 4289108680 4288911303 4288911305 4288845510 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306059 4289372106 4289372106 4289372106 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635278 4289635278 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290227666 4290161873 4290161873 4290293459 4290293459 4290293459 4290293459 4290359252 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886615 4290952154 4290952157 4290820570 4291610338 4291610590 4291215578 4290886615 4291149533 4291083740 4291017947 4291083740 4291149533 4291083740 4291083740 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291346914 4291346912 4291412959 4291347164 4291413210 4292136931 4292860908 4292926699 4292992240 4292531691 4292005348 4291610336 4291544543 4291544543 4291610336 4291676129 4291676129 4291676129 4291676129 4291676129 4291676129 4291742176 4291742176 4291742176 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292005347 4292136933 4292136934 4292136934 4292202726 4292202724 4292202724 4292400357 4293189871 4293255666 4293058287 4292597482 4292334310 4292400105 4292400105 4292400105 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292597736 4292729322 4292795115 4292729322 4292729322 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293190384 4293190383 4293453553 4293716979 4293848565 4293980151 4293782772 4293387760 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293321967 4293519346 4293650932 4293848565 4294177530 4294243321 4294111735 4294111735 4294177276 4293979897 4293716725 4293650932 4293585139 4293585139 4293585139 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848311 4293782772 4293782772 4293848565 4293782770 4293980149 4294243321 4294309113 4294374907 4294309114 4294177528 4294045942 4293980149 4293914356 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294243320 4294309113 4294374906 4294506746 4294506746 4294506492 4294440699 4294309113 4294243320 4294243320 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286278572 4286607285 4287002043 4287068086 4287003057 4286015911 4283712148 4281803399 4293981162 4294900991 4294967295 4294967290 4294966783 4294703864 4294966783 4281016662 4280226118 4280620625 4280488788 4280554581 4280752211 4280555343 4280555089 4280752217 4280818264 4281014888 4282001019 4284041610 4283317384 4283974809 4285620640 4287199674 4287002556 4287726526 4290359766 4292334561 4294967039 4294966783 4292465899 4289636045 4285487531 4282329219 4281868935 4281803652 4294967286 4294967293 4294900735 4294967293 4294901759 4294967295 4285884325 4286936751 4287200174 4287068847 4294967293 4294901503 4294901502 4294967293 4294967039 4294966783 4288121789 4282198149 4282264195 4282197899 4282394762 4282460553 4282329998 4288122557 4294967295 4294901247 4294967295 4294967291 4294901757 4294967295 4282198660 4282591890 4282526097 4282526344 4282658951 4282461071 4282724495 4282395276 4283382926 4287529398 4289965511 4292598247 4294769663 4294967288 4293321959 4291742425 4288320187 4283910800 4282527878 4282789767 4282855301 4283841685 4284962973 4286739380 4287265718 4287397304 4287791808 4287529150 4287529917 4289372370 4290886615 4292531438 4292597736 4294966527 4294967293 4294967295 4292664040 4291742437 4288452284 4284700567 4283185804 4282986895 4283184025 4283184528 4282922374 4283185044 4282987918 4282791046 4294967039 4294967295 4294967295 4294967293 4294967039 4294901754 4287597216 4281541482 4282002278 4282593407 4282724744 4287200936 4294901753 4294836222 4294901752 4294770427 4294967295 4294900735 4291938785 4283383177 4283053458 4283513741 4294177268 4294835455 4294967295 4294770427 4294967295 4294901500 4294966527 4282595426 4281543255 4282464359 4282924658 4282595175 4282003290 4281805657 4281739615 4282002538 4282133619 4282331503 4282988668 4283250823 4283711120 4283908751 4283711890 4284040351 4284040353 4283974558 4283580562 4285555108 4288977094 4291939554 4293453547 4294967033 4294966783 4293519089 4292071138 4289108933 4285357981 4283843987 4284172442 4284501406 4285555106 4286608045 4287726016 4288121023 4288450754 4287727294 4294835707 4294901759 4294967039 4294967295 4294901502 4294967039 4289109703 4284107161 4284173202 4284435613 4284566430 4284500888 4284435873 4289306829 4294901502 4294967293 4294967293 4294967295 4294901759 4294901503 4284370836 4284435865 4284632992 4284502171 4294967295 4294901754 4294967039 4294967293 4294967290 4294967033 4284436645 4284437146 4285819550 4290820822 4293519356 4294967293 4294967293 4290425043 4284765081 4284633242 4285093793 4284896675 4285027759 4285357478 4288055994 4291281625 4293190124 4293782257 4294967039 4294900991 4293651184 4292203239 4289504718 4286346144 4284831136 4285357470 4285291172 4285356466 4285489064 4286870717 4287726528 4289307332 4291479255 4292466147 4293848563 4294901500 4294967293 4293848303 4292926952 4291215578 4288056246 4285292185 4285357731 4285751723 4285816750 4286080171 4285554849 4285883560 4285949355 4285817769 4285949356 4285883309 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286871217 4288582087 4289832403 4289766861 4289635529 4289899217 4289635792 4288780485 4286871220 4286476462 4286542001 4286344622 4286410415 4286410415 4286542001 4286476208 4286673330 4286607537 4286673330 4286673328 4286607537 4286607537 4286738869 4286870455 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286739631 4286937012 4287068599 4287002806 4287002805 4287397815 4288253121 4289108682 4289833426 4289965010 4290096596 4290228182 4290228180 4290228180 4290162387 4290031055 4290293457 4290293205 4289371854 4288055743 4287463356 4287331770 4287331770 4287397563 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287463605 4287924156 4289108684 4290227161 4289372105 4289766861 4290425043 4290819801 4290557398 4290623191 4290491606 4289965010 4289043655 4288188096 4287793087 4287793089 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288582590 4288450750 4288582340 4288253121 4288253122 4288450501 4288253121 4288450754 4288384707 4288516293 4288450500 4288450754 4288582340 4288516547 4288450754 4288713672 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288713924 4288845510 4289042889 4289042889 4288977096 4288911303 4288911303 4288977096 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289701068 4289635275 4289635277 4289701070 4289766863 4289766863 4289766863 4289766861 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289965012 4290030803 4290096848 4290557396 4290689236 4290425810 4290360019 4290360020 4290228182 4290491354 4290228182 4290162389 4290293975 4290359768 4290359768 4290228182 4290425813 4290294227 4290360020 4290425813 4290491606 4290425813 4290491606 4290557399 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886363 4290952156 4291017949 4290952156 4290886363 4290952156 4291083742 4291017949 4290952154 4291017947 4291017947 4291083994 4291149787 4291215580 4291149787 4291149785 4291149787 4291215580 4291281373 4291281373 4291281373 4291281119 4291346912 4291346912 4291346912 4291346912 4291347166 4291347164 4291413211 4291610590 4292268519 4292992242 4292926701 4292860654 4292531691 4291939555 4291610590 4291544543 4291610336 4291676129 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292202727 4292136934 4292136934 4292202727 4292136933 4292136933 4292400103 4293124080 4292992494 4292597736 4292334310 4292334310 4292334310 4292334312 4292465898 4292465896 4292465896 4292531689 4292531689 4292531689 4292465896 4292531691 4292597484 4292531689 4292531689 4292597482 4292597736 4292597736 4292597734 4292597734 4292597734 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293256176 4293321969 4293519346 4293782772 4293980151 4293914104 4293650934 4293387762 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387760 4293453553 4293585139 4293782772 4293980151 4294111737 4294177528 4294111735 4294045690 4293848311 4293650932 4293585139 4293585139 4293585139 4293650932 4293716725 4293651186 4293651186 4293651186 4293716979 4293782772 4293782772 4293716979 4293716979 4293716979 4293782772 4293848565 4293848565 4293782772 4293848563 4294045942 4294177528 4294374906 4294374906 4294309113 4294111734 4293980148 4293980148 4293980148 4294045941 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294440953 4294506746 4294572285 4294506492 4294374906 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294374906 4294440699 4294506492 4294638078 4294703871 4294703871 4294638078 4294704125 4294704125 4294704125 4294638332 4294572539 4294572539 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4285225379 4284633244 4285488553 4287002041 4287068596 4286805426 4285423273 4282527625 4294901754 4294901247 4294967295 4294835961 4294967039 4294967291 4294834943 4280095807 4280423503 4280423505 4280817499 4281080674 4280817248 4280817250 4281080168 4280948584 4280883302 4281409395 4283317636 4286213030 4285883814 4285949356 4287331008 4286870960 4288978618 4294374143 4294967039 4294967290 4294967287 4294967290 4294835709 4294967295 4294966781 4291609568 4282594172 4282066824 4294966783 4294769151 4294966783 4294769916 4294770429 4294901503 4284765590 4286673327 4286805163 4287003057 4294967295 4294704383 4294967295 4294901500 4294966782 4294967039 4288187580 4281869695 4282066814 4282132106 4282328967 4282394758 4282264205 4288122557 4294967295 4294901247 4294967295 4294967291 4294901759 4294901502 4282133116 4282263172 4282263172 4282723727 4282395528 4282395530 4282395781 4288582089 4294241535 4294967039 4294900735 4294769407 4294967039 4294835967 4294966527 4294900991 4294769663 4294966527 4288253375 4282527367 4282526346 4283052933 4283316881 4283317133 4284370070 4285225630 4285883812 4290293457 4294440187 4294967291 4294901240 4294967039 4294835198 4294967295 4294967291 4294967290 4294638328 4294967039 4294966783 4294900223 4289174724 4283975566 4282986645 4283118481 4283317133 4282987665 4282987918 4282791046 4294967039 4294967295 4294901502 4294967293 4294967039 4294901754 4287530918 4281541984 4282199155 4282593659 4283712655 4293387250 4294638078 4294901759 4294638841 4294901757 4294967039 4294308603 4284634258 4282856833 4283382674 4283184779 4294967039 4294901503 4294835709 4294901759 4294704123 4294967293 4294966783 4281017413 4281345360 4281674075 4281871203 4282002538 4282199665 4282331251 4282265458 4282330738 4282462835 4282528882 4282988671 4283513742 4283776913 4283711120 4283909018 4283909020 4283646355 4286147496 4292398832 4294900735 4294967039 4294967039 4294901247 4294835455 4294967295 4294901500 4294901241 4294967291 4294966527 4292530922 4287595695 4286476713 4287397563 4288187329 4288252611 4288910790 4288385211 4287924927 4294901754 4294901503 4294967295 4294967295 4294901502 4294967293 4288978115 4283975573 4284041616 4284304027 4284500637 4284500888 4284370080 4289306829 4294901502 4294967293 4294967293 4294967295 4294901759 4294901503 4284107664 4284238484 4284501404 4284370585 4294967295 4294901754 4294967295 4294967293 4294967036 4294967293 4283910799 4286411939 4294439679 4294967291 4294901759 4294835958 4294967034 4292333293 4284436116 4284961704 4284436126 4284962973 4286938016 4292334312 4294967039 4294967293 4294967039 4294901247 4294967293 4294967286 4294967288 4294835711 4294967295 4294769151 4284962971 4284962710 4285160340 4285489056 4285423269 4285424541 4289899469 4294768895 4294703614 4294901247 4294967039 4294835707 4294835711 4294967295 4294900991 4294967039 4294966527 4290030538 4285358232 4285225894 4285620137 4285554597 4285817767 4285883560 4285751976 4285883562 4285883563 4285949102 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278829 4287068598 4288253122 4289240266 4289766863 4289766861 4289504459 4289438666 4287265978 4286344876 4286410415 4286476210 4286607796 4286476210 4286410417 4286410417 4286607283 4286739123 4286673330 4286673330 4286870709 4286804916 4286673330 4286673076 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286871219 4286739634 4286673841 4287002805 4287924159 4289174477 4289898449 4290096080 4290030801 4290096594 4290162389 4290162391 4289898964 4289438415 4288912071 4288583108 4289964240 4289437899 4288253375 4287332022 4287331770 4287397563 4287331770 4287265977 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287726780 4287463608 4287858364 4289108430 4288516545 4288319164 4288845762 4290030036 4290294227 4290491606 4290623191 4290491605 4290293973 4289767378 4288714440 4287793340 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4289240520 4289898450 4289635024 4288977096 4288648131 4288384959 4288319166 4288384959 4288516293 4288582086 4288516547 4288516547 4288516547 4288516547 4288582340 4288647879 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288779717 4288845510 4288911303 4288977096 4288911303 4288845510 4288911303 4288977096 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289635275 4289701070 4289766863 4289701070 4289701070 4289701070 4289766863 4289832656 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290030805 4289965010 4290228433 4291149787 4291807715 4291676131 4291281119 4290754775 4290491605 4290425812 4290294227 4290294227 4290228434 4290425813 4290623192 4290293973 4290294227 4290425813 4290491606 4290360020 4290360020 4290425813 4290491606 4290491606 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290820568 4290886361 4290952154 4291083740 4291083994 4291018201 4291018201 4291017947 4291083740 4291083740 4291149533 4291149533 4291149787 4291281373 4291347166 4291149785 4291215578 4291215580 4291281373 4291281373 4291281373 4291281119 4291346912 4291281119 4291346912 4291347166 4291347164 4291412957 4291544797 4292005347 4292597484 4292992494 4292926701 4292663275 4292202726 4291873762 4291807969 4291742176 4291610590 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292136933 4292136934 4292071141 4292136934 4292334312 4292268519 4292202726 4292334310 4292860908 4292795115 4292531943 4292334310 4292334310 4292334310 4292334312 4292465898 4292400103 4292400103 4292400103 4292400103 4292400103 4292465896 4292465896 4292531689 4292531689 4292531689 4292597482 4292663275 4292663529 4292663529 4292663529 4292663529 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293387762 4293519346 4293716725 4293848565 4293914358 4293848311 4293650932 4293453555 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387760 4293453553 4293519346 4293651186 4293848565 4294045944 4294111735 4294111735 4293914104 4293782518 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293651186 4293651186 4293716979 4293716979 4293782772 4293782772 4293782772 4293716979 4293782772 4293848565 4293848565 4293848565 4293782772 4293848563 4293980149 4294111735 4294243321 4294374907 4294374907 4294243321 4294111735 4294045942 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294440953 4294506746 4294506492 4294440699 4294374906 4294309113 4294243320 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294638078 4294703871 4294703871 4294638078 4294704125 4294704125 4294704125 4294638332 4294572539 4294572539 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4282658953 4282132609 4283251088 4285949104 4287002293 4287200184 4286870968 4284502171 4294901503 4294967295 4294967295 4294967295 4294967293 4294967033 4294834943 4287267998 4280357978 4280686173 4280817759 4280948836 4281211756 4281408368 4281473909 4281407604 4281409397 4282198909 4284897170 4286541995 4286870960 4287134132 4286804916 4289042879 4294967039 4294967293 4294901753 4294967293 4294967295 4294901247 4294967291 4294967286 4294967283 4294901241 4292399854 4282266224 4294966783 4294966783 4294835198 4294967290 4294901757 4294967295 4283186562 4285620388 4285489054 4286081704 4294967295 4294901759 4294967295 4294901502 4294900991 4294967039 4288056246 4281606774 4282001019 4282000518 4282328967 4282394758 4282264203 4288056764 4294967295 4294901247 4294967295 4294967293 4294901759 4294835961 4281870449 4282264442 4282526847 4282131590 4282263942 4283449231 4289964759 4294834943 4294967281 4294901490 4294967295 4294703871 4294901755 4294901752 4294967295 4294967039 4294967291 4294901746 4294900991 4290095577 4282461824 4282460805 4282657930 4282789520 4283052941 4283250321 4283514260 4292004591 4294967286 4294639344 4294967284 4294835960 4294967295 4294967039 4294967295 4294835709 4294901759 4294836222 4294770168 4294967291 4294966268 4292595950 4283449221 4282724746 4283053709 4282987918 4282987916 4282791046 4294967039 4294967295 4294901502 4294967293 4294967039 4294967291 4287859115 4281607777 4281936240 4282199164 4288385208 4294967039 4294967039 4294638332 4294901759 4294967293 4294572537 4288451771 4282659713 4282922121 4282922626 4283184527 4294900735 4294967291 4294901500 4294967295 4294967291 4294770168 4294966527 4287728800 4281541986 4281673573 4282134124 4282528630 4282593913 4282725245 4283120005 4282725247 4282989179 4282923129 4283119751 4283776662 4283513741 4283974811 4283842972 4283646862 4288320185 4294966271 4294769655 4294901749 4294967290 4294967295 4294967293 4294967290 4294967290 4294967293 4294967295 4294901500 4294835960 4294966782 4294966527 4290491855 4287726777 4287990201 4288055743 4288450239 4288121785 4287201204 4294967293 4294835455 4294967295 4294967295 4294901503 4294967293 4288780734 4283646860 4283778697 4284106646 4284434843 4284500886 4284370078 4289241034 4294967295 4294967293 4294967293 4294967295 4294901759 4294901503 4283712904 4283909773 4284238486 4284238997 4294967295 4294901755 4294967293 4294769916 4294967295 4294901241 4285161870 4294439679 4294966782 4294967283 4294769916 4294967291 4294967039 4289043641 4284041867 4284107161 4284831637 4288780220 4294967291 4294967039 4294835455 4294835455 4294704123 4294967293 4294967291 4294836218 4294835960 4294967039 4294967290 4294967291 4284041616 4284765343 4285291674 4285028251 4285819551 4290820568 4294967039 4294704121 4294967295 4294967295 4294769914 4294901755 4294967295 4294835711 4294967295 4294967288 4294769906 4294967039 4291215329 4284963990 4285225630 4285423011 4285817769 4285686183 4285751976 4286015149 4285949356 4285751977 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212785 4286147247 4286476462 4287595194 4289042891 4289898450 4289898701 4289307332 4287529149 4286279083 4286476208 4286476210 4286410419 4286410417 4286476210 4286607796 4286541490 4286673076 4286541490 4286541490 4286739123 4286739123 4286673330 4286739123 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4287002552 4286936759 4286871220 4286937010 4287858363 4289372106 4290359250 4290227917 4290359252 4290227412 4289964242 4289306059 4288450754 4287660985 4287463354 4287660733 4288516545 4288121789 4287463606 4287134389 4287331770 4287331770 4287265977 4287463354 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529149 4287529149 4287463354 4287924159 4287726780 4287726778 4287792571 4288516294 4289569484 4290227666 4290754007 4290820052 4290820054 4290688215 4289898449 4288911301 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288977094 4290556380 4290753758 4290490584 4290161619 4289503691 4289108934 4288713922 4288516547 4288450754 4288450754 4288516547 4288516547 4288582340 4288582340 4288516293 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288779717 4288845510 4288845510 4288845510 4288779717 4288845510 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289569484 4289701070 4289701070 4289701070 4289766863 4289766863 4289701070 4289832656 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290162391 4290096594 4290557398 4291544545 4292071141 4292136934 4292136680 4291741922 4291741922 4291215578 4290886615 4290755029 4290426064 4290754775 4291412705 4291083740 4290491606 4290425813 4290360020 4290425813 4290425813 4290425813 4290425559 4290491352 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886361 4290886361 4290952154 4291347166 4291873508 4291939555 4291742176 4291742175 4291478750 4291347164 4291281373 4291215580 4291215580 4291478752 4292005096 4292465393 4291873762 4291544543 4291281371 4291149785 4291281373 4291412959 4291347166 4291215580 4291281119 4291347166 4291347166 4291347164 4291412957 4291413211 4291610590 4292071140 4292663527 4292926701 4292926701 4292597482 4292465896 4292465898 4292202726 4291742176 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292136934 4292136933 4292071140 4292136933 4292202726 4292202726 4292202726 4292268517 4292531689 4292531689 4292400103 4292268517 4292334310 4292334310 4292334312 4292400105 4292465896 4292465896 4292465896 4292400103 4292465896 4292465896 4292531689 4292597482 4292531689 4292531689 4292597482 4292597482 4292663275 4292663275 4292663529 4292663529 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293387760 4293716979 4293914358 4293914356 4293848563 4293848565 4293782772 4293650932 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293585393 4293782772 4293980151 4294111735 4294111735 4293782518 4293650932 4293519346 4293585139 4293585139 4293585139 4293650932 4293650932 4293651186 4293716979 4293716979 4293782772 4293782772 4293782772 4293782772 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293848563 4293914356 4293914356 4294177528 4294309114 4294440700 4294374907 4294177528 4294045942 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294440953 4294506746 4294506492 4294440699 4294374906 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294572285 4294638078 4294638078 4294638078 4294704125 4294704125 4294704125 4294704125 4294638332 4294572539 4294572539 4294572539 4294572539 4294572539 4294572539 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281671555 4281868934 4282198151 4284237981 4286475699 4287068085 4286673840 4285884325 4291940316 4294704121 4294967295 4294901247 4294901754 4294901753 4294967039 4294834943 4290097600 4283517047 4280948842 4281211256 4281343093 4281605744 4281473646 4281736568 4281737849 4283515014 4286410409 4286607796 4286805427 4287397815 4287661236 4294373626 4294901759 4294901759 4294901759 4294835967 4294966783 4294769407 4294967039 4294769914 4294835455 4294901759 4294967295 4289242303 4294901502 4294967039 4294967039 4294967034 4294901755 4294967295 4281673323 4283448968 4283186050 4283976078 4294835711 4294901759 4294901502 4294967295 4294967295 4294967039 4287858864 4281409646 4281935477 4281934979 4282263172 4282328965 4282264203 4288056764 4294967295 4294901247 4294967295 4294967293 4294835967 4294967291 4281146724 4281804143 4282066549 4282461323 4282330748 4289832403 4294967039 4294901753 4294901749 4294967293 4294835455 4294967295 4294967290 4294901751 4294835707 4294901754 4294967293 4294901757 4294967288 4294967039 4288977348 4282264452 4282790021 4282921104 4282658183 4282921106 4282592657 4290951654 4294638582 4294901759 4294835711 4294967039 4294769663 4294967039 4294835711 4294704382 4294835967 4294901759 4294967295 4294967039 4294967288 4294967286 4290951890 4282659706 4282790539 4282790789 4282922123 4282791301 4294967039 4294967295 4294901502 4294967293 4294967039 4294967293 4287661986 4281410149 4282330998 4283910281 4294571773 4294835447 4294835455 4294967295 4294703871 4294967291 4291676631 4282068847 4282133619 4282922375 4282593407 4283184777 4291873243 4294967291 4294967291 4294835711 4294901754 4294967291 4294901247 4294769151 4290754762 4284766596 4282265207 4282725253 4283120257 4282988922 4282922877 4283251339 4283120264 4283580808 4283646097 4283645076 4283711891 4284106144 4283251597 4288648129 4294967293 4294967291 4294967291 4294967039 4294835199 4294900991 4294967293 4294836211 4294770425 4294835455 4294966783 4294966783 4294967039 4294835455 4294967295 4294769918 4290491606 4287266981 4287726780 4286739631 4285884324 4284503188 4294835450 4294967295 4294967295 4294967295 4294967295 4294967293 4288517816 4283252355 4283449730 4283909267 4284369050 4284435093 4284304285 4289241034 4294967295 4294967293 4294967293 4294967295 4294901759 4294901502 4283318398 4283580805 4283909773 4284041616 4294967295 4294901757 4294835709 4294901503 4294967039 4294967288 4289965764 4294966783 4294900735 4294966783 4294901502 4294967290 4294966782 4289043643 4283713153 4283976327 4288715195 4294900735 4294901247 4294967039 4294901502 4294967039 4294966783 4294704127 4294901759 4294836215 4294967295 4294703871 4294966783 4293453292 4284107662 4284238745 4284567449 4285094047 4290821333 4294967039 4294901754 4294901503 4294901247 4294901759 4294901757 4294901759 4294967291 4294704123 4294967295 4294704121 4294967288 4294572789 4294967039 4290097863 4285029265 4285160348 4285554598 4285488804 4285883560 4285883563 4286080942 4285817767 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286146734 4286344113 4286344624 4286476208 4287265975 4288582340 4289437899 4289635275 4287792321 4286476462 4286607794 4286410419 4286278833 4286476210 4286476210 4286410415 4286673076 4286673076 4286673076 4286738869 4286673076 4286607537 4286673330 4286870707 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286673587 4286870966 4287068599 4286937010 4287332019 4288779715 4289964240 4290096080 4289569485 4288911301 4288187580 4287660984 4287397815 4287134391 4287134392 4287265724 4287266227 4287332022 4287265975 4287331770 4287397563 4287265977 4287265975 4287529147 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287397561 4287792319 4287660733 4287529147 4287529147 4287858112 4287660733 4287726526 4288055996 4289042887 4289964494 4290425042 4290820054 4290819801 4289898447 4288779969 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288516545 4290030036 4290885596 4291082972 4291017433 4290754008 4290424791 4290095829 4289371852 4288845510 4288516545 4288516547 4288516547 4288582086 4288648133 4288516547 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288845510 4288779717 4288779717 4288779717 4288779717 4288845510 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289569485 4289701071 4289635277 4289635277 4289898449 4289832656 4289701070 4289832657 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289899217 4290096594 4290820570 4291741924 4291939555 4292071141 4292334313 4292136934 4292268519 4291939554 4291807968 4291742176 4291347418 4291544543 4292005094 4291676129 4291083742 4290557398 4290294226 4290491606 4290623192 4290491352 4290425559 4290491352 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820568 4290820568 4290886615 4291544543 4292400106 4292597482 4292334564 4292466150 4292531689 4292400105 4292334312 4292268519 4292071141 4292005348 4292268520 4292597231 4292597484 4292202726 4291742176 4291347418 4291215578 4291215578 4291215580 4291215580 4291281373 4291412959 4291347166 4291412959 4291412957 4291347164 4291479004 4291742176 4292400355 4292926699 4293058285 4292926699 4292926701 4292860908 4292400103 4291610589 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071141 4292136933 4292202726 4292202724 4292136931 4292071138 4292136931 4292268519 4292268517 4292334310 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292465896 4292465896 4292465896 4292465896 4292465896 4292531689 4292597736 4292531943 4292597482 4292597482 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293321967 4293716979 4293980149 4293914356 4293848563 4293980149 4293914358 4293716725 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293453553 4293453553 4293453553 4293519600 4293716979 4293980151 4294111735 4294111735 4293716725 4293585139 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293651186 4293651186 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848565 4293848565 4293848565 4293848563 4293848563 4293848563 4294045942 4294243321 4294440700 4294374907 4294243321 4294111735 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294375160 4294440953 4294506492 4294506492 4294440699 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294638078 4294638078 4294704125 4294704125 4294704125 4294704125 4294704125 4294638332 4294638332 4294572539 4294572539 4294572539 4294572539 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736327 4281999499 4281671556 4282461321 4285027748 4286936248 4286936753 4286607784 4289965513 4294967039 4294835709 4294967039 4294967290 4294967290 4294638078 4294967295 4294967293 4294835711 4293321459 4287792820 4283251591 4281737082 4281605496 4281999992 4282527365 4285357721 4286739121 4287068345 4287002803 4286805676 4290622671 4294967039 4294901754 4294836220 4294901759 4294901757 4294572789 4294967293 4294901503 4294967039 4294901759 4294638839 4294836218 4294769407 4294967291 4294572535 4294967293 4294966527 4294901755 4294967295 4281015393 4281672559 4281738352 4282199414 4294835711 4294901757 4294836222 4294967295 4294967295 4294967293 4287728299 4281212517 4281541484 4281869182 4282263172 4282329219 4282198408 4288056764 4294967295 4294901247 4294967295 4294967293 4294835967 4294967293 4281212519 4281738098 4281868917 4282132605 4287332273 4294966783 4294901754 4294967295 4294967295 4294967291 4294638332 4294243071 4288518580 4287399845 4290360271 4294967039 4294967290 4294572796 4294901759 4294835958 4294966527 4285490586 4282329470 4282658184 4282724226 4283053193 4282724744 4288517046 4294967291 4294966783 4294966783 4293782259 4291545810 4291348429 4291348428 4294967295 4294638581 4294901749 4294967039 4294638079 4294967295 4294901490 4294966783 4285555608 4282527363 4282790537 4282856328 4282725508 4294967039 4294967295 4294901502 4294967293 4294967039 4294967293 4287794077 4281673323 4281870447 4290623695 4294967039 4294967283 4294967039 4294835707 4294967293 4294243063 4283253871 4281673572 4282133619 4282330992 4282988167 4282725247 4289240769 4294967039 4294967293 4294967295 4294639094 4294967291 4294769663 4294967295 4294966271 4294966783 4293518319 4288385460 4284502671 4283251850 4283382925 4283514763 4283580313 4283317132 4283711888 4283711637 4283974813 4283646105 4286279082 4294703103 4294901759 4294901759 4294638843 4294901759 4294967039 4294835455 4294966783 4294966783 4294966783 4294967039 4294769914 4294967290 4294638839 4294901759 4294704634 4294901755 4294834687 4287333793 4284568464 4284502171 4284172952 4284173206 4294967039 4294967291 4294967293 4294967295 4294967039 4294967293 4288254641 4282923386 4283186811 4283777935 4284303511 4284369554 4284238747 4289175241 4294967295 4294967293 4294901500 4294967295 4294901759 4294901500 4282857846 4283252092 4283712391 4283844492 4294967295 4294901757 4294967293 4294967039 4294703871 4294967288 4294967039 4294835448 4294966783 4294966527 4294967293 4294967283 4294835448 4288582838 4283318647 4285950870 4294834687 4294967039 4294901759 4294901757 4294901752 4294572786 4294967295 4294967039 4294967295 4294967293 4294769151 4294967039 4294967039 4291940308 4283582070 4283910281 4284370832 4288911552 4294835711 4294901757 4294901755 4294967039 4294901247 4294901503 4294111737 4289834691 4289769399 4292006361 4294967039 4294967039 4294835455 4294835711 4294967293 4294967291 4287200934 4284765841 4285357476 4285489315 4285686181 4285685930 4285817516 4285949353 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286146986 4286278572 4286475697 4286410419 4286278829 4286739633 4288055743 4289305809 4287989700 4286476462 4286476210 4286476212 4286476212 4286607794 4286608048 4286542254 4286739121 4286344363 4286541744 4286870455 4286673076 4286607537 4286739121 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286805427 4286805427 4286937013 4286871219 4287068596 4287989952 4288779466 4288779465 4287858366 4287397815 4287068850 4287134389 4287265975 4287265977 4287134391 4287200184 4287265977 4287265977 4287200184 4287200184 4287331770 4287397563 4287331768 4287265975 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287660987 4287595194 4287529401 4287660987 4287595194 4287660733 4287660733 4287792319 4287660735 4287924157 4288384959 4289240519 4290227412 4290424793 4289240520 4287858615 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288319168 4289108680 4290490838 4291017431 4291017429 4291149017 4291017180 4290951135 4290622172 4289437899 4288648131 4288582340 4288516293 4288516293 4288582340 4288648133 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288845510 4288845510 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289700817 4289766864 4289635277 4289569482 4289766861 4289766861 4289701070 4289832656 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290030801 4289965008 4290360019 4291083740 4291347164 4291676129 4292136934 4292005348 4292005345 4292136931 4292136933 4292202726 4292005347 4292005347 4292202726 4292071140 4291807717 4291215580 4290688982 4290491605 4290491605 4290425813 4290491352 4290557145 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886361 4290886615 4291544543 4292465898 4292729068 4292531943 4292663527 4292597734 4292531941 4292597736 4292663529 4292663529 4292597736 4292663529 4292794861 4292663275 4292663275 4292465898 4292071140 4291544797 4291281371 4291281371 4291412959 4291347166 4291412959 4291347166 4291412959 4291478750 4291412957 4291478750 4291676129 4292137185 4292729320 4292860906 4292926698 4292992492 4292992494 4292597482 4291676382 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071141 4292202726 4292465896 4292597736 4292597736 4292400357 4292334310 4292268519 4292268519 4292268519 4292268519 4292334312 4292334310 4292334310 4292400103 4292400103 4292334310 4292400103 4292465896 4292465896 4292466150 4292531943 4292531943 4292466150 4292597482 4292597482 4292597482 4292597482 4292597482 4292663275 4292729068 4292729068 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293256174 4293651186 4293914356 4293848563 4293914356 4293980149 4293848565 4293585139 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293453553 4293453553 4293453553 4293585393 4293782772 4294045944 4294111735 4294045942 4293782518 4293650932 4293585139 4293585139 4293650932 4293650932 4293585139 4293650932 4293651186 4293651186 4293716979 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293848565 4293848565 4293848563 4293848563 4293848563 4293980149 4294177528 4294309114 4294243321 4294111735 4294045942 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294309367 4294440953 4294572285 4294572285 4294506492 4294374906 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294440699 4294506492 4294572285 4294638078 4294704125 4294704125 4294769918 4294769918 4294704125 4294704125 4294638332 4294638332 4294572539 4294572539 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281933706 4281802120 4281933960 4281671555 4283053711 4285883311 4287133879 4286607784 4287793588 4294900479 4294967039 4294967039 4294967291 4294967291 4294901503 4294901754 4294967293 4294967295 4294967293 4294835450 4294966783 4290293456 4283449221 4281868932 4283711891 4286673577 4286870706 4286871219 4287134641 4287596211 4294176765 4294967039 4294704634 4294901759 4294835967 4294967293 4294967291 4294967039 4290031809 4287333539 4289045171 4294967039 4294967288 4294967290 4294770167 4294967293 4294704374 4294967295 4294901757 4294967295 4281015391 4281146213 4281540719 4281673072 4294967039 4294836220 4294901757 4294901503 4294901247 4294967291 4288123307 4281475940 4281278563 4281803901 4282197633 4282263426 4282198408 4287990969 4294967295 4294901247 4294967295 4294967293 4294901759 4294637819 4281212519 4281540973 4281803640 4282067568 4293255412 4294967286 4294901757 4294901759 4294769914 4294967293 4292202724 4281674589 4280818780 4281016157 4281081433 4283714927 4293848565 4294967293 4294967291 4294967293 4294901247 4289571006 4282001273 4282132354 4282921607 4282658435 4282921607 4288318657 4291938533 4287069865 4282397295 4281739880 4281213538 4281081954 4280950366 4281279834 4287596462 4294242559 4294769916 4294967290 4294835709 4294967039 4294900991 4288912574 4282527866 4282527116 4282724742 4282659713 4294967039 4294967295 4294901502 4294967293 4294967039 4294967293 4287793562 4281673321 4285359251 4294967039 4294769914 4294967291 4294967039 4294967291 4294967291 4287662506 4281476445 4281870949 4281936493 4282594164 4282791291 4282988168 4285621402 4294702079 4294967039 4294967293 4294901757 4294836220 4294967295 4294901500 4294967291 4294967036 4294967036 4294967036 4294967039 4291017429 4284963222 4283185806 4283316628 4283645844 4283646349 4283975063 4283645593 4283712401 4291741672 4294967290 4294901503 4294572798 4294901755 4294967288 4294967288 4292993507 4287334555 4284241783 4284373621 4287795358 4293454056 4294967290 4294967293 4294770175 4294704382 4294901759 4294967039 4291544794 4283515774 4283843989 4283514771 4283777941 4294966782 4294967290 4294967291 4294901502 4294967039 4294967293 4288123309 4282660465 4283055223 4283646347 4284171925 4284369554 4284238747 4289109448 4294967295 4294967293 4294901500 4294967295 4294901759 4294967291 4282529133 4283054966 4283515264 4283712904 4294967295 4294901759 4294967290 4294967295 4294835455 4294835707 4294901500 4294967286 4294967290 4294967039 4294900735 4294967039 4294966271 4288582587 4282989931 4292005345 4294967293 4294901754 4294639094 4294967290 4294901754 4294967291 4294967295 4291348431 4287399837 4285820300 4285688968 4288584614 4292269022 4291808469 4283318896 4283976328 4284173958 4293781743 4294901759 4294967295 4294704121 4294967293 4294967295 4292598244 4283780971 4283846010 4284899200 4285162622 4287005331 4294374398 4294967039 4294967039 4294835707 4294901754 4291018452 4284108930 4284831387 4285291934 4285554847 4286080688 4285817518 4286081193 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286344363 4286146986 4286146732 4286344113 4286278833 4286278831 4286805173 4287529150 4287594942 4286344622 4286344624 4286542005 4286476210 4286410669 4287332022 4288121535 4287726267 4286870960 4286607534 4286673330 4286607283 4286673330 4286804914 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4287002805 4286871219 4286937013 4286937013 4286871220 4287134392 4287331517 4287199931 4287068599 4287134392 4287200185 4287265977 4287134391 4287002803 4287068596 4287265975 4287200184 4287265977 4287200184 4287200184 4287265977 4287397561 4287331768 4287200182 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287660985 4287397813 4287529399 4287792571 4287595194 4287529401 4287660987 4287726780 4287858115 4287726526 4287792571 4288187582 4288779719 4288977098 4288450754 4287792570 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288516545 4290161619 4291083226 4291017431 4291083224 4290951640 4291017180 4290424791 4289372105 4288516543 4288450754 4288516293 4288516293 4288516547 4288648133 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288845510 4288845510 4288845510 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289569231 4289635278 4289701068 4289767115 4289767113 4289767115 4289766861 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290162387 4290030801 4289965262 4290294226 4290425810 4290754775 4291281373 4291412959 4291676383 4292005348 4292005348 4292136933 4292202726 4292136933 4292202724 4292334310 4292202727 4292070887 4291478750 4290689236 4290360017 4290425812 4290557399 4290557399 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886363 4290952156 4291017947 4291478750 4292202727 4292465898 4292465896 4292597482 4292663529 4292597736 4292597736 4292597736 4292597734 4292663527 4292729320 4292729320 4292729322 4292795115 4292794861 4292729070 4292400105 4292005348 4291610336 4291412957 4291347166 4291412959 4291347166 4291347166 4291478752 4291478750 4291478750 4291676129 4292268517 4292795115 4292795113 4292860905 4292992491 4292926699 4292729068 4291939554 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071141 4292202726 4292663529 4293124078 4293255664 4293058287 4292663275 4292268519 4292334312 4292268519 4292334312 4292334312 4292268519 4292334310 4292400103 4292400103 4292334310 4292465896 4292465896 4292465896 4292597736 4292729322 4292795113 4292729320 4292597736 4292597736 4292597736 4292531943 4292597736 4292597482 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293256174 4293585393 4293848565 4293914356 4293914356 4293848565 4293651186 4293321967 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293453553 4293453553 4293453553 4293585393 4293848565 4294045944 4294111735 4294045942 4293782518 4293650932 4293585139 4293650932 4293650932 4293650932 4293585139 4293650932 4293651186 4293651186 4293651186 4293716979 4293782772 4293782772 4293782772 4293716979 4293782772 4293782772 4293782772 4293782772 4293848565 4293848563 4293914356 4293848563 4293914356 4294045942 4294111735 4294111735 4293980149 4293980149 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294309367 4294375160 4294506492 4294572285 4294506492 4294374906 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294440699 4294506492 4294506492 4294572285 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294704125 4294704125 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802371 4281802372 4282065546 4281999751 4282000518 4284106395 4286409906 4286805167 4285819299 4291281371 4294900991 4294835196 4294835707 4294967293 4294967295 4294901500 4294769916 4294967295 4294769916 4294967293 4294770168 4294967039 4294966271 4287267495 4285094296 4286344616 4287199925 4286805173 4286410669 4289504457 4294966783 4294967295 4294835967 4294967295 4294967039 4294835455 4294834687 4284241268 4280424004 4280423757 4280555089 4283516529 4293848050 4294901745 4294967291 4294967295 4294704375 4294967290 4294836222 4294835707 4280818264 4281014880 4281474926 4281541232 4294967039 4294770427 4294901757 4294835967 4294901247 4294967290 4288649905 4282463086 4281607526 4281738362 4282197633 4282263425 4282132615 4287990969 4294967295 4294901247 4294967295 4294967293 4294967291 4294967039 4281081184 4281278050 4281738100 4286213539 4294967039 4294967291 4294836222 4294901754 4294967291 4294834687 4282793575 4281212768 4280883807 4281014878 4281278050 4280884054 4287530920 4294967295 4294901751 4294704123 4294967039 4294967039 4282660216 4282133371 4282264195 4282526344 4282921102 4283447948 4282264948 4282067065 4281936493 4281607526 4281278561 4281541737 4281673323 4281081435 4281345106 4287530921 4294967295 4294901747 4294901755 4294638335 4294967039 4291413208 4282002537 4282264195 4282593410 4282593920 4294967039 4294967295 4294901502 4294967293 4294967039 4294967293 4287727519 4281476443 4292597733 4294835709 4294901757 4294901247 4294901500 4294967291 4292334047 4281410903 4281608031 4281541735 4282463086 4282330487 4282988670 4282790537 4282791038 4290490586 4294769407 4294967291 4294901759 4294704382 4294967293 4294901503 4294704123 4294967295 4294967295 4294967293 4294506996 4294967039 4294966527 4287991469 4283448968 4283777684 4283514763 4283646098 4283711386 4286147494 4294966783 4294835960 4294835967 4294967295 4294967291 4294769914 4293322219 4284241771 4283715178 4284175477 4284175478 4284504440 4285294461 4294045439 4294900991 4294967039 4294638332 4294901759 4294770167 4294966783 4285358481 4283252355 4283646862 4283712401 4294967039 4294967036 4294967290 4294901503 4294967039 4294967293 4287991721 4282463340 4282923889 4283580554 4284106130 4284369553 4284172954 4289109703 4294967293 4294967293 4294901500 4294967295 4294901759 4294967291 4282265959 4282923378 4283383677 4283581316 4294967295 4294901759 4294770680 4294901759 4294967295 4294901502 4294967295 4294901502 4293388012 4286150533 4281938524 4282267229 4282464355 4284174205 4285293958 4294966783 4294770165 4294967288 4294967039 4294967293 4294835961 4294966527 4288254895 4282464355 4282135394 4282398048 4282464105 4282398562 4282530403 4286281105 4283121016 4283647109 4287990201 4294966266 4294901247 4294901503 4294967291 4294967291 4294769151 4284175729 4282859113 4283318900 4283976828 4284306044 4284701305 4289439670 4294900991 4294901243 4294769916 4294967295 4294637566 4285293454 4284503188 4285029016 4285292187 4285817516 4285620139 4285685665 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286146732 4286344111 4286409904 4286278318 4286212525 4286278831 4286344624 4286410417 4286739634 4286344622 4286410417 4286410417 4286344622 4286674092 4288450754 4289700817 4289568720 4288647622 4287463097 4286739121 4286673330 4286739123 4286739123 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286739634 4286805427 4286937013 4287002806 4287002806 4287002806 4287068345 4287134138 4287200184 4287068598 4286937012 4287002805 4287134391 4287265977 4287265977 4287200184 4287002805 4287200184 4287331770 4287331768 4287265975 4287331768 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287463608 4287529401 4287660987 4287660987 4287595194 4287726780 4287726780 4287595194 4287660987 4287792573 4287924159 4287989952 4287989952 4287924159 4287924157 4287989950 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288384708 4288384961 4289437898 4290622422 4290951640 4291017431 4291149019 4291149019 4290293457 4289503689 4288713922 4288450754 4288582086 4288582086 4288516293 4288582340 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288779717 4288845510 4288845510 4288845510 4288845510 4288845510 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289569485 4289569484 4289964494 4290425042 4290556628 4290556629 4290293459 4289832654 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4289899215 4290030801 4290030801 4290228180 4290162387 4290031055 4290294227 4290425813 4290886361 4291281119 4291478752 4291873508 4292268520 4292202726 4292202724 4292071138 4292268517 4292334312 4292005348 4291412957 4290820822 4290557396 4290557398 4290557399 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290754777 4290820570 4290886361 4291149787 4291478752 4291676129 4291742176 4291873762 4292005348 4292202727 4292400106 4292465898 4292531689 4292663529 4292729322 4292663529 4292795113 4292729320 4292663529 4292729068 4292729070 4292400106 4291807715 4291347164 4291347166 4291412959 4291347166 4291347166 4291412959 4291478752 4291478752 4291610338 4292400105 4292926447 4292860906 4292926698 4292992491 4292860906 4292663275 4291939554 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071141 4292202726 4292729322 4293321457 4293518835 4293255664 4292729068 4292202726 4292334313 4292268520 4292334312 4292400105 4292268519 4292334310 4292465896 4292400103 4292400105 4292531689 4292531689 4292531943 4292663529 4292992492 4293189871 4293189871 4292926699 4292926699 4292926699 4292860906 4292795115 4292729322 4292663529 4292663529 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293190383 4293519346 4293848311 4293914358 4293848565 4293716725 4293453553 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293453553 4293453553 4293453553 4293585393 4293848565 4294045944 4294111735 4294045942 4293782518 4293650932 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293651186 4293716979 4293848565 4293848565 4293782772 4293716979 4293782772 4293782772 4293782772 4293848565 4293848565 4293848563 4293914356 4293914356 4293914356 4293980149 4294045942 4293980149 4293914356 4293980149 4293980149 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294243574 4294375160 4294440699 4294506492 4294440699 4294374906 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294704125 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736830 4281868418 4281604993 4281933960 4281803142 4282395526 4284764830 4286475949 4286345394 4285754509 4292861410 4294967034 4294967295 4294835709 4294835709 4294901759 4294967291 4294967293 4294967295 4294638332 4294901759 4294836222 4294770429 4294901759 4289371592 4286015651 4285357721 4284765091 4283252622 4290294224 4294901503 4294967290 4294967293 4294901753 4294967290 4294900735 4287465377 4280226625 4280423757 4280686164 4280620372 4280751708 4285621902 4294967039 4294966527 4294901247 4294901759 4294901503 4294901759 4294901500 4280752470 4281080671 4281277801 4281541486 4294901247 4294901757 4294770427 4294901759 4294967039 4294770167 4289044662 4283384956 4282199917 4281672569 4282131840 4282263425 4282132615 4287990969 4294967295 4294901247 4294967295 4294967293 4294835960 4294967039 4280884054 4281278555 4281672559 4289042887 4294901241 4294967039 4294966783 4294967293 4294835709 4291347415 4280819015 4280818255 4281146969 4281212511 4281408869 4281607267 4284043124 4294966527 4294901503 4294967039 4294966783 4294967285 4284964493 4281804905 4282330238 4282658183 4282658181 4282592640 4282658432 4282197881 4281869938 4281672808 4281870438 4281475680 4281541987 4281410147 4281607777 4282331751 4294966783 4294967291 4294638839 4294901755 4294705137 4294966783 4281476442 4282330741 4282461824 4282528381 4294966782 4294967295 4294967295 4294967293 4294967039 4294967293 4287990444 4287727529 4294967039 4294901752 4294704127 4294901759 4294967295 4294967033 4284042872 4281411153 4281410147 4282002286 4282133359 4282988668 4282856328 4283251340 4283053709 4283516026 4292466399 4294967290 4294901759 4294901759 4294901755 4294967039 4294901759 4294572796 4294901759 4294704375 4294967291 4294967293 4294769918 4294901247 4287923646 4283251337 4283514509 4283843477 4283711386 4289043141 4294835448 4294967295 4294967039 4294901500 4294638328 4294967039 4288123309 4283583089 4284175226 4284503672 4284832638 4284767615 4284767612 4288847281 4294967039 4294704375 4294967291 4294835707 4294967290 4294966783 4288319415 4283055477 4283383937 4283515527 4294967039 4294967039 4294967290 4294901502 4294967039 4294967293 4287991975 4282397545 4282858096 4283580554 4284106130 4284303760 4284172954 4289109703 4294967293 4294967293 4294835707 4294967295 4294836222 4294967291 4282200166 4282857583 4283318138 4283515523 4294967295 4294901759 4294901759 4294770429 4294967293 4294901502 4294967295 4292269028 4282662498 4282004069 4282267489 4282069350 4282529649 4282661738 4288649653 4294966527 4294967039 4294835967 4294901502 4294769918 4294966783 4290821071 4282070099 4282200666 4282463587 4282726761 4282464359 4282726775 4283121535 4282925157 4283647360 4284042623 4289767366 4294967037 4294967293 4294967295 4294967034 4294967036 4291742173 4282727013 4282595175 4282924643 4283187053 4283647863 4283582321 4285819782 4294967039 4294967290 4294967293 4294966783 4294967293 4286412186 4284305807 4284765843 4285292187 4285422758 4286080436 4286080423 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278067 4286344114 4286278320 4286212525 4286278572 4286410415 4286476208 4286410415 4286213290 4286476208 4286410417 4286278831 4286608048 4287463606 4289240266 4289898449 4290029523 4289437134 4287857851 4286673327 4286673330 4286739123 4286607537 4286804914 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286870966 4286937013 4286871220 4286871219 4286937010 4286937010 4287002803 4287068598 4286937264 4287068596 4287134389 4287134391 4287134391 4287134392 4287200185 4287200185 4287331770 4287200184 4287200182 4287265975 4287265975 4287331768 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287594940 4287594940 4287529147 4287529147 4287726526 4287660733 4287660733 4287726780 4287792570 4287726778 4287660987 4287726526 4287858114 4287923905 4287924157 4287858364 4287924159 4287924159 4287924157 4287989950 4287989950 4288055743 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288187329 4288253375 4288779715 4290227412 4291082973 4291083226 4291214810 4291017431 4291148766 4290556377 4289503692 4288713926 4288582086 4288582086 4288582086 4288713926 4288582340 4288648133 4288648133 4288648133 4288713924 4288713924 4288713924 4288779717 4288779717 4288845510 4288845510 4288845510 4288779717 4288845510 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108680 4289108680 4289174473 4289174473 4289174473 4289240266 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289766864 4289635277 4290293457 4291214558 4291675363 4291675109 4291017180 4290030287 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290030801 4290096594 4289965010 4290030803 4290096596 4290030803 4290162389 4290162387 4290162641 4290294227 4290491605 4291083994 4291676129 4292005347 4292268517 4292202724 4292268771 4292071138 4292071140 4292136934 4291610336 4290754775 4290425812 4290557398 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290886364 4290886363 4290952156 4290952154 4290886361 4290952408 4291083992 4291083992 4291017949 4291281119 4291412959 4291412957 4291676383 4292136933 4292597482 4292729068 4292663527 4292663527 4292597736 4292465896 4292136933 4291807969 4291610590 4291478750 4291347166 4291412959 4291347166 4291347166 4291412959 4291412959 4291412959 4291544545 4291676382 4292400103 4292531941 4292860905 4292992491 4292926701 4292860654 4292202727 4291610336 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071141 4292202726 4292795115 4293321456 4293321456 4293058285 4292597482 4292202726 4292268520 4292268520 4292334312 4292400105 4292268519 4292334310 4292465896 4292400103 4292400105 4292400103 4292400103 4292400357 4292663529 4293124078 4293453043 4293453043 4293518835 4293518835 4293453042 4293321457 4293189871 4292992492 4292860908 4292729322 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124590 4293453555 4293782518 4293914358 4293782772 4293585139 4293387762 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293453553 4293453553 4293387760 4293519600 4293782772 4294045944 4294111735 4294045942 4293782518 4293650932 4293519346 4293585139 4293585139 4293585139 4293650932 4293650932 4293782772 4293716979 4293716979 4293782772 4293848565 4293914358 4293848565 4293716979 4293782772 4293848565 4293848565 4293848565 4293848565 4293848563 4293914356 4293914356 4293914358 4293980151 4293980151 4293914358 4293914358 4293980151 4294045944 4293980151 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294243574 4294309367 4294374906 4294374906 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294440699 4294638332 4294572539 4294572539 4294572539 4294638332 4294704125 4294704125 4294704125 4294769918 4294704125 4294704125 4294704125 4294704125 4294704125 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281802374 4281933960 4281604995 4281868164 4282131586 4282921353 4285816499 4285818773 4283712906 4282002286 4287465127 4294967039 4294769918 4294967295 4294967286 4294967284 4294966782 4294769663 4294901759 4294836220 4294769914 4294967295 4294966782 4294111734 4283713670 4282198913 4282066561 4281934975 4291807196 4294835709 4294901759 4294967295 4294835707 4294967293 4294967039 4281279831 4280292171 4280620884 4280752211 4281145946 4280883041 4280884057 4293124327 4294967291 4294967295 4294900991 4294835961 4294901759 4294967293 4280489299 4281212259 4281409133 4281409648 4294835455 4294901755 4294967295 4294967295 4294835707 4294967293 4288781740 4283121521 4282133108 4281803123 4282262661 4282328967 4282132609 4288055996 4294967039 4294901243 4294966527 4294967287 4294901759 4294967291 4280752219 4281212760 4281803893 4291610324 4294967295 4294901757 4294967288 4294901503 4294900735 4287530918 4280622406 4280556110 4281279329 4281345126 4281344623 4281608298 4281609048 4294834431 4294967039 4294770168 4294967286 4294967286 4287794093 4281738855 4282264177 4282395001 4282921096 4282658181 4282133118 4284635787 4287926443 4291413723 4292334572 4294901502 4294967288 4294901247 4294111222 4291413210 4294967039 4294967293 4294967295 4294901500 4294967295 4294967039 4281476194 4282067568 4282330487 4282331000 4294967039 4294901503 4294967293 4294967291 4294967039 4294966782 4288453296 4294045692 4294901754 4294967291 4294966783 4294967039 4294967039 4287531170 4281410137 4281607516 4281673311 4282462578 4282659452 4282988168 4283250318 4283447699 4283119753 4282857346 4282463088 4287925679 4294966783 4294835960 4294967291 4294967295 4294901754 4294901755 4294967295 4294967295 4294835711 4294967295 4294967295 4294967293 4294111734 4283516544 4283120518 4283645844 4283646598 4292136163 4294769663 4294901755 4294901759 4294770429 4294967295 4294966783 4284439665 4284109682 4284372856 4285030784 4285491086 4285688717 4285622923 4286083223 4294835711 4294967039 4294967295 4294967295 4294901759 4294967039 4291479502 4282595693 4283120765 4283252618 4294967039 4294967295 4294901503 4294967295 4294835961 4294967295 4287860648 4282332268 4282791802 4283646850 4284106132 4284369567 4284173206 4289109448 4294966783 4294901500 4294967293 4294835196 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967291 4294835707 4294967291 4294769655 4294966783 4285162373 4282266210 4282134622 4282463330 4282726763 4282989433 4283056245 4291676634 4294967293 4294967295 4294770427 4294901500 4294901754 4294967039 4283715178 4282266976 4282397796 4282989933 4283054962 4283187060 4283515776 4283581821 4283778697 4283976325 4283779718 4292202984 4294901755 4294901753 4294967291 4294967295 4294966783 4288189611 4282596194 4282398314 4283121788 4283385207 4283779967 4283648633 4283583341 4294966271 4294900991 4294967293 4294967039 4294967039 4288781491 4283845758 4284502418 4285291934 4285160602 4285883560 4285817770 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212527 4286344113 4286344111 4286278318 4286344111 4286344111 4286409904 4286475697 4286410669 4286278831 4286410419 4286542003 4286739631 4288384961 4289832657 4290030036 4290029523 4288779206 4287068339 4286739123 4286804916 4286541742 4286673330 4286804662 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286739380 4286937013 4286937013 4286871219 4287002805 4287002805 4286937012 4287002806 4287068085 4287199671 4287199671 4287133878 4287133878 4287199672 4287331258 4287331258 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792571 4287792571 4287792571 4287792571 4287858114 4287989952 4287924156 4287924156 4287989952 4288055745 4287989950 4288121789 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253122 4288253122 4288450754 4289503438 4290753759 4290687963 4290556629 4291280352 4291017433 4291214559 4290753756 4289635278 4288713924 4288516545 4288582338 4288582336 4288582340 4288648133 4288648133 4288648133 4288648133 4288713926 4288713926 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288845508 4289042887 4288977094 4288911301 4288977862 4288912324 4289833422 4290030801 4289503691 4289108680 4289108684 4289240268 4289306059 4289108934 4289306313 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289438668 4289636045 4290162641 4291412959 4291742176 4291807715 4291149535 4289899217 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290162387 4290228180 4290294227 4290820570 4291610084 4292070889 4292005094 4291939555 4292004326 4292070119 4292004326 4291872742 4291675363 4291214812 4290754007 4290622421 4290622421 4290622422 4290622938 4290491606 4290557396 4290689236 4290557396 4290623192 4290755029 4290623189 4290754777 4290754777 4290820571 4290886363 4290754777 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291083740 4291018201 4291018201 4291018199 4291215578 4291873762 4292465899 4292531692 4292136682 4291939303 4291676131 4291478752 4291412959 4291412959 4291347166 4291281373 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291479004 4291676383 4291939555 4292334312 4292794861 4293058287 4292795115 4292400355 4291807715 4291676129 4291610336 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4291939555 4292005348 4292005348 4292071140 4292071140 4292071140 4292005347 4292005347 4292334310 4293058287 4293255664 4293321457 4293189871 4292400103 4292334312 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400105 4292465896 4292400103 4292466150 4292531943 4292663527 4293058285 4293650422 4293453555 4293453555 4293387760 4293519346 4293519348 4293124591 4292729581 4292663790 4292729068 4292663275 4292663529 4292729322 4292795115 4292795115 4292860908 4292860908 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293058797 4293124590 4293190383 4293124588 4293387760 4293782518 4293848311 4293585139 4293321967 4293256174 4293256174 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293453555 4293453555 4293387760 4293519346 4293782772 4294045944 4294111735 4293980149 4293782518 4293650932 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293782772 4293651186 4293585393 4293848565 4294111737 4294177530 4293980149 4293782770 4293782772 4293848565 4293848565 4293782772 4293782772 4293914358 4293914358 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294045942 4294045942 4294111735 4294111735 4294111735 4294111734 4294045942 4294111735 4294243321 4294374907 4294309114 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294638078 4294638078 4294638078 4294769918 4294769918 4294769918 4294769918 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281736581 4281933960 4281802374 4281868165 4281934211 4282066047 4283447697 4283316883 4281474176 4281540221 4280620384 4282726509 4287333542 4293058285 4294835709 4294900991 4294967036 4294967291 4294967295 4294835967 4294967295 4294638328 4294967039 4294967039 4287333041 4281540979 4281606263 4281474424 4294176251 4294967295 4294901759 4294967295 4294967293 4294967295 4291940308 4280161353 4280620884 4280686424 4281080923 4281079904 4281343342 4281147229 4289504960 4294967293 4294769916 4294901503 4294967295 4294901759 4294901500 4280818264 4281146466 4281211754 4281607027 4294967039 4294901755 4294835711 4294967295 4294901500 4294967295 4288123560 4281936996 4281343594 4281934963 4282065533 4282329219 4282395777 4288253373 4294703612 4294901753 4294967039 4294967293 4294901755 4294967293 4280883805 4281278301 4281540719 4293979122 4294967295 4294901757 4294967293 4294901502 4294967295 4294835455 4294967295 4294967039 4294835450 4294901243 4294966783 4294967039 4294440692 4294967290 4294901754 4294967295 4294835455 4294966783 4288781491 4281344356 4282066812 4282592391 4282395260 4285160088 4291938547 4294967039 4294967293 4294967288 4294901503 4294967290 4294835961 4294966783 4294967291 4294966782 4294967039 4294967293 4294967295 4294967293 4294967295 4294967039 4281410401 4281935980 4282264694 4282265207 4294967039 4294901503 4294967293 4294967291 4294967039 4294967039 4294901502 4294967295 4294967290 4294901754 4294967039 4294900991 4292071389 4281214290 4281410137 4281475932 4282265196 4282264945 4282659454 4283119754 4283447697 4283447697 4283251086 4282922121 4282791046 4282330998 4283451003 4288057264 4293058797 4294967295 4294967039 4294967039 4294835711 4294967295 4294835709 4294967295 4294638330 4294967295 4294967039 4288319932 4283120514 4283317132 4284172942 4293847031 4294967039 4294704887 4294901757 4294901757 4294967295 4292664291 4284175980 4284241268 4285162373 4285622924 4286083225 4286543776 4286543776 4286214560 4293453547 4294769914 4294967291 4294967295 4294901759 4294703871 4293255913 4282529900 4282989179 4282660735 4294967039 4294967293 4294901503 4294967295 4294901754 4294967295 4287729062 4282266475 4282594425 4283581059 4283974796 4284238232 4284239250 4288978117 4294835455 4294967288 4294967293 4294900735 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967293 4294967295 4294967293 4294967293 4292400354 4282069848 4281805661 4282595175 4282857836 4283187061 4283252605 4283450749 4293453296 4294967295 4294769916 4294967295 4294967293 4294967291 4293190635 4282135894 4282200933 4282726763 4283055474 4283778687 4284042372 4283976074 4284305292 4284370832 4284371085 4284437395 4293979900 4294967291 4294967295 4294638328 4294967291 4294967290 4294901751 4294967287 4294967290 4294901241 4294967293 4294967039 4294901247 4294967039 4294967295 4294901500 4294967295 4294967039 4294967039 4289571004 4283648633 4284107914 4284765590 4285686946 4285554595 4285883563 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212527 4286344113 4286344111 4286278318 4286344111 4286344111 4286344111 4286475697 4286344622 4286344624 4286542005 4286542001 4287660987 4289371854 4289964243 4289898449 4289634767 4287989437 4286739121 4286739123 4286804916 4286673328 4286739123 4286673076 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286871220 4286937013 4286871220 4286805427 4286937012 4286937013 4286937013 4287068599 4287068085 4287068085 4287133878 4287199671 4287199671 4287265464 4287331257 4287265464 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792571 4287792571 4287858364 4287858364 4287792321 4287989952 4288055742 4287924156 4287924159 4287989952 4288055743 4288121535 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288318915 4288384707 4288319168 4288845510 4289503692 4289503691 4289635275 4290556631 4291280603 4290820054 4290951387 4290819549 4289701071 4288713922 4288582340 4288582340 4288582340 4288582340 4288648133 4288648133 4288713926 4288713926 4288779719 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911303 4288911303 4288911301 4289174473 4290228184 4290951905 4291346915 4291017949 4289766861 4289174727 4289174475 4289174475 4289240266 4289108934 4289306313 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289438668 4289701838 4290228434 4291412959 4291742176 4291807715 4291017949 4289833424 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290228180 4290293973 4290294227 4290491605 4290886363 4291083740 4290952408 4290952408 4290820054 4290885847 4290820054 4290754261 4290819800 4290688214 4290556628 4290556628 4290622421 4290622422 4290622938 4290688985 4291149787 4291610336 4291610338 4291610084 4290886615 4290754775 4290754777 4290754777 4290820571 4290886363 4290754777 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291083740 4291083740 4291083994 4291083994 4291083992 4291412957 4291610336 4291544797 4291412959 4291347166 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291412957 4291544543 4291676383 4291873761 4292268519 4292663275 4292729322 4292597736 4291807715 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4291939555 4292005348 4292005348 4292071140 4292071140 4292071140 4292071140 4292136933 4292400103 4293058287 4293255664 4293321457 4293124078 4292334310 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400105 4292465896 4292400103 4292466150 4292531943 4292597734 4292926699 4293387250 4293519348 4293519346 4293453553 4293453553 4293453553 4293124591 4292729579 4292597995 4292597736 4292729322 4292795115 4292795115 4292729322 4292729322 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4292993004 4293058797 4293058797 4293058797 4293058797 4293058797 4293058797 4293124590 4293124590 4293321969 4293650934 4293716727 4293453555 4293256176 4293256176 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387762 4293453553 4293585139 4293848565 4294045944 4294111735 4294045942 4293782518 4293650932 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293651186 4293651186 4293848565 4294111737 4294243323 4294045942 4293848563 4293782772 4293848565 4293848565 4293782772 4293782772 4293914358 4293914358 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294045942 4294045942 4294111735 4294111735 4294111735 4294111734 4294045942 4294177528 4294309114 4294440700 4294374907 4294243321 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294638078 4294638078 4294769918 4294769918 4294769918 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281933958 4281736579 4281868167 4281802120 4281802374 4281868164 4281802625 4281868414 4281604743 4281868164 4281342840 4281145714 4281014378 4280620635 4280423757 4285489815 4290293708 4294900735 4294967291 4294769916 4294967039 4294967295 4294967293 4294835199 4294703871 4290360523 4281344107 4281277550 4281606010 4294966783 4294967295 4294901759 4294835709 4294835709 4294967039 4290821576 4280424275 4280752217 4281015138 4280949088 4281671538 4281474426 4281541482 4287398832 4294901502 4294967293 4294967290 4294967039 4294901759 4294835707 4280949850 4280949087 4281211754 4281475441 4294967039 4294770425 4294967039 4294967295 4294967291 4294901502 4287596965 4281081436 4281540719 4281803375 4282263164 4282263425 4282001273 4288122555 4294966782 4294967288 4294835455 4294967039 4294770678 4294967039 4280818012 4281146718 4281343592 4294967039 4294901502 4294901757 4294770429 4294901759 4294901759 4294835711 4294835711 4294967295 4294901503 4294967295 4294769914 4294770168 4294967290 4294901751 4294901751 4294770168 4294901759 4294835967 4291413973 4281739880 4281738362 4282264696 4287594930 4294965503 4294901247 4294770673 4294900991 4294967293 4294769914 4294967293 4294967039 4294900735 4294900989 4294967039 4294967039 4294967293 4294967295 4294967293 4294967295 4294967039 4281344607 4281870187 4282198901 4282265207 4294967039 4294901503 4294967293 4294967291 4294967039 4294967039 4294967288 4294967295 4294440949 4294967291 4294835711 4294967039 4293321457 4281214292 4281542238 4281936744 4282264945 4282527868 4283382925 4283251086 4283316879 4283580051 4283382423 4283119502 4283053958 4282857346 4282528379 4281739366 4281740634 4286149265 4290229447 4294966783 4294901247 4294967295 4294967293 4294901500 4294967295 4294967295 4294769663 4291084243 4282265456 4283975314 4285488802 4294966783 4294967039 4294901754 4294836218 4294967291 4294967293 4291874775 4284175981 4284701822 4285425295 4285885077 4286476710 4286674089 4286477227 4286214059 4292269020 4294967288 4294967288 4294901247 4294901757 4294901503 4294966783 4282200935 4282660467 4282792319 4294967039 4294835707 4294967295 4294967295 4294967293 4294835709 4287860646 4282266729 4283186562 4283383426 4284040586 4284172691 4284370834 4289109701 4294967039 4294836210 4294704375 4294966783 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967295 4294967295 4294769916 4294966782 4289834428 4281543506 4282660716 4282858095 4283318138 4283778438 4283713155 4283976327 4294967039 4294901503 4294901754 4294967295 4294967295 4294901502 4291545558 4281740885 4282727280 4283318649 4283318649 4284107654 4284502672 4284304788 4284765081 4284765330 4284634258 4284568729 4294967039 4294835707 4294835711 4294967295 4294901503 4294967295 4294901503 4294900991 4294967039 4294967039 4294967288 4294835960 4294769914 4294967293 4294901754 4294967291 4294967295 4294835455 4294967291 4291545048 4283385457 4284436878 4284699797 4285160348 4285620388 4285949355 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212527 4286278320 4286278318 4286278318 4286409904 4286344111 4286344111 4286409904 4286410417 4286344626 4286476212 4286739634 4288582086 4289832657 4289964242 4289701070 4288778953 4287068339 4286541744 4286738869 4286673330 4286739121 4286804914 4286607537 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286805427 4286937013 4286937013 4287002806 4287068599 4287002806 4286937013 4286937013 4287331257 4287199671 4287199671 4287199671 4287199925 4287199925 4287199925 4287199925 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792571 4287792571 4287858364 4287858364 4287989698 4287858364 4287858617 4288055996 4288055743 4287989952 4287989952 4288055742 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288318914 4288253121 4288319168 4288648131 4288450750 4288648129 4289372106 4290491089 4291083226 4291214812 4291017179 4290754010 4289898449 4288911303 4288582086 4288582340 4288582340 4288648133 4288648133 4288713926 4288713926 4288779719 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911303 4288911303 4289042887 4289174727 4290359768 4291478501 4291478498 4291083994 4290095826 4289306313 4289174475 4289174475 4289240266 4289108934 4289306313 4289240268 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289504461 4289701838 4290294227 4291478752 4291742176 4291741922 4290952156 4289833424 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290162641 4290228434 4290228434 4290294227 4290360020 4290360020 4290360019 4290360019 4290490835 4290556628 4290490835 4290425042 4290556629 4290622422 4290622422 4290754008 4290688215 4290688217 4290622938 4290754777 4291544543 4292334312 4292268520 4292136680 4291083994 4290820568 4290820570 4290754777 4290754778 4290820570 4290754777 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017949 4291017947 4291083740 4291083740 4291083994 4291149787 4291215580 4291083992 4291149787 4291149787 4291149787 4291149787 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291412959 4291544543 4291544543 4291544797 4291676383 4292005347 4292268519 4292400103 4291741922 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292071140 4292071140 4292071140 4292071140 4292202726 4292531689 4293189873 4293321457 4293321457 4293058285 4292334310 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292465896 4292400103 4292465896 4292466150 4292466150 4292729320 4293058285 4293387760 4293519346 4293453553 4293453553 4293519346 4293387762 4293058798 4292861165 4292729322 4292729322 4292729322 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293058797 4293058797 4293124590 4293124590 4293124590 4293190383 4293256176 4293453555 4293453555 4293256176 4293256176 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387762 4293453553 4293519346 4293716979 4293914358 4293980151 4293980151 4293716725 4293585139 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293651186 4293716979 4293914358 4294177530 4294243321 4294111735 4293914356 4293848565 4293848565 4293848565 4293782772 4293848565 4293914358 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294243321 4294374907 4294506493 4294374907 4294243321 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294638078 4294638078 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281933957 4281868165 4281802374 4281802120 4281736327 4281868167 4282065544 4281868164 4281933706 4281539453 4281605495 4281671286 4281014378 4281080420 4280949087 4280620120 4280555341 4283516526 4293847803 4294967295 4294769914 4294835707 4294901503 4294967039 4294967295 4293256168 4280489049 4281409387 4281408886 4294966782 4294967295 4294901759 4294967293 4294967295 4294769663 4291479252 4280358482 4280554842 4281080681 4281540721 4281737081 4281408384 4281869946 4287793592 4294901503 4294967291 4294967291 4294901503 4294901759 4294901500 4280818264 4280949087 4281606512 4281475441 4294901247 4294901755 4294967039 4294572537 4294967290 4294967295 4287399334 4280752219 4281277549 4281934961 4282132089 4282460301 4281935487 4290557145 4294967291 4294901754 4294967039 4294901503 4294836213 4294967039 4280949596 4281146466 4281541224 4294967037 4294967295 4294901757 4294901759 4294901759 4294507255 4294901757 4294967293 4294967293 4294704375 4294967288 4294967295 4294967295 4294769916 4294769914 4294967293 4294901759 4294836222 4294770175 4291940819 4282004067 4281673586 4283844991 4294045182 4294967039 4294704123 4294901755 4294967039 4294967293 4294967039 4294242808 4291281873 4291742425 4291282127 4291479252 4294967039 4294967293 4294967295 4294967293 4294967295 4294967039 4281278814 4281738855 4282133108 4282199414 4294967039 4294901503 4294967293 4294967291 4294967039 4294967039 4289440434 4294900735 4294967039 4294967293 4294901500 4294967291 4294967039 4287531170 4281410650 4282068331 4282396795 4282856328 4282856330 4283185293 4283909016 4283448465 4283909267 4285094046 4285620639 4284173447 4282594164 4282726009 4282199917 4282002535 4282201688 4284636280 4293848314 4294967295 4294835961 4294967291 4294704123 4294967039 4294967295 4293321959 4282265707 4283054464 4283975563 4294966527 4294967039 4294901754 4294967293 4294967293 4294835709 4291874521 4284109936 4283977594 4283976577 4284634255 4284699797 4284436627 4284238995 4284305560 4291479252 4294967288 4294967288 4294967039 4294836218 4294967295 4294966527 4282003556 4282528879 4283187330 4294967036 4294967293 4294967293 4294572537 4294967293 4294967295 4287926694 4282069349 4282857597 4283580808 4284237967 4284238235 4284238997 4291215328 4294967291 4294835958 4294967295 4294835455 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294901502 4294967039 4294967295 4294835198 4288123558 4282069597 4282923891 4282989684 4283646852 4284106898 4284305293 4284305041 4294967039 4294769407 4294967290 4294901503 4294967295 4294769916 4291479766 4282661989 4282463856 4283449983 4283976327 4284502159 4284699799 4284765089 4285093795 4285028502 4285160350 4284633755 4294967291 4294967295 4294967295 4294967295 4294769918 4294967295 4294967295 4294967293 4294967034 4294901240 4294967039 4294967039 4294967039 4294967295 4294901500 4294967291 4294901753 4294967290 4294967039 4291742427 4283056747 4284042118 4284765592 4285357729 4285488802 4285817767 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212527 4286278320 4286278318 4286278318 4286409904 4286344111 4286278318 4286409904 4286542003 4286213038 4286607794 4287660987 4289437645 4289832654 4290030033 4289437898 4287726269 4286607537 4286607285 4286738871 4286541744 4286673328 4286673328 4286739123 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286871219 4286871219 4286805427 4286871220 4286937013 4286937013 4287002805 4287068598 4287068599 4287002806 4287002806 4287134392 4287134391 4287134391 4287134391 4287200184 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287792571 4287792571 4287858364 4287924157 4287792573 4288121535 4288450752 4288384959 4288055742 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288187328 4288318914 4288187328 4288253375 4288450754 4288319168 4288253375 4288582340 4289240519 4290688217 4291214558 4290951638 4291149019 4290885594 4289832656 4289174475 4288648133 4288648133 4288582340 4288648133 4288648133 4288713926 4288779719 4288713926 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911305 4288977096 4289108680 4288977348 4289965008 4291281121 4291281371 4291215832 4290425045 4289372106 4289174475 4289108682 4289240520 4289174727 4289306313 4289240268 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289504461 4289701838 4290425813 4291544545 4291742176 4291741922 4290886363 4289833424 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290162641 4290228434 4290228434 4290228180 4290293973 4290293973 4290359766 4290359766 4290556629 4290622422 4290556629 4290556629 4290622422 4290622422 4290556631 4290688217 4290688215 4290754010 4290622938 4290688984 4291544797 4292400103 4292400103 4292136933 4291215580 4290820568 4290754777 4290754777 4290754778 4290886363 4290820570 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952156 4291017949 4291083742 4291017947 4291083740 4291215326 4291281119 4291215326 4291215580 4291281373 4291281373 4291347166 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478752 4291544545 4291544545 4291478750 4291478750 4291610590 4291807969 4291873762 4291741922 4291676129 4291676129 4291741922 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292071141 4292071140 4292071140 4292071140 4292071140 4292202724 4292663529 4293255664 4293387249 4293255663 4292860906 4292334310 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292334310 4292400103 4292465896 4292465896 4292466150 4292466150 4292531943 4292795115 4293256174 4293453553 4293453553 4293453553 4293585139 4293650934 4293453555 4293321969 4292992492 4292860906 4292663527 4292663527 4292795113 4292860908 4292860908 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293124590 4293124590 4293124590 4293124590 4293190383 4293190383 4293190383 4293190383 4293190383 4293256176 4293321969 4293190383 4293256176 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293519346 4293651186 4293651186 4293651186 4293650932 4293585139 4293519346 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293782772 4294045944 4294243321 4294309114 4294177528 4294045942 4293848565 4293848565 4293782772 4293782772 4293848565 4293914358 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294243320 4294374906 4294506492 4294506492 4294374906 4294243320 4294177527 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572285 4294506492 4294506492 4294572285 4294572285 4294572285 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736579 4281933958 4281802374 4281868167 4281867913 4281802120 4281933960 4281802374 4281868667 4281868418 4281868167 4281670785 4281539703 4281276782 4281474410 4281079903 4280620123 4280686175 4284372102 4294638079 4294967286 4294967293 4294967039 4294769916 4294901502 4294967036 4281081184 4280949088 4281145714 4292531675 4294967295 4294901759 4294835707 4294967295 4294835455 4292861159 4280490064 4281081182 4281080683 4281606265 4281868668 4281934474 4281738109 4289899468 4294967295 4294704375 4294967039 4294967291 4294901759 4294967293 4280686678 4280949087 4281409133 4281343855 4294967039 4294901755 4294967295 4294967295 4294967291 4294901502 4289044411 4281213022 4281343340 4281737582 4282197884 4282131087 4282264452 4292597231 4294967290 4294967039 4294901247 4294967291 4294901754 4294967039 4280949850 4281146466 4281672810 4293847536 4294967293 4294901759 4294770175 4294836220 4294901755 4294901500 4294901247 4294901247 4294967039 4294967039 4294769405 4294967039 4294967039 4294901247 4294967295 4294835711 4294967295 4294967293 4292006612 4283320177 4282332021 4288846531 4294966783 4294901754 4294770427 4294901759 4294967036 4294110975 4285030537 4281213791 4281279333 4281410401 4281344608 4281279066 4294967039 4294967293 4294967295 4294967293 4294967293 4294967039 4281278812 4281673062 4282133108 4282199414 4294967039 4294967295 4294967293 4294967291 4294967039 4294967039 4287531170 4289044157 4294966783 4294638582 4294967295 4294638330 4294967291 4294835455 4284437377 4281870951 4282659713 4282922382 4283382676 4283382672 4283514511 4284896164 4286608039 4287923644 4287397304 4285357468 4284765333 4284502671 4284634507 4284634760 4284043391 4284175224 4287268249 4294835199 4294967291 4294901754 4294967295 4294967039 4294835709 4294835447 4282463338 4282528117 4282857082 4294373626 4294967039 4294704887 4294967295 4294967295 4294901247 4292860906 4284109684 4283253623 4283054972 4283449479 4283975314 4284040855 4283777941 4283646608 4292992492 4294967291 4294901754 4294901503 4294901754 4294901247 4293255917 4282135143 4282397293 4282726777 4294835450 4294967295 4294967293 4294967295 4294967293 4294901502 4289374136 4282464357 4282857595 4283449221 4283975312 4284106144 4284304790 4292729071 4294967288 4294967293 4294967039 4294967291 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967295 4294901247 4294967295 4294967039 4287860386 4282332771 4282594674 4283449981 4283975565 4284369818 4284568213 4284502167 4294243063 4294834943 4294967290 4294835709 4294967295 4294967295 4293190383 4282069850 4282924405 4283515776 4284305293 4284830872 4284897180 4285225129 4285356713 4285225882 4285291425 4284896929 4294177520 4294967295 4294967293 4294704121 4294967293 4294967293 4294835707 4294967039 4294967039 4294967039 4294967295 4294967295 4294967293 4294967293 4294769916 4294967295 4294967293 4294967293 4294966783 4291807969 4283517043 4283778946 4284699797 4284962971 4286080939 4285686181 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212527 4286278320 4286278318 4286344111 4286409904 4286344111 4286278318 4286475697 4286542001 4286410669 4287068596 4288779719 4289898449 4289766861 4289964243 4288384959 4286936500 4286607283 4286738871 4286673078 4286607537 4286673328 4286607535 4286804916 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286871219 4286871219 4286871220 4286937013 4287002806 4287068598 4287068850 4286937262 4287068599 4287134392 4287134392 4287200185 4287200185 4287134392 4287134392 4287200185 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287792571 4287792571 4287858364 4287924157 4287924156 4289240268 4290030035 4289240520 4288187580 4287989949 4288187329 4288121536 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288318914 4288384707 4288253121 4288253121 4288384707 4288384707 4288384707 4288516293 4288647879 4289174475 4290490838 4291214812 4291149017 4291149019 4290885594 4289964240 4288779719 4288713926 4288582340 4288582340 4288648133 4288713926 4288713926 4288713926 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4289042891 4288845510 4288977094 4288977348 4289899215 4291346912 4291347164 4291479003 4290688217 4289372105 4289174473 4289108682 4289240520 4289174727 4289240266 4289240268 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289438668 4289636045 4290491606 4291610338 4291742176 4291676129 4290754777 4289833424 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290228434 4290162641 4290228180 4290228180 4290228180 4290293975 4290359768 4290359768 4290425045 4290556631 4290490838 4290490838 4290622424 4290556631 4290556631 4290556631 4290622422 4290688217 4290622938 4290688982 4291479004 4292400357 4292466150 4292268517 4291281373 4290820568 4290754777 4290754777 4290754778 4290886363 4290820570 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017949 4291017949 4291017949 4291017947 4291017947 4291149533 4291149533 4291149533 4291149787 4291215580 4291281373 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291412959 4291478752 4291544545 4291544543 4291544543 4291610336 4291676129 4291610590 4291741922 4291676129 4291676129 4291741922 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292071141 4292071140 4292005347 4292005347 4292071140 4292136931 4292729322 4293321457 4293387249 4293124077 4292663527 4292268517 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292334310 4292400103 4292465896 4292465896 4292531689 4292465896 4292466150 4292663529 4293124590 4293387762 4293387762 4293321969 4293453555 4293650934 4293585139 4293519346 4293387249 4293124077 4292860906 4292729320 4292729320 4292795113 4292795113 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4292993004 4293124590 4293124590 4293124590 4293124590 4293190383 4293190383 4293190383 4293190383 4293124590 4293190383 4293256176 4293190383 4293256176 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293387760 4293453553 4293519346 4293453553 4293650932 4293585139 4293519346 4293585139 4293650932 4293585139 4293650932 4293650932 4293651186 4293782772 4293914358 4294111735 4294243321 4294309114 4294243321 4294111735 4293914358 4293848565 4293782772 4293782772 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294177527 4294374906 4294440699 4294506492 4294506492 4294374906 4294243320 4294177527 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281868165 4281802372 4281868167 4281933960 4281802374 4281802374 4281802374 4281736830 4281868165 4281604743 4281802374 4281604992 4282065797 4281210484 4281473910 4281540721 4280948080 4280752217 4294966783 4294967283 4294769914 4294901247 4294967293 4294967293 4294967039 4280554838 4281146466 4281079921 4291412692 4294967295 4294770175 4294967295 4294769918 4294967039 4294966783 4282464359 4280686675 4281541232 4281474426 4282131840 4281803139 4282133371 4293189870 4294967293 4294835707 4294966783 4294967288 4294901759 4294967293 4280752471 4281080673 4281080168 4281541234 4294967039 4294901755 4294835709 4294967295 4294769914 4294835707 4292663529 4280555594 4281475178 4281869170 4282132091 4282000521 4283778699 4294966783 4294704374 4294967039 4294835455 4294901751 4294836220 4294835709 4280818263 4281146464 4281475431 4291609819 4294967291 4294836222 4294967295 4294967293 4294967295 4290163906 4280359743 4280885076 4281082205 4280819031 4281278561 4280884573 4280950366 4281147743 4280950615 4281148499 4282793575 4283912563 4284241270 4284437897 4283385471 4292334823 4294967286 4294967290 4294967291 4294901503 4294967034 4285030786 4281148248 4281212770 4281475944 4281344356 4281673323 4284108163 4294967039 4294967293 4294967295 4294967293 4294967293 4294967039 4281278812 4281673060 4282067315 4282199414 4294967039 4294967295 4294967293 4294967291 4294967039 4294967039 4287465377 4283056996 4294966271 4294967291 4294901247 4294967039 4294967295 4294967295 4292464877 4282266210 4282133619 4283054220 4283054218 4284633244 4286080942 4287528387 4287924156 4287989950 4287792321 4287200185 4287463356 4287134641 4286937765 4286411672 4286213538 4285753490 4285162876 4294900735 4294967293 4294901754 4294967295 4294967295 4294967293 4294967039 4281805410 4282462578 4282725496 4291938784 4294769663 4294901755 4294835455 4294967295 4294967039 4294768895 4283912305 4282792303 4283252355 4283252104 4283711121 4284040604 4283909270 4284634006 4294834943 4294967295 4294967295 4294835967 4294901754 4294967039 4291150287 4282200682 4282331500 4282595189 4294967293 4294901502 4294769914 4294967295 4294901502 4294769914 4292795623 4281806678 4283121018 4283580805 4283909519 4284567200 4285358748 4294966783 4294835958 4294967295 4294703871 4294967288 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967295 4294967295 4294704125 4294967039 4288123560 4282595945 4282989433 4283713155 4284304530 4284633244 4284567449 4284699548 4292202976 4294966783 4294967291 4294967293 4294967295 4294967293 4294967039 4285754507 4282858863 4283976579 4284305293 4284633496 4285028766 4285225129 4285356967 4285291425 4284962461 4285160101 4292203229 4294901247 4294770168 4294967293 4294967295 4294637823 4290821586 4281872722 4282530148 4282661484 4282727277 4282990703 4283385459 4282793324 4283253623 4282661487 4282595693 4282727277 4282596443 4283056743 4283319666 4284108165 4284700051 4285160350 4285225632 4286080939 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278320 4286278320 4286278318 4286344111 4286409904 4286278318 4286344111 4286607283 4287463354 4287726780 4288055742 4289503692 4289898701 4289766861 4289437647 4287266229 4286673328 4286738869 4286738871 4286607283 4286739121 4286804913 4286607535 4286738869 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286871219 4286871220 4287002806 4287068599 4287331768 4287858364 4288187582 4288121787 4287595194 4287529401 4287332022 4287134389 4287134389 4287200184 4287265977 4287200185 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287792571 4287792571 4287924157 4287989950 4289174475 4290293208 4290951389 4290425045 4289306313 4288319168 4287924156 4288055742 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288318914 4288318914 4288318914 4288318914 4288384707 4288384707 4288450500 4288516042 4288516293 4289306313 4290359250 4291082972 4291346144 4290885594 4289832908 4288713926 4288713926 4288648133 4288582340 4288648133 4288713926 4288713926 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4289042891 4288911303 4288977094 4289108934 4289636043 4290952156 4291149785 4291347418 4290885594 4289372105 4289174473 4289174473 4289240520 4289240520 4289240266 4289240268 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289438668 4289636045 4290557399 4291676131 4291807969 4291676129 4290688984 4289833424 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290228434 4290162387 4290162387 4290228180 4290293973 4290359766 4290359768 4290293975 4290490838 4290556631 4290556631 4290490838 4290622424 4290622422 4290556629 4290688215 4290556628 4290688215 4290622938 4290688982 4291413211 4292334310 4292400103 4292334312 4291478752 4290820568 4290688984 4290754777 4290754778 4290886363 4290820570 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291083740 4291083740 4291083740 4291149533 4291149533 4291083740 4291149533 4291149787 4291215580 4291215580 4291215580 4291215580 4291215580 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478752 4291478752 4291544543 4291610336 4291610336 4291676129 4291610336 4291544543 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292071141 4292071140 4292005347 4292071140 4292202726 4292268771 4292795113 4293255663 4293321456 4293058284 4292597736 4292268517 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292334310 4292465896 4292465896 4292465896 4292531689 4292465896 4292465896 4292597482 4292729833 4292993005 4292993005 4292927212 4293124591 4293387762 4293519346 4293585393 4293584882 4293518835 4293321456 4293058284 4292795113 4292729320 4292729320 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4292927211 4293124590 4293190383 4293058797 4293058797 4293124590 4293190383 4293124590 4293190383 4293124590 4293190383 4293256176 4293256176 4293321969 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293321967 4293453553 4293519346 4293453553 4293453553 4293519346 4293519346 4293519346 4293585139 4293519346 4293519346 4293585139 4293650932 4293585139 4293650932 4293650932 4293651186 4293782772 4293980149 4294177528 4294243321 4294243321 4294243321 4294177528 4293980151 4293914358 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294045942 4294045942 4294111735 4294177528 4294243320 4294440699 4294440699 4294506492 4294506492 4294374906 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294572539 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281933960 4281802374 4281802372 4281802372 4281868165 4281933958 4281868167 4281933960 4282658451 4282790284 4281672054 4281803389 4281671037 4281473910 4281868668 4281539451 4281868919 4281474675 4281805408 4294966783 4294836212 4294967295 4294901247 4294901754 4294901754 4292202976 4280818012 4280751706 4280948333 4287859115 4294967293 4294835967 4294967295 4294835709 4294967295 4294967290 4287267749 4280950352 4281212521 4281606012 4281802875 4282264191 4286937262 4294966783 4294835958 4294967295 4294967039 4294967291 4294835967 4294967293 4280818264 4281146466 4281277547 4281804406 4294374907 4294901755 4294967293 4294967295 4294769916 4294967290 4294900991 4283056229 4281278050 4281671538 4282000754 4282133108 4290688217 4294967293 4294967293 4294835455 4294967295 4294967291 4294901759 4294967290 4280949847 4281278304 4281541225 4287858866 4294967291 4294901759 4294967039 4294967291 4294967293 4293847801 4280753990 4280490064 4280686678 4281278814 4281081435 4281147229 4281410149 4281015391 4281147229 4282200166 4283516275 4284504191 4284306312 4285161620 4284964489 4294967295 4294901746 4294901503 4294901503 4294967039 4294966271 4281147226 4281081182 4281475940 4281410149 4281410151 4281475942 4289043132 4294967039 4294967293 4294967295 4294967293 4294967293 4294967039 4281279066 4281738853 4282067315 4282199414 4294967039 4294967295 4294967293 4294901754 4294967039 4294967039 4287333791 4280885576 4289307835 4294967039 4294967295 4294967039 4294901502 4294835455 4294966783 4287727783 4282857844 4283515274 4284765339 4287002805 4288055232 4288055230 4288253892 4288451522 4287925427 4287925174 4287529652 4287332020 4287727031 4287266730 4286937262 4286806179 4286411921 4294966783 4294966782 4294835707 4294967293 4294901759 4294769914 4292597733 4281739617 4282265197 4282725750 4288451255 4294901503 4294901757 4294967295 4294967293 4294835450 4294966783 4286807449 4282397798 4282923388 4283186311 4283842960 4284039834 4284041105 4288384959 4294967291 4294835455 4294967039 4294901757 4294770425 4294967039 4287729054 4282003305 4282463086 4282858361 4294769657 4294967295 4294967293 4294901503 4294901502 4294967291 4294769663 4283978098 4282726510 4283317885 4283975566 4284042370 4291149785 4294835711 4294967291 4294901759 4294967295 4294967291 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294835707 4294967295 4294967295 4294967039 4287926181 4282266980 4283186812 4283647363 4284370321 4284699035 4284698786 4284699548 4289241018 4294966783 4294966782 4294967291 4294967295 4294704375 4294835709 4291676382 4282925161 4283516279 4284239499 4284962207 4285159837 4285290920 4285291426 4285620139 4285094047 4285160101 4289241788 4294967039 4294967295 4294769914 4294901502 4294967039 4294045692 4282333525 4282267231 4282727277 4283187063 4282989935 4282924138 4283318896 4283187314 4283318646 4282858345 4283121770 4282990449 4283253621 4283779967 4284173958 4284897430 4285423522 4285620390 4285817769 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278320 4286278320 4286278318 4286344111 4286409904 4286278318 4286409904 4286738869 4288779465 4289371856 4289306313 4289964494 4289964492 4289766863 4288450501 4286870966 4286607535 4286739123 4286607283 4286607537 4286804914 4286739120 4286673330 4286738869 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4286937012 4286937013 4286871220 4286937012 4287529401 4288845512 4289832657 4290095826 4289701071 4289569485 4289174473 4288713924 4288450500 4288187329 4287726780 4287266229 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287792571 4287792571 4287924157 4287989950 4289635792 4290293975 4290754777 4290820570 4290425561 4289241036 4288188096 4287990717 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288187328 4288253121 4288384707 4288384707 4288318914 4288318914 4288319168 4288384961 4288384708 4288648133 4288582336 4288977347 4290293205 4290753756 4289898449 4289108934 4288582340 4288648133 4288648133 4288648133 4288648133 4288713926 4288779719 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911303 4288911303 4289108680 4289240520 4289372873 4290688985 4291281119 4291478752 4291082973 4289437896 4289240266 4289174473 4289240520 4289240520 4289240266 4289306061 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289504461 4289636045 4290623192 4291741924 4291807969 4291610336 4290623191 4289767631 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290228180 4290162387 4290228180 4290293973 4290293973 4290359766 4290425813 4290360020 4290556631 4290556631 4290490838 4290425043 4290556629 4290556629 4290490836 4290622421 4290622421 4290622422 4290557399 4290623191 4291347418 4292202724 4292334312 4292268520 4291610338 4290886361 4290754777 4290754777 4290754778 4290886363 4290820570 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291018201 4291083994 4291083994 4291083740 4291215326 4291215326 4291149533 4291215326 4291215326 4291215326 4291281119 4291281119 4291281119 4291281119 4291281119 4291281119 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291544543 4291544543 4291676129 4291676129 4291676129 4291741922 4291741922 4291741922 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292071141 4292071140 4292005347 4292202726 4292465898 4292729322 4293058285 4293255663 4293321456 4293124077 4292729322 4292400103 4292268519 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292465896 4292465896 4292400103 4292465896 4292465896 4292465896 4292531689 4292400614 4292597993 4292663788 4292597995 4292795372 4292993005 4293321967 4293585393 4293584882 4293650675 4293650675 4293387249 4293058285 4292795113 4292729320 4292729322 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058797 4293190383 4293256176 4293124590 4293058797 4293124590 4293190383 4293124590 4293256176 4293124590 4293190383 4293256176 4293190383 4293256176 4293321969 4293256176 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293519346 4293519346 4293519346 4293585139 4293585141 4293519348 4293585139 4293519346 4293519346 4293650932 4293650932 4293585139 4293585139 4293650932 4293651184 4293848563 4294045942 4294243321 4294243321 4294243321 4294243320 4294177527 4294111737 4293914358 4293782772 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294045942 4294045942 4294111735 4294243321 4294374906 4294506492 4294440699 4294506492 4294506492 4294440699 4294309113 4294243320 4294243320 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281868167 4281670788 4281933958 4281868165 4281670785 4281868165 4281868165 4281868165 4285291926 4294240511 4289042627 4284172439 4281802888 4281605760 4281868668 4282000004 4283579535 4282988670 4288977345 4294967039 4294967291 4294901247 4294967039 4294967291 4294967290 4289110202 4280554842 4281080671 4281145712 4285753491 4294967291 4294901759 4294901503 4294967295 4294967291 4294835697 4294966015 4285621905 4281146724 4281606014 4281868414 4284501658 4294372863 4294967039 4294967283 4294967039 4294967295 4294967295 4294901759 4294967293 4280620885 4280949087 4281474926 4281343855 4292466910 4294770425 4294901754 4294967039 4294967295 4294770165 4294967291 4292070117 4284041608 4281803126 4283711623 4289963480 4294966527 4294901492 4294967295 4294901759 4294967291 4294835711 4294901503 4294967286 4280949847 4281080923 4281540971 4284173956 4294901753 4294901759 4294967039 4294967291 4294703862 4294966527 4289174976 4280884305 4281213019 4281015892 4281278302 4281607269 4281343845 4281475431 4281607780 4282331751 4286674592 4284832638 4285490318 4285490570 4285491338 4294967039 4294967295 4294966527 4294967039 4294967290 4294966776 4282924391 4281081684 4281410652 4281410147 4281870702 4284765580 4294176237 4294967039 4294967293 4294967295 4294901754 4294967293 4294967039 4281279066 4281738853 4282067315 4282199414 4294967039 4294967295 4294967293 4294901754 4294967039 4294967039 4287531172 4281016659 4282990952 4294966783 4294769914 4294967291 4294835960 4294901759 4294966517 4294570751 4284371586 4284963223 4286542254 4287398066 4287858356 4287989940 4289899217 4294637055 4291874011 4288912823 4287793338 4287398078 4287003575 4286938029 4286805676 4286148249 4290754259 4294834687 4294967039 4294967293 4294769914 4294901757 4294967291 4289439421 4281936742 4282265197 4282594164 4285226895 4294967295 4294836222 4294901502 4294901754 4294967290 4294966783 4293255414 4283318896 4282528882 4283383686 4283842956 4284040086 4284896917 4293451519 4294967283 4294967039 4294901247 4294836213 4294901755 4294967039 4284439150 4281871721 4282594672 4282660982 4292730074 4294835455 4294967293 4294769918 4294967295 4294901753 4294967295 4292531440 4285029264 4283449470 4285159837 4290754261 4294967039 4294967291 4294901759 4294770429 4294967295 4294835455 4294901759 4294967291 4282265959 4282857585 4283449470 4283515523 4294967295 4294901759 4294967293 4294835709 4294967295 4294967039 4288189353 4282530152 4283318398 4283778949 4284501391 4284633496 4284961706 4284633757 4286609048 4294900735 4294967039 4294901753 4294967295 4294967290 4294835961 4294966527 4290228434 4284437377 4284107913 4284699035 4284962712 4285291174 4285094046 4285817266 4285423012 4284765341 4286609565 4294966783 4294967039 4294835709 4294967293 4294967293 4294967039 4289834176 4282530653 4282727527 4283055217 4283713397 4283516015 4283713395 4283449973 4283581561 4283713143 4285818770 4283582084 4283582337 4284043140 4284437128 4284897429 4285291936 4285554597 4285817769 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278320 4286278320 4286278318 4286344111 4286344111 4286278318 4286409904 4286804662 4289042889 4289832403 4289701068 4290030285 4289964492 4289503692 4287200182 4286673591 4286607534 4286673330 4286541490 4286739123 4286739120 4286541741 4286804916 4286738871 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286871220 4287002806 4287200185 4287265978 4287397563 4287989950 4289240268 4290161619 4290161871 4290161870 4290293457 4290293459 4290161619 4290030036 4289635026 4288648133 4287660984 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287792573 4287792573 4287792573 4287792571 4287792571 4287924157 4288055743 4288649152 4290031055 4290623189 4290491603 4290754524 4290491101 4289241038 4288319682 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288384708 4288253121 4288253121 4288318914 4288319168 4288319168 4288384961 4288384961 4288450752 4288450752 4288516543 4288714176 4289043141 4289306059 4289108682 4288648133 4288516547 4288582340 4288648133 4288713926 4288713926 4288713926 4288779719 4288779719 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288911303 4288911301 4289043141 4289175496 4290688731 4291346914 4291281119 4291280352 4289503689 4289240520 4289240266 4289240520 4289240520 4289306059 4289306061 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289503692 4289569485 4289569485 4289569484 4289635277 4289504461 4289636045 4290688985 4291741924 4291742176 4291610336 4290557398 4289701838 4289832654 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290161873 4290161873 4290161873 4290227666 4290227666 4290227666 4290293459 4290293459 4290162387 4290162387 4290293973 4290293973 4290162641 4290228434 4290294227 4290228433 4290425045 4290556631 4290490838 4290490836 4290622422 4290622421 4290556628 4290622421 4290688214 4290622422 4290491606 4290557398 4291347164 4292202726 4292400106 4292399852 4291807717 4290952154 4290754777 4290754777 4290688985 4290820570 4290886363 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291018201 4291083994 4291018201 4290952408 4291083994 4291083994 4291017947 4291215326 4291083740 4291149533 4291215326 4291281119 4291281119 4291346912 4291346912 4291346912 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291412957 4291412957 4291544543 4291610590 4291610590 4291610590 4291610590 4291676383 4291610336 4291610336 4291676129 4291741922 4291741922 4291741922 4291741922 4291873508 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292071141 4292071140 4292071140 4292334312 4292663277 4293124080 4293321457 4293321456 4293321710 4293255663 4292926701 4292597482 4292400105 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292465896 4292400103 4292334310 4292465896 4292465896 4292465898 4292531691 4292400614 4292597995 4292532202 4292466409 4292532202 4292729833 4292993004 4293322221 4293519089 4293584882 4293650675 4293584628 4293387249 4293124078 4292860906 4292663529 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293124590 4293387762 4293453555 4293256176 4293124590 4293124590 4293190383 4293190383 4293256177 4293124591 4293190384 4293190384 4293190384 4293256177 4293321970 4293256177 4293256176 4293321969 4293321969 4293321969 4293321969 4293387762 4293387762 4293387762 4293387760 4293453553 4293519346 4293519346 4293519346 4293519348 4293519348 4293519348 4293519346 4293519346 4293519346 4293650932 4293650932 4293585139 4293585139 4293650932 4293651184 4293848563 4294111735 4294243321 4294243321 4294243321 4294177527 4294177527 4294111737 4293980151 4293848565 4293848565 4293848565 4293848565 4293782772 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293914358 4293980149 4294045942 4294045942 4294111735 4294177528 4294309114 4294374906 4294506492 4294440699 4294440699 4294506492 4294506492 4294374906 4294243320 4294177527 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294572285 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802372 4281868167 4281802374 4281802120 4281736327 4281802372 4281868164 4281868418 4285095073 4294900991 4294967039 4294900479 4293255664 4290425812 4287728308 4287859644 4288978364 4293190124 4294901243 4294967039 4294966783 4294900989 4294967293 4294967039 4294901502 4286215060 4280291917 4281146979 4281014375 4281344105 4293122555 4294967279 4294835707 4294967295 4294967295 4294835709 4294835707 4294967039 4290097610 4287662514 4289439941 4294901503 4294967291 4294769918 4294967039 4294835707 4294967293 4294835455 4294967288 4294901247 4280621403 4280949596 4281146474 4281607025 4289569485 4294967288 4294966527 4294967039 4294835450 4294967291 4294835707 4294967295 4294901500 4294967291 4294901503 4294901503 4294967295 4294901500 4294967293 4294967293 4294835711 4294901247 4294835711 4294967288 4280949847 4281278304 4281475432 4281541232 4291478249 4294901749 4294901247 4294967039 4294967039 4294901243 4294967039 4290426313 4283780219 4281081701 4281410665 4281410668 4281476207 4281608296 4286279082 4290425292 4294966271 4285687194 4285753490 4286213792 4286082972 4292992242 4294967295 4294901502 4294901759 4294901755 4294901247 4290295240 4282135394 4281081701 4281805423 4285293709 4294110972 4294966782 4294967291 4294967288 4294967039 4294967290 4294967033 4294966783 4281344599 4281803624 4282133870 4281805423 4294967295 4294704382 4294901757 4294704885 4294967295 4294967291 4287662239 4281147981 4281344856 4288912053 4294835448 4294967288 4294901759 4294769919 4294967293 4294967293 4291545046 4284437377 4285686432 4286870960 4287528371 4287988922 4289504457 4294966783 4294967293 4294966783 4293650934 4291676640 4289570765 4289176005 4288978616 4292663275 4294966783 4294967034 4294967033 4294967291 4294967039 4294834943 4294967034 4286807195 4281805156 4282396783 4282594164 4282594675 4291741672 4294967286 4294967295 4294967039 4294967039 4294967291 4294967293 4293124078 4286740900 4282989949 4283450251 4287266996 4293321207 4294967039 4294769655 4294967293 4294967293 4294901243 4294966782 4291412959 4281937245 4282134115 4282528369 4283186560 4290031055 4294967286 4294966783 4294900991 4294967291 4294967291 4294769914 4294967295 4294967295 4294901503 4294967291 4294901247 4294835707 4294967290 4294967039 4294835711 4294967293 4294967039 4294901754 4294901749 4282331751 4282857583 4283252345 4283581569 4294901754 4294901754 4294705145 4294901750 4294901750 4294967295 4287991972 4282661220 4283252605 4283844237 4284566933 4284765081 4284896416 4284633505 4284305293 4291939301 4294967039 4294967033 4294901247 4294967295 4294901502 4294901502 4294966783 4293386998 4289044157 4287070118 4287333300 4288780998 4290952416 4294308854 4285029530 4284568211 4284634257 4292004577 4294901749 4294901500 4294967295 4294967291 4294836212 4294901755 4290822097 4285162893 4283253621 4283451002 4283714175 4284043139 4283911803 4287530918 4290492360 4294966783 4284107911 4284305292 4284502671 4284963223 4285291936 4285489317 4285752489 4285686441 4285949104 4285883311 4286080941 4286739121 4286673581 4286015397 4286015146 4286278069 4286081193 4286081193 4286080939 4286146734 4286212528 4286146735 4286146734 4286212527 4286080939 4286409904 4286344113 4286278320 4286278318 4286410158 4286344365 4287002293 4288846026 4289570001 4289833426 4289833422 4289636045 4289437645 4288384707 4286871217 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286804662 4286870455 4286804916 4286871220 4286937012 4287068596 4287266229 4287200436 4287661754 4288385729 4289109448 4289504459 4289767629 4289965008 4290096596 4290228182 4290359250 4290227664 4290293459 4290293205 4289635278 4288450500 4287529147 4287265978 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287989952 4288911305 4290095828 4290819800 4290754259 4290885847 4290491606 4289372873 4288384961 4288121789 4288318914 4288121535 4288055742 4288318914 4288187328 4288121535 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288516293 4288450500 4288450754 4288648133 4288713926 4288648133 4288582340 4288582087 4288779719 4288713922 4288582338 4288713926 4288779719 4288713922 4288779969 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4289042889 4288845510 4288977098 4289108682 4289109448 4290293973 4291412707 4291347166 4291215075 4289899217 4288912069 4289109450 4289240268 4289108680 4289372106 4289240519 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289899469 4289899468 4291017947 4291676129 4291807715 4291610338 4290557396 4289965261 4289964240 4289832654 4289832654 4289898447 4289964240 4289964240 4289964240 4289964240 4289964242 4290030033 4290095826 4290030033 4290030033 4290095826 4290095826 4290030287 4290161873 4290227666 4290227666 4290227666 4290096080 4290161873 4290425045 4290227666 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290688215 4290491605 4290623443 4291281371 4292071141 4292400105 4292465896 4291873762 4290952406 4290886361 4290820570 4290754778 4290820570 4290688982 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291083740 4291149533 4291149533 4291083740 4291083740 4291149533 4291215326 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291544545 4291741924 4291610336 4291610336 4291807715 4291807715 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292005348 4292005347 4292071140 4292268519 4292531691 4293189870 4293255663 4293255663 4293321456 4293387250 4293189873 4292729068 4292334312 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4293190124 4293519089 4293782007 4293716214 4293387249 4292992492 4292795113 4292795113 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292993005 4292861419 4292861419 4292993005 4292993005 4292993005 4292993005 4293058798 4293388014 4293585393 4293782518 4293782518 4293453553 4293190383 4293124590 4293190383 4293190384 4293256176 4293190383 4293124590 4293256176 4293256176 4293256176 4293387760 4293321969 4293321969 4293387762 4293387762 4293387762 4293387762 4293387762 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293782772 4293716979 4294045944 4294243321 4294243321 4294243320 4294045941 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294111735 4294045942 4294045942 4294177528 4294309113 4294440699 4294506492 4294506492 4294506492 4294440699 4294309114 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294572539 4294572539 4294506746 4294506746 4294572539 4294572539 4294638332 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736578 4281802371 4281868165 4281802374 4281736581 4281868165 4281933957 4281802625 4287859133 4294967284 4294967282 4294835447 4294967284 4294835707 4294967039 4294901247 4294967039 4294769914 4294967291 4294769663 4294967039 4294967295 4294967295 4294704125 4292927212 4280556358 4280686424 4280751966 4281145964 4281212014 4287727027 4294900991 4294901759 4294638589 4294967295 4294967293 4294967288 4294506993 4294967291 4294967295 4294966783 4294835709 4294770168 4294967295 4294835455 4294967291 4294967293 4294967039 4294967290 4294835455 4280621401 4281081182 4281212267 4281738613 4285950366 4294966783 4294967291 4294703862 4294967291 4294835711 4294967039 4294835199 4294966783 4294967039 4294967039 4294967293 4294967291 4294967039 4294901500 4294901247 4294901502 4294967288 4294901503 4294835961 4280949850 4281080925 4281541225 4281673072 4284240768 4294901247 4294967291 4294901502 4294967039 4294967039 4294966782 4294966782 4294966782 4294374649 4291347669 4291347667 4292532194 4294967036 4294769407 4294967288 4294967288 4285818780 4286213788 4286345124 4285622169 4290886615 4294769918 4294967290 4294704634 4294770175 4294967039 4294967295 4294835711 4291348180 4292465896 4294966783 4294967036 4294967291 4294967293 4294836212 4294966783 4294967295 4294967295 4294769407 4281542487 4281673060 4281936242 4282397563 4294835199 4294967039 4294770175 4294901759 4294967039 4294967295 4287661737 4281476443 4281476194 4282266208 4294439167 4294967036 4294901500 4294901759 4294835455 4294967295 4294966783 4286346395 4283120765 4284172693 4285093793 4285816999 4290425810 4294967039 4294835699 4294967291 4294967291 4294967295 4294966783 4294967039 4294967039 4294967295 4294967295 4294967295 4294967295 4294704125 4294967295 4294967039 4293321710 4281543508 4281870952 4282330992 4282791291 4282988928 4284898698 4294966783 4294967293 4294901502 4294704123 4294967293 4294638069 4294967291 4294835196 4294967039 4294835455 4294967295 4294967293 4294704121 4294967295 4294967295 4294967295 4294967293 4294966783 4284372856 4281805659 4282528618 4282725750 4282857597 4287201706 4294967039 4294967286 4294967288 4294967291 4294638332 4294967039 4294967039 4294835961 4294967286 4294901500 4294967293 4294770167 4294901754 4294769663 4294967039 4294572789 4294967290 4294835455 4294967039 4282200168 4282857838 4283383931 4283515525 4294966783 4294901247 4294901503 4294901759 4294967039 4294900991 4288123309 4282792554 4283252605 4283778444 4284435093 4284896668 4284765082 4284765343 4284370834 4286477728 4294966271 4294967293 4294901759 4294704125 4294967295 4294967293 4294770168 4294967291 4294967293 4294967293 4294967295 4294901503 4294901247 4294967283 4286411688 4284897180 4284370583 4286411421 4294966783 4294901247 4294967039 4294572537 4294967293 4294638328 4294901759 4294901759 4294177019 4292202975 4292071392 4292729322 4294966271 4294966783 4294967039 4294967290 4284437130 4284831634 4285029013 4285292187 4285555360 4285818278 4286081450 4286015659 4286147245 4286147245 4286673587 4287923905 4288582087 4287989950 4287068598 4286344622 4286475697 4286278318 4286080941 4286080942 4286146735 4286212527 4286212527 4286212525 4286212525 4286409904 4286278320 4286278320 4286344111 4286475951 4286410158 4287133879 4289043657 4289767378 4289899217 4289701838 4289964242 4289898198 4288779468 4287134391 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673330 4286739121 4286804913 4287266229 4287858364 4288450754 4289240268 4289635024 4289635794 4289833171 4289899219 4290030803 4290162387 4290162387 4290030801 4290030801 4290161873 4290359252 4290227412 4289306313 4288253373 4287529399 4287200182 4287134392 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4288055745 4287924156 4288714176 4290096080 4290754008 4290819800 4290688985 4290359766 4289437645 4288582336 4288648131 4288779719 4288319168 4288121535 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288516293 4288516293 4288450754 4288516547 4288582340 4288516547 4288516547 4288582087 4288582340 4288582336 4288648131 4288648133 4288647879 4288713924 4288779969 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4289042889 4288911301 4288978117 4290293973 4291346912 4291347164 4290952156 4289965008 4289241289 4289241034 4289240266 4289108680 4289372106 4289306313 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4290491606 4291083742 4291478752 4291741922 4291807969 4291610338 4291215326 4290754777 4290030033 4289898447 4289832654 4289832654 4289898447 4289898447 4289964240 4289964240 4289964242 4290030033 4290030033 4290030033 4290030033 4290095826 4290161619 4290096080 4290095826 4290095826 4290095826 4290293205 4290293459 4290227666 4290425045 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290622422 4290557398 4290623443 4291018199 4291873762 4292465898 4292400103 4292005348 4290755027 4290688982 4290754777 4290754778 4290886363 4290820568 4290754775 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952154 4291017947 4291017947 4291017947 4291083740 4291083740 4291149533 4291149533 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291741924 4291741922 4291676129 4291610590 4291676383 4291676383 4291741922 4291873508 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292005348 4292005347 4292071140 4292202726 4292400105 4293124078 4293255663 4293321456 4293387249 4293321457 4292926701 4292531689 4292334312 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292860905 4293124077 4293387249 4293387250 4293124078 4292860906 4292795113 4292860908 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292927212 4292927212 4292993005 4292993005 4292993005 4292927212 4293058798 4293190384 4293585393 4293782772 4293914104 4293782518 4293453553 4293256176 4293190383 4293190383 4293124591 4293256176 4293190383 4293190383 4293256176 4293321969 4293321969 4293453553 4293387762 4293321969 4293321969 4293321969 4293387762 4293453555 4293453553 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293782772 4293716979 4294045944 4294243321 4294243321 4294243320 4294045941 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294045942 4294045942 4294045942 4294177528 4294309113 4294440699 4294440699 4294440699 4294440699 4294309113 4294243321 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294440699 4294506746 4294506746 4294572539 4294572539 4294572539 4294572539 4294638332 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736832 4281802371 4281933957 4281802372 4281736579 4281933957 4281933957 4281736832 4287529917 4294967039 4294901500 4294967295 4294770419 4294967293 4294967293 4294967295 4294967295 4294967293 4294769916 4294901247 4294967295 4294967290 4294704374 4294967295 4284043638 4280095306 4280817759 4281014629 4281343089 4281211507 4281344356 4292530419 4294704382 4294901759 4294967295 4294901502 4294967039 4294967039 4294967295 4294967291 4294967288 4294967290 4294769918 4293980151 4294901503 4294967290 4294835961 4294967039 4294901754 4294967039 4280424020 4280883803 4281738100 4281146223 4281739114 4293057016 4294967295 4294901500 4294967291 4294901502 4294769918 4294967295 4294770425 4294836213 4294638328 4294967293 4294967039 4288452787 4294967290 4294835455 4294967293 4294836210 4294967291 4294967290 4280818263 4281344097 4281409385 4281803893 4281608296 4286872739 4294638079 4294967295 4294638328 4294967293 4294967295 4294835709 4294967293 4294770167 4294967295 4294901500 4294967291 4294836209 4294967291 4294967290 4294967034 4285030034 4286411169 4286016159 4286081952 4287004325 4294769151 4294967288 4294967291 4294967039 4294835711 4294901754 4294967290 4294967295 4294572537 4294770168 4294967039 4293321456 4292335074 4294967290 4294769663 4294967039 4294967039 4294967039 4281081934 4281804907 4281935737 4282265207 4294966783 4294638330 4294967293 4294901503 4294967039 4294967295 4287661485 4281344857 4281673323 4281870952 4287990702 4294900991 4294967288 4294901755 4294967295 4294440949 4294967295 4294176511 4283318647 4282725253 4283316881 4283646097 4288847040 4294901247 4294967291 4294967293 4294770165 4294901753 4294770429 4294901755 4294835455 4294967295 4294967295 4294967295 4294967293 4294704121 4294967293 4294835707 4284964993 4281410649 4281804905 4282528117 4282922878 4283054471 4282989433 4287399081 4294967295 4294967295 4294967295 4294967295 4294967039 4294704125 4294967291 4294836212 4294967284 4294967290 4294506744 4294967039 4294967039 4294835711 4294967295 4294967039 4286939286 4281740115 4281805407 4282791792 4282923129 4283186309 4283252854 4293387001 4294967295 4294901500 4294967291 4294967291 4294835711 4294967039 4294704383 4294901759 4294901247 4294967039 4294966527 4289308347 4294835199 4294967039 4294901247 4294967291 4294901753 4294967033 4282332005 4282791792 4283449470 4283581569 4294900989 4294835961 4294901759 4294901500 4294901754 4294967039 4288123558 4282661471 4283318646 4283910021 4284304277 4284896668 4284765082 4284962461 4284502169 4283976328 4288123058 4294900735 4294836218 4294901757 4294901759 4294967295 4294835711 4294901502 4294835707 4294901754 4294835960 4294967291 4294967039 4294901492 4287135411 4284304788 4284304538 4284173958 4287991469 4294966527 4294901502 4294967291 4294967295 4294901247 4294967293 4294967288 4294967291 4294901754 4294967293 4294835709 4294967295 4294835709 4294967295 4294901502 4284700299 4285687194 4286279332 4286476711 4286805676 4287068850 4287266229 4287200436 4287266227 4287332020 4287726780 4288779465 4289569231 4289437645 4288911303 4288187328 4287265465 4286804916 4286344111 4286212525 4286278320 4286344111 4286278318 4286278572 4286278318 4286344111 4286212527 4286278320 4286344111 4286410158 4286410158 4287265465 4289175496 4289701840 4289701838 4289636047 4289503438 4288516293 4287397563 4286542001 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286870707 4286739120 4286805165 4287924156 4289371854 4290030035 4290095826 4290030287 4290358998 4290293205 4290161619 4290161621 4290227412 4290095826 4290096080 4290359252 4290293205 4289964242 4289108680 4287924156 4287200436 4287134389 4287200184 4287134391 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4288055743 4287924157 4288055996 4288977094 4290030035 4290688217 4290952157 4290754777 4290687963 4289766863 4289766864 4289898196 4288779717 4287990203 4288318914 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288516293 4288516293 4288450754 4288516547 4288516547 4288516547 4288582340 4288647879 4288648131 4288713922 4288779717 4288648133 4288647879 4288713926 4288779715 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977094 4288977094 4289042887 4289042887 4289241289 4290360020 4291281373 4291347164 4291215580 4290623191 4290228180 4289701840 4289306059 4289240266 4289240266 4289306313 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4290228434 4291675879 4291676131 4291742176 4291873762 4291676129 4291741670 4291083742 4290030033 4289898447 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4290030035 4290030033 4290030033 4290030033 4290030033 4290095826 4290161619 4290161873 4290293207 4290161621 4290030033 4290293205 4290227666 4290161873 4290293459 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290556629 4290557398 4290689236 4290886613 4291807969 4292465898 4292334310 4292136934 4290952406 4290820568 4290886363 4290688985 4290886363 4290886361 4290754775 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291017947 4291083740 4291083740 4291083740 4291083740 4291083740 4291083740 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291741924 4291610336 4291742176 4291807969 4291807968 4291742176 4291742176 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292005348 4292071140 4292071140 4292136933 4292268519 4292992492 4293189871 4293387249 4293387250 4293124078 4292597736 4292268517 4292334312 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292597734 4292795113 4292992492 4292992492 4292926701 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292861419 4292927212 4293058798 4292993005 4292927212 4292927212 4293124591 4293387762 4293716979 4293914358 4293914104 4293650932 4293387762 4293256176 4293190383 4293190383 4293124591 4293190383 4293190383 4293190383 4293256176 4293321969 4293387762 4293650932 4293585141 4293453555 4293321967 4293321967 4293387760 4293453553 4293453553 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293782772 4293716979 4293980151 4294243321 4294243321 4294243320 4294045941 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294045942 4294111735 4294177528 4294309113 4294506492 4294440699 4294374906 4294309113 4294177527 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294440699 4294440699 4294506746 4294572539 4294572539 4294638332 4294572539 4294572539 4294572539 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281868165 4281802372 4281868165 4281802372 4281670788 4281802372 4281802372 4281670786 4287793087 4294966783 4294967039 4294703871 4294967291 4294901247 4294901502 4294967295 4294835455 4294967295 4294967295 4294901502 4294835960 4294967286 4294901247 4286281614 4280556111 4280554838 4280686175 4281475180 4281343089 4281671805 4281343343 4283976328 4294177276 4294967295 4294770168 4294835707 4294967039 4294506751 4294901503 4294704383 4294967285 4294967039 4292203237 4288518829 4294967039 4294770165 4294967291 4294967039 4294967293 4294901247 4280687447 4280818010 4281606514 4281606265 4281343343 4285555611 4294967039 4294967039 4294835707 4294967293 4294967295 4294770175 4294901759 4294770175 4294967288 4294966783 4292334313 4281608799 4294901494 4294967039 4294966782 4294967293 4294704624 4294967291 4281015642 4281344097 4281606766 4281540470 4281803901 4281476207 4287005590 4294637823 4294967039 4294901247 4294967039 4294769663 4294967295 4294967290 4294835455 4294967039 4294967039 4294967295 4294769663 4294900735 4294966783 4284043139 4285884827 4286608548 4286542503 4283779968 4289899469 4294966783 4294901243 4294967039 4294967290 4294967293 4294967039 4294835455 4294967293 4294835961 4294966271 4284240516 4287728300 4294967295 4294835711 4294901500 4294638328 4294967290 4284767110 4281673070 4282198649 4281936493 4294967291 4294967286 4294836212 4294967293 4294769916 4294967039 4287924909 4281345106 4281805159 4281738604 4283055728 4294307837 4294967290 4294901753 4294901754 4294967291 4294967290 4294967039 4290689236 4282594675 4282791299 4282923139 4288649659 4294967039 4294967295 4294967039 4294835961 4294901754 4294704636 4294901755 4294967039 4294835711 4294901500 4294967290 4294375410 4294967295 4294900991 4286611084 4281016659 4282068330 4282068077 4282857336 4282988417 4283185804 4283054725 4282727030 4287334304 4294835199 4294967295 4294769916 4294967039 4294967039 4294835455 4294967295 4294967295 4294901247 4294901247 4294835711 4294638582 4294967295 4294769407 4286807958 4281477711 4281805659 4282397547 4282857333 4283186049 4283449483 4283383939 4286543525 4294967039 4294901247 4294769916 4294704123 4294967295 4294704382 4294901759 4294770425 4294967283 4294967293 4292268266 4282859869 4294967039 4294835697 4294967291 4294967290 4294967295 4294967039 4282200165 4282726001 4283383678 4283449984 4294966783 4294967039 4294967295 4294704121 4294967293 4294966783 4288188330 4282529382 4283384191 4283844237 4284370323 4284633244 4285028002 4284830621 4284699550 4284370583 4283647612 4288385713 4294901500 4294901500 4294769916 4294967295 4294967039 4294901247 4294967039 4294769663 4294967295 4294966783 4294966527 4294967039 4287200687 4283713155 4284173453 4284042369 4283911554 4287925676 4294900991 4294967290 4294769914 4294967295 4294769918 4294967291 4294967039 4294967295 4294704123 4294967295 4294835709 4294901503 4294967039 4294769663 4285161100 4286871718 4287924406 4288319164 4288713922 4289042887 4289174473 4289108680 4289043655 4289109450 4289043659 4289241036 4289438668 4289438664 4289504459 4289372875 4289239759 4288713160 4287857855 4287002292 4286344365 4286080939 4286146732 4286344111 4286212525 4286278318 4286278320 4286409906 4286344111 4286344365 4286344365 4287331258 4289372873 4289833424 4289767633 4289437645 4288516547 4287134389 4286542255 4286673589 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286739121 4286870706 4286936751 4288055742 4289635024 4290293207 4290227666 4290096078 4290030033 4289964242 4289766610 4289503440 4289042889 4288713922 4289174727 4289964242 4289766864 4288713924 4287660984 4287200182 4287200184 4287265977 4287200184 4287200182 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287726778 4288055745 4287989952 4288121536 4288911305 4290030035 4290754778 4290820568 4290951387 4290754008 4290819803 4290687963 4289306313 4288187580 4288318914 4288187329 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288516293 4288516293 4288516547 4288582340 4288582340 4288582340 4288648133 4288648133 4289240266 4289306313 4288845508 4288648133 4288779465 4288779719 4288779717 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4289042887 4288911301 4288977094 4289437899 4289965010 4290754778 4291281373 4291413211 4291544797 4291281373 4291017950 4289965010 4289306313 4289306059 4289174473 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289570250 4291215328 4291610336 4291742175 4291807968 4291807715 4291675877 4290623192 4289964240 4289898447 4289832654 4289832654 4289898447 4289898447 4289898447 4289964240 4289964242 4290030033 4290030033 4290030033 4290030033 4290095826 4290095826 4290096080 4290227414 4290227414 4290095826 4290227412 4290227666 4290161873 4290293459 4290227664 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290622422 4290623191 4290952408 4291347164 4292005348 4292465898 4292334310 4292334312 4291610590 4291478752 4291083742 4290688985 4290754777 4290886363 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017949 4291083742 4291083742 4291149535 4291149535 4291149535 4291149535 4291083742 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291676131 4291544543 4292005348 4292400105 4292334310 4292202726 4291939555 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4291939555 4292005348 4292005348 4292071140 4292071140 4292071140 4292136933 4292795113 4293255664 4293453043 4293189871 4292860908 4292334310 4292136933 4292334312 4292268517 4292334310 4292334310 4292334310 4292334310 4292334310 4292334310 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292597736 4292729322 4292795115 4292860908 4292795115 4292729322 4292729322 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292861419 4292927212 4292993005 4292927212 4292861418 4292993004 4293321969 4293650934 4293848565 4293848311 4293782518 4293453553 4293190383 4293124590 4293124590 4293124591 4293124591 4293256176 4293190383 4293190383 4293256176 4293256176 4293453555 4293716725 4293782518 4293650932 4293453553 4293321967 4293321967 4293387760 4293387760 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293782772 4293716979 4293980151 4294243321 4294243321 4294243320 4293980148 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294111735 4294111735 4294243321 4294374906 4294506492 4294440699 4294309113 4294243320 4294177527 4294177528 4294177528 4294177528 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294309113 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294572285 4294572539 4294638332 4294704125 4294704125 4294638332 4294572539 4294572539 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802120 4281736327 4281933706 4281868167 4281802374 4281933960 4281868167 4281999753 4290360019 4294967039 4294966783 4294967293 4294967290 4294901503 4294901500 4294967295 4294967291 4294967290 4294769914 4294901247 4294967039 4291677396 4285360262 4281872228 4280686678 4280554842 4281277801 4281277033 4281671540 4281606010 4281737596 4281409136 4283846008 4292136680 4294967039 4294967290 4294770167 4294967291 4294835960 4294967288 4294966783 4292136682 4281675094 4287267746 4294901247 4294967290 4294835960 4294835711 4294901759 4294835455 4280687445 4280883803 4281474929 4281803389 4282000768 4281277801 4286741402 4294242559 4294967295 4294835958 4294836212 4294967290 4294704121 4294967295 4294967039 4291347666 4281214792 4280819033 4294967039 4294834687 4294966783 4294966783 4294966783 4294965759 4280883805 4281015132 4281672559 4282066812 4281803393 4281869694 4281410666 4284109184 4290952911 4294967293 4294967290 4294967291 4294704375 4294967291 4294769916 4294967291 4294769916 4294967288 4294967293 4294966783 4293321710 4282793322 4285358483 4286345628 4286476964 4284765590 4282331503 4289372103 4294966527 4294966783 4294901753 4294967293 4294967295 4294967039 4294835450 4294308854 4284899201 4281344872 4287793841 4294900991 4294835455 4294967295 4294967295 4294901241 4285358730 4281476194 4282199404 4282331243 4294966527 4294900991 4294967295 4294967039 4294967293 4294967039 4287793325 4281608532 4281870439 4282527614 4282133613 4287990704 4294966527 4294900479 4294769916 4294967039 4294835199 4294966782 4294966783 4285753488 4282528881 4282923388 4290952660 4294967039 4294967295 4294835455 4294967293 4294967293 4294967039 4294901247 4294967293 4294967291 4294967293 4294835711 4294966783 4290821333 4283846774 4281280596 4282068328 4281541987 4282528371 4282923129 4283185796 4283514512 4282988425 4283383688 4282595189 4284767110 4291544794 4294835199 4294967295 4294967293 4294835961 4294967288 4294967291 4294835709 4294967295 4294967293 4294769914 4291545810 4284373367 4281543516 4281805661 4282265961 4282725748 4282857336 4283712394 4283646095 4283975825 4283054972 4287860137 4294110975 4294967295 4294967290 4294967288 4294835958 4294967290 4294967290 4294967293 4291282125 4283319915 4282333022 4294966783 4294835196 4294966783 4294900735 4294901240 4294966782 4282397796 4282857846 4283449730 4283449983 4294966783 4294901243 4294967039 4294967039 4294967039 4294637052 4288254377 4283121770 4283318647 4283910021 4284502161 4284698783 4284896165 4285093541 4284633242 4284699037 4284370834 4283384439 4285492102 4291545309 4294967039 4294967295 4294835958 4294967286 4294967288 4294967290 4294967290 4294967039 4294967039 4294769403 4286477213 4283779197 4284371337 4284173443 4283976593 4283648382 4285688716 4291808217 4294966783 4294967039 4294967293 4294704375 4294966783 4294901247 4294967039 4294704121 4294967291 4294901754 4294769916 4293651437 4284700800 4286674590 4287990450 4288516794 4288977345 4289306310 4289569482 4289569482 4289504461 4289635792 4289504208 4289569999 4289570252 4289504711 4289570250 4289438666 4289700811 4289568972 4289173962 4288252611 4287133878 4286278572 4286080941 4286212527 4286212525 4286344111 4286278320 4286409906 4286344111 4286278572 4286541744 4287726016 4289372875 4289832657 4289042889 4287726777 4286871471 4286410669 4286410417 4286542005 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673076 4286870709 4286804913 4287660987 4289108430 4289832405 4289766864 4289503691 4289042889 4288779719 4288253122 4287660987 4287200182 4287200436 4288121536 4289305809 4288055996 4287463606 4287068596 4287200185 4287265978 4287134392 4287068598 4287200182 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287792571 4287924159 4287792319 4287989698 4288253122 4288713922 4289767629 4290688982 4290688982 4290820568 4290820570 4290754778 4289701838 4288385727 4288122303 4288122306 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450500 4288516293 4288450500 4288450754 4288648133 4288582340 4288516547 4288582340 4288911301 4290161621 4290095828 4288977348 4288648133 4288845258 4288779465 4288779717 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977094 4288911301 4288977094 4289437899 4290228182 4291149536 4291478752 4291347418 4291413211 4291412957 4291017949 4289767631 4289174727 4289240266 4289174473 4289306059 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289636045 4290623192 4291544543 4291676382 4291676382 4291807715 4291215328 4290030801 4289832654 4289832654 4289832654 4289898447 4289964240 4289898447 4289898447 4289964240 4289964242 4289964240 4290030033 4290030033 4290095826 4290095826 4290095826 4290096080 4290030287 4290293459 4290293459 4290227666 4290227666 4290227666 4290359252 4290161873 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290688984 4291215580 4292005094 4292334313 4292334312 4292465896 4292400105 4292268520 4291807717 4291083742 4290754777 4290820570 4290754777 4290886361 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952154 4290952154 4291017947 4291017947 4291083740 4291083740 4291215326 4291215326 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291741924 4291676383 4292334312 4292926701 4292992494 4292794861 4292268520 4291939301 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292071140 4292071140 4292071140 4292071140 4292597736 4293255664 4293387250 4292860906 4292531943 4292268517 4292136933 4292334313 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292729068 4292729068 4292729068 4292795115 4292729322 4292729322 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292927212 4292927212 4292927212 4292861418 4292927211 4293190381 4293585139 4293848311 4293848311 4293782518 4293519346 4293190383 4293058797 4293058797 4293124591 4293124591 4293190384 4293256176 4293256176 4293190383 4293256176 4293256176 4293387762 4293782518 4293980151 4293848565 4293716979 4293519346 4293321967 4293256174 4293321967 4293453553 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293980151 4294243321 4294243321 4294243320 4293980148 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294111735 4294111735 4294309114 4294440699 4294506492 4294440699 4294309113 4294243320 4294177527 4294177528 4294177528 4294177528 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294440953 4294440953 4294440953 4294440953 4294506746 4294572539 4294638332 4294638332 4294704125 4294704125 4294769918 4294769918 4294638332 4294572539 4294572539 4294572539 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802122 4281736329 4281868167 4281802372 4281999750 4281999750 4281539199 4281670785 4281277811 4283252604 4286542506 4288320437 4291281624 4292005345 4294967039 4294966783 4294966783 4293058536 4292202975 4288715698 4285096831 4282991455 4283254124 4282135142 4281212772 4281080933 4281145961 4281605745 4281671286 4281934461 4281540219 4281803389 4281212269 4281081436 4286214039 4290294727 4294045433 4294966783 4293782520 4289966527 4286477465 4280621133 4280490318 4287794092 4294967039 4294967291 4294901500 4294967295 4294836222 4294967295 4280424271 4281146464 4281540722 4281605495 4281802621 4282001019 4281607275 4282003557 4288320436 4292334564 4294900735 4294966783 4292992743 4290163903 4284240518 4280753489 4280490066 4281146991 4280621901 4280950364 4281214041 4281345874 4281016394 4280686926 4281474928 4281475429 4281672559 4281869938 4282395779 4282067065 4282067325 4281607279 4281278814 4283055726 4287333542 4291150038 4292861416 4294967295 4294967290 4294967293 4291413462 4290097348 4287859886 4283845760 4281279064 4282265209 4285161104 4286082456 4286674341 4285489315 4282725506 4282331251 4285095560 4289570488 4292202976 4294966783 4293913593 4291347418 4287530918 4282266711 4281410901 4281475940 4281146466 4281739864 4281213787 4280884822 4281082201 4280951118 4281607275 4281869684 4282329468 4282132358 4282462584 4282265977 4282529396 4282990198 4283648880 4281872218 4281542235 4281805156 4282199154 4282198652 4282593409 4282462324 4282265958 4281805659 4281476959 4281081950 4281344607 4281739615 4282134373 4282199665 4282527878 4282790549 4282659967 4284635276 4287201453 4288978117 4291479001 4292269273 4294835199 4294967295 4294966527 4293321456 4291215831 4287530918 4283319917 4281214290 4281608796 4281411417 4281607780 4282397296 4282857336 4282922877 4283448970 4283580305 4283777941 4283054471 4283054220 4282594170 4282529131 4284503421 4287662756 4291676634 4293321967 4294769663 4294966527 4293255664 4291610587 4287860389 4284438901 4281609299 4281411420 4281937261 4282199914 4282331503 4282857082 4283712393 4283317382 4283843728 4283909780 4283646862 4282923135 4283845761 4289044411 4292400608 4294834943 4294966783 4293321459 4291216344 4286938783 4283912306 4283517043 4283582840 4283451250 4282925161 4282727782 4282201688 4282332005 4282266461 4282463088 4282923637 4283581316 4283910032 4283581818 4283581821 4282989682 4282660968 4282003289 4282792806 4282595177 4282463088 4283383937 4283975563 4284370321 4284962209 4284632993 4285225129 4284699037 4284764828 4284501910 4284304528 4283581570 4283122037 4284767361 4288386730 4291742676 4293519340 4294900735 4294967039 4293321710 4291676380 4289176246 4287135895 4283582072 4283252856 4284107654 4284304528 4284305290 4284173704 4283844993 4283188080 4284570233 4288386730 4291676632 4293453042 4294967293 4294901243 4294900991 4292137432 4290887118 4288452274 4285885846 4283056496 4284766595 4286543006 4287858866 4288516796 4288977348 4289240520 4289503692 4289503438 4289371854 4289437647 4289437649 4289635024 4289701068 4289569482 4289635277 4289569231 4289700557 4289042628 4288055483 4287134130 4286475949 4286146732 4286146734 4286212528 4286278318 4286344111 4286278320 4286344113 4286278318 4286344365 4286673330 4287923395 4289437647 4288911051 4287595192 4286673838 4286410669 4286410415 4286541490 4286541490 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286804662 4286870455 4286673330 4287134391 4288121284 4288582089 4288187329 4287529398 4287002803 4287002803 4287002805 4287068599 4287068599 4287002806 4287134391 4287594942 4287134132 4287134132 4287199671 4287199672 4287133879 4287133878 4287199671 4287331257 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287989949 4287924157 4287858112 4288055491 4287989952 4288187580 4289241287 4290425813 4290886361 4290886361 4290688982 4290820570 4290359766 4288846276 4287990717 4288188099 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450500 4288450500 4288384707 4288450754 4288582340 4288516547 4288516547 4288582340 4289437896 4290819803 4290754010 4289306312 4288713924 4288779465 4288779719 4288713924 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288845508 4289042887 4289042887 4289108680 4289767633 4291017950 4291544545 4291215578 4291347418 4291347166 4290688985 4289504459 4289108934 4289174473 4289174473 4289306059 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289636047 4290030801 4291347166 4291742176 4291742175 4291676131 4290557399 4289636045 4289766861 4289766861 4289832654 4289898447 4289964240 4289898447 4289964240 4289964240 4289964242 4289964240 4290030033 4290095826 4290095826 4290030033 4290095826 4290161873 4290490835 4290885593 4290754007 4290425043 4290227664 4290161873 4290359252 4290293459 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290754008 4290623191 4291215580 4292202473 4292465899 4292334312 4292465896 4292400103 4292400105 4291676129 4290820568 4290820570 4290886363 4290754777 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291083994 4291149787 4291215580 4291149787 4291018201 4291018201 4291083994 4291149787 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291741924 4291742176 4292531689 4292992492 4293189871 4292992494 4292268519 4291939301 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292071140 4292071140 4292071140 4292005347 4292400357 4293189873 4293124080 4292531943 4292334564 4292268517 4292202727 4292334313 4292268517 4292268517 4292334310 4292334310 4292334310 4292334310 4292400103 4292400103 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292663275 4292663275 4292663529 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292993005 4292993005 4292993005 4292993004 4293190381 4293453553 4293716979 4293848565 4293782518 4293585139 4293321967 4293124590 4293058797 4293124590 4293124591 4293190384 4293190384 4293256176 4293190383 4293256176 4293256176 4293190383 4293387762 4293716725 4294045942 4293980149 4293914358 4293716979 4293453807 4293321967 4293387760 4293453553 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293651186 4293716979 4293716979 4293980151 4294243321 4294243321 4294243320 4293980148 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294111735 4294177528 4294309114 4294506492 4294440699 4294374906 4294309113 4294243320 4294177527 4294177528 4294177528 4294177528 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294374906 4294440699 4294506492 4294506746 4294506746 4294506746 4294506746 4294572539 4294638332 4294704125 4294704125 4294769918 4294769918 4294769918 4294704125 4294638332 4294572539 4294572539 4294572539 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281867913 4281868167 4281802371 4281934209 4282986895 4283316114 4282197633 4281737082 4281737346 4281014126 4281211507 4280751968 4280686426 4280159831 4280884056 4280226127 4281016145 4282924643 4283648363 4283582319 4283648115 4283977077 4282858596 4281608278 4281015138 4281343594 4281408368 4281802875 4281934209 4281868414 4282328965 4281540221 4281407863 4281539700 4281014629 4280883543 4280818766 4280358215 4280555857 4280424020 4280555343 4280686424 4281871203 4287925928 4294835198 4294967293 4294967295 4294704382 4294901759 4294967295 4280884822 4281278052 4281408366 4282066298 4282066046 4281802872 4281540478 4281540981 4281344105 4280883805 4280686424 4280752471 4281015642 4280621652 4281542487 4281937496 4282200666 4282397798 4283187563 4283516279 4283582322 4283516780 4282265197 4281343843 4281211757 4281475429 4281935477 4282264442 4282000253 4282395261 4282197633 4281803644 4281803640 4281343592 4281147229 4281147478 4280950869 4280819029 4280884826 4280753238 4281278312 4281015389 4281081182 4281081186 4281608031 4281936744 4285029264 4286345378 4286476964 4285950117 4283515276 4282264445 4281738603 4281739355 4281213524 4281411153 4281016395 4281344605 4281212770 4281278304 4281541474 4281409890 4282001508 4281213263 4281607267 4281410400 4281739365 4281805661 4281541222 4282068071 4282462061 4282724742 4282594172 4282792319 4284306311 4284898698 4283978096 4282726761 4281739114 4282067826 4282264694 4282856063 4282592639 4282593410 4282330489 4281936493 4281936745 4281739363 4281673311 4281739104 4281739104 4282331243 4282528119 4282856581 4282922887 4282331503 4282594423 4282199412 4282134373 4281213522 4281871201 4281214040 4281542739 4281410899 4281542489 4281476442 4281673822 4281608029 4281871200 4281936993 4282331251 4282594421 4283120254 4283316614 4283579537 4283711637 4283514769 4283580817 4283711374 4282922372 4282725247 4282396533 4282331500 4281674075 4281609050 4281872222 4281937247 4281739866 4281739866 4281936993 4281805156 4281870952 4282068330 4282463086 4282528882 4283054972 4283120256 4283579784 4284237716 4284172693 4283910034 4283712403 4283778446 4283252353 4282594672 4282923888 4282397796 4282332254 4283253605 4284241520 4284306293 4284832637 4285030266 4284898682 4285358730 4284898182 4284503423 4284240252 4282792305 4282726761 4282792053 4283252602 4283581316 4283712655 4283844741 4283581570 4283252353 4283121018 4282529130 4282595177 4282858096 4283384188 4283778436 4284107401 4284369818 4284830621 4284896414 4284830371 4285159336 4284764830 4284699289 4284304530 4283909773 4283778438 4283449981 4282792556 4282661220 4282463840 4282464610 4282332769 4282464357 4282529900 4282398564 4282660968 4283318398 4283844229 4283975814 4284567703 4284766092 4284371083 4284239246 4283844742 4283779198 4282990701 4282661989 4282793575 4282924392 4282792805 4282924389 4282858596 4283055975 4283055978 4283055724 4283318898 4284240000 4285424276 4286411171 4287068847 4287397813 4287660987 4287858366 4287726780 4287858366 4287924159 4288187329 4288977098 4289503692 4289372106 4289240270 4288976847 4287726267 4287068339 4286344362 4286081193 4286146732 4286278318 4286278318 4286212525 4286278318 4286344111 4286212527 4286278320 4286278318 4286410158 4286541744 4287594430 4288187331 4287331768 4286410669 4286410417 4286607796 4286541490 4286541744 4286607537 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673330 4286936502 4286804914 4286805427 4286871220 4286937012 4287068598 4286937012 4287068345 4287068345 4286871220 4286739633 4286871219 4286937013 4286937013 4287002552 4287133881 4287199672 4287133878 4287068085 4287134132 4287265464 4287331257 4287331257 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287792570 4287924157 4287924159 4287989952 4287924157 4288384961 4289504206 4290359768 4290952156 4290820568 4290754775 4290820570 4290754524 4289570254 4288254143 4288122305 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288450500 4288450500 4288450754 4288516547 4288516547 4288582340 4288911305 4290227664 4291148765 4291082972 4289832908 4288845508 4288713926 4288779719 4288713924 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911303 4288977096 4289042889 4288911301 4289175496 4290293973 4291149533 4291347164 4291478752 4291346912 4290293973 4289307082 4289174473 4289174473 4289240266 4289240266 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289438413 4289701838 4290886361 4291676383 4291742176 4291149787 4289965008 4289570254 4289832654 4289766861 4289832654 4289898447 4289898447 4289898447 4289898447 4289964240 4289964242 4289964240 4290030033 4290095826 4290030033 4290030033 4290227412 4290359252 4291346394 4291741154 4291543775 4291083226 4290556628 4290227664 4290293459 4290358998 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290622422 4290688215 4290557398 4290952408 4291741922 4292334313 4292400105 4292465896 4292400103 4292136933 4291347164 4290754775 4290754777 4290886363 4290820570 4290754775 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291149785 4291478750 4291741922 4291807715 4291544543 4291281371 4291149785 4291149785 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291676129 4291939555 4292663529 4292926699 4293058284 4292795115 4292005347 4291807969 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4292005348 4292071141 4292005348 4292005347 4292071140 4292136933 4292071140 4292268771 4292926701 4292795115 4292268771 4292202724 4292202726 4292136934 4292268266 4292202724 4292268517 4292268517 4292334310 4292334310 4292400103 4292400103 4292465896 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292597736 4292663529 4292663529 4292729322 4292729320 4292795113 4292795113 4292795113 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292927212 4293058798 4293256177 4293321969 4293453553 4293651186 4293782772 4293848565 4293650932 4293387760 4293124588 4293124590 4293124590 4293124591 4293124591 4293256177 4293190384 4293190383 4293190383 4293256176 4293256176 4293256176 4293387762 4293716725 4293980149 4293980149 4293980149 4293914358 4293782772 4293585139 4293453553 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293651186 4293716979 4293716979 4293980151 4294177528 4294177528 4294177527 4293980148 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294111735 4294177528 4294374907 4294506492 4294440699 4294309113 4294243320 4294177527 4294177527 4294177528 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294506492 4294572285 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294704125 4294638332 4294638332 4294572539 4294572539 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802374 4281802371 4281868416 4282592390 4284895397 4286013876 4284566430 4283579535 4281342842 4281672058 4281277045 4280751455 4280883294 4280817250 4280488785 4280686678 4280883295 4283121008 4283647851 4283976818 4284108155 4284305280 4284370822 4282857333 4281278314 4281409135 4281802874 4281802371 4281933700 4282065795 4281868416 4281934727 4281934201 4281473910 4281342323 4281277549 4280620122 4280949596 4280686428 4280620130 4280686424 4281015393 4282529130 4289110707 4294967293 4294967295 4294901247 4294901759 4294770429 4294967295 4280884822 4280949088 4281671538 4281934710 4282000251 4282197630 4282132605 4281540721 4281343594 4281409639 4280949598 4281015642 4281279317 4283055977 4283647865 4283845244 4284503172 4285095307 4284963721 4285029514 4285226897 4284700299 4282857334 4281672808 4281475178 4282067818 4282067066 4282198400 4282657681 4282460551 4282461305 4282263675 4282132091 4281540721 4281804396 4281213022 4281212768 4281147494 4281081184 4281213019 4281015389 4281279317 4281278804 4281475429 4281475429 4282132856 4284371335 4286674092 4286805676 4286871468 4284172942 4282527365 4282132609 4281869684 4281672818 4281343843 4281541473 4281146716 4281541473 4281541727 4281607269 4281869684 4282000243 4282198382 4282067065 4281870190 4281738861 4281935980 4282132605 4282329971 4282593142 4282724746 4284107413 4285949864 4285622674 4285556881 4284963972 4282659963 4282133621 4281936244 4282725499 4282856566 4282987901 4282922375 4282724996 4282593912 4282132856 4282133611 4282133864 4282133359 4282199155 4282593910 4282857084 4282856579 4282987916 4282988671 4282527866 4282527614 4281936744 4282068579 4281673570 4281739363 4281673060 4281738852 4282002278 4281673311 4281870692 4282002025 4282199152 4282462326 4282660218 4282857595 4283120257 4283908500 4283645079 4283909018 4283712148 4283646610 4283646080 4283580037 4283185026 4282922875 4282660208 4282265959 4282265707 4282003054 4282133611 4282133860 4282134111 4282068320 4282331243 4282199403 4282660206 4282594664 4282923386 4283318146 4283778187 4284040339 4284171923 4284106898 4284567964 4284304540 4284304780 4284436617 4284831626 4284700038 4284766596 4284898179 4284898684 4284964727 4285161856 4285358984 4285688198 4286017415 4285885328 4286148248 4284635010 4283318397 4283186299 4282858096 4283252605 4283581569 4283778697 4284041366 4284107662 4283975566 4283647113 4283186812 4283252856 4283318136 4283054712 4283580805 4283975566 4284238738 4284764327 4284567703 4285094298 4285028002 4285027497 4284961955 4285159069 4284830102 4284633228 4284041607 4283844228 4283383677 4283318649 4282989682 4282924142 4282726761 4282661738 4282464108 4282924910 4283384693 4283121016 4283910273 4284436615 4284633495 4284633753 4284896925 4284567960 4284305041 4283844741 4283582589 4283451002 4283122037 4282989935 4283121521 4282989935 4283055728 4283187314 4283121267 4283318647 4283647614 4283976579 4284502923 4284897427 4285292187 4285555360 4285818278 4286081452 4285884073 4286081193 4286081191 4286607788 4288121278 4289108169 4288647618 4287528888 4286475951 4286212528 4286146735 4286146735 4286212528 4286212528 4286146734 4286212525 4286278572 4286212525 4286278318 4286212527 4286278320 4286344111 4286410158 4286278572 4287068086 4286805427 4286673587 4286410417 4286410164 4286475700 4286475697 4286607537 4286541742 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286804913 4286804913 4286739120 4286871220 4286805427 4286739380 4286870966 4286805173 4286673591 4287002554 4287002806 4286937010 4287002803 4287068598 4287002806 4287002552 4287067834 4287068088 4287133878 4287265718 4287265716 4287134132 4287199671 4287331258 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397561 4287397561 4287397561 4287463354 4287463354 4287529147 4287529147 4287529147 4287529147 4287594940 4287594940 4287595194 4287660987 4287660987 4287660987 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924410 4287924156 4287924157 4288055743 4287924156 4288253375 4289306829 4290227929 4290360020 4290623191 4290886361 4290754777 4290754778 4290096598 4288648901 4288056512 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288318914 4288450500 4288516293 4288516547 4288516547 4288516547 4288845512 4289240270 4290885593 4291149019 4291214812 4290293457 4289043141 4288648131 4288845510 4288779715 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4289042889 4288845510 4288977098 4289042889 4288912069 4289504457 4290688984 4291478752 4291346912 4291149535 4289899215 4289109448 4289174473 4289174473 4289306059 4289240520 4289306313 4289306313 4289306313 4289372106 4289372106 4289437899 4289437899 4289437899 4289437899 4289437899 4289503692 4289503692 4289569485 4289569485 4289635277 4289635277 4289570001 4289767631 4290557396 4291478750 4291610590 4290557396 4289570252 4289833171 4289832654 4289832654 4289832654 4289898447 4289898447 4289832654 4289898447 4289964240 4289964242 4289964240 4290030033 4290095826 4290030033 4290095826 4290293205 4290556631 4291609819 4292201957 4292267496 4291938533 4291280351 4290556629 4290359252 4290424791 4290162387 4290228180 4290228180 4290228180 4290293973 4290293973 4290293973 4290359766 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290688215 4290491605 4290623443 4291215578 4292071141 4292465898 4292400103 4292400357 4291873761 4291149785 4290820568 4290688984 4290754777 4290820570 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291018199 4291544543 4292202473 4292465645 4292202473 4291807715 4291478750 4291412957 4291149787 4291215580 4291215580 4291215580 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291544543 4291544543 4291610336 4291610336 4291610336 4291741922 4292202727 4292992494 4293058284 4293058284 4292729320 4291873761 4291807969 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4291939555 4292071141 4292071141 4292005348 4292005347 4292136933 4292136933 4292071140 4292268517 4292663529 4292531943 4292137185 4292268517 4292202726 4292071141 4292334059 4292202724 4292202724 4292268517 4292334310 4292334310 4292400103 4292465896 4292465896 4292400105 4292400103 4292465896 4292465896 4292465896 4292465896 4292531689 4292531943 4292531689 4292597482 4292597482 4292597736 4292597736 4292597736 4292663529 4292729322 4292663529 4292663529 4292729322 4292795113 4292795113 4292795113 4292795112 4292795112 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292861419 4293190384 4293519348 4293585141 4293650932 4293716979 4293782772 4293782770 4293453553 4293124588 4292993004 4293124590 4293190383 4293124591 4293058798 4293190384 4293190384 4293190383 4293124590 4293256176 4293321969 4293256176 4293387762 4293716725 4293914355 4293980149 4293980149 4294045944 4293980151 4293782518 4293585139 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293651186 4293716979 4293716979 4293980151 4294177528 4294177528 4294177527 4293980148 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293914358 4293914358 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4293980149 4294045942 4294111735 4294111735 4294177528 4294374907 4294572285 4294374906 4294309113 4294177527 4294111734 4294111734 4294177528 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294572285 4294638078 4294638332 4294704125 4294704125 4294769918 4294769918 4294704125 4294638332 4294638332 4294704125 4294638332 4294638332 4294572539 4294572539 4294572539 4294638332 4294638332 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281802112 4281867652 4281868934 4283514773 4286147245 4286871217 4286739380 4285225892 4282263174 4281802621 4281408117 4281211505 4281145964 4281014377 4280883043 4280883041 4281278050 4282330740 4282528117 4283383931 4284568965 4285161100 4285292690 4284436876 4282527614 4281606010 4281671556 4281803142 4281606014 4282000000 4282065543 4281933708 4281868414 4281802621 4281671288 4281539700 4281342573 4281277033 4281211236 4281211236 4281080420 4281277801 4281870447 4289242041 4294967291 4294704127 4294901757 4294770682 4294967039 4294967295 4280423770 4280818012 4281606766 4281802874 4282066044 4282262663 4282000768 4281803644 4281672054 4281606514 4281409387 4281409639 4281870187 4282528371 4284239748 4285029518 4285490065 4285556112 4285753237 4286016411 4285950366 4285687711 4284897681 4284436876 4283844488 4283186307 4282725506 4282462083 4282461831 4282527625 4282592905 4282329735 4282132356 4282132609 4281803894 4281672559 4281804145 4281540973 4281541224 4281475431 4281475432 4281475432 4281540971 4281606764 4281869938 4282198903 4284041871 4286739885 4287003306 4287332022 4285028515 4282527624 4282462085 4282001783 4282001272 4281935731 4281804397 4281738603 4281738603 4281870190 4282001524 4282132858 4282132605 4282461823 4282198903 4282264696 4282330237 4282330237 4282264442 4282725247 4283054976 4285029016 4286410666 4286871471 4286871722 4286476960 4285489305 4283251589 4282593407 4282659202 4282856582 4282987914 4283053707 4282987914 4282922121 4282856582 4282659454 4282593661 4282527868 4282527868 4282593661 4282790786 4282922374 4282988167 4283185547 4282988167 4282790786 4282725247 4282528120 4282330740 4282199152 4282199406 4282067817 4282133610 4282265197 4282330990 4282330992 4282462326 4282725499 4282856831 4283185028 4283382409 4283645328 4283842709 4283974041 4283974041 4283908502 4283842709 4283711637 4283645844 4283448718 4283251591 4283054210 4282922877 4282725750 4282659957 4282528882 4282463089 4282463089 4282528628 4282594423 4282726009 4282989181 4283186562 4283383175 4283646349 4284106648 4283909269 4284370331 4285554855 4286213036 4286805424 4287200434 4287134640 4286937513 4286674593 4286345625 4286082704 4285885579 4285885577 4286082705 4286214293 4286609051 4286871971 4286345378 4285094806 4284107662 4283712651 4283646598 4283646598 4283712393 4283975565 4284238738 4284304277 4284238484 4284238484 4283975566 4283909772 4283778184 4283712391 4283843977 4283910285 4284238995 4284567962 4284764830 4285027750 4284830372 4285093795 4285554595 4285949605 4285884073 4284962718 4284699288 4284567702 4284304528 4284041610 4283778436 4283647103 4283515517 4283449722 4283384182 4283384182 4283515513 4283712896 4283975815 4284304782 4284633495 4284830874 4285028253 4285028253 4284962458 4284830872 4284567954 4284370573 4284107401 4283975814 4283779198 4283647612 4283581819 4283581819 4283581819 4283647612 4283844991 4284042370 4284436366 4284765331 4285225884 4285489056 4285686181 4285817767 4285883562 4285883562 4286080941 4286015148 4286409906 4287002041 4287067834 4286541490 4286146732 4286212525 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286344876 4286410415 4286410419 4286476212 4286542001 4286410669 4286410415 4286476210 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286805173 4286673587 4286673587 4286739634 4286739634 4286739634 4286805427 4286871220 4286870966 4286937013 4287002805 4286937010 4286937012 4287002806 4287002552 4287002554 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287200436 4287265975 4287265977 4287265978 4287331770 4287397815 4287529398 4287792822 4287726778 4287595192 4287463608 4287595194 4287594940 4287594940 4287660735 4287397563 4287529399 4287595192 4287595192 4287595194 4287660987 4287726780 4287726780 4287726780 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287858366 4287924159 4287989950 4287924157 4287924157 4288055743 4288253122 4288450501 4289306063 4289700817 4290490838 4290951386 4290885847 4290490838 4289503692 4288253373 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450500 4288450754 4288450754 4288384707 4288713672 4288582340 4288714176 4290359252 4291017950 4291017949 4291149533 4290623191 4289437898 4288713924 4288845512 4288713926 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911555 4288977094 4288911303 4288977098 4289042889 4289174727 4290095826 4291477731 4291544027 4291083226 4289701322 4289174727 4289240268 4289108682 4289371852 4289306313 4289371852 4289240266 4289306059 4289437645 4289371852 4289240266 4289371852 4289635024 4289437899 4289437899 4289437898 4289503691 4289503691 4289503689 4289569482 4289635275 4289701071 4289701068 4290161873 4291411937 4291346144 4290030287 4289701068 4289898450 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289898447 4289964240 4290030033 4290030033 4290096080 4290359252 4290622424 4291610590 4291939554 4292136933 4292071140 4291939555 4291676129 4291017947 4290294226 4290359250 4290293459 4290359252 4290425045 4290425045 4290490838 4290425043 4290359250 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290557398 4290491606 4290622938 4290622938 4290754777 4291610338 4292334312 4292334564 4292334312 4291478750 4290886361 4290820571 4290688985 4290754777 4290886361 4290820822 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952154 4291149787 4291807969 4292597482 4292597482 4292466409 4292531949 4291939814 4291676380 4291413210 4291149787 4291215326 4291281121 4291281119 4291215578 4291281625 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478752 4291610336 4291478750 4291478750 4291610336 4291610336 4291544543 4291676131 4291742175 4292663275 4292926701 4292992492 4292860906 4292268517 4291873762 4291807717 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292202724 4292202726 4292268519 4292334312 4292334310 4292400357 4292729320 4293058284 4292663529 4292400357 4292334564 4292465896 4292531689 4292400103 4292465896 4292597482 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292927212 4293321969 4293585139 4293651186 4293782772 4293782772 4293716725 4293650932 4293190383 4293124590 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293190384 4293124590 4293190383 4293190383 4293190383 4293256176 4293453555 4293650932 4293914356 4293980149 4294045942 4294045942 4293980149 4293782772 4293650932 4293519346 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293914358 4294177528 4294309114 4294177528 4294045942 4293716979 4293782772 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294045942 4294111735 4294243321 4294374907 4294506492 4294440700 4294243321 4294177528 4294177528 4294177528 4294243321 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294440699 4294572285 4294638078 4294703871 4294638332 4294638332 4294638332 4294638332 4294638332 4294638332 4294572539 4294572539 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294769918 4294769918 4294835711 4294835711 4294835711 4294901502 4294835709 4294835709 4294835709 4294901502 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281933700 4281868165 4282000518 4284633250 4286936759 4286937010 4286673589 4284896675 4282263176 4281868416 4281605242 4281408631 4281343091 4281277296 4281145964 4281145963 4281080422 4281803891 4281672305 4282330740 4284436876 4285818781 4286016160 4286081701 4283975312 4282198400 4281737348 4282066060 4281934725 4282065793 4282197383 4282131085 4282000002 4281934207 4281868668 4281737081 4281605747 4281539952 4281539951 4281540205 4281606514 4281408882 4281738613 4288978618 4294967036 4294769663 4294901757 4294836220 4294967295 4294835707 4280752987 4281146977 4281343340 4282000253 4282000253 4282328454 4282198151 4282066563 4281934975 4281869435 4281738101 4281540721 4281738352 4282001524 4282725496 4284436366 4285950369 4286542503 4286674343 4286740136 4286608550 4286476710 4286542757 4286410917 4286213287 4286081704 4285752489 4285094308 4284238747 4283580564 4282856582 4282658951 4282263940 4282263940 4282329984 4282198651 4282067063 4281869686 4281935729 4281869936 4281869938 4281869938 4281935477 4282001270 4282264444 4282527616 4283843728 4286673581 4287332012 4287594932 4285817769 4283053707 4282527365 4282527617 4282330238 4282264444 4282133110 4282067315 4282067315 4282198903 4282330237 4282396031 4282527365 4282724996 4282527614 4282659202 4282659203 4282658949 4282790789 4283514509 4285818282 4287002805 4287332022 4287332020 4287134894 4287003304 4285949858 4283185798 4282856581 4282922375 4282987914 4283119500 4283185295 4283119502 4283119500 4283053707 4282988167 4282922374 4282856579 4282790786 4282922372 4282988167 4283119754 4283185293 4283317133 4283251340 4283185546 4283119751 4282988419 4282856831 4282725499 4282725498 4282856831 4282659706 4282593913 4282725498 4282791291 4282922878 4283120003 4283317382 4283514511 4283514512 4283580051 4283645846 4283711639 4283843225 4283909016 4283909016 4283843223 4283777430 4283646097 4283514509 4283383177 4283251843 4283120256 4283054463 4283054715 4282988668 4282988668 4283054463 4283186049 4283251843 4283449222 4283646601 4283777681 4283777683 4284106648 4284238232 4285554857 4287528896 4288253122 4288384961 4288384959 4288121785 4287792820 4287529648 4287266730 4287003557 4286806178 4286740385 4286871969 4287266729 4287266476 4286411171 4285292439 4284502672 4284041871 4283844239 4284107151 4284041358 4284107152 4284304531 4284501656 4284501656 4284501658 4284501658 4284238738 4284238738 4284172944 4284041358 4284172944 4284370836 4284436374 4284436374 4284896668 4285028000 4285488551 4286278320 4287528637 4287923394 4286542003 4285160099 4285028254 4284896668 4284699288 4284501907 4284304782 4284173194 4284107400 4284041607 4283976066 4283976068 4284107654 4284238987 4284436368 4284699286 4284962460 4285094047 4285291426 4285291426 4285225632 4285159837 4285028251 4284831126 4284633745 4284502159 4284371083 4284305290 4284239497 4284239497 4284239497 4284305290 4284502669 4284634255 4284962712 4285225884 4285489056 4285620388 4285751974 4285883562 4285949355 4285949355 4285949355 4285883562 4285949355 4286146734 4286212525 4286015146 4286015146 4286080939 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286344622 4286410417 4286344626 4286344624 4286410415 4286476208 4286542001 4286607794 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286673587 4286673587 4286739634 4286739634 4286805427 4286805427 4286871220 4287068345 4286805173 4286739634 4286937012 4287002805 4287002806 4287002552 4287134138 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287266229 4287265975 4287200184 4287200185 4287265977 4287463608 4288318914 4289371856 4289371854 4289240266 4288911303 4288713924 4288384961 4288187582 4288187328 4287858364 4287529401 4287529401 4287595194 4287660987 4287660987 4287726780 4287792573 4287792573 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287989952 4287989950 4287989950 4287924157 4287989950 4288121536 4288187329 4288319168 4288450752 4288911554 4289569736 4290161873 4290556379 4289898196 4288648131 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384708 4288516547 4288450754 4288516547 4288450500 4288384961 4289372105 4290688215 4291083743 4291149533 4291215580 4290886363 4289964242 4288845510 4288582340 4288845510 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977348 4289042887 4288977096 4289042891 4289042889 4289043141 4289701068 4290754010 4291346396 4290819800 4289503689 4289108680 4289240268 4289174475 4289371852 4289240520 4289371852 4289372106 4289372106 4289372106 4289437899 4289503692 4289437899 4289306313 4289503692 4289503692 4289503692 4289569485 4289569485 4289635278 4289635278 4289635278 4289635278 4289701070 4289964494 4290819801 4290754008 4289832908 4289701070 4289766864 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4290030033 4289964240 4290030033 4290030033 4290030033 4290030287 4290161873 4290359252 4290886615 4291412957 4291873762 4292071141 4292071141 4292005094 4291676131 4291281119 4290688214 4290490835 4290688214 4290819801 4290490836 4290359250 4290490836 4290425043 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290557398 4290425813 4290557145 4290622938 4290623191 4291215580 4292005348 4292334310 4292334313 4291347164 4290754775 4290754778 4290754778 4290754777 4290820568 4290820822 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017949 4291083994 4291544797 4292400103 4292663529 4292597995 4292663790 4292400363 4292465896 4292136933 4291741922 4291412705 4291281119 4291215326 4291215578 4291281625 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478752 4291544543 4291544543 4291544543 4291676129 4291610336 4291544543 4291610336 4291939554 4292663275 4292992494 4293058285 4292795115 4292136931 4291807969 4291807717 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292202726 4292268519 4292334312 4292334310 4292400357 4292795113 4293255663 4293058287 4292729322 4292400357 4292400357 4292531943 4292531943 4292531689 4292531689 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292795625 4293387762 4293716725 4293782772 4293848565 4293782772 4293651186 4293650932 4293190383 4293124590 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293190384 4293124590 4293190383 4293190383 4293190383 4293256176 4293387762 4293650932 4293980151 4294045942 4294045942 4294045942 4293914356 4293716979 4293519346 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293651186 4293651186 4293848565 4294045944 4294111735 4294045942 4293914356 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4293980149 4294045942 4294045942 4294111735 4294177528 4294309114 4294440699 4294374907 4294243321 4294111735 4294177528 4294243321 4294243321 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294440699 4294506492 4294572285 4294638078 4294638078 4294638332 4294638332 4294638332 4294638332 4294638332 4294572539 4294572539 4294506746 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294769918 4294835711 4294835711 4294835711 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281867654 4282065544 4282987663 4285883824 4287068598 4287134391 4286278578 4283317133 4282131590 4281934211 4281736830 4281736830 4281606012 4281474424 4281474679 4281474679 4281474677 4281671803 4281408631 4281606263 4283777935 4285949864 4286476461 4286805424 4285817767 4283251340 4281737346 4282066060 4282000520 4281934211 4282131590 4282065544 4282065797 4282065795 4282000002 4281934207 4281934461 4281868667 4281802874 4281802872 4281606010 4281737598 4281738108 4288451255 4294900989 4294967295 4294901755 4294901759 4294967291 4294901241 4280490068 4281081184 4281211756 4282066046 4282066047 4282328967 4282197899 4282132104 4282066565 4282066563 4282066561 4281935230 4281869437 4281869435 4281935226 4282922374 4284567703 4286081193 4286937010 4287003055 4287003054 4287200433 4287003308 4287069101 4287068848 4287200182 4287331770 4287265724 4286870968 4286410419 4285751976 4284698783 4283053711 4282329735 4282461319 4282329986 4282264191 4282264191 4282198652 4282198652 4282198652 4282198398 4282264191 4282264191 4282461572 4282658951 4283317133 4286607537 4287726518 4287529139 4286344111 4283646098 4282724746 4282856332 4282593158 4282593156 4282527617 4282461823 4282527616 4282593410 4282658949 4282724744 4282856332 4282922121 4282790789 4282922121 4282790539 4282856332 4283185295 4283975063 4286015406 4287660735 4287792571 4287660984 4287595445 4287463346 4286212777 4283448718 4283119500 4283119500 4283185295 4283251090 4283251090 4283251090 4283251088 4283251088 4283251086 4283251086 4283185547 4283185547 4283185547 4283251086 4283316881 4283382674 4283448465 4283448465 4283382926 4283317133 4283185546 4283185546 4283119751 4283119751 4283119753 4282988165 4283053958 4283251337 4283382923 4283317132 4283317133 4283514512 4283514258 4283580053 4283777432 4283909020 4283974811 4283909018 4283843223 4283777430 4283909016 4283909016 4283843477 4283777683 4283711888 4283646095 4283580556 4283580556 4283449222 4283449222 4283448968 4283514761 4283580556 4283646349 4283777935 4283909521 4284040856 4284040856 4284172441 4284172693 4285488804 4287726526 4288648133 4288582590 4288450750 4288319164 4288121787 4287727031 4287068848 4286410920 4286213287 4286279080 4287595443 4287397812 4286542506 4285292188 4284436629 4284304788 4284304792 4284173206 4284370070 4284370070 4284370070 4284501658 4284633244 4284633244 4284632990 4284632990 4284567449 4284501656 4284567449 4284633242 4284567703 4284502167 4284831132 4285226145 4285686433 4286475949 4287923394 4288449990 4288910539 4288384199 4286015659 4285160101 4285093795 4285028000 4284962207 4284830875 4284765081 4284699286 4284633493 4284567954 4284502161 4284567954 4284633493 4284699286 4284830874 4284962460 4285159840 4285225633 4285356965 4285423012 4285423012 4285357218 4285291425 4285225630 4285094044 4285028505 4284897430 4284831637 4284831637 4284831637 4284897430 4284897430 4285029016 4285160602 4285291423 4285488802 4285620388 4285686183 4285751976 4285817770 4285883563 4285883563 4285949355 4286015148 4286015148 4285949355 4285949353 4286080939 4286146732 4286080939 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286344626 4286344626 4286410417 4286410417 4286410417 4286542001 4286542001 4286476208 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286805427 4286805427 4286739382 4286805173 4287002806 4287068599 4287002805 4286871220 4286871220 4287068345 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287200182 4287134389 4287200184 4287331771 4287265977 4287332022 4288253122 4289503188 4290161873 4290359252 4290359252 4290293459 4290161619 4290161621 4290030036 4289437645 4288055491 4287594940 4287529147 4287660733 4287660733 4287726526 4287726526 4287594940 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4287989950 4288055743 4288121789 4288121789 4288187580 4288253371 4288648129 4289371852 4289371854 4288648131 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384708 4288582086 4288384961 4288713926 4288450754 4288648131 4290490584 4291214558 4291083742 4291215580 4291215580 4291149535 4290687963 4289306059 4288516545 4288911303 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911301 4289042887 4288977096 4289042891 4289042889 4288977348 4289240519 4289832654 4291082973 4290425045 4289372105 4289108680 4289240268 4289174475 4289371852 4289240266 4289175241 4289306827 4289241034 4289175496 4289570252 4290030803 4289965008 4289504457 4289569485 4289503692 4289437899 4289503438 4289569231 4289635024 4289635024 4289635024 4289569485 4289766863 4289701068 4290096080 4290030287 4289701068 4289766863 4289701071 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4290030033 4290030033 4290030033 4290030033 4290030033 4290030287 4290030287 4290161873 4290162641 4290623191 4291281119 4291741922 4292070887 4292268520 4292136934 4291873762 4291478750 4291149787 4291412959 4291478498 4290688984 4290294226 4290360020 4290294227 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290491605 4290491606 4290491352 4290622938 4290623191 4290820568 4291544543 4292202726 4292071141 4291083992 4290623189 4290754777 4290820571 4290754777 4290820568 4290820822 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291083742 4291017947 4291281625 4292136931 4292663529 4292663786 4292729579 4292729581 4292794861 4292400105 4291807715 4291347166 4291149533 4291215580 4291347164 4291347164 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478750 4291544543 4291544543 4291610336 4291676129 4291610336 4291544797 4291610590 4292268517 4292794861 4293058287 4293058285 4292531943 4291873761 4291807969 4291741922 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292268519 4292334312 4292334312 4292334310 4292466150 4292926699 4293453042 4293387252 4293058287 4292729322 4292531943 4292466150 4292466150 4292531943 4292531689 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292993004 4293453553 4293716979 4293716979 4293782770 4293848565 4293782772 4293650932 4293190383 4293124590 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293190384 4293190383 4293190383 4293190383 4293190383 4293256176 4293387762 4293585139 4293914358 4293914358 4293980149 4294045942 4293980149 4293716979 4293453553 4293256174 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293651186 4293651186 4293716979 4293848565 4293914358 4293848563 4293782770 4293782772 4293782772 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294111735 4294177528 4294243321 4294309113 4294243321 4294177528 4294111735 4294177528 4294243321 4294243321 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294440699 4294506492 4294572285 4294572285 4294572285 4294572285 4294638332 4294638332 4294638332 4294572539 4294572539 4294506746 4294506746 4294506746 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294835711 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281736070 4282131336 4284237981 4286673591 4286739631 4287068599 4285488299 4282132354 4281999750 4281868164 4281802371 4281802371 4281802625 4281605760 4281605760 4281671553 4281671807 4281539967 4281671555 4281605760 4282724744 4285291174 4286871220 4286871471 4287068086 4284699037 4282329735 4281934728 4282000521 4281999750 4282263176 4282131590 4282065797 4282065797 4282065797 4282065797 4282065797 4282000002 4282000002 4282000002 4281869184 4282000772 4281934977 4288187832 4294967039 4294967039 4294638582 4294967039 4294967039 4294967039 4280423503 4281015391 4281540722 4281934461 4282197381 4282263172 4282263690 4282197897 4282132104 4282132104 4282198151 4282198151 4282198151 4282132358 4282198151 4282263940 4283119500 4284896416 4286738871 4287331517 4286871220 4286213290 4286607535 4287002293 4287331257 4287397050 4287462843 4287594683 4287528890 4287397304 4287397051 4285554344 4283251088 4282461323 4282592909 4282527114 4282527112 4282527112 4282395781 4282395781 4282461319 4282461319 4282461319 4282461319 4282592907 4282724493 4283251088 4286343860 4287594430 4286607537 4285883057 4283909020 4282921872 4282658698 4282790284 4282790539 4282724744 4282724744 4282790537 4282790537 4282856332 4282856077 4282921870 4282922125 4282922123 4283053711 4282921872 4282987665 4283119249 4283777432 4284831132 4287397561 4287792824 4287792570 4287989437 4287660472 4286080939 4283580051 4283185295 4283251090 4283251090 4283250835 4283316628 4283316883 4283316883 4283316881 4283382421 4283382676 4283316881 4283316881 4283382674 4283448469 4283448469 4283448214 4283514260 4283514260 4283448467 4283316879 4283316879 4283448465 4283448465 4283382672 4283448718 4283382925 4283251339 4283317132 4283514512 4283580053 4283645848 4283711386 4283843225 4283777432 4283777432 4283843225 4283843225 4283843225 4283909016 4284040602 4283909016 4283909016 4283909016 4283909270 4283909270 4283909270 4283843477 4283843477 4283777681 4283711888 4283777681 4283843476 4283909269 4283909269 4283975062 4284106649 4284040856 4284106649 4284369821 4284238232 4285028254 4287068086 4288121538 4288121789 4287595194 4287200436 4286673840 4286015911 4285160350 4284568215 4284633753 4285028513 4286936753 4286015398 4285028253 4284501658 4284501404 4284567199 4284632992 4284567197 4284567451 4284501658 4284567197 4284632990 4284632990 4284632990 4284698785 4284698785 4284830623 4284764830 4284764576 4284764830 4284633242 4284896925 4285818280 4286673587 4288055745 4288318915 4289042891 4289042889 4288911305 4287660476 4285423011 4285093541 4285093541 4285027748 4285028002 4284962209 4284962207 4284962207 4284896668 4284896668 4284896414 4284962207 4285028000 4285028000 4285093793 4285159586 4285225379 4285291172 4285356965 4285422758 4285422758 4285488805 4285423012 4285423011 4285357218 4285291425 4285291425 4285225632 4285225632 4285291425 4285291425 4285291425 4285423011 4285488804 4285488804 4285554597 4285686183 4285817770 4285817770 4285883563 4285883563 4285883309 4285883562 4286015148 4286015148 4286015148 4286015148 4286080939 4286080939 4286015146 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286475957 4286344626 4286410415 4286476208 4286410417 4286476210 4286476208 4286476462 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286805173 4286805173 4286739634 4286805427 4286805427 4286739634 4286805427 4286936759 4286936759 4286870966 4286805427 4286937013 4287068599 4287068599 4286937013 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287200182 4287134389 4287200184 4287331770 4287331770 4287134389 4287463606 4288187329 4289701320 4290359250 4290622421 4290622421 4290556628 4290622422 4290358998 4289503691 4288055491 4287660733 4287726526 4287792319 4287529147 4287529147 4287726526 4287726526 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287858366 4287858366 4287924157 4287989950 4287989950 4287989950 4287989950 4288055743 4287924156 4288121535 4288253122 4288121536 4288055743 4288384707 4288516547 4288253375 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450501 4288516293 4288319168 4288713926 4288582340 4289042887 4290622424 4291083226 4291017947 4291149787 4291149787 4291017949 4290753758 4289635024 4288713922 4288779715 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288845508 4288977094 4288977096 4288977096 4289042889 4289042887 4289108933 4289306312 4290359000 4289832656 4289240520 4289174473 4289240266 4289240266 4289437899 4289372106 4289109703 4289372875 4289372873 4289504459 4290162387 4291017950 4291215328 4290886363 4290358998 4290030033 4289701068 4289437898 4289437898 4289503692 4289569485 4289635024 4289635024 4289766864 4289635277 4289701068 4289766861 4289701070 4289832657 4289766610 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290096080 4290096080 4290096080 4289965010 4290162387 4290491606 4290952154 4291544545 4292005348 4292136933 4292136933 4292202726 4291873761 4292071141 4292136680 4291347166 4290557396 4290360020 4290293973 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290491606 4290623192 4290623192 4290623192 4290623191 4290688982 4291083994 4291807715 4291544543 4290952408 4290623189 4290754777 4290820570 4290820570 4290820568 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017949 4291083740 4291149785 4291807968 4292597736 4292663786 4292532454 4292664040 4292663529 4292268517 4291676383 4291215578 4291149787 4291347166 4291347166 4291281371 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291478750 4291544543 4291544543 4291544543 4291610336 4291676383 4291742176 4291807968 4292597482 4292926701 4293058287 4292926701 4292202724 4291742175 4291873762 4291741922 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292268519 4292334312 4292334312 4292268517 4292466150 4292926699 4293518835 4293387250 4293387250 4293124078 4292795115 4292466150 4292400357 4292466150 4292531689 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4293124588 4293519346 4293651186 4293585391 4293716977 4293848565 4293716979 4293519346 4293124590 4293124590 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124591 4293190383 4293190383 4293190383 4293190383 4293256176 4293387762 4293519346 4293585139 4293716979 4293848565 4293980149 4294045942 4293848565 4293585139 4293387760 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716725 4293651186 4293651186 4293716979 4293716979 4293782772 4293716979 4293716979 4293716977 4293848563 4293980149 4293980149 4293980149 4293914356 4293914356 4293848563 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294111735 4294111735 4294111735 4294111735 4294177527 4294177528 4294111735 4294111735 4294177528 4294243321 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506746 4294506746 4294572539 4294572539 4294506746 4294506746 4294506746 4294440953 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294835711 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281999753 4282789516 4285422506 4287002552 4286871217 4286607796 4283777430 4282066311 4281868165 4281868165 4281802372 4281868165 4281868165 4281802372 4281671556 4281737349 4281868418 4281736578 4281868935 4281934728 4282000772 4283909270 4286475697 4287199923 4287199925 4286080941 4283645846 4282066311 4281868935 4282065544 4282262922 4282131590 4282065543 4282131336 4282131336 4282131336 4282131336 4282131336 4282065543 4282065543 4282198402 4281606263 4281935228 4288121787 4294702591 4294967039 4294967293 4294966783 4294966527 4294966527 4281015642 4281015393 4281408882 4281802874 4282065797 4282394758 4282329737 4282329737 4282263944 4282198151 4282198151 4282263944 4282263690 4282263690 4282263174 4282460551 4282526598 4282922123 4284567200 4285948852 4285356713 4283711888 4283448719 4284501406 4285685678 4286409907 4286870455 4287265465 4287528890 4287660474 4287331258 4285093793 4282922125 4282526862 4282658448 4282658702 4282724495 4282592909 4282592909 4282592909 4282658702 4282658702 4282658702 4282658702 4282724495 4282790288 4283053709 4284435614 4284501407 4283119502 4282921874 4282592655 4282724493 4282856332 4282856079 4282856079 4282856077 4282921870 4282921870 4282921870 4282921872 4282921872 4283053458 4283053456 4283053711 4283119251 4283053460 4283119253 4282987663 4283580051 4285555110 4287595194 4287924410 4287989439 4287726015 4287660223 4286146481 4283580053 4283251090 4283251090 4283316628 4283316628 4283316628 4283316628 4283316883 4283316883 4283448216 4283382421 4283382421 4283448469 4283448469 4283514262 4283514007 4283448216 4283580053 4283514260 4283514260 4283514260 4283580053 4283711639 4283645846 4283580053 4283448469 4283580053 4283711637 4284238234 4285225129 4285619885 4285225127 4284632992 4284369820 4284106648 4283909269 4283909269 4283975063 4283974809 4283909016 4283909016 4283909016 4283909016 4283909016 4283974809 4283974809 4283974809 4283974809 4283974809 4283975063 4283975063 4284040856 4284106649 4284106395 4284106395 4284172188 4284237981 4284369051 4284303258 4284303774 4284238235 4284698785 4285949104 4286541493 4286344111 4285554344 4285028002 4284633244 4284501658 4284435611 4284369820 4284501406 4284764578 4285159839 4284699289 4284435611 4284567200 4284698532 4284632739 4284567200 4284698785 4284698783 4284632992 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284764576 4284830369 4284896164 4284830371 4285028002 4286213040 4287792068 4288713423 4288977614 4289042889 4288911554 4289043141 4288582340 4286870706 4285291426 4285159334 4285159334 4285159334 4285159334 4285159334 4285159588 4285159588 4285159588 4285159588 4285225127 4285225381 4285291174 4285291174 4285291174 4285356965 4285356965 4285422758 4285422760 4285488551 4285488551 4285554344 4285554344 4285554598 4285554598 4285554598 4285554598 4285488805 4285554598 4285620391 4285620391 4285620391 4285620391 4285751977 4285686184 4285751977 4285817770 4285883563 4285883563 4285883563 4285949102 4285949102 4285949355 4285949355 4285949355 4285949355 4285949355 4286015148 4286080941 4286080939 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286475957 4286344624 4286608047 4286542254 4286344622 4286410417 4286476210 4286608048 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286805173 4286805173 4286739634 4286805427 4286805427 4286805427 4286937013 4286871219 4286937012 4286937013 4287002806 4287002806 4287002806 4287002806 4287068598 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287265975 4287200184 4287134391 4287200184 4287331768 4287265975 4287266229 4287463608 4288845761 4289898447 4290556631 4290556628 4290425042 4290556629 4290424791 4289701070 4288647880 4287858364 4287595192 4287660987 4287660987 4287726526 4287858112 4287660733 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287858366 4287858366 4287924157 4287924157 4287989950 4288055743 4288055743 4288055743 4288055742 4288055743 4288121538 4288187077 4288121538 4288253122 4288253121 4288121789 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450501 4288516293 4288450754 4288450754 4288582340 4288911303 4289569482 4290227663 4290886361 4291083994 4291149787 4290425813 4289898449 4289437647 4288911301 4288714176 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911301 4288977096 4288911303 4288977096 4289042887 4289108680 4289043141 4289108934 4289306059 4289108680 4289174727 4289635277 4289701068 4289635275 4289832654 4289832654 4289965010 4290096594 4290096594 4290228434 4290754777 4291412705 4291610338 4291412959 4291477984 4291149019 4290688214 4290293457 4289964494 4289832654 4289701068 4289635277 4289701071 4289766864 4289635277 4289701070 4289701070 4289701070 4289832657 4289766864 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290095826 4290096080 4290096080 4290096080 4290162391 4290030803 4289965008 4290228434 4290754775 4291281371 4291873762 4292202726 4292136931 4292136931 4292136931 4292202726 4291807969 4291018201 4290360019 4290293973 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290491606 4290688985 4290623192 4290557399 4290623192 4290688984 4290820568 4291215326 4291018201 4290820568 4290754775 4290754777 4290754777 4290820570 4290886361 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952156 4291083740 4291083994 4291479004 4292400103 4292729579 4292532200 4292664040 4292729322 4292531689 4292005347 4291479004 4291215578 4291281373 4291281373 4291281373 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544543 4291478750 4291478752 4291544545 4291610336 4291807969 4292136933 4292334310 4292795115 4293058287 4293058287 4292729322 4292005345 4291742175 4291939301 4291741922 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292202724 4292268519 4292334312 4292334312 4292268517 4292400357 4292926699 4293453042 4293387249 4293518835 4293453043 4293124078 4292795115 4292531943 4292466150 4292466150 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4293124588 4293585139 4293848565 4293716979 4293716979 4293585393 4293321967 4293124590 4293058797 4293058797 4293058797 4293058797 4293058797 4293124590 4293124590 4293124590 4293124591 4293190383 4293256176 4293190383 4293190383 4293256176 4293321969 4293387760 4293321967 4293453553 4293651186 4293914356 4294045942 4293980151 4293716979 4293453553 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716725 4293716725 4293716725 4293716979 4293716979 4293716979 4293782772 4293782772 4293716977 4293848563 4294111735 4294243321 4294243321 4294111735 4293980149 4293914356 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294111735 4294111735 4294045942 4294045942 4294045942 4294111734 4294111735 4294111735 4294111735 4294177528 4294243321 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294440699 4294440699 4294440699 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294835711 4294835711 4294835709 4294835709 4294769916 4294835709 4294835709 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4281868418 4283909018 4286475700 4286871219 4287068599 4285949102 4282461319 4282131339 4281933445 4281868165 4281868165 4281933958 4281933958 4281933958 4281868165 4281933958 4282065797 4282065797 4281868164 4282000521 4281934727 4282593160 4285028000 4287199672 4287134132 4287199674 4285290922 4282856077 4281934727 4281999751 4282065543 4282065543 4282131337 4282131337 4282197130 4282197130 4282197130 4282131337 4282131337 4282131337 4281736595 4282460567 4281934227 4281606265 4282331249 4283318395 4284371838 4282266728 4280884808 4280424507 4280883805 4281080420 4281737849 4281869437 4282394509 4282131840 4282394758 4282460551 4282460553 4282460553 4282460553 4282460553 4282460553 4282460555 4282460553 4282723725 4282526344 4282197379 4282592907 4283579800 4283579800 4282724491 4282395276 4282724495 4283053456 4283316881 4283909269 4284896414 4286015148 4286673076 4286409907 4284435613 4282790284 4282526862 4282526862 4282527116 4282724495 4282592909 4282723725 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790539 4282987663 4282921872 4282592657 4282789783 4282921623 4282987667 4282987918 4283052688 4283052688 4283052688 4283118481 4283118481 4283118481 4283118481 4283118481 4282987667 4283053458 4283053456 4283053458 4283053460 4283185044 4283185295 4284238234 4287002554 4287792571 4288121278 4287594430 4286146735 4286278067 4285488301 4283382676 4283251090 4283316628 4283316628 4283316630 4283382421 4283382421 4283316883 4283316881 4283448216 4283448216 4283448214 4283448469 4283514262 4283514262 4283514007 4283514007 4283580055 4283514262 4283514262 4283645846 4283645846 4283580053 4283514260 4283514260 4283842722 4283777181 4283711637 4284567451 4286475697 4287923394 4287989439 4287594679 4287199422 4286673078 4286080941 4285686184 4285225381 4284698785 4284106395 4283777432 4283974811 4283974811 4283974811 4283974811 4284040604 4284040604 4284040604 4284040604 4284040602 4284040602 4284106395 4284172188 4284172188 4284172188 4284172188 4284237981 4284369051 4284303260 4284369053 4284172188 4284172188 4284435360 4284567200 4284304027 4284501155 4284303776 4284369567 4284566946 4284632739 4284501407 4284435614 4284435614 4284369818 4284501406 4284567200 4284567200 4284566946 4284566946 4284567200 4284567200 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284896416 4284764578 4284896165 4284961958 4284764830 4285357731 4287200184 4288845259 4288648647 4288846276 4288846531 4289306313 4288187329 4286015146 4285093793 4285093541 4285159588 4285225381 4285225127 4285225127 4285225127 4285225127 4285225127 4285290920 4285290920 4285290920 4285356967 4285356967 4285356967 4285356967 4285422760 4285422758 4285422758 4285488551 4285488551 4285488551 4285554344 4285554344 4285554598 4285554598 4285685930 4285620137 4285620137 4285685930 4285685930 4285685930 4285751723 4285817516 4285883563 4285817770 4285817770 4285817770 4285817770 4285817770 4285883563 4285949356 4286015149 4285949356 4285949355 4286080941 4286080941 4286015148 4286080941 4286212527 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286278833 4286608047 4287397813 4287134643 4286542255 4286476212 4286476210 4286542255 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286739380 4286739380 4286739634 4286805427 4286805427 4286937013 4287331771 4287397813 4287068850 4286937010 4287068598 4287002806 4286739634 4286871220 4287200184 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287134391 4287265977 4287265977 4287200182 4287331768 4287397561 4287397561 4287397561 4287660984 4288977096 4290095828 4290622424 4290490836 4290556629 4290753756 4290490586 4290095575 4289108680 4288253373 4287792824 4287595192 4287660987 4287726526 4287529147 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287989952 4287924159 4287924157 4287924157 4287989950 4287989950 4288055743 4288055743 4288253122 4288121536 4288055745 4288121538 4288121538 4288121536 4288253121 4288384707 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288450754 4288648133 4288384961 4288516293 4288648133 4288714176 4289832908 4290886361 4291083994 4291149533 4289833422 4288845508 4288911305 4288845510 4288713922 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977096 4288977094 4289042887 4289108680 4289108680 4289042887 4289240268 4289306059 4290095828 4291017182 4291214558 4291148765 4291280351 4291280352 4291281121 4291346914 4291412705 4291412705 4291544545 4291676131 4291676129 4291610336 4291807199 4291807199 4291741152 4291477984 4291017179 4290425045 4289898447 4289503689 4289635277 4289635277 4289635277 4289701070 4289766863 4289701070 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4290030033 4290030033 4290030033 4290030033 4290030033 4290096080 4290096080 4290096080 4290096596 4289965010 4290030803 4290096594 4290162641 4290491603 4291083994 4291676129 4292071140 4292202724 4292136931 4292136931 4292136933 4291478750 4290688984 4290360020 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290425813 4290623192 4290623192 4290491606 4290623192 4290688984 4290623191 4290688984 4290623191 4290754777 4290820570 4290754777 4290754777 4290820570 4290886361 4290820568 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4290952156 4291149533 4291083994 4291215578 4292071141 4292597997 4292466409 4292663786 4292795115 4292795115 4292531689 4291939554 4291413211 4291149785 4291215580 4291347166 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544797 4291478750 4291544545 4291544545 4291610338 4292005348 4292597482 4292926701 4292926699 4293058285 4292992494 4292663275 4292005347 4291742176 4291939301 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292202724 4292268519 4292334312 4292400105 4292268517 4292400357 4292860906 4293387249 4293519089 4293518835 4293518835 4293387250 4293124078 4292860908 4292597736 4292465896 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4293256176 4293650932 4293782518 4293585139 4293387760 4293124588 4292993004 4293058798 4293058797 4293058797 4293058797 4293124590 4293058797 4293124590 4293124590 4293124590 4293124591 4293190383 4293256176 4293190383 4293190383 4293256176 4293321969 4293321967 4293256176 4293387760 4293585393 4293848565 4294045942 4294045944 4293782772 4293585139 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716725 4293716725 4293716725 4293716725 4293716979 4293782772 4293782772 4293782772 4293782770 4293980149 4294177528 4294374907 4294374907 4294243321 4294045942 4293914356 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294111735 4294111735 4294045942 4294045942 4294045942 4294111734 4294111735 4294111735 4294111735 4294177528 4294243321 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294440699 4294374906 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294835711 4294835711 4294835711 4294769916 4294769916 4294769916 4294769916 4294835709 4294901502 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4282329219 4285159336 4286805175 4286805426 4286739382 4284632992 4282328969 4281999499 4281933447 4281933445 4281933958 4281933958 4281933958 4281933958 4281933958 4281933958 4281933957 4281934211 4281802371 4281933958 4282066060 4282000518 4283514258 4286343860 4287199925 4287462844 4286146481 4283580051 4282132358 4282131337 4282131337 4282197130 4282131337 4282131337 4282131337 4282197129 4282197129 4282197129 4282197129 4282131336 4282066314 4282066816 4282066565 4281803640 4281738352 4282462839 4283779451 4282002786 4280752219 4281213273 4280883043 4281474926 4281540470 4281869435 4281999753 4282460805 4282328969 4282328969 4282394762 4282460555 4282526348 4282460555 4282460555 4282526348 4282394762 4282394762 4282526348 4282592141 4282394762 4282460553 4282461323 4282527116 4282526864 4282526864 4282526862 4282592909 4282658698 4282856332 4283119502 4283316881 4283974809 4283250835 4282461069 4282526864 4282724495 4282658700 4282724495 4282658448 4282723725 4282789518 4282855311 4282789518 4282789516 4282855309 4282921102 4282855309 4282856081 4282790286 4282592909 4282855827 4282855829 4282987413 4282790286 4282724491 4283052688 4283052688 4283052688 4283118481 4283118481 4283118481 4283118481 4283118481 4282921874 4282987665 4283053458 4282987665 4283053458 4283251090 4283777684 4285817516 4287791809 4287989437 4287857851 4286475699 4284172442 4284238235 4284040088 4283184527 4283250835 4283250835 4283316628 4283316628 4283316628 4283382676 4283382674 4283382674 4283448216 4283448214 4283448469 4283448469 4283514260 4283514260 4283514262 4283514262 4283580055 4283514262 4283580055 4283711639 4283711639 4283645844 4283843223 4284106649 4283974811 4284304028 4284567449 4285423009 4287068339 4288252864 4288384446 4288253114 4288186816 4288252611 4288384199 4288186567 4287265215 4285817264 4284566946 4283909018 4283974811 4283974811 4283974811 4283974811 4284040604 4284040602 4284040602 4284040602 4284040602 4284040602 4284106395 4284172188 4284172188 4284106395 4284172188 4284237981 4284171674 4284303260 4284434592 4284500385 4284303774 4284303774 4284369821 4284304028 4284500639 4284566432 4284632225 4284698018 4284566430 4284500637 4284632223 4284763809 4284566946 4284632993 4284567200 4284501406 4284501406 4284632992 4284632993 4284501407 4284698785 4284632992 4284632992 4284698785 4284764578 4284698785 4284698785 4284764578 4284962209 4284632990 4284896165 4285159337 4284962209 4285423522 4287200436 4288845510 4288912330 4288912069 4288780483 4288779719 4287331771 4285488551 4285093541 4285027748 4285093793 4285159586 4285159588 4285159588 4285159588 4285225381 4285225381 4285290920 4285291174 4285291174 4285356967 4285356967 4285356967 4285356967 4285356967 4285422760 4285422758 4285422758 4285422758 4285488551 4285488551 4285488551 4285554598 4285554598 4285620391 4285620391 4285620391 4285686184 4285686184 4285620391 4285686184 4285817770 4285751977 4285751977 4285817770 4285883563 4285883563 4285817770 4285817770 4285817769 4285883563 4285883563 4285949356 4286015148 4286080941 4286015148 4285949355 4286015148 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4286542001 4287595194 4288779717 4287924410 4286673841 4286541750 4286410419 4286410669 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286739380 4286673587 4286739634 4286805427 4286739634 4287002806 4287594943 4289108682 4288253375 4287332020 4286871217 4286937012 4287068599 4287068599 4287002806 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287068598 4287265977 4287331768 4287265975 4287265975 4287331768 4287331768 4287331770 4287463354 4288318915 4289503438 4290556377 4290622422 4290359250 4290490838 4290556377 4290622424 4290424791 4289964242 4289108680 4288187582 4287660985 4287660987 4287858112 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4287858364 4288055743 4288187329 4288253121 4288187328 4288187328 4288253121 4288318914 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288384707 4288450754 4288582340 4288450500 4288582087 4288516293 4288582338 4290030035 4290886361 4291083740 4291017949 4289570252 4288582338 4288713926 4288713926 4288779715 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977094 4288977094 4289042887 4289042887 4289108680 4289108682 4289108682 4289240520 4290359252 4291477984 4291675359 4291675359 4291741154 4291675361 4291347166 4291412959 4291478750 4291478750 4291544543 4291544543 4291544543 4291544543 4291609820 4291675613 4291741154 4291477984 4291017180 4290424791 4289898449 4289569485 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4290030033 4290095826 4290030033 4290030033 4290096080 4290096080 4290030287 4289965008 4289965008 4290096596 4290162389 4290030801 4290031055 4290557398 4291149533 4292136934 4292202726 4292202724 4292136931 4292202726 4292005094 4291281119 4290623192 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290491606 4290557399 4290557399 4290557399 4290623192 4290623192 4290623192 4290557399 4290623191 4290688984 4290754777 4290754775 4290820568 4290820568 4290820570 4290820570 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291083740 4291083740 4291083994 4291741922 4292071398 4291939812 4292203239 4292597736 4292663529 4292729068 4292465896 4291939555 4291412957 4291281373 4291346912 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291479004 4291478750 4291610338 4291610084 4291610338 4292005348 4292663275 4293058285 4292992491 4293058285 4292992494 4292860654 4292334312 4291873762 4291807715 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292202724 4292268519 4292334312 4292334312 4292268517 4292400357 4292860906 4293387249 4293453296 4293453296 4293453042 4293453042 4293255664 4292860908 4292597736 4292531943 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4293387762 4293519348 4293387762 4293190381 4293058797 4292927212 4292926958 4293124337 4292993004 4293058797 4293058797 4293124590 4293058797 4293124590 4293124590 4293124590 4293124591 4293190383 4293256176 4293190383 4293190383 4293256176 4293321969 4293256174 4293321969 4293321969 4293453553 4293716979 4293980151 4294045944 4293914358 4293716725 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716725 4293716725 4293716725 4293716725 4293782772 4293782772 4293782772 4293782772 4293848563 4294045942 4294243321 4294374907 4294309114 4294177528 4293980149 4293914356 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4294045944 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294177528 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294440699 4294440699 4294374906 4294374906 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294835711 4294835711 4294769918 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4284040602 4286212276 4286870966 4287134391 4286147247 4282856328 4282131336 4281867915 4281867654 4281933445 4281933445 4281868165 4281933957 4281933957 4281933957 4281933957 4281868165 4281868164 4282065543 4281868167 4281934478 4281868681 4282461321 4284896165 4286805167 4286673328 4285751976 4283514512 4281934977 4282065544 4282065546 4282131339 4282065544 4282065544 4282131336 4282131336 4282131336 4282131590 4282131590 4282131590 4282262671 4281934977 4282000520 4282000518 4281868932 4281671807 4282660218 4281607528 4281343089 4281146466 4281343343 4281474928 4281803644 4282197630 4282262925 4282329219 4282526094 4282394508 4282328715 4282394508 4282460301 4282460301 4282394508 4282460301 4282657168 4282394509 4282460302 4282591887 4282526094 4282526348 4282592139 4282460551 4282461323 4282395530 4282395276 4282526862 4282592655 4282592657 4282592657 4282592657 4282724493 4282855827 4282526864 4282526864 4282724495 4282658700 4282658700 4282724495 4282723723 4282855309 4282855309 4282789516 4282855309 4282921356 4282987149 4282921356 4282789266 4283052690 4282855563 4283118734 4282855562 4283118735 4282986895 4283052688 4282987149 4282987149 4283052688 4283052688 4283118481 4283118481 4283118735 4283118735 4282987413 4283053458 4283053458 4283053458 4283053458 4283316881 4284369818 4287265215 4287791808 4287923644 4287199923 4285291172 4283251090 4283316883 4283184525 4283645078 4283251090 4283250835 4283250835 4283250835 4283316628 4283316883 4283382674 4283382672 4283448214 4283448214 4283448469 4283448467 4283448467 4283448467 4283448467 4283448469 4283580055 4283580055 4283711639 4283974811 4283974809 4284106649 4284698786 4285356715 4286344363 4287068086 4287594683 4287857853 4288252609 4288384195 4288318402 4288449988 4288319164 4288253373 4288055742 4287134643 4285752485 4284370585 4283843736 4283843484 4283909020 4283974813 4283974811 4283974811 4283974809 4283974809 4284040602 4284040602 4284237467 4284237467 4284237467 4284303260 4284303258 4284303258 4284369051 4284434844 4284368799 4284434592 4284303006 4284369053 4284369821 4284369820 4284369818 4284304025 4284500636 4284500636 4284500636 4284566429 4284632222 4284566429 4284566429 4284500636 4284501157 4284501153 4284501406 4284632990 4284699037 4284698783 4284632992 4284632993 4284764578 4284698785 4284698785 4284764578 4284830371 4284764578 4284764578 4284764576 4284764830 4284896162 4284961958 4284896165 4285422760 4287068345 4288582086 4288911301 4288714953 4288715205 4288912071 4288451271 4286673589 4285159334 4285159334 4285225381 4285094047 4285159586 4285159586 4285159586 4285159588 4285225381 4285225381 4285291174 4285356965 4285356965 4285422758 4285422758 4285356965 4285356965 4285422760 4285422760 4285488805 4285488805 4285488805 4285488805 4285554598 4285554598 4285620391 4285620391 4285620391 4285620391 4285620391 4285686184 4285686184 4285620391 4285686184 4285817770 4285686184 4285751977 4285949356 4286146735 4286212527 4286080941 4285883562 4285883562 4285949356 4285949356 4285949356 4285949356 4286015148 4286080941 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286212527 4286212527 4286212527 4286212527 4286278320 4286344111 4286344111 4286344111 4286344111 4286409904 4286409904 4287265978 4288713672 4289832657 4288319166 4286542254 4286410164 4286476212 4286542001 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286805173 4286739380 4286739634 4286805427 4286673841 4287002806 4287726529 4289437899 4289700819 4289240016 4287989952 4287134391 4287068599 4287134392 4287002806 4287002805 4287068598 4287134391 4287134391 4287134391 4287134391 4287200184 4287200184 4287200184 4287331770 4287265975 4287200182 4287265975 4287265975 4287265977 4287397563 4287331771 4287463608 4288450752 4289832654 4290293457 4289898698 4290096078 4290359250 4290491089 4290688214 4290622424 4290227414 4289635026 4288845258 4288121538 4287660733 4287726780 4287726780 4287792573 4287792573 4287792573 4287858366 4287858364 4287858364 4287858366 4287858366 4287924157 4287989950 4287989950 4287989950 4288055743 4288055743 4288121538 4288187329 4288055742 4287990203 4288055994 4288253375 4288253121 4288187329 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288516547 4288450754 4288384961 4288384707 4288647882 4288450503 4288713926 4290161622 4290952156 4291017949 4290886364 4289636047 4288845512 4288845258 4288648133 4288845508 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288911303 4288845510 4288911301 4289042887 4289042887 4289042887 4289108682 4289174475 4289174475 4289174727 4290227664 4291346396 4291544026 4291544026 4291609820 4291477980 4291479004 4291544797 4291544797 4291479004 4291479004 4291544543 4291610336 4291610336 4291675613 4291477980 4291017433 4290490835 4289964494 4289701070 4289700817 4289766610 4289635275 4289635275 4289766863 4289701070 4289701070 4289766863 4289766861 4289832654 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289832654 4289964240 4290030033 4290030033 4290030033 4290096080 4290161873 4290096080 4290162640 4290031055 4290030801 4290096596 4290096596 4290162389 4290688985 4291281122 4291939301 4292005348 4292136931 4292136931 4292136933 4292268520 4291807463 4290952156 4290490836 4290490836 4290490836 4290556629 4290556629 4290622422 4290622422 4290622422 4290623192 4290557399 4290557399 4290623191 4290623192 4290623192 4290688731 4290688731 4290754778 4290688984 4290688984 4290754775 4290886361 4290820568 4290754777 4290820570 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4290952154 4291017947 4291083740 4291412959 4291479265 4291216091 4291479261 4292466150 4292597736 4292729322 4292794861 4292465898 4291873508 4291412959 4291215326 4291347166 4291347166 4291347166 4291412959 4291412959 4291478752 4291478752 4291478752 4291544797 4291478750 4291610338 4291610084 4291478752 4291873762 4292531689 4292926699 4293058284 4293058285 4292926701 4293058033 4292663278 4291939555 4291741922 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292268519 4292334312 4292334312 4292334310 4292466150 4292926699 4293453042 4293387501 4293387503 4293453296 4293453042 4293124078 4292663529 4292531943 4292663529 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4293387763 4293256177 4292993004 4292993004 4293124590 4293058798 4292992751 4293058546 4292993004 4293058797 4293058797 4293124590 4293058797 4293058797 4293124590 4293190383 4293124591 4293190383 4293256176 4293190383 4293190383 4293321969 4293321969 4293256174 4293321969 4293321969 4293387760 4293585393 4293914358 4294045944 4293980151 4293848311 4293453553 4293453553 4293453553 4293453553 4293519346 4293519346 4293519346 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293650932 4293650932 4293716725 4293716725 4293716725 4293782772 4293716979 4293716979 4293980149 4294045942 4294243321 4294309114 4294243321 4294111735 4293980149 4293848563 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294177527 4294177528 4294177528 4294177528 4294177528 4294177528 4294177528 4294177528 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294440699 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294638078 4294638078 4294638332 4294638332 4294638332 4294704125 4294704125 4294704125 4294769918 4294835711 4294835711 4294901503 4294901503 4294835711 4294769918 4294769918 4294769916 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286081452 4287068086 4286936499 4286936502 4285093541 4282263940 4281803142 4281933706 4281868165 4281868165 4281868165 4281868165 4281933958 4281933958 4281933958 4281933958 4281999750 4281802372 4281933958 4281999751 4281999751 4281933958 4282197129 4282986899 4285159334 4284501407 4283316883 4282065795 4282065543 4282065544 4282065544 4282197130 4282131337 4282131337 4282131336 4282131336 4282131336 4282197129 4282197129 4282197129 4282066313 4282066313 4282000520 4281934725 4281869186 4281737596 4281606265 4281606263 4281474928 4281474929 4281606261 4281737849 4281935230 4282197633 4282263172 4282328965 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282526348 4282592141 4282592141 4282657934 4282657934 4282657934 4282657934 4282657934 4282723725 4282723725 4282723725 4282723725 4282789518 4282789518 4282789518 4282789518 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921872 4282921872 4282921872 4282921872 4282987665 4282987665 4282987665 4282987665 4283052688 4283053456 4282987665 4283119251 4283185042 4283646097 4286146732 4287792573 4287858364 4287857601 4286080688 4283843223 4283382421 4283250837 4283316628 4283381904 4283250835 4283250835 4283316628 4283316628 4283316628 4283316628 4283382421 4283382421 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283514007 4283580053 4284304028 4285554344 4286541490 4287331770 4287463608 4287792571 4288121535 4288253121 4288187328 4288253121 4288253121 4288187328 4288384707 4288318914 4288253375 4288121025 4287002295 4285291174 4284172442 4283974809 4283975063 4283974292 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284567199 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284632992 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284764828 4284962209 4284830369 4285291683 4286871219 4288450754 4288977094 4288911555 4288911301 4288187329 4288319166 4288055485 4285751723 4285225127 4285159586 4285027750 4285159588 4285159588 4285093795 4285159588 4285291174 4285225381 4285225379 4285291172 4285685930 4285751723 4285554344 4285685930 4285422758 4285422758 4285422758 4285422758 4285422758 4285422758 4285488551 4285488551 4285488551 4285554344 4285554344 4285620137 4285620137 4285620137 4285685930 4285686184 4285686184 4285686184 4285751977 4285751977 4285817767 4285685930 4286015149 4286673579 4288187071 4286212777 4285949356 4285817770 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286278318 4286212525 4286409906 4286409906 4286278318 4286410158 4286541742 4286804913 4288648897 4289635792 4289832657 4288713926 4286739631 4286542001 4286476210 4286410415 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286673587 4286739380 4286739380 4286739634 4286805427 4286805427 4286937013 4287200185 4289043140 4290227414 4290030035 4289701070 4288845510 4287858364 4287200185 4287068349 4287068598 4287068598 4287068598 4287134391 4287134391 4287134391 4287200184 4287200184 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397813 4287463606 4287595191 4288647879 4289174477 4288319168 4288384959 4289569233 4290227666 4290622422 4290556628 4290688214 4290556629 4290095826 4289503438 4288516547 4287792571 4287726778 4287792573 4287792573 4287726780 4287858366 4287924157 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450500 4288450754 4288450754 4288516293 4288450501 4288516293 4288713922 4290161619 4291017947 4291017947 4290886363 4289504461 4288648133 4288779465 4288713926 4288713922 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108934 4289174726 4289898701 4290819801 4290951386 4290754008 4290688215 4290688217 4290623192 4290425813 4290425813 4290425813 4290557398 4291149533 4291544545 4291347164 4291017182 4290490584 4289898447 4289635277 4289569485 4289635278 4289635277 4289569484 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290227412 4290161619 4290095826 4290227666 4290293459 4290161873 4290425045 4291017182 4291149787 4291478752 4291610336 4291807715 4292005348 4292071141 4292005347 4291544796 4290885594 4290556629 4290425043 4290556629 4290556629 4290622422 4290688215 4290688215 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291083740 4291083740 4291017947 4291149533 4291149533 4291149787 4291281373 4291610336 4292400106 4292794861 4292663527 4292663527 4292531689 4291939555 4291412957 4291347166 4291347166 4291412959 4291412959 4291412959 4291412959 4291478752 4291478752 4291479004 4291478750 4291544545 4291544545 4291676129 4291807968 4292663529 4292992492 4292992492 4292992492 4292926701 4292663275 4292202726 4291742176 4291676129 4291807715 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292268519 4292334312 4292268519 4292268519 4292465896 4292926701 4293321457 4293124590 4293453555 4293387762 4293321969 4292993004 4292532454 4292466407 4292532202 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124590 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293321969 4293256176 4293321969 4293387762 4293453553 4293716725 4293980151 4294045944 4293914356 4293716979 4293519600 4293453553 4293519346 4293519346 4293519346 4293519346 4293453553 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4293980148 4294177528 4294309114 4294309114 4294177528 4293980149 4293848563 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294572285 4294572285 4294638332 4294638332 4294638332 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294769918 4294769918 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 4286936761 4287002293 4287265464 4286607537 4284567197 4282724491 4282000521 4281736327 4281868165 4281868165 4281868165 4281868165 4281933958 4281933958 4281933958 4281933958 4281868164 4281933958 4282065544 4281933958 4281999751 4281999751 4281999750 4282263176 4282724495 4282000518 4281934728 4281999753 4282065546 4282065544 4282197129 4282065797 4282131337 4282131337 4282131336 4282131336 4282131336 4282197129 4282197129 4282197129 4282066313 4282066313 4282066313 4282000518 4282000772 4281934975 4281869437 4281803642 4281737851 4281737851 4281803389 4281934977 4282066565 4282263176 4282328715 4282328716 4282394762 4282394762 4282394762 4282394762 4282460555 4282460555 4282460555 4282460555 4282460555 4282460555 4282526348 4282526348 4282526348 4282526348 4282592141 4282592141 4282526348 4282592141 4282592141 4282657934 4282657934 4282657934 4282657934 4282657934 4282723725 4282723725 4282723725 4282723725 4282789518 4282789518 4282789518 4282789518 4282789518 4282789518 4282855311 4282855311 4282855311 4282855311 4282921104 4282921104 4282790288 4282790288 4282790288 4282856081 4282856081 4282856081 4282856081 4282856081 4282921872 4282921872 4282921872 4282921872 4282987665 4282987665 4282987665 4282987665 4283118481 4283053456 4283053458 4283119251 4283382421 4284764578 4287396799 4287858366 4287792571 4287133878 4284962207 4283185293 4283250835 4283185044 4283250835 4283381904 4283250835 4283250835 4283316628 4283316628 4283316628 4283316628 4283382421 4283382421 4283382676 4283382676 4283448469 4283448469 4283448469 4283448469 4283514262 4283514262 4283579802 4283711637 4285554598 4287660476 4288055485 4288187582 4288187329 4288187331 4288055742 4288187328 4288121535 4288187328 4288121535 4288055742 4288187328 4288121535 4287858366 4286475949 4284830621 4284040856 4283843227 4283842972 4283909020 4284105629 4283909018 4283909018 4283974811 4283974809 4283974809 4284040602 4284040602 4284040602 4284040602 4284106395 4284106395 4284106395 4284172188 4284172442 4284172442 4284238235 4284172442 4284238235 4284238235 4284238235 4284304028 4284304028 4284304028 4284369821 4284369821 4284369821 4284435614 4284435614 4284435614 4284435614 4284501407 4284501407 4284567199 4284567199 4284567199 4284567199 4284567199 4284632992 4284632992 4284632992 4284698785 4284698785 4284698785 4284764578 4284764578 4284764578 4284764578 4284830371 4284830372 4284896164 4285356965 4286739634 4288318914 4288977096 4288911303 4288976844 4287660736 4286344626 4286344875 4286739121 4285225127 4284961955 4285094047 4285159334 4285093795 4285225381 4285225381 4285159588 4285225381 4285159588 4285291172 4285620137 4287199923 4288186820 4287462843 4286344365 4285817769 4285817770 4285554344 4285554346 4285554344 4285554344 4285554344 4285554344 4285554344 4285554344 4285554344 4285620137 4285620137 4285620137 4285685930 4285686184 4285686184 4285686184 4285751977 4285751977 4285686181 4285751723 4286015149 4287923646 4289042380 4287133879 4285949356 4285949356 4285949356 4285949356 4285949356 4286015148 4286015148 4286015148 4286080941 4286080941 4286080941 4286080941 4286146734 4286146734 4286146734 4286146734 4286212527 4286278320 4286212525 4286344111 4286278320 4286212527 4286409904 4286344365 4286804914 4288252359 4289438413 4289833171 4289766864 4288779719 4286871217 4286476208 4286410417 4286607794 4286607283 4286607537 4286607537 4286673330 4286673330 4286739123 4286739123 4286739121 4286607794 4286739380 4286739380 4286805427 4286805427 4286739634 4286805427 4287002806 4288713922 4290095829 4290161619 4290161873 4290030033 4289503691 4288516545 4287661238 4287068598 4287068598 4287068598 4287134391 4287134391 4287134391 4287200184 4287200184 4287200184 4287200184 4287265977 4287265977 4287265977 4287331770 4287331770 4287331770 4287397563 4287331770 4287397563 4287858112 4287858366 4287595194 4287726778 4287858364 4288779717 4289898450 4290358998 4290556629 4290688214 4290754008 4290556631 4289635275 4288318915 4287792571 4287660987 4287858366 4287858366 4287792573 4287792571 4287858364 4287924159 4287924159 4287989950 4287989950 4287989950 4287989950 4288055743 4288055743 4288055742 4288121535 4288121535 4288121535 4288187328 4288187328 4288187328 4288253121 4288253121 4288253121 4288318914 4288318914 4288318914 4288384707 4288384707 4288384707 4288450500 4288450754 4288450754 4288516293 4288516294 4288647879 4288779715 4290293205 4291017947 4291017947 4290886363 4289504461 4288648133 4288779465 4288713926 4288713922 4288779719 4288779719 4288779717 4288845510 4288845510 4288911303 4288911303 4288911303 4288977096 4288977096 4288977096 4289042887 4289042887 4289042887 4289108680 4289108680 4289108430 4289108682 4289437645 4289635277 4289503689 4289503691 4289503692 4289372106 4289241289 4289306827 4289306827 4289241289 4289636047 4290622938 4290886364 4290294226 4289898701 4289701068 4289569482 4289569484 4289569485 4289569485 4289569484 4289635277 4289635277 4289635277 4289701070 4289701070 4289701070 4289766863 4289766863 4289766863 4289832656 4289832656 4289832656 4289898447 4289898447 4289898447 4289964240 4289964240 4289964240 4289964240 4290030033 4290030033 4290030033 4290095826 4290095826 4290095826 4290095826 4290227412 4290227412 4290161873 4290227666 4290293459 4290227666 4290293459 4290294227 4290425813 4290425813 4290754777 4290952154 4291083740 4291478752 4291610338 4290951387 4290622422 4290490836 4290556629 4290556629 4290556629 4290622422 4290622422 4290622422 4290688215 4290688215 4290688215 4290754008 4290754008 4290754008 4290819801 4290688984 4290688984 4290754777 4290754777 4290754777 4290820570 4290820570 4290820570 4290820570 4290886363 4290886363 4290886361 4290952154 4290952154 4290952154 4291017947 4291017947 4291083740 4291083740 4291017947 4291149533 4291149533 4291149787 4291281373 4291347164 4291610590 4292400103 4292860906 4292729320 4292663275 4292531692 4291939301 4291347166 4291347166 4291412959 4291412959 4291412959 4291412959 4291478752 4291478752 4291479004 4291478750 4291544545 4291478752 4291610336 4291676382 4292531943 4292860906 4292992492 4292992492 4292663529 4292071138 4291742175 4291742176 4291807715 4291741922 4291807969 4291807969 4291807969 4291873762 4291873762 4291939555 4291939555 4291939555 4292005348 4292005348 4292005348 4292005348 4292005348 4292071141 4292071141 4292071141 4292071140 4292136933 4292136933 4292136933 4292202726 4292202726 4292202726 4292268519 4292268517 4292268519 4292334312 4292334312 4292334312 4292400103 4292597736 4292795113 4292861418 4293256176 4293387762 4293453555 4293190383 4292664040 4292466407 4292466409 4292531689 4292531689 4292597482 4292597482 4292597482 4292663275 4292663275 4292663275 4292663529 4292663529 4292729322 4292729322 4292729322 4292795115 4292795115 4292795115 4292795115 4292860908 4292860908 4292860908 4292926699 4292926699 4292926699 4292992492 4292992492 4292992492 4293058285 4293058285 4293058285 4293058285 4293058285 4293058285 4293058797 4293058797 4293124590 4293124590 4293124590 4293124590 4293124590 4293190383 4293124590 4293190383 4293190383 4293190383 4293256176 4293256176 4293256176 4293321969 4293256176 4293321969 4293321969 4293321967 4293585139 4293914358 4294045944 4293980149 4293914358 4293651186 4293519346 4293519346 4293453553 4293519346 4293585139 4293519346 4293585139 4293585139 4293585139 4293585139 4293650932 4293650932 4293650932 4293650932 4293716979 4293716979 4293716979 4293716979 4293716979 4293782772 4293782772 4293782772 4294177527 4294243321 4294309114 4294243321 4294045942 4293914356 4293848563 4293848565 4293848565 4293980151 4293980151 4293914356 4293914356 4293980149 4294045942 4293980149 4293980151 4294045942 4294045942 4294045942 4294045942 4294045942 4294111735 4294111734 4294111735 4294111735 4294177528 4294177528 4294177528 4294177528 4294243321 4294243321 4294243320 4294243320 4294243320 4294243320 4294309113 4294309113 4294309113 4294309113 4294309113 4294309113 4294374906 4294374906 4294374906 4294374906 4294440699 4294440699 4294374906 4294440699 4294440699 4294440699 4294506492 4294506492 4294506492 4294506492 4294506492 4294506492 4294572285 4294572285 4294572285 4294572285 4294638078 4294638078 4294572285 4294572285 4294638332 4294638332 4294638332 4294704125 4294769918 4294769918 4294835711 4294835711 4294835711 4294769918 4294769918 4294769918 4294769918 4294769918 4294769916 4294769916 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294967295 4294967295 4294967295 )
		offset: 0 @ 0! !

!SSFrame class methodsFor: 'class initialization' stamp: 'al 4/30/2004 12:13'!
initialize
	super initialize.
	Logo _ self compressJpeg: self formLogo.! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 1/18/2006 07:17'!
actions
	| controller |
	controller _ self component activeController.
	^Array streamContents: [ :stream |
		self isHome ifTrue: [ 
			stream nextPutAll: #( 
				'RSS feed' '/feed.rss'
				'Register Member' #registerMember
				'Register Group' #registerGroup
				'Register Project' #registerProject ).
			self session isSuperUser ifTrue: [
				stream nextPutAll: #('Edit Settings' #editSettings)]].
		(controller respondsTo: #actions)
			ifTrue: [ stream nextPutAll: controller actions ] ]! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 20:21'!
back
	| parent |
	parent _ component.
	[ parent delegate delegate isNil ]
		whileFalse: [ parent _ parent delegate ].
	parent clearDelegate.! !

!SSFrame methodsFor: 'private' stamp: 'lr 3/15/2004 18:29'!
call: aComponent
	self component 
		clearDelegate;
		call: aComponent! !

!SSFrame methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:41'!
component
	^component activeController! !

!SSFrame methodsFor: 'actions' stamp: 'al 3/31/2004 11:36'!
editMember
	| metaobject |
	metaobject _ self session user metaobjectEdit.
	(self call: (SSEditorVisitor metaobject: metaobject heading: 'Edit Member'))
		ifNotNil: [ self session save ]! !

!SSFrame methodsFor: 'configuration' stamp: 'bf 5/24/2005 15:20'!
groupsClass
	^SSGroups! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:31'!
helpClass
	^SSHelp! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 1/26/2004 17:07'!
homeClass
	^SSHome! !

!SSFrame methodsFor: 'configuration' stamp: 'bf 5/24/2005 15:44'!
homeClasses
	^Array 
		with: self homeClass
		with: self projectsClass
		with: self membersClass
		with: self groupsClass
		with: self helpClass
		with: self loginClass
		! !

!SSFrame methodsFor: 'initialization' stamp: 'lr 3/12/2004 22:58'!
initialize
	super initialize.
	component _ self homeClass 
		model: self model.! !

!SSFrame methodsFor: 'testing' stamp: 'lr 3/15/2004 18:34'!
isHome
	^self homeClasses includes: self component class ! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
login
	self call: (self loginClass model: self model).
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:09'!
loginClass
	^SSLogin! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
logout
	self session logout.
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
membersClass
	^SSMembers! !

!SSFrame methodsFor: 'accessing' stamp: 'lr 3/12/2004 22:57'!
model
	^SSRepository current! !

!SSFrame methodsFor: 'private' stamp: 'lr 3/15/2004 18:30'!
performAction: aSymbol
	self component 
		perform: aSymbol.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
projectsClass
	^SSProjects! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 7/9/2005 10:31'!
renderActionsOn: html
	self renderMenu: 'Actions' do: [
		self actions pairsDo: [ :description :selector |
			self renderMenuItem: [
				selector isSymbol 
					ifTrue: [ html anchorWithAction: [ self performAction: selector ] text: description ]
					ifFalse: [ html anchorWithUrl: selector do: description ] ] on: html ].
		self isHome ifFalse: [
			self renderMenuItem: [
				html anchorWithAction: [ self back ] text: 'Back' ] on: html ] ] on: html! !

!SSFrame methodsFor: 'rendering' stamp: 'al 3/31/2004 11:37'!
renderAuthenticationOn: html
	self session isValidUser 
		ifTrue: [
			self renderMenu: self session user do: [
				self
					renderMenuItem: [ html anchorWithAction: [ self logout ] text: 'Logout' ]
					on: html.
				self 
					renderMenuItem: [ html anchorWithAction: [ self editMember ] text: 'Edit Account' ] 
					on: html.
				html break.
				self session user projects asSortedCollection do: [ :each |
					self 
						renderMenuItem: [ html anchorWithAction: [ self showProject: each ] text: each title ] 
						on: html ] ] on: html ]
		ifFalse: [
			self renderMenu: 'Authentication' do: [
				self 
					renderMenuItem: [ html anchorWithAction: [ self login ] text: 'Login' ] 
					on: html ] on: html ]! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 23:00'!
renderContentsOn: html
	html render: component.! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 3/19/2004 19:01'!
renderHeadElementsOn: html
	super renderHeadElementsOn: html.
	html title: self model title.
	! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 1/28/2004 22:55'!
renderHeadingOn: html
	html title: self model title.
	html text: self model title.! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 3/15/2004 18:47'!
renderNavigationOn: html
	self renderActionsOn: html.
	self renderAuthenticationOn: html.! !

!SSFrame methodsFor: 'rendering' stamp: 'bf 5/24/2005 15:18'!
renderToolbarOn: html
	html anchorWithAction: [ self showHome ] text: 'Home'.
	html anchorWithAction: [ self showProjects ] text: 'Projects'.
	html anchorWithAction: [ self showMembers ] text: 'Members'.
	html anchorWithAction: [ self showGroups ] text: 'Groups'.
	html anchorWithAction: [ self showHelp ] text: 'Help'.! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 1/10/2006 10:09'!
renderTopOn: html
	html text: 'Version 1.3'.
	html space.! !

!SSFrame methodsFor: 'initialization' stamp: 'bf 12/15/2004 16:26'!
setComponent: aComponent
	component _ aComponent! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 15:19'!
showGroups
	self call: (self groupsClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHelp
	self call: (self helpClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHome
	self call: (self homeClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showMembers
	self call: (self membersClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 18:12'!
showProject: aProject
	self call: aProject view! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showProjects
	self call: (self projectsClass model: self model)! !

!SSFrame methodsFor: 'sylesheet' stamp: 'bf 12/15/2005 17:11'!
styleColor
	^ SSRepository current styleColor! !

!SSGenericFrame class methodsFor: 'private' stamp: 'lr 3/15/2004 15:52'!
compressJpeg: aForm
	| stream |
	stream _ RWBinaryOrTextStream on: String new.
	(JPEGReadWriter2 on: stream)
		nextPutImage: aForm
		quality: 95
		progressiveJPEG: false.
	^MIMEDocument
		contentType: 'image/jpeg'
		content: stream contents! !

!SSGenericFrame class methodsFor: 'private' stamp: 'lr 3/15/2004 15:28'!
formBack
	"Transcript show: (GIFReadWriter formFromFileNamed: 'bg.gif') storeString"

	^(ColorForm
		extent: 780 @ 2
		depth: 1
		fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294966783 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293918720 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293918720)
		offset: 0 @ 0)
		colorsFromArray: #((0.0 0.0 0.0) (1.0 1.0 1.0));
		yourself! !

!SSGenericFrame class methodsFor: 'private' stamp: 'lr 3/15/2004 15:22'!
formLogo
	^self subclassResponsiblity! !

!SSGenericFrame class methodsFor: 'class initialization' stamp: 'lr 3/18/2004 22:39'!
initialize
	Back _ self compressJpeg: self formBack.! !

!SSGenericFrame class methodsFor: 'accessing' stamp: 'bf 5/20/2005 12:52'!
makeBack: aFileName
	"SSFrame makeBack: 'back.gif'"
	| stream |
	stream := FileStream readOnlyFileNamed: aFileName.
	Back _ MIMEDocument
		contentType: stream mimeType
		content: stream contentsOfEntireFile
! !

!SSGenericFrame class methodsFor: 'accessing' stamp: 'bf 5/20/2005 12:52'!
makeLogo: aFileName
	"SSFrame makeLogo: 'logo.gif'"
	| stream |
	stream := FileStream readOnlyFileNamed: aFileName.
	Logo _ MIMEDocument
		contentType: stream mimeType
		content: stream contentsOfEntireFile
! !

!SSGenericFrame class methodsFor: 'accessing' stamp: 'lr 3/15/2004 15:21'!
mimeBack
	^Back! !

!SSGenericFrame class methodsFor: 'accessing' stamp: 'lr 3/15/2004 15:22'!
mimeLogo
	^Logo! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 1/17/2006 22:40'!
encodeUrl: aString
	^(aString copyReplaceAll: ':' with: '%3A')
		copyReplaceAll: '/' with: '%2f'! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 1/17/2006 22:39'!
feedUrl
	^SSRepository rootUrl , 'feed.rss'! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 1/18/2006 07:17'!
renderBottomOn: html
	| encodedFeed |
	html layoutTableOfWidth: '100%' do: [
		html tableRow: [
			html attributeAt: #align put: #left.
			html tableData: [
				html anchorWithUrl: 'http://validator.w3.org/check/referer' do: 'XHTML'.
				html text: ' | '.
				html anchorWithUrl: 'http://jigsaw.w3.org/css-validator/check/referer' do: 'CSS'.
				html text: ' | '.
				encodedFeed := self encodeUrl: self feedUrl.
				html anchorWithUrl: 'http://validator.w3.org/feed/check.cgi?url=' , encodedFeed do: 'RSS'. ].
			html attributeAt: #align put: #right.
			html tableData: Date today ] ]
! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 7/4/2005 20:43'!
renderContainerOn: html
	html divNamed: 'top' with: [ 
		self renderTopOn: html ].
	html divNamed: 'sstoolbar' with: [
		self renderToolbarOn: html ].
	html divNamed: 'page' with: [
		self renderPageOn: html ].
	html divNamed: 'bottom' with: [
		self renderBottomOn: html ]! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/19/2004 19:13'!
renderContentOn: html
	html divNamed: 'container' with: [
		self renderContainerOn: html ].! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderContentsOn: html! !

!SSGenericFrame methodsFor: 'rendering-head' stamp: 'pmm 1/18/2006 19:24'!
renderHeadElementsOn: html
	super renderHeadElementsOn: html.
	html rssLinkWithUrl: self feedUrl title: 'SqueakSource'.! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'lr 3/12/2004 23:47'!
renderMenu: aString do: aBlock on: html
	html divClass: 'title' with: aString.
	html divClass: 'list' with: aBlock.! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'lr 3/12/2004 23:47'!
renderMenuItem: aBlock on: html
	html divClass: 'item' with: aBlock.! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderNavigationOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 23:49'!
renderPageOn: html
	html divNamed: 'navigation' with: [
		self renderNavigationOn: html ].
	html divNamed: 'contents' with: [
		self renderContentsOn: html ].! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'pmm 1/18/2006 22:29'!
renderStyleBatchOn: aStream
	aStream nextPutAll: '#batch {'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: 		'margin-top: 8px;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/19/2004 18:43'!
renderStyleBottomOn: aStream
	aStream nextPutAll: '#bottom {'.
	aStream nextPutAll: 		'padding-left: 5px;'.
	aStream nextPutAll: 		'padding-right: 5px;'.
	aStream nextPutAll: 		'margin: 0px;'.
	aStream nextPutAll: 		'clear: both;'.
	aStream nextPutAll: 		'border-top: 1px solid black;'.
	aStream nextPutAll: 		'background: white;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/19/2004 18:42'!
renderStyleContainerOn: aStream
	aStream nextPutAll: '#container {'.
	aStream nextPutAll: 		'margin: auto;'.
	aStream nextPutAll: 		'width: 780px;'.
	aStream nextPutAll: 		'background: white url('; nextPutAll: self styleUrlBack; nextPutAll: ') repeat-y;'.
	aStream nextPutAll: 		'border: 1px solid black;'.
	aStream nextPutAll: 		'border-top: 5px solid black;'.
	aStream nextPutAll: 		'border-bottom: 5px solid black;'.
	aStream nextPutAll: 		'text-align: left;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/19/2004 18:40'!
renderStyleContentsOn: aStream
	aStream nextPutAll: '#contents {'.
	aStream nextPutAll: 		'width: 610px; height: auto;'.
	aStream nextPutAll: 		'padding: 5px 10px 10px 10px;'.
	aStream nextPutAll: 		'margin: 0px 0px 0px 150px;'.
	aStream nextPutAll: 		'text-align: justify;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#contents h1 {'.
	aStream nextPutAll: 		'margin-top: 0px;'.
	aStream nextPutAll: 		'font-size: 20px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#contents h2 {'.
	aStream nextPutAll: 		'margin-bottom: 5px;'.
	aStream nextPutAll: 		'font-size: 15px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#contents h3 {'.
	aStream nextPutAll: 		'margin-bottom: 5px;'.
	aStream nextPutAll: 		'font-size: 13px;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#contents hr {'.
	aStream nextPutAll: 		'border: none;'.
	aStream nextPutAll: 		'border-bottom: 1px dotted black;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'pmm 1/17/2006 20:18'!
renderStyleHtmlOn: aStream
	aStream nextPutAll: 'body {'.
	aStream nextPutAll:	 	'margin: 0px;'.
	aStream nextPutAll:	 	'padding: 10px;'.
	aStream nextPutAll: 		'border: 0px;'.
	aStream nextPutAll: 		'background: gray;'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: 'body, div, table, tr, td, th, form input, form submit {'.
	aStream nextPutAll: 		'font-family: Geneva, Arial, Helvetica, sans-serif;'.
	aStream nextPutAll:	 	'font-size: 11px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'table, tr, td, th, form {'.
	aStream nextPutAll: 		'margin: 0px;'.
	aStream nextPutAll: 		'padding: 0px;'.
	aStream nextPutAll: 		'border: 0px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'th {'.
	aStream nextPutAll: 		'text-align: left;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'a, a:visited {'.
	aStream nextPutAll: 		'color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'text-decoration: none;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/19/2004 18:40'!
renderStyleNavigationOn: aStream
	aStream nextPutAll: '#navigation {'.
	aStream nextPutAll: 		'float: left;'.
	aStream nextPutAll: 		'width: 130px;'.
	aStream nextPutAll: 		'padding: 10px;'.
	aStream nextPutAll: 		'padding-top: 0px;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#navigation .title {'.
	aStream nextPutAll: 		'margin-top: 11px;'.
	aStream nextPutAll: 		'font-weight: bold;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'pmm 1/18/2006 22:03'!
renderStyleOn: aStream
	self renderStyleHtmlOn: aStream.	
	self renderStyleContainerOn: aStream.
	self renderStyleTopOn: aStream.
	self renderStyleToolbarOn: aStream.
	self renderStylePageOn: aStream.
	self renderStyleNavigationOn: aStream.
	self renderStyleContentsOn: aStream.
	self renderStyleBottomOn: aStream.
	self renderStyleTabPanelOn: aStream.
	self renderStyleBatchOn: aStream! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/19/2004 18:42'!
renderStylePageOn: aStream
	aStream nextPutAll: '#page {'.
	aStream nextPutAll: 		'padding: 0px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#page td, #page th {'.
	aStream nextPutAll: 		'padding-right: 5px;'.
	aStream nextPutAll: 		'vertical-align: top;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'pmm 1/17/2006 20:18'!
renderStyleTabPanelOn: aStream
	aStream nextPutAll: '.TabSelected {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'color: white;'.
	aStream nextPutAll: 		'width: 95px;'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.TabUnselected {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor muchLighter asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'width: 95px;'.
	aStream nextPutAll: 		'text-align: center}'.
			
	aStream nextPutAll: 	'.TabSpacer {'.
	aStream nextPutAll: 		'width: 5px;'.
	aStream nextPutAll: 	'}'.
		
	aStream nextPutAll: 	'.TabLine {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'pmm 1/17/2006 20:19'!
renderStyleToolbarOn: aStream
	aStream nextPutAll: '#sstoolbar {'.
	aStream nextPutAll: 		'height: 18px;'.
	aStream nextPutAll: 		'border-bottom: 1px solid black;'.
	aStream nextPutAll: 		'background: white;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#sstoolbar a {'.
	aStream nextPutAll: 		'padding-left: 10px;'.
	aStream nextPutAll: 		'padding-right: 10px;'.
	aStream nextPutAll: 		'padding-top: 2px;'.
	aStream nextPutAll: 		'padding-bottom: 2px;'.
	aStream nextPutAll: 		'margin-left: -1px;'.
	aStream nextPutAll: 		'border-left: 1px solid black;'.
	aStream nextPutAll: 		'border-right: 1px solid black;'.
  	aStream nextPutAll: 		'line-height: 18px;'.
 	aStream nextPutAll: 		'letter-spacing: 1px;'.
 	aStream nextPutAll: 		'text-decoration: none;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#sstoolbar a:hover {'.
	aStream nextPutAll: 		'color: white;'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/15/2004 15:30'!
renderStyleTopOn: aStream
	aStream nextPutAll: '#top {'.
	aStream nextPutAll: 		'width: 780px; height: 50px;'.
	aStream nextPutAll: 		'background: url(' , self styleUrlLogo , ') no-repeat;'.
	aStream nextPutAll: 		'border-bottom: 1px solid black;'.
	aStream nextPutAll: 		'font-size: 9px;'.
	aStream nextPutAll: 		'text-align: right;'.
	aStream nextPutAll: '}'.! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:45'!
renderToolbarOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/15/2004 15:02'!
renderTopOn: html! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/15/2004 14:42'!
style
	style isNil ifTrue: [
		style _ String streamContents: [ :stream |
			self renderStyleOn: stream ] ].
	^style! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/15/2004 14:50'!
styleColor 
	^self subclassResponsibility! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/15/2004 15:30'!
styleUrlBack
	^self session application urlForRequestHandler: (WADocumentHandler
		document: self class mimeBack
		mimeType: self class mimeBack mimeType
		fileName: nil)! !

!SSGenericFrame methodsFor: 'sylesheet' stamp: 'lr 3/15/2004 15:31'!
styleUrlLogo
	^self session application urlForRequestHandler: (WADocumentHandler
		document: self class mimeLogo
		mimeType: self class mimeLogo mimeType
		fileName: nil)! !

!WAComponent methodsFor: '*SqueakSource-View' stamp: 'bf 1/7/2006 13:18'!
resetModel! !

!WAHtmlRenderer methodsFor: '*SqueakSource' stamp: 'lr 3/15/2004 17:54'!
passwordInputOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		passwordInputWithCallback: (self callbackForSelector: aSymbol of: anObject)! !

!MIMEDocument methodsFor: '*SqueakSource' stamp: 'al 3/13/2004 18:11'!
asMIMEDocument
	^self! !

WATableReport subclass: #SSTableReport
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSTableReport methodsFor: 'initialization' stamp: 'bf 12/19/2005 09:14'!
initialize
	super initialize.
	batchedList _ SSBatchedList new
		batchSize: SSRepository current batchSize;
		items: rows;
		yourself.
	self rowColors: #( '#ffffff' '#f4f4ff' ).! !

!SSTableReport methodsFor: 'rendering' stamp: 'pmm 1/18/2006 22:29'!
renderBatchOn: html
	batchedList maxPages > 1 ifTrue: [ 
		html tableFooter: [ 
			html attributeAt: 'colSpan' put: columns size.
			html tableData: batchedList ] ]! !

!SSTableReport methodsFor: 'rendering' stamp: 'lr 3/15/2004 19:44'!
renderColumn: aColumn row: aRow on: html
	aColumn renderReport: self row: aRow on: html! !

!SSTableReport methodsFor: 'rendering' stamp: 'pmm 1/18/2006 20:02'!
renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderBatchOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html ]! !

!SSTableReport methodsFor: 'rendering' stamp: 'pmm 1/18/2006 19:58'!
renderTableHeaderOn: html
	html tableHeader: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]! !

!SSTableReport methodsFor: 'accessing' stamp: 'lr 3/19/2004 21:45'!
rows
	batchedList items: super rows.
	^batchedList batch! !

!SSTableReport methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:11'!
rows: aCollection
	super rows: aCollection.
	batchedList items: aCollection.! !

!SocketStream methodsFor: '*squeaksource-override' stamp: 'bf 7/15/2005 11:11'!
printOn: aStream
	"super tries to print out contents which is bad"
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		print: socket;
		nextPut: $)! !

!WAWalkbackPage methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 18:38'!
show
	| req |
	req _ self session respond: [:url | self responseWithUrl: url].
	self perform: (req at: 'debug') asSymbol.! !

!MCVersionInfo methodsFor: '*SqueakSource' stamp: 'lr 2/20/2004 14:02'!
clearAncestors
	ancestors _ #().
	^self! !

TWWiki subclass: #SSWiki
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View'!

!SSWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:15'!
actions
	^Array streamContents: [ :stream |
		(self project isMember: self session user allowedTo: SSAccessPolicy write) ifTrue: [ 
			stream nextPutAll: #( 'View' #view: ).
			stream nextPutAll: #( 'Edit' #edit: ) ].
		stream nextPutAll: #( 'Home' home ) ].! !

!SSWiki methodsFor: 'events' stamp: 'lr 3/30/2004 19:22'!
onSaved
	self session save.! !

!SSWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:12'!
project
	^project! !

!SSWiki methodsFor: 'initialization' stamp: 'lr 3/28/2004 20:11'!
setModel: aModel
	super setModel: (project _ aModel) wiki.! !

!SSWiki methodsFor: 'rendering' stamp: 'lr 3/29/2004 22:41'!
style
	^
'.wikiheader h1 {
	display: none; 
}
.wikiheader .list {
	margin-top: 5px;
	margin-bottom: 10px;
}
.wikiheader .listItem {
	display: inline;
	margin-right: 10px;
}

.wikicontent p { 
	margin: 0px;
	margin-bottom: 5px;
}

.wikifooter h1 {
	display: none;
}
.wikifooter .list:before {
	content: "References: ";
	font-weight: bold;
}
.wikifooter .list {
	margin-top: 10px;
	border-top: 1px dotted black;
}
.wikifooter .listItem {
	display: inline;
	margin-right: 10px;
}'! !

!SeasidePlatformSupport class methodsFor: '*SqueakSource' stamp: 'lr 3/31/2004 11:04'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: '*SqueakSource' stamp: 'bf 12/15/2005 19:45'!
smtpServer
	^ SSRepository current smtpServer

	! !

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:29'!
refreshLocalFileHeaderTo: aStream
	"Re-writes my local header to the given stream.
	To be called after writing the data stream.
	Assumes that fileName and localExtraField sizes didn't change since last written."

	| here |
	here _ aStream position.
	aStream position: writeLocalHeaderRelativeOffset.

	aStream nextPutAll: LocalFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.
	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.
	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: localExtraField size.

	aStream position: here.
! !

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:30'!
writeCentralDirectoryFileHeaderTo: aStream
	"C2 v3 V4 v5 V2"

	aStream nextPutAll: CentralDirectoryFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 1 put: versionMadeBy.
	aStream nextLittleEndianNumber: 1 put: fileAttributeFormat.

	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.

	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.

	"These next 3 should have been updated during the write of the data"
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.

	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: cdExtraField size.
	aStream nextLittleEndianNumber: 2 put: fileComment size.
	aStream nextLittleEndianNumber: 2 put: 0.		"diskNumberStart"
	aStream nextLittleEndianNumber: 2 put: internalFileAttributes.

	aStream nextLittleEndianNumber: 4 put: externalFileAttributes.
	aStream nextLittleEndianNumber: 4 put: writeLocalHeaderRelativeOffset.

	aStream nextPutAll: fileName asByteArray.
	aStream nextPutAll: cdExtraField asByteArray.
	aStream nextPutAll: fileComment asByteArray.! !

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:27'!
writeLocalFileHeaderTo: aStream
	"Write my local header to a file handle.
	Stores the offset to the start of the header in my
	writeLocalHeaderRelativeOffset member."

	aStream nextPutAll: LocalFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.

	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.

	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: localExtraField size.

	aStream nextPutAll: fileName asByteArray.
	aStream nextPutAll: localExtraField asByteArray.
! !

!WAReportColumn class methodsFor: '*SqueakSource' stamp: 'lr 3/23/2004 14:13'!
selector: aSymbol title: aString onFormat: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		formatBlock: aBlock! !

!WAReportColumn methodsFor: '*SqueakSource' stamp: 'lr 3/15/2004 19:45'!
renderReport: aReport row: aRow on: html
	html tableData: [
		self canChoose
			ifTrue: [ 
				html 
					anchorWithAction: [ aReport chooseRow: aRow column: self ] 
					do: [ self renderRow: aRow on: html ] ]
			ifFalse: [ self renderRow: aRow on: html ] ]! !

!WAReportColumn methodsFor: '*SqueakSource' stamp: 'lr 2/4/2004 11:30'!
renderRow: aRow on: html
	| data |
	data _ self valueForRow: aRow.
	formatBlock numArgs = 1
		ifTrue: [ html text: (formatBlock value: data) ]
		ifFalse: [ formatBlock value: data value: html ]! !
SSRepository initialize!
SSFrame initialize!
SSGenericFrame initialize!
